**************************************************************************
** Program name: PDM_VCX.PRG
** Version: 1.3.0
** Create date: 2010-01-01
** Description: Class for analyze source code
** Author: Martina Jindrov
** E-mail: jindra@egservis.cz
** JID: gorila@dione.zcu.cz
** CP: 1250

#INCLUDE "Main.h"
#INCLUDE "RegAPI.h"
#INCLUDE "winnt.h"
#INCLUDE "procthrd.h"
#INCLUDE "dumpfll.h"

****************************************************************
** Definice tdy pro analzu zdrojovho kdu
DEFINE CLASS _PDM_AnalyseSC AS custom
   Name="_PDM_AnalyseSC"

   PDM=.NULL. && Nzev PUBLIC odkazu na PDM objekt
   PDMs=.NULL. && Nzev PUBLIC odkazu na PDMs objekt

   hFile=0 && Handle otevenho souboru

   APRC="" && Alias tabulky procedur
   APROPS="" && Alias tabulky vlastnost
   AOBJ="" && Alias tabulky tdy/objekt

   iSource=_ASC_PRG && Pznak, odkud se generuje strom;
             * _ASC_PRG (0) - PRG File;
             * _ASC_SCX (1) - SCX File;
             * _ASC_VCX (2) - VCX File
             * _ASC_FRX (3) - FRX/LBX File
             * _ASC_MNX (4) - MNX File

   HTMLName="" && Zkladn nzev HTML strnky pro generovn co tda, to strnka
   HTMLFileD=""  && Nzev aktuln strnky detailu
   FirstHTML="" && Nzev prvn HTML strnky
   FirstHTMLTitle="" && Titulek prvn HTML strnky

   preHTMLName="" && Prefix nzvu strnky tdy (pouv menu)

   Target="F3"
   lLNK=.F. && Pznak pouit tabulky LNK

   PROCEDURE Init(pcPDMs,pcPDM) && Inicializace objektu
      m.This.APRC=SYS(2015) && Alias tabulky procedur
      m.This.APROPS=SYS(2015) && Alias tabulky vlastnost
      m.This.AOBJ=SYS(2015) && Alias tabulky tdy/objekt
      m.This.PDMs=pcPDMs
      m.This.PDM=pcPDM
   ENDPROC

   PROCEDURE Reset() && 
      SELE (m.This.APRC)
      ZAP
      SELE (m.This.APROPS)
      ZAP
      SELE (m.This.AOBJ)
      ZAP

      m.This.hFile=0 && Handle otevenho souboru
      STORE "" TO m.This.HTMLName,m.This.HTMLFileD,m.This.FirstHTML,m.This.preHTMLName
      m.This.iSource=_ASC_PRG && Pznak, odkud se generuje strom;

      m.This.Target="F3"
      m.This.lLNK=.F. && Pznak pouit tabulky LNK
   ENDPROC

   PROCEDURE CreateCursors() && Vytvo potebn kurozy pro analzu
      LOCAL m.loPDMs
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDM objekt
      
      SET COLLATE TO "MACHINE"
      CREATE CURSOR (m.This.APRC) (XX101 I,XX101C I,XX101P I,Flags I,XX000 I,OBJNAME M,RESERVED7 M,Params M, XXSC M, XX100R I, XXDesc M, XX001 I, Inherited N(1), ;
                                   XXSCN M, XXMI M, XXMC M, XXDescF M, XXCNTA I, XXCNTC I, XXCNTE I, XXSIZEA I, XXSIZEC I, XXSIZEE I)
      INDEX ON BINTOC(XX101P) TAG I01

      CREATE CURSOR (m.This.AOBJ) (XX101C I, XX101P I, XX101 I, Flags I, XX000 I, OBJNAME M, BaseClass M, Class M, RESERVED7 M, CLASSLOC M, ;
                                   RESERVED8 M, RESERVED6 M, RESERVED4 M,RESERVED5 M,XX100R I, Inherited N(1), XXDesc M, XXI03 C(6), XXKEY M)
      INDEX ON BINTOC(XX101P) TAG I01
      INDEX ON BINTOC(XX101) TAG I00

      CREATE CURSOR (m.This.APROPS) (XX101C I, XX101P I, Flags I,XX000 I, OBJNAME M, Value M, RESERVED7 M,XX100R I, SYS2007 I, Inherited N(1))
      INDEX ON BINTOC(XX101P) TAG I01
      INDEX ON BINTOC(XX101P)+BINTOC(SYS2007) TAG I02

      SET COLLATE TO (m.loPDMs.Collate)
   ENDPROC

   PROCEDURE CloseCursors() && Uzave oteven kurzory
      IF USED(m.This.APRC)
         USE IN (m.This.APRC)
      ENDIF

      IF USED(m.This.AOBJ)
         USE IN (m.This.AOBJ)
      ENDIF

      IF USED(m.This.APROPS)
         USE IN (m.This.APROPS)
      ENDIF
   ENDPROC
   

   PROCEDURE GetClsObj(liRam) && Fet empty Ram object for add class/object on FLY
       LOCAL liSele,loRam
       liSele=SELE()
       DO CASE
          CASE liRam=_PDM_GetDCOPRam_Object
               SELE (m.This.AOBJ)
               SCATTER NAME loRam FIELDS OBJNAME, CLASS, BASECLASS, CLASSLOC, RESERVED4,;
                                         RESERVED5, RESERVED6, RESERVED7, RESERVED8, FLAGS MEMO BLANK
          CASE liRam=_PDM_GetDCOPRam_Prop
               SELE (m.This.APROPS)
               SCATTER NAME loRam FIELDS Flags, OBJNAME, Value, RESERVED7, Inherited;
                            MEMO BLANK

          CASE liRam=_PDM_GetDCOPRam_Method
               SELE (m.This.APRC)
               SCATTER NAME loRam FIELDS Flags, XX000, OBJNAME, RESERVED7, Params, XXSC, ;
                                  Inherited  MEMO BLANK

       ENDCASE
       SELE (m.liSele)
       RETURN loRam
   ENDPROC

   PROCEDURE AddCOPEM(loDCOPEM) && Add class/object/PEM, only for FLY adding
      * loDCOPEM - 
*stop c

      LOCAL loPDMs,loPDM,liSele,lcOBJNAME,lcCLASS,liClass,lcCLS,llProc,lcAPRC,lcAPROPS,lia,;
            m.XX101C,m.XX101P,m.XX101,m.Flags,m.XX000,m.OBJNAME,m.BaseClass,;
            m.Class,m.RESERVED7,m.CLASSLOC,m.RESERVED8,m.RESERVED6,m.RESERVED4,;
            m.RESERVED5,m.XX100R,m.Inherited,loRam,lcPom,llFound,m.SYS2007

      loRam=loDCOPEM.oRam
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt

*_DCOPEM
*cParent
*aProperites()
*aMethods()

       lcAPRC=m.This.APRC
       lcAPROPS=m.This.APROPS

       llProc=EMPTY(loRam.OBJNAME)
       IF !llProc
          m.OBJNAME=loRam.OBJNAME
          liClass=AT(".",loRam.OBJNAME)
          IF m.liClass=0
             lcCLS=UPPER(m.OBJNAME)
          ELSE
             lcCLS=UPPER(LEFT(m.OBJNAME,m.liClass-1))
             m.OBJNAME=SUBST(m.OBJNAME,m.liClass+1)
          ENDIF

  *       m.Flags,m.XX000,;
  *       m.Inherited

          m.BaseClass=loRam.BASECLASS
          m.CLASS=loRam.CLASS
          m.CLASSLOC=loRam.CLASSLOC
          m.RESERVED4=loRam.RESERVED4
          m.RESERVED5=loRam.RESERVED5
          m.RESERVED6=loRam.RESERVED6
          m.RESERVED7=loRam.RESERVED7
          m.RESERVED8=loRam.RESERVED8
          STORE 0 TO m.XX101P,m.XX101C,m.Inherited,m.XX000 && Je to tda

          liSele=SELE()
          SELE (m.This.AOBJ)
          SET COLLATE TO "MACHINE"
       
          SET ORDER TO "I01"
          SET KEY TO BINTOC(0)
          LOCATE FOR XX101P=0 AND UPPER(OBJNAME)==m.lcCls
          SET KEY TO 

          IF FOUND() OR !FOUND() AND m.liClass=0 && zavd objekt a tda nen
             IF !FOUND() && Class not found, Add It
                SET ORDER TO "I00"
                GO BOTTOM
                m.XX101=XX101+1
                m.XX100R=RECC()+1
                m.Flags=BITSET(loRam.Flags,_Flags_bClass)
                INSERT INTO (m.This.AOBJ) FROM MEMVAR && zalo vtu do pomocnho kurzoru
                STORE m.XX101 TO m.XX101P,m.XX101C &&
             ELSE
                STORE XX101 TO m.XX101P,m.XX101C && 
             ENDIF

             IF m.liClass>0 && Jde o objekt
                * Try find object
                LOCATE FOR XX101C=m.XX101C AND UPPER(OBJNAME)=UPPER(m.OBJNAME)

                IF !FOUND() && Object found, Add it
                   m.XX000=1 && Znm rove (XX101 udv definici objektu, xx101x pak id tdy)

                   SET ORDER TO "I00"
                   GO BOTTOM
                   m.XX100R=RECC(m.This.AOBJ)+1
                   m.XX101=XX101+1

                   m.Flags=BITSET(loRam.Flags,_Flags_bObject)
                   INSERT INTO (m.This.AOBJ) FROM MEMVAR
                   m.XX101P=m.XX101
                ELSE
                   STORE XX101 TO m.XX101P
                ENDIF
             ENDIF

             * Nyn projdi matice aProperties[] a aMethods[]

             FOR lii=1 TO loDCOPEM.iMethods
                 m.OBJNAME=loDCOPEM.aMethods(lii).OBJNAME

*!*	                 m.RESERVED7=loRam.RESERVED7
*!*	                 m.RESERVED8=loRam.RESERVED8
*!*	                 m.Params=loRam.PARAMS
*!*	                 m.XXDESC=loRam.XXDESC
*!*	                 m.XXSC=loRam.XXSC
*!*	                 m.XXSCN=loRam.XXSCN
*!*	                 m.Inherited=loRam.INHERITED

*!*	                 * XXMI M, XXMC M, XXDescF M

                  loDCOPEM.aMethods(lii).XXSC="PROCEDURE "+m.OBJNAME+CRLF+;
                                           "LPARAM "

* zpracovat metadata nebo je nathnout z DIAMP

*                  This.Analyse(loDCOPEM.DCOPPar.oPDMx,loDCOPEM.aMethods(lii).XXSC,m.XX101C,m.XX101P,m.OBJNAME)
             NEXT

             m.XX000=0
             m.SYS2007=0
             FOR lii=1 TO loDCOPEM.iProperties
                 m.OBJNAME=loDCOPEM.aProperties(lii).OBJNAME

                 IF EMPTY(m.OBJNAME)
                    LOOP
                 ENDIF

                 m.Flags=loDCOPEM.aProperties(lii).Flags
                 m.RESERVED7=loDCOPEM.aProperties(lii).RESERVED7
                 m.Value=loDCOPEM.aProperties(lii).Value
                 m.Inherited=loDCOPEM.aProperties(lii).Inherited

                 * Nejdve mus otestovat, zda tam ona vlastnost existuje
                 * Pokud ne, pak ji zalo
                 lia=ATC("(",m.OBJNAME)
                 lia=IIF(lia=0,ATC("[",m.OBJNAME),m.lia)

                 m.Flags=m.Flags+IIF(lia>0,BITSET(m.Flags,_Flags_bArray),0)

                 SELE (m.lcAPROPS)
                 IF m.lia=0 OR m.lia>0 AND loPDM.Array_RemoveCells=0
                    =SEEK(BINTOC(m.XX101P))
                    LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                    IF !FOUND()
                       m.XX100R=RECC()+1
                       INSERT INTO (m.lcAPROPS) FROM MEMVAR
                    ELSE
                       IF BITTEST(m.Flags,0) OR BITTEST(m.Flags,1)
                          REPL FLAGS WITH BITSET(FLAGS,IIF(BITTEST(m.Flags,0),0,1))
                       ENDIF
                    ENDIF
                 ENDIF

                 IF loPDM.Array_AddAsProperty=1 AND m.lia>0
                    m.OBJNAME=LEFT(m.OBJNAME,m.lia-1)
                    =SEEK(BINTOC(m.XX101P))
                    LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                    IF !FOUND()
                       m.XX100R=RECC()+1
                       INSERT INTO (m.lcAPROPS) FROM MEMVAR
                    ENDIF
                 ENDIF
             NEXT
          ENDIF

       ELSE
          * Jenom procedury uvnit FXP
       ENDIF

       SET COLLATE TO (m.loPDMs.Collate)
       SELE (m.liSele)
   ENDPROC

   PROCEDURE Analyse(loObj,lcSC,m.XX101C,liXX101P,lcOBJNAME) && Provede analzu zdrojovho kdu
      * loObj  - Odkaz na objekt s informacema pro zpracovn
      *@lcSC  - Zdrojov pedan jako etzec

      IF EMPTY(m.lcSC) && Pokud je to przdn, pak se vra
         RETURN
      ENDIF

      LOCAL lcAPRC,lcAOBJ,lcLine,liCount,liCRLF,;
            lcPom,lcName,liy,liz,lcXXSC,lcXXSCN,lcXXSCB,lcXXSCL,lcPom2,;
            m.XX101,m.XX101L,m.OBJNAME,m.Class, lcMeta, ;
            liXX101X_X,m.CLASSLOC,m.XX000,lcAPROPS,lii,;
            m.Flags,m.RESERVED7,lcRESERVED7,m.XX001,m.Inherited,;
            m.Value,m.Params,llPRC,lcProc,m.XXMI,m.XXMC,;
            m.loPDM,llExit,loSA,llFound,m.XX101P,m.XX100R,m.loPDMs,;
            llSyntaxColoring,liCFlags,lia,;
            liSC,liOSC,lcSC_S,llSC,llSC_S,llPRCPMP,;
            liDD,liODD,lcDD_S,llDD,llDD_S,lcDOCS,lcDOCE,llDOC,;
            lcXXDESC,lcXXDESCB,llPRCDOC,llOC,loPIPar,llOne,lcPreKey,lcAnchor,liAnch,lcLineX,m.XXMIX,m.XXMCX,;
            lcFile,lcFileX,llCLS,liIndent,m.liMC,llMI,llMC,m.XXDescF,liRow,liRowh,llByRow, llIgnoreXXX,;
            m.liXXCNTA, m.liXXCNTC, m.liXXCNTE, m.liPCOUNT, m.liXXSIZEA, m.liXXSIZEC, m.liXXSIZEE

      LOCAL ARRAY laRows(1),laAnch(1,2),laSO(1),laRowsX(1),laXXMI(1),laXXMC(1),laComments(1)

      m.liPCOUNT=PCOUNT()
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      llOne=m.loPDM.One
      lcPreKey=SYS(2015)
      liAnch=0

      * Nejdve provedu analzu PRG soubou
      * Jako prvn budu hledat definici td
      * a potom definici procedur a funkc
      * a na konec piazen hodnot vlastnostem

      lcAPRC=m.This.APRC && Alias tabulky procedur
      lcAPROPS=m.This.APROPS && Alias tabulky vlastnost
      lcAOBJ=m.This.AOBJ && Alias tabulky tdy/objekt

      liSC=m.loPDM.IncludeSC
      liOSC=m.loObj.IncludeSC
      llSC_S=m.liSC=_ESC_Signed
      lcSC_S=UPPER(ALLT(m.loPDM.IncludeSC_S))

      llMI=m.loPDM.SCIndent=1
      llMC=m.loPDM.SCCounter=1

      liDD=m.loPDM.IncludeDD
      liODD=m.loObj.IncludeDD
      llDD_S=m.liDD=_EDD_Signed
      lcDD_S=UPPER(ALLT(m.loPDM.IncludeDD_S))
      lcDOCS=UPPER(ALLT(m.loPDM.DD_START))
      lcDOCE=UPPER(ALLT(m.loPDM.DD_STOP))
      llOC=m.loPDM.OnlyComment=_DD_OC_Yes
   
      llSyntaxColoring=m.loPDM.SyntaxColoring>0
      * I need support for row
      llByRow=m.llSyntaxColoring AND m.loPDM.aCF(1,1).SCByRow

      llSC=liSC=_ESC_Include OR m.llSC_S OR m.liSC=_ESC_User AND (m.liOSC=_SC_Include OR m.liOSC=_SC_Signed)
      llDD=liDD=_EDD_Include OR m.llDD_S OR m.liDD=_EDD_User AND (m.liODD=_DD_Include OR m.liODD=_DD_Signed)

      STORE "" TO m.Params,m.CLASSLOC,lcXXSC,lcXXSCB,m.RESERVED7,lcXXDESC,;
                  lcXXDESCB,lcXXSCN,lcXXDESCcls,m.XXMI,m.XXMC,lcProc,lcMeta,m.XXDescF

      STORE 0 TO m.Inherited, m.Flags, m.liXXCNTA, m.liXXCNTC, m.liXXCNTE, m.liXXSIZEA, m.liXXSIZEC, m.liXXSIZEE
      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.loObj.File
      loPIPar.oPDMx=m.loObj
      loPIPar.Type="DIAMP"
      loPIPar.oPDMx=loObj


      IF m.liPCOUNT=5 && Pat pod njakou tdu/objekt
         lcOBJNAME=m.lcOBJNAME+IIF(!EMPTY(m.lcOBJNAME),".","")
      ELSE
         m.XX101P=-2 && Main program
         m.XX101C=-2 && Main program

         * Pro jistotu zalo proceduru Main_PRG
         m.XX100R=RECC(m.lcAPRC)+1
         m.XX000=1
         m.XX001=_PDM_MF_None
         m.XX101=1
         m.OBJNAME="Main Program"
         INSERT INTO (m.lcAPRC) FROM MEMVAR && zalo vtu do pomocnho kurzoru
         llPRC=.T.

         m.XX101P=-1 && Nen tda (ist procedury)
         m.XX101C=-1 && Nen tda (ist procedury)
      ENDIF


      m.laComments(1)="&"+"&"

      ***************************
      * Analza zdrojovho kdu *
      ***************************

      ********************************************
      ** Nat se dek po dku, ale pokud je v dku stednk oznaujc prokraovn na dalm dku
      ** pak se nate dal dek, a tak dle dokud dek je ukonen stednkem.
      ** Pokud se na inkriminovanch dcch nachz komet, pak se pit do dal promnn
      ********************************************

      =RepairSource(@m.lcSC)
      liCRLF=OCCURS(CRLF,m.lcSC) && Zjisti poet enter

      IF m.liCRLF<=64000 OR VAL(m.loPDMs.VFPVers)>8
         liCount=ALINES(laRows,m.lcSC)
      ELSE      
         loSA=CREATEOBJECT("_SupperArray") && Vytvo objekt pro prci a Super maticemi
         liCount=m.loSA.ALines(@m.lcSC) && Nati zdrojov kd do matice
      ENDIF
      STORE "" TO lcSC,lcTextByRow

      STORE .F. TO llPRCPMP,llPRCDOC,llDOC,llAddSpace && Nastav pznak, e metoda/procedura se m zpracovat
      STORE 0 TO m.XX000,liRow,liRowH && nebindovan M/P/O
      m.XX001=_PDM_MF_None
      m.liMC=LEN(LTRIM(STR(m.liCount)))

      FOR m.XX101=1 TO m.liCount
          STORE "" TO lcLine,m.RESERVED7
          STORE IIF(m.liCRLF<=64000 OR VAL(m.loPDMs.VFPVers)>8,laRows(m.XX101),m.loSA.GetRow(m.XX101)) TO lcPom,lcXXSCL

          liRowH=IIF(m.liPCOUNT=5,liRowH+1,0)
          liRow=IIF(m.liPCOUNT=5,liRowH,m.XX101)

          lii=Trim_SC(@m.lcPom,@paComments,@m.lcRESERVED7,@liIndent) && Odezej koment a zjisti, kde je stednk
          lcMeta=m.lcMeta+STR(m.lii,1)

          m.liXXSIZEA=m.liXXSIZEA+LEN(m.lcXXSCL)
          m.liXXCNTA=m.liXXCNTA+1
          IF EMPTY(m.lcXXSCL)
             m.liXXCNTE=m.liXXCNTE+1
             m.liXXSIZEE=m.liXXSIZEE+LEN(m.lcXXSCL)
          ENDIF
          IF EMPTY(m.lcPom) AND NOT EMPTY(m.lcRESERVED7)
             m.liXXCNTC=m.liXXCNTC+1
             m.liXXSIZEC=m.liXXSIZEC+LEN(m.lcXXSCL)
          ENDIF

          * Jde - li o dek metody/procedury
          IF m.llPRC
             * V ppad procedury zkontrolovat, zda koment obsahuje klov slova pro 
             * kontrolu, zda metoda/procedura je zahrnuta do HTML dokumentace
             * i m doplkovou dokumentaci
             liz=AT_NonSpace(@m.lcRESERVED7,1) && najdi prvn znak
             liz=IIF(liz=0,1,m.liz)
             liCFlags=IIF(LEN(m.lcSC_S)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcSC_S)))==m.lcSC_S,1,;
                         IIF(LEN(m.lcDD_S)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDD_S)))==m.lcDD_S,2,;
                            IIF(LEN(m.lcDOCS)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDOCS)))==m.lcDOCS,4,;
                                IIF(LEN(m.lcDOCE)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDOCE)))==m.lcDOCE,8,0))))

             llPRCPMP=IIF(m.liCFlags=1,.T.,m.llPRCPMP)
             llPRCDOC=IIF(m.liCFlags=2,.T.,m.llPRCDOC)
             llDOC=IIF(m.liCFlags=8,.F.,IIF(m.liCFlags=4,.T.,m.llDOC))

*!*	             * pokud se nem zobrazit zdrojk a popis
*!*	             IF m.llSC AND !m.llPRCPMP AND m.llDD AND !m.llPRCDOC
*!*	                * Pak to cel zaho????
*!*	                DELE NEXT 1 IN (m.lcAPRC)         
*!*	             ENDIF

             IF llAddSpace AND m.llSC AND !m.llDOC AND ;
                LEN(m.lcXXSC)>0 AND LEN(m.lcXXSCB)=0 AND LEFT(m.lcXXSC,12)="LPARAMETERS " AND ;
                LEN(m.lcXXSCL)>0

                lia=LEN(m.lcXXSCL)-LEN(LTRIM(m.lcXXSCL))
                lcXXSC=SPACE(lia)+m.lcXXSC

                m.XXMCX=IIF(m.llMC AND llSyntaxColoring AND m.llSC AND (!m.llDOC AND liCFlags=0 OR liCFlags=4),STR(m.XX101L,m.liMC)+CRLF,"")
                m.XXMC=m.XXMCX+m.XXMC

                m.XXMIX=IIF(m.llMI AND llSyntaxColoring AND m.llSC AND (!m.llDOC AND liCFlags=0 OR liCFlags=4),IIF(m.lia>0,STR(lia,2),"  ")+CRLF,"")
                m.XXMI=m.XXMIX+m.XXMI


                llAddSpace=.F.
             ENDIF
             lcLineX=IIF(m.llSC AND (!m.llDOC AND liCFlags=0 OR liCFlags=4),;
                        IIF(m.llMC AND !llSyntaxColoring,STR(m.liRow,m.liMC)+" ","")+;
                        IIF(m.llMI AND !llSyntaxColoring,IIF(m.liIndent>0,STR(m.liIndent,2)+" ","   "),"")+;
                        IIF(!m.llDOC AND liCFlags=0,IIF(LEN(m.lcXXSCL)=0,"",m.lcXXSCL),IIF(LEN(m.lcPom)=0,"",m.lcPom))+CRLF,"")

             lcXXSCB=m.lcXXSCB+m.lcLineX

             m.XXMCX=IIF(m.llMC AND llSyntaxColoring AND m.llSC AND (!m.llDOC AND liCFlags=0 OR liCFlags=4),STR(m.liRow,m.liMC)+CRLF,"")
             m.XXMC=m.XXMC+m.XXMCX

             m.XXMIX=IIF(m.llMI AND llSyntaxColoring AND m.llSC AND (!m.llDOC AND liCFlags=0 OR liCFlags=4),IIF(m.liIndent>0,STR(liIndent,2),"  ")+CRLF,"")
             m.XXMI=m.XXMI+m.XXMIX


             IF m.liCFlags>0 && Pokud je njak pznak
                lcXXDESCB=m.lcXXDESCB+IIF(m.llDD AND m.liCFlags=8,CRLF+CRLF,"")
                LOOP && Pak sko na dal vtu
             ENDIF

             lcXXDESCB=m.lcXXDESCB+;
                       IIF(m.llDD AND m.llDOC,;
                          IIF(m.llOC,IIF(LEN(m.lcRESERVED7)>0,m.lcRESERVED7,""),;
                          IIF(LEN(m.lcXXSCL)>0,m.lcXXSCL,""))+CRLF,"")
          ENDIF

          IF m.llCLS AND !llPRC
             * V ppad tdy zkontrolovat ( A nen to procedura), zda koment obsahuje klov slova pro 
             * kontrolu a m doplkovou dokumentaci
             liz=AT_NonSpace(@m.lcRESERVED7,1) && najdi prvn znak
             liz=IIF(liz=0,1,m.liz)
             liCFlags=IIF(LEN(m.lcDD_S)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDD_S)))==m.lcDD_S,2,;
                            IIF(LEN(m.lcDOCS)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDOCS)))==m.lcDOCS,4,;
                                IIF(LEN(m.lcDOCE)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDOCE)))==m.lcDOCE,8,0)))

             llPRCDOC=IIF(m.liCFlags=2,.T.,m.llPRCDOC)
             llDOC=IIF(m.liCFlags=8,.F.,IIF(m.liCFlags=4,.T.,m.llDOC))

             lcXXDESCB=m.lcXXDESCB+;
                       IIF(m.llDD,;
                          IIF(m.llOC,IIF(LEN(m.lcRESERVED7)>0,m.lcRESERVED7,""),;
                              IIF(!m.llDOC AND liCFlags=0,IIF(LEN(m.lcXXSCL)=0,"",m.lcXXSCL), IIF(LEN(m.lcPom)=0,"",m.lcPom))+CRLF),"")

             IF m.liCFlags>0 && Pokud je njak pznak
                lcXXDESCB=m.lcXXDESCB+IIF(m.llDD AND m.liCFlags=8,CRLF+CRLF,"")
                LOOP && Pak sko na dal vtu
             ENDIF
          ENDIF

          IF !llDOC
             m.RESERVED7=ALLTRIM(m.lcRESERVED7)
             lcLine=ALLTRIM(m.lcPom)
          ENDIF


          * Cykluj zde tak dlouho, dokud je stednk ped komentem
          DO WHILE m.lii=1 AND m.XX101<m.liCount
             m.XX101=m.XX101+1 && Inkrementuj ta

             liRowH=IIF(m.liPCOUNT=5, liRowH+1,0)
             liRow=IIF(m.liPCOUNT=5, liRowH, m.XX101)

             STORE IIF(m.liCRLF<=64000 OR VAL(m.loPDMs.VFPVers)>8,laRows(m.XX101),m.loSA.GetRow(m.XX101)) TO lcPom,lcXXSCL
             * Jde - li o dek metody/procedury

             * Otestuj dek, co je za
             * Pokud tam nen stednk ped komentem
             lii=Trim_SC(@m.lcPom,@laComments,@m.lcRESERVED7,@liIndent)

             lcLineX=IIF(m.llPRC AND m.llSC AND (!m.llDOC AND liCFlags=0 OR liCFlags=4),;
                        IIF(m.llMC AND !llSyntaxColoring,STR(m.liRow,m.liMC)+" ","")+;
                        IIF(m.llMI AND !llSyntaxColoring,IIF(m.liIndent>0,STR(m.liIndent,2)+" ","   "),"")+;
                        IIF(!m.llDOC AND liCFlags=0,IIF(LEN(m.lcXXSCL)=0,"",m.lcXXSCL),IIF(LEN(m.lcPom)=0,"",m.lcPom))+CRLF,"")

             lcXXSCB=m.lcXXSCB+m.lcLineX

             m.XXMCX=IIF(m.llMC AND llSyntaxColoring  AND m.llPRC AND m.llSC  AND (!m.llDOC AND liCFlags=0 OR liCFlags=4),STR(m.liRow,m.liMC)+CRLF,"") &&
             m.XXMC=m.XXMC+m.XXMCX

             m.XXMIX=IIF(m.llMI AND llSyntaxColoring AND m.llSC AND (!m.llDOC AND liCFlags=0 OR liCFlags=4),IIF(m.liIndent>0,STR(m.liIndent,2),"  ")+CRLF,"") && 
             m.XXMI=m.XXMI+m.XXMIX

             lcMeta=m.lcMeta+STR(m.lii,1)

             lcXXDESCB=m.lcXXDESCB+;
                       IIF((m.llPRC OR m.llCLS) AND m.llDD AND m.llDOC,;
                          IIF(m.llOC,IIF(LEN(m.lcRESERVED7)>0,m.lcRESERVED7,""),;
                          IIF(LEN(m.lcXXSCL)>0,m.lcXXSCL,""))+CRLF,"")

             m.RESERVED7=m.RESERVED7+IIF(LEN(m.lcRESERVED7)>0 AND !m.llDOC," "+ALLT(m.lcRESERVED7),"")

             lcLine=m.lcLine+IIF(LEN(m.lcPom)>0," "+ALLT(m.lcPom),"")

             m.liXXSIZEA=m.liXXSIZEA+LEN(m.lcXXSCL)
             m.liXXCNTA=m.liXXCNTA+1
             IF EMPTY(m.lcPom) AND NOT EMPTY(m.lcRESERVED7)
                m.liXXCNTC=m.liXXCNTC+1
                m.liXXSIZEC=m.liXXSIZEC+LEN(m.lcXXSCL)
             ENDIF

          ENDDO

          IF lii=2 && Pokud je tam stednk za komentem
             * Pak tento koment nati
             llExit=.F.
             DO WHILE m.XX101<m.liCount AND !m.llExit
                m.XX101=m.XX101+1 && Inkrementuj ta

                liRowH=IIF(m.liPCOUNT=5, liRowH+1, 0)
                liRow=IIF(m.liPCOUNT=5, liRowH, m.XX101)

                STORE IIF(m.liCRLF<=64000 OR VAL(m.loPDMs.VFPVers)>8,laRows(m.XX101),m.loSA.GetRow(m.XX101)) TO m.lcRESERVED7,m.lcXXSCL

                liz=AT_NonSpace(@m.lcRESERVED7,1,LEN(m.lcRESERVED7))
                liy=RAT_NonSpace(@m.lcRESERVED7,LEN(m.lcRESERVED7),m.liz)
                lcRESERVED7=IIF(m.liz=0,m.lcRESERVED7,SUBS(m.lcRESERVED7,m.liz,m.liy-m.liz+1))

                llExit=RIGHT(m.lcRESERVED7,1)#";"
                lcMeta=m.lcMeta+IIF(m.llExit,"0","2")

                liz=m.liz-1
                * Jde - li o dek metody/procedury
                lcLineX=IIF(m.llMC AND !llSyntaxColoring AND m.llPRC AND m.llSC AND !m.llDOC,STR(m.liRow,m.liMC)+" ","")+;
                        IIF(m.llMI AND !llSyntaxColoring AND m.llPRC AND m.llSC AND !m.llDOC,IIF(m.liz>0,STR(m.liz,2)+" ","   "),"")+;
                        IIF(m.llPRC AND m.llSC AND !m.llDOC,m.lcXXSCL+CRLF,"")

                lcXXSCB=m.lcXXSCB+lcLineX

                m.XXMCX=IIF(m.llMC AND llSyntaxColoring AND m.llPRC AND m.llSC AND !m.llDOC,STR(m.liRow,m.liMC)+CRLF,"")
                m.XXMC=m.XXMC+m.XXMCX
  
                m.XXMIX=IIF(m.llMI AND llSyntaxColoring AND m.llPRC AND m.llSC AND !m.llDOC,IIF(m.liz>0,STR(m.liz,2),"  ")+CRLF,"")
                m.XXMI=m.XXMI+m.XXMIX

                lcXXDESCB=m.lcXXDESCB+;
                          IIF((m.llPRC OR m.llCLS) AND m.llDD AND m.llDOC,;
                             IIF(m.llOC,IIF(LEN(m.lcRESERVED7)>0,m.lcRESERVED7,""),;
                             IIF(LEN(m.lcXXSCL)>0,m.lcXXSCL,""))+CRLF,"")

                m.liXXSIZEA=m.liXXSIZEA+LEN(m.lcXXSCL)
                m.liXXCNTA=m.liXXCNTA+1
                IF NOT EMPTY(m.lcRESERVED7)
                   m.liXXCNTC=m.liXXCNTC+1
                   m.liXXSIZEC=m.liXXSIZEC+LEN(m.lcXXSCL)
                ENDIF

                IF !m.llDOC
                   lcRESERVED7=;
                               IIF(RIGHT(m.lcRESERVED7,1)=";",LEFT(m.lcRESERVED7,LEN(m.lcRESERVED7)-1),m.lcRESERVED7)

                   m.RESERVED7=m.RESERVED7+IIF(LEN(m.lcRESERVED7)>0," "+RTRIM(m.lcRESERVED7),"")
                ENDIF
             ENDDO
          ENDIF

          * Pokud je dek przdn
          * - i pokud je na dku SC jen koment, pak ve pouit kd vrt przdn dek a koment
          * je vrcen zvl᚝

*!*	if atc('DIMENSION aZI_FileInfo[1]',lcLine)>0
*!*	   susp
*!*	endif

          m.Flags=0
          =IIF(!EMPTY(m.lcLine),ParseRowSC(@m.lcLine,m.llPRC,@m.Flags,@m.OBJNAME,@m.Params,@m.Class,@m.CLASSLOC),.T.)

*!*	if atc("#if ",lcline)>0
*!*	susp
*!*	endif

          IF (BITTEST(m.Flags,25) OR BITTEST(m.Flags,27)) AND !(m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_DBC)
             llIgnoreXXX=.T.
          ENDIF
          
          IF llIgnoreXXX AND (BITTEST(m.Flags,26) OR BITTEST(m.Flags,28))
             llIgnoreXXX=.F.
          ENDIF

          * Pokud to nen dn hlavika/patika je to dek metody/procedury
          IF (m.Flags=0 OR BITTEST(m.Flags,25) OR BITTEST(m.Flags,26) OR BITTEST(m.Flags,27) OR BITTEST(m.Flags,28) OR llIgnoreXXX OR ;
             (BITTEST(m.Flags,14) OR BITTEST(m.Flags,15) OR BITTEST(m.Flags,16) OR;
              BITTEST(m.Flags,17) OR BITTEST(m.Flags,18) OR BITTEST(m.Flags,19) OR;
              BITTEST(m.Flags,22) OR BITTEST(m.Flags,20) OR BITTEST(m.Flags,23) OR;
              BITTEST(m.Flags,24);
              ) AND !EMPTY(m.CLASSLOC)  ) AND m.llPRC

             IF m.llDOC
                lcXXDESC=m.lcXXDESC+m.lcXXDESCB && Pak piti buffer do obsahu detailniho popisu
                lcXXDESCB="" && Vyisti mezibuffer
             ELSE
                lcXXSCN=m.lcXXSCN+m.lcXXSCB && Pak piti buffer do obsahu metody/procedury

                * Je to include soubor a nen zpracovvn jeden soubor
                IF BITTEST(m.Flags,14) AND !m.llOne AND !EMPTY(m.CLASSLOC)
                   * Promnn m.CLASSLOC obsahuje nzev souboru
                   lcAnchor=m.loPDMs.GetAnchor(FULLPATH(ALLT(m.CLASSLOC),m.loObj.File),"../../")

                   IF LEN(m.lcAnchor)>0
                      lcPom=IIF(!m.llSyntaxColoring AND m.Class=["],m.CLASSLOC,;
                            IIF(m.llSyntaxColoring AND LEN(m.Class)=0, m.loPDM.Expr2xhtml(m.CLASSLOC,0,.F.,.F.),m.CLASSLOC))

                      lii=RAT_Ex(@m.lcXXSCB,m.lcPom,LEN(m.lcXXSCB),1)
                      IF lii>0
                         liAnch=m.liAnch+1 && Inkrementuj ta
                         IF ALEN(laAnch,1)<m.liAnch
                            DIME laAnch(liAnch,2)
                         ENDIF
                         laAnch(m.liAnch,1)="PDM_A_"+SYS(2015)
                         laAnch(m.liAnch,2)=[<a href="]+m.lcAnchor+[" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05166),"%name%",m.CLASSLOC)+[" target="_top">]+m.CLASSLOC+[</a>]

                         lcXXSCB=STUFF(m.lcXXSCB,m.lii,LEN(m.lcPom),laAnch(m.liAnch,1))
                      ENDIF
                   ENDIF
                ENDIF
                
                * Je to SET PROCEDURE TO... a nen zpracovvn jeden soubor
                * Je to SET CLASSLIB TO... a nen zpracovvn jeden soubor
                * Je to DO FORM... a nen zpracovvn jeden soubor
                * Je to REPORT FORM... a nen zpracovvn jeden soubor
                * Je to LABEL FORM... a nen zpracovvn jeden soubor
                * Je to DO... a nen zpracovvn jeden soubor
                * Je to WITH object AS class OF classlib... a nen zpracovvn jeden soubor
                IF (BITTEST(m.Flags,15) OR BITTEST(m.Flags,16) OR BITTEST(m.Flags,17) OR;
                    BITTEST(m.Flags,18) OR BITTEST(m.Flags,19) OR BITTEST(m.Flags,22) OR;
                    BITTEST(m.Flags,20) OR BITTEST(m.Flags,24)) AND ;
                    !m.llOne AND !EMPTY(m.CLASSLOC)
                   * seznam oddlen rkou

                   lcAnchor=""
                   lcPom2=m.CLASSLOC
                   m.CLASSLOC=LTRIM(m.CLASSLOC)
                   liz=1
                   DO WHILE liz>0
                      liz=FindMDSC(m.CLASSLOC,",",1,LEN(m.CLASSLOC))
                      lcFile=IIF(m.liz=0,m.CLASSLOC,ALLT(LEFT(m.CLASSLOC,m.liz-1)))
                      m.CLASSLOC=LTRIM(SUBST(m.CLASSLOC,m.liz+1))

                      lcFileX=m.loPDMs.ParseFile(lcFile)
                      * lcFile obsahuje cel nzev souboru
                      * lcFileX obsahuje relevantn nzev souboru (vetn sloek)

                      IF !EMPTY(m.lcFileX)
                         * Pidej koncovku (chyb-li)
                         lii=RAT(".",m.lcFileX)
                         IF lii=0 OR EMPTY(SUBST(m.lcFileX,lii+1))
                            lcFileX=lcFileX+IIF(lii=0 AND !BITTEST(m.Flags,20),".","")+;
                                            IIF(BITTEST(m.Flags,15),"prg",;
                                            IIF(BITTEST(m.Flags,16),"vcx",;
                                            IIF(BITTEST(m.Flags,17),"scx",;
                                            IIF(BITTEST(m.Flags,18),"frx",;
                                            IIF(BITTEST(m.Flags,19),"lbx",;
                                            IIF(BITTEST(m.Flags,22),"dbc",""))))))
                         ENDIF

                         DO CASE
                            CASE BITTEST(m.Flags,20) && Procedura/soubor?
                                 * Nejdve najdi odkazy na procedury

                                 lii=loPDMs.GetMPAnchors(@laSO,"",m.lcFileX,"../../")
                                 * pokud nic nenajde, hledej to jako soubor
                                 IF lii=0
                                    lii=RAT(".",m.lcFileX)
                                    IF lii=0 OR EMPTY(SUBST(m.lcFileX,lii+1))
                                       lcFileX=lcFileX+IIF(lii=0,".","")+"prg"
                                    ENDIF
                                    lii=m.loPDMs.GetAnchors(@laSO,m.lcFileX,"../../")
                                 ENDIF

                            CASE BITTEST(m.Flags,24) && tda
                                 * Nejdve najdi odkazy na tdu
                                 lcFileX=m.loPDM.FullPath(m.lcFile,m.loObj.File)
                                 m.lcPom2=m.OBJNAME

                                 lcPom=m.loPDMs.GetClassAnchor(m.lcFileX,m.OBJNAME,"../../")
                                 lcAnchor=m.lcAnchor+;
                                          IIF(EMPTY(m.lcPom),m.OBJNAME,'<a href="'+m.lcPom+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_04719),"%name%",LOWER(m.OBJNAME))+'">'+m.OBJNAME+'</a>')+" , "


*!*            IF !(EMPTY(CLASSLOC) OR BaseClass==Class)
*!*                lcClassLib=m.loPDMs.GetClassAnchor(m.lcClassLibF,"","../../")
*!*                lcString=m.lcString+;
*!*                         m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04774)+'</td><td>'+;
*!*                         IIF(EMPTY(m.lcClassLib),CLASSLOC,'<a href="'+m.lcClassLib+'" target="_blank" title="'+STRTRAN(m.loPDMs.aStrings(PDM_04720),"%name%",LOWER(CLASSLOC))+'">'+CLASSLOC+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
*!*             ENDIF

                              OTHERWISE
                                 lii=m.loPDMs.GetAnchors(@laSO,m.lcFileX,"../../")
                         ENDCASE
                       
                         IF !BITTEST(m.Flags,24)
                            * Nyn me najt vechny odkazy
                            m.XX001=IIF(!BITTEST(m.XX001,_PDM_MF_bLNKS) AND m.lii>1,BITSET(m.XX001,_PDM_MF_bLNKS),m.XX001)
                            IF m.lii<=1
                               lcAnchor=m.lcAnchor+IIF(m.lii=0,m.lcFile,;
                                       [<a href="]+laSO(1,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05049),"%name%",m.lcFileX)+[">]+StrTranHTMLString(m.lcFile)+[</a>])
                            ELSE
                               m.lcRecnoX=SYS(2015)
                               lcAnchor=m.lcAnchor+;
                                       [<span id="SPN_]+m.lcRecnoX+[" class="LNK_collaborative" onclick="pcLNK=']+m.lcRecnoX+[';" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05049),"%name%",m.lcFileX)+[">]+StrTranHTMLString(m.lcFile)+"</span>"+;
                                       [<div id="LNK_]+m.lcRecnoX+[" class="LNK_tab"> <!-- Link Table Begin -->]+;
                                       [<table class="a_center">]
                
                               FOR liy=1 TO m.lii
                                   lcAnchor=m.lcAnchor+;
                                           [<tr><td><a href="]+laSO(m.liy,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05049),"%name%",m.lcFileX)+[">]+StrTranHTMLString(m.lcFile)+[</a></td></tr>]
                               NEXT
                               lcAnchor=m.lcAnchor+;
                                       [</table>]+;
                                       [</div> <!-- Link Table End -->]
                            ENDIF
                            lcAnchor=m.lcAnchor+" , "
                         ENDIF
                      ENDIF
                   ENDDO

                   IF LEN(lcAnchor)>0
                      liAnch=m.liAnch+1 && Inkrementuj ta
                      IF ALEN(laAnch,1)<m.liAnch
                         DIME laAnch(liAnch,2)
                      ENDIF
                      laAnch(m.liAnch,1)="PDM_A_"+SYS(2015)
                      laAnch(m.liAnch,2)=LEFT(lcAnchor,LEN(lcAnchor)-3)

                      lcXXSCB=STUFF(m.lcXXSCB,AT(m.lcPom2,m.lcXXSCB),LEN(m.lcPom2),laAnch(m.liAnch,1))
                   ENDIF
                ENDIF

                * DECLARE API
                IF BITTEST(m.Flags,23)
                   lcFileX=m.loPDMs.ParseFile(m.CLASSLOC)

                   liAnch=m.liAnch+1 && Inkrementuj ta
                   IF ALEN(laAnch,1)<m.liAnch
                      DIME laAnch(liAnch,2)
                   ENDIF
                   laAnch(m.liAnch,1)="PDM_A_"+SYS(2015)
                   laAnch(m.liAnch,2)=[<a href="]+STRTRAN(STRTRAN(m.loPDM.APISearcher,"%name%",m.OBJNAME),"%File%",m.lcFileX)+[" target="blank">]+m.OBJNAME+[</a>]

                   lcXXSCB=STUFF(m.lcXXSCB,AT(m.OBJNAME,m.lcXXSCB),LEN(m.OBJNAME),laAnch(m.liAnch,1))
                ENDIF

                lcXXSC=m.lcXXSC+m.lcXXSCB && Pak piti buffer do obsahu metody/procedury
                lcXXSCB="" && Vyisti mezibuffer
             ENDIF

             IF m.XX101<m.liCount
                LOOP && Sko na dal dek
             ENDIF
          ENDIF



          IF m.llCLS AND !m.llPRC AND m.llDOC
             lcXXDESCcls=m.lcXXDESCcls+m.lcXXDESCB && Pak piti buffer do obsahu detailniho popisu
             lcXXDESCB="" && Vyisti mezibuffer
          ENDIF


          * Je-li tda, a je konec tdy nebo zatek procedury/metody
          IF m.llCLS AND (BITTEST(m.Flags,13) OR BITTEST(m.Flags,2) OR BITTEST(m.Flags,3)) AND !EMPTY(m.lcXXDesccls)
             REPL XXDESC WITH m.lcXXDesccls IN (m.lcAOBJ)
             STORE "" TO lcXXDESCcls,lcXXDESCB && Vyisti buffery
          ENDIF

          * Je-li to zatek definice tdy, nebo konec procedury, nebo zatek procedury/metody a byla procedura/metoda
          IF (BITTEST(m.Flags,11) OR BITTEST(m.Flags,12) OR BITTEST(m.Flags,2) OR BITTEST(m.Flags,3) OR m.XX101=m.liCount) AND m.llPRC
             * Pak to zapi do (lcAPRC), pokud je co


*!*	      liDD=m.loPDM.IncludeDD
*!*	      liODD=m.loObj.IncludeDD
*!*	      llDD_S=m.liDD=_EDD_Signed
*!*	      lcDD_S=UPPER(ALLT(m.loPDM.IncludeDD_S))
*!*	      lcDOCS=UPPER(ALLT(m.loPDM.DD_START))
*!*	      lcDOCE=UPPER(ALLT(m.loPDM.DD_STOP))
*!*	      llOC=m.loPDM.OnlyComment=_DD_OC_Yes

*!*	liDD=m.loPDM.IncludeDD && Include Description - global
*!*	liODD=m.loObj.IncludeDD && Include Description - local
*!*	llDD_S=m.liDD=_EDD_Signed && Include Description - global signed
*!*	lcDD_S=UPPER(ALLT(m.loPDM.IncludeDD_S))
*!*	lcDOCS=UPPER(ALLT(m.loPDM.DD_START))
*!*	lcDOCE=UPPER(ALLT(m.loPDM.DD_STOP))

* liSC=m.loPDM.IncludeSC && Include Code - Global
* liOSC=m.loObj.IncludeSC && Include Code - Local
* llSC_S=m.liSC=_ESC_Signed && Include Code - Global Signed
* lcSC_S=UPPER(ALLT(m.loPDM.IncludeSC_S))
   
* llSC=liSC=_ESC_Include OR m.llSC_S OR m.liSC=_ESC_User AND (m.liOSC=_SC_Include OR m.liOSC=_SC_Signed)
* llDD=liDD=_EDD_Include OR m.llDD_S OR m.liDD=_EDD_User AND (m.liODD=_DD_Include OR m.liODD=_DD_Signed)

* m.liSC=_ESC_Include
* m.llSC_S
* m.llPRCPMP
* m.liSC=_ESC_User
* m.liOSC=_SC_Include
* m.liOSC=_SC_Signed


*!*	liCFlags=IIF(LEN(m.lcSC_S)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcSC_S)))==m.lcSC_S,1,;
*!*	         IIF(LEN(m.lcDD_S)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDD_S)))==m.lcDD_S,2,;
*!*	         IIF(LEN(m.lcDOCS)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDOCS)))==m.lcDOCS,4,;
*!*	         IIF(LEN(m.lcDOCE)>0 AND UPPER(SUBS(m.lcRESERVED7,m.liz,LEN(m.lcDOCE)))==m.lcDOCE,8,0))))

*!*	llPRCPMP=IIF(m.liCFlags=1,.T.,m.llPRCPMP)
*!*	llPRCDOC=IIF(m.liCFlags=2,.T.,m.llPRCDOC)

             IF !EMPTY(m.lcXXSC) AND (m.liSC=_ESC_Include OR m.llSC_S AND m.llPRCPMP OR m.liSC=_ESC_User AND (m.liOSC=_SC_Include OR m.liOSC=_SC_Signed AND m.llPRCPMP))
                m.lcXXSC=STRTRAN(m.lcXXSC,CHR(9),SPACE(m.loPDM.TabSize))
                IF m.llByRow
                   lcPom=""
                   =ALINES(laXXMI,m.XXMI)
                   =ALINES(laXXMC,m.XXMC)
                   FOR lii=1 TO ALINES(laRowsX,m.lcXXSC)
                       lcPom=m.lcPom+m.loPDM._Row2xhtml(laRowsX(m.lii),SUBST(m.lcMeta,m.lii,1),IIF(LEN(m.XXMI)>0,laXXMI(m.lii),""),IIF(LEN(m.XXMC)>0,laXXMC(m.lii),""))+;
                             IIF(m.loPDM.aCF(1,1).AddedEnterByRow,"",CRLF)
                   NEXT
                   lcPom=m.loPDM._Codes2xhtml(@m.lcPom)
                ELSE
                   lcPom=m.loPDM._Code2xhtml(@m.lcXXSC,@m.lcMeta,@m.XXMI,@m.XXMC)
                ENDIF
                IF liAnch>0
                   FOR lii=1 TO m.liAnch
                       m.liy=AT(laAnch(m.lii,1),m.lcPom)
                       m.lcPom=STUFF(m.lcPom,m.liy,LEN(laAnch(m.lii,1)),laAnch(m.lii,2))
                   NEXT
                   liAnch=0
                ENDIF

                REPL XXSC WITH m.lcPom, XXSCN WITH m.lcXXSCN,;
                     XXMI WITH m.XXMI, XXMC WITH m.XXMC IN (m.lcAPRC)
             ENDIF

             loPIPar.lLNK=.F.
             IF (m.liDD=_EDD_Include OR m.llDD_S AND m.llPRCDOC OR m.liDD=_EDD_User AND (m.liODD=_DD_Include OR m.liODD=_DD_Signed AND m.llPRCDOC))
                IF m.loPDM.iDIAMP=0
                   lcXXDesc=IIF(EMPTY(m.lcXXDESC),"",;
                               '<div class="DIAMP">'+CRLF+"  "+IIF(m.loPDM.SyntaxColoring=0,"",m.loPDM.aCF(1).GetTag("Comment",_PDM_SC_BT))+CRLF+;
                            STRTRAN(StrTranHTMLString(@m.lcXXDESC),CRLF,"<br />")+CRLF+"  "+IIF(m.loPDM.SyntaxColoring=0,"",m.loPDM.aCF(1).GetTag("Comment",_PDM_SC_ET))+CRLF+"</div>"+CRLF)
                ELSE
                   SELE (m.lcAPRC)
                   SCATTER NAME m.loPIPar.Ram MEMO
                   loPIPar.Ram.XXDESC=m.lcXXDesc
                   loPIPar.FileGroup=IIF(m.XX101P<1 AND m.XX101C<1,_PDM_FG_Proced,_PDM_FG_Method)

                   lcPom=EVAL(m.lcAOBJ+".OBJNAME")
                   IF LEN(m.lcPom)>0
                      liy=RECNO(m.lcAOBJ)
                      lii=EVAL(m.lcAOBJ+".XX101C")
                      IF SEEK(BINTOC(m.lii),m.lcAOBJ,"I00")
                         lcPom=EVAL(m.lcAOBJ+".OBJNAME")
                      ENDIF
                      GO (liy) IN (m.lcAOBJ)
                      lcPom=lcPom+"."+loPIPar.Ram.ObjName
                   ENDIF
                   lii=RAT(".",lcPom)
                   IF lii=0
                      loPIPar.cParent=""
                      loPIPar.cPEM=loPIPar.Ram.ObjName
                   ELSE
                      loPIPar.cParent=LEFT(lcPom,lii-1)
                      loPIPar.cPEM=SUBST(lcPom,lii+1)
                   ENDIF

                   STORE "" TO lcPom,m.XXDescF
                   FOR lii=1 TO m.loPDM.iDIAMP
                       lcPom=m.lcPom+m.loPDM.aDIAMP(m.lii,1).Run(@m.loPIPar,m.loPDM.aDIAMP(m.lii,2))
                       m.XXDescF=m.XXDescF+m.loPIPar.xhtmlFooter
                   NEXT
                   lcXXDesc=m.lcPom+IIF(LEN(m.lcPom)=0,"",CRLF)
                ENDIF
                IF !EMPTY(m.lcXXDesc)
                   REPL XXDESC WITH m.lcXXDesc,XXDESCF WITH m.XXDescF IN (m.lcAPRC)
                ENDIF
             ENDIF

             REPL XX001 WITH IIF(!BITTEST(m.XX001,_PDM_MF_bLNKS) AND loPIPar.lLNK,BITSET(m.XX001,_PDM_MF_bLNKS),m.XX001) IN (m.lcAPRC)

*m.liDD=_EDD_Include 
*m.llDD_S
*m.llPRCDOC
*m.liDD=_EDD_User
*m.liODD=_DD_Include
*m.liODD=_DD_Signed


             STORE "" TO lcXXSC,lcXXSCN,lcXXSCB,lcXXDESC,lcXXDESCB,lcMeta,m.XXMI,m.XXMC && Vyisti buffery
             m.liAnch=0
          ENDIF

          DO CASE
             CASE llIgnoreXXX

                  * Je to tda
             CASE BITTEST(m.Flags,11)
                  =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valClassIP),"%name%",m.OBJNAME))
                  IF !EMPTY(m.CLASSLOC)
                     IF AT(".FXP",UPPER(m.CLASSLOC))>0
                        m.CLASSLOC=ChangeExtensionFromFile(m.CLASSLOC,"PRG")
                     ENDIF
                  ELSE

                     lcPom=UPPER(m.Class)
                     IF (AT(".PRG",UPPER(m.loObj.File))>0 OR AT(".DBC",UPPER(m.loObj.File))>0 OR AT(".MNX",UPPER(m.loObj.File))>0) AND ;
                        !(m.lcPom=="CHECKBOX" OR m.lcPom=="COLLECTION" OR m.lcPom=="COLUMN" OR;
                         m.lcPom=="COMBOBOX" OR m.lcPom=="COMMANDBUTTON" OR m.lcPom=="COMMANDGROUP" OR;
                         m.lcPom=="CONTAINER" OR m.lcPom=="CONTROL" OR m.lcPom=="CURSOR" OR;
                         m.lcPom=="CURSORADAPTER" OR m.lcPom=="CUSTOM" OR m.lcPom=="DATAENVIRONMENT" OR;
                         m.lcPom=="EDITBOX" OR m.lcPom=="EXCEPTION" OR m.lcPom=="FORM" OR;
                         m.lcPom=="FORMSET" OR m.lcPom=="GRID" OR m.lcPom=="HEADER" OR;
                         m.lcPom=="HYPERLINK" OR m.lcPom=="IMAGE" OR m.lcPom=="LABEL" OR;
                         m.lcPom=="LINE" OR m.lcPom=="LISTBOX" OR m.lcPom=="OLECONTROL" OR;
                         m.lcPom=="OLEBOUNDCONTROL" OR m.lcPom=="OPTIONBUTTON" OR m.lcPom=="OPTIONGROUP" OR;
                         m.lcPom=="PAGE" OR m.lcPom=="PAGEFRAME" OR m.lcPom=="PROJECTHOOK" OR;
                         m.lcPom=="RELATION" OR m.lcPom=="SEPARATOR" OR m.lcPom=="SHAPE" OR;
                         m.lcPom=="SESSION" OR m.lcPom=="SPINNER" OR m.lcPom=="TEXTBOX" OR;
                         m.lcPom=="TIMER" OR m.lcPom=="TOOLBAR" OR m.lcPom=="XMLADAPTER" OR;
                         m.lcPom=="XMLTABLE" OR m.lcPom=="XMLFIELD")
                        
                        m.CLASSLOC=ExtractFileFromFile(m.loObj.File)
                     ENDIF
                  ENDIF
                  STORE 0 TO m.XX101P,m.XX101C,m.Inherited && Je to tda
                  STORE .F. TO llPRC,llDOC && Resetuj pznak tla metody
                  llCLS=.T.
                  * v m.OBJNAME je jej nzev
                  m.XX100R=RECC(m.lcAOBJ)+1
                  INSERT INTO (m.lcAOBJ) FROM MEMVAR && zalo vtu do pomocnho kurzoru
                  STORE m.XX101 TO m.XX101P,m.XX101C
                  LOOP && Sko na dal dek

                  * Je to konec tdy
             CASE BITTEST(m.Flags,13)
                  STORE .F. TO llPRC,llDOC,llCLS && Resetuj pznak tla metody
                  * Je
                  STORE -1 TO m.XX101P,m.XX101C
                  LOOP && Pak sko na dal dek

                  * Je to konec procedury
             CASE BITTEST(m.Flags,12)
                  STORE .F. TO llPRC,llDOC && Resetuj pznak tla metody
                  REPLACE XXCNTA WITH m.liXXCNTA, XXCNTC WITH m.liXXCNTC, XXCNTE WITH m.liXXCNTE,;
                          XXSIZEA WITH m.liXXSIZEA, XXSIZEC WITH m.liXXSIZEC, XXSIZEE WITH m.liXXSIZEE IN (m.lcAPRC)
                  LOOP && A sko na dal vtu

                  * Je to procedura/funkce
             CASE BITTEST(m.Flags,2) OR BITTEST(m.Flags,3)
                  * v m.OBJNAME je jej nzev
                  STORE .T. TO llPRC && Nastav pznak tla metody/procedury
                  STORE .F. TO llPRCPMP,llDOC,llPRCDOC && Zru pznak zpracovn metody/procedury a detainiho popisu
                  STORE 0 TO m.liXXCNTA, m.liXXCNTC, m.liXXCNTE, m.liXXSIZEA, m.liXXSIZEC, m.liXXSIZEE 

                  =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(IIF(m.liPCOUNT=5 OR m.XX101C=0,_PDM_valMethodIP,_PDM_valProcedureIP)),"%name%",m.OBJNAME))
                  
                  m.OBJNAME=IIF(m.liPCOUNT=5,m.lcOBJNAME,"")+m.OBJNAME
                  m.XX000=IIF(OCCURS(".",m.OBJNAME)=IIF(EMPTY(m.lcOBJNAME),0,1),1,0)
                  llFound=.F.
                  IF m.liPCOUNT=5 && Pokud provd analzu SC z VCX/SCX
                     m.XX101P=IIF(m.XX000=1,m.liXX101P,m.XX101C)
                     * Pak mus nejdve metodu najt (mla by tam bt)
                     SELE (m.lcAPRC)
                     =SEEK(BINTOC(m.XX101P))
                     LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                     llFound=FOUND()
                  ENDIF

                  IF m.llFound
                     REPL XX101 WITH m.XX101
                  ELSE
                     m.Inherited=IIF(m.XX101C=m.XX101P AND m.liPCOUNT=5,1,0)
                     m.XX100R=RECC(m.lcAPRC)+1
                     INSERT INTO (m.lcAPRC) FROM MEMVAR && zalo vtu do pomocnho kurzoru
                  ENDIF
                  STORE 0 TO m.XX000,m.XX001,liRowh
                  STORE "" TO lcXXSC,lcXXSCN,lcXXDESC,lcXXDESCB && Vyisti buffer
                  lcXXSCB=IIF(EMPTY(m.Params),"","LPARAMETERS "+m.Params+CRLF)
                  m.XX101L=m.XX101
                  llAddSpace=.T.
                  LOOP && Pak sko na dal vtu

             CASE BITTEST(m.Flags,4) OR BITTEST(m.Flags,6) && Je to seznam vlastnost/matic
                  m.Value=""
                  * A pak to parsuj na nzvy vlastnost
                  STORE 1 TO liy,lii && Nastav potek
                  DO WHILE m.liy>0
                     * Najdi oddlova
                     liy=FindMDSC(@m.Params,",",m.lii)
                     m.OBJNAME=CHRTRAN(IIF(m.liy=0,SUBST(m.Params,m.lii),;
                                  IIF(m.lii=1,LEFT(m.Params,m.liy-1),SUBST(m.Params,m.lii,m.liy-m.lii));
                                  )," "+CHR(9),"")

                     lii=m.liy+1
                     IF !EMPTY(m.OBJNAME)
                        * Nejdve mus otestovat, zda tam ona vlastnost existuje
                        * Pokud ne, pak ji zalo

                        lia=ATC("(",m.OBJNAME)
                        lia=IIF(lia=0,ATC("[",m.OBJNAME),m.lia)

                        SELE (m.lcAPROPS)
                        IF m.lia=0 OR m.lia>0 AND loPDM.Array_RemoveCells=0
                           =SEEK(BINTOC(m.XX101P))
                           LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                           IF !FOUND()
                              m.XX100R=RECC()+1
                              INSERT INTO (m.lcAPROPS) FROM MEMVAR
                              m.RESERVED7="" && Vyma poznmku (bude jen u prvn vlastnosti)
                           ELSE
                              IF BITTEST(m.Flags,0) OR BITTEST(m.Flags,1)
                                 REPL FLAGS WITH BITSET(FLAGS,IIF(BITTEST(m.Flags,0),0,1))
                              ENDIF
                           ENDIF
                        ENDIF

                        IF loPDM.Array_AddAsProperty=1 AND m.lia>0
                           m.OBJNAME=LEFT(m.OBJNAME,m.lia-1)
                           =SEEK(BINTOC(m.XX101P))
                           LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                           IF !FOUND()
                              m.XX100R=RECC()+1
                              INSERT INTO (m.lcAPROPS) FROM MEMVAR
                           ENDIF
                        ENDIF
                     ENDIF
                  ENDDO
                  LOOP

                  * Je to objekt
             CASE BITTEST(m.Flags,5) && Je to definice objektu
                  * Test na objekt - ADD OBJExCT [PROTxECTED/HIDDxEN] name AS class [NOINxIT] [WITH left=5, top=1,...]

                  * m.OBJNAME  obsahuje nzev objektu
                  * m.Class  obsahuje nzev tdy
                  * m.Flags  obsahuje pznaky
                  * m.Params obsahuje seznam vlastnost

                  =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valObjectIP),"%name%",m.OBJNAME ) )

                  * Zalo vtu do tabulky objekt
                  m.XX000=1 && Znm rove (XX101 udv definici objektu, xx101x pak id tdy)
                  m.XX100R=RECC(m.lcAOBJ)+1

                  INSERT INTO (m.lcAOBJ) FROM MEMVAR
                  IF !EMPTY(m.Params) && Pokud m seznam vlastnost
                     liXX101X_X=m.XX101P && Zapamatuj si to
                     m.XX101P=m.XX101
                     m.Value=""
                     m.RESERVED7="" && Vyma poznmku (u vech vlastnost)
                     lcName=m.OBJNAME && Zapamatuj si nzev tdy

                     SELE (m.lcAPROPS)

                     * A pak to parsuj na nzvy vlastnost
                     STORE 1 TO liy,lii && Nastav potek
                     DO WHILE m.liy>0
                        * Najdi oddlova
                        liy=FindMDSC(@m.Params,",",m.lii)
                        m.OBJNAME=ALLT(IIF(m.liy=0,SUBST(m.Params,m.lii),;
                                     IIF(m.lii=1,LEFT(m.Params,m.liy-1),SUBST(m.Params,m.lii+1,m.liy-m.lii-1));
                                     ))

                        lii=m.liy+1
                        IF !EMPTY(m.OBJNAME)
                           * Nejdve mus otestovat, zda tam ona vlastnost existuje
                           * Pokud ne, pak ji zalo
                           liz=AT("=",m.OBJNAME)
                           m.Value=ALLT(SUBST(m.OBJNAME,m.liz+1))
                           m.OBJNAME=m.lcName+"."+ALLT(LEFT(m.OBJNAME,m.liz-1))

                           lia=ATC("(",m.OBJNAME)
                           lia=IIF(lia=0,ATC("[",m.OBJNAME),m.lia)

                           IF m.lia=0 OR m.lia>0 AND loPDM.Array_RemoveCells=0
                              =SEEK(BINTOC(m.XX101P))
                              LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                              IF !FOUND()
                                 m.XX100R=RECC()+1
                                 INSERT INTO (m.lcAPROPS) FROM MEMVAR
                              ENDIF
                           ENDIF

                           IF loPDM.Array_AddAsProperty=1 AND m.lia>0
                              m.OBJNAME=LEFT(m.OBJNAME,m.lia-1)
                              =SEEK(BINTOC(m.XX101P))
                              LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                              IF !FOUND()
                                  m.XX100R=RECC()+1
                                 INSERT INTO (m.lcAPROPS) FROM MEMVAR
                              ENDIF
                           ENDIF
                        ENDIF
                     ENDDO
                     m.XX101P=m.liXX101X_X && Vra to nazptek
                  ENDIF
                  m.XX000=0
                  LOOP

                  * Je-li definovna tda a nen to tlo procedury/metody
                  * Pak se jedn (mon o piazen hodnoty do vlastnosti)
             CASE m.Flags=0 AND m.XX101C>-1 AND !m.llPRC AND !EMPTY(m.lcLine)
                  m.Value=""

                  lii=AT("=",m.lcPom)
                  m.OBJNAME=CHRTRAN(LEFT(m.lcPom,m.lii-1)," "+CHR(9),"")

                  lia=ATC("(",m.OBJNAME)
                  lia=IIF(lia=0,ATC("[",m.OBJNAME),m.lia)

                  SELE (m.lcAPROPS)
                  =SEEK(BINTOC(m.XX101P))

                  IF m.lia=0 OR m.lia>0 AND loPDM.Array_RemoveCells=0
                     m.Value=ALLT(SUBST(m.lcPom,m.lii+1))
                     * Nejdve mus otestovat, zda tam ona vlastnost existuje
                     * Pokud ne, pak ji zalo
                     LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                     IF !FOUND()
                        m.XX100R=RECC()+1
                        INSERT INTO (m.lcAPROPS) FROM MEMVAR
                     ELSE
                        REPLACE Value WITH m.Value
                        IF !EMPTY(m.RESERVED7)
                           REPLACE RESERVED7 WITH m.RESERVED7
                        ENDIF
                     ENDIF
                  ENDIF

                  IF loPDM.Array_AddAsProperty=1 AND m.lia>0
                     m.OBJNAME=LEFT(m.OBJNAME,m.lia-1)
                     =SEEK(BINTOC(m.XX101P))
                     LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                     IF !FOUND()
                        m.XX100R=RECC()+1
                        INSERT INTO (m.lcAPROPS) FROM MEMVAR
                     ENDIF
                  ENDIF
                  LOOP

     
          ENDCASE
      NEXT

      RETURN
   ENDPROC


   PROCEDURE Analyse_FLL(loObj,loDump) && Provede analzu DUMP objektu
      * loObj  - Odkaz na objekt s informacema pro zpracovn
      *@loDump - Dump objekt

      LOCAL lcAPRC,lcPom,lcName,lii,;
            m.XX101,m.OBJNAME, m.XX000,;
            m.Flags,m.RESERVED7,m.XX001,m.Inherited,m.XXDescF,;
            m.Params,m.XX101P,m.XX100R,m.XX101C,;
            m.loPDM,m.loPDMs,;
            liDD,liODD,llDD_S,llPRCDOC,loPIPar,loFN

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      * Nejdve provedu analzu PRG soubou
      * Jako prvn budu hledat definici td
      * a potom definici procedur a funkc
      * a na konec piazen hodnot vlastnostem

      lcAPRC=m.This.APRC && Alias tabulky procedur

      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.loObj.File
      loPIPar.oPDMx=m.loObj
      loPIPar.Type="DIAMP"
      loPIPar.oPDMx=loObj
    
      STORE -1 TO m.XX101P,m.XX101C
      STORE 0 TO m.XX000,m.XX001,m.Inherited
      STORE "" TO m.RESERVED7,m.Params,m.XXSC
      m.Flags=BITSET(0,3)
      
      liDD=m.loPDM.IncludeDD
      llDD_S=m.liDD=_EDD_Signed
      liODD=m.loObj.IncludeDD
      llPRCDOC=.T.

      FOR m.XX101=1 TO IIF(loDump.iFoxTable>0 AND loDump.aFoxTable(_aFT_Count)>0,loDump.aFoxTable(_aFT_Count),0)
          loFN=loDump.aFoxInfo(m.XX101)
          m.OBJNAME=loFN.cFuncName
          STORE "" TO m.XXDesc,m.XXDescF

          =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valProcedureIP),"%name%",m.OBJNAME))
          m.XX100R=RECC(m.lcAPRC)+1
          INSERT INTO (m.lcAPRC) FROM MEMVAR && zalo vtu do pomocnho kurzoru

          loPIPar.lLNK=.F.
          IF m.loPDM.iDIAMP>0 AND ;
             (m.liDD=_EDD_Include OR m.llDD_S AND m.llPRCDOC OR m.liDD=_EDD_User AND (m.liODD=_DD_Include OR m.liODD=_DD_Signed AND m.llPRCDOC))

             SELE (m.lcAPRC)
             SCATTER NAME m.loPIPar.Ram MEMO
             loPIPar.Ram.XXDESC=m.XXDesc
             loPIPar.FileGroup=_PDM_FG_Proced
             loPIPar.cParent=""
             loPIPar.cPEM=loPIPar.Ram.ObjName

             STORE "" TO lcPom,m.XXDescF
             FOR lii=1 TO m.loPDM.iDIAMP
                 lcPom=m.lcPom+m.loPDM.aDIAMP(m.lii,1).Run(@m.loPIPar,m.loPDM.aDIAMP(m.lii,2))
                 m.XXDescF=m.XXDescF+m.loPIPar.xhtmlFooter
             NEXT
             m.XXDesc=m.lcPom+IIF(LEN(m.lcPom)=0,"",CRLF)
          ENDIF

          REPL XXDESC WITH m.XXDesc, ;
               XXDESCF WITH m.XXDescF,;
               XX001 WITH IIF(!BITTEST(m.XX001,_PDM_MF_bLNKS) AND loPIPar.lLNK,BITSET(m.XX001,_PDM_MF_bLNKS),m.XX001) IN (m.lcAPRC)
      NEXT
      RETURN
   ENDPROC


   PROCEDURE RepairObjectHierarchy(loObj) && Oprav objektovou/tdn hierarchii
      * loObj  - Odkaz na objekt s informacema pro zpracovn
      LOCAL lcAPRC,lcAPROPS,lcAOBJ,liy,lcAlias,lcACLS,m.loPDM,m.Class,m.RESERVED7,m.Flags,m.XX000,liRecno,m.XX101,;
            m.XX101P,lii,liz,m.OBJNAME,m.XX101C,lcTable,lcOBJNAME,m.XX100R,lcFile,m.loPDMs,lcPom,lcValue,loPIPar,lcXXI03
      LOCAL ARRAY laFields(1)


      m.loPDM=EVAL(m.This.PDM) && Zskej odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      =m.loPDMs.WriteDMSG(m.loPDMs.GetString(_PDM_valRepairOHPI))

      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.loObj.File
      loPIPar.Type="DCOP"
      loPIPar.oPDMx=m.loObj
      loPIPar.oASC=m.This
      loPIPar.FileGroup=_PDM_FG_None
      FOR lii=1 TO m.loPDM.iDCOP
          =m.loPDM.aDCOP(lii,1).Run(@m.loPIPar,m.loPDM.aDCOP(lii,2))
      NEXT


      lcAPRC=m.This.APRC && Alias tabulky procedur
      lcAPROPS=m.This.APROPS && Alias tabulky vlastnost
      lcAOBJ=m.This.AOBJ && Alias tabulky tdy/objekt
      lcAlias=SYS(2015)
      lcACLS=SYS(2015)
      lcTable=GetTempPathEx()+m.lcAlias
      lcFile=m.loObj.File

      GO TOP IN(m.lcAOBJ)
      IF EOF(m.lcAOBJ) && Pokud tam nic nen, pak vypadni
         RETURN
      ENDIF

      SET COLLATE TO "MACHINE"

      ***************************************************************
      * Oprava objektov hierarchie ve vlastnostech
      ***************************************************************
      SELE (m.lcAPROPS)
      INDEX ON LEFT(OBJNAME,230) TAG I05 ADDITIVE

      SCAN ALL FOR OCCURS(".",OBJNAME)>0 AND UPPER(SUBST(OBJNAME,RAT(".",OBJNAME)+1))=="NAME"
           liRecno=RECNO()
           lcPom=LEFT(OBJNAME,RAT(".",OBJNAME)-1) && Nzev objektu (cel cesta)
           lii=OCCURS(".",OBJNAME)
           lcValue=EVAL(VALUE)
           IF !UPPER(IIF(m.lii=1,m.lcPom,SUBST(m.lcPom,RAT(".",m.lcPom)+1)))==UPPER(m.lcValue) && Jmna jsou rozdln
              LOCATE FOR LEFT(OBJNAME,LEN(m.lcPom)+1)==m.lcPom+"."
              DO WHILE FOUND()
                 REPL OBJNAME WITH IIF(m.lii=1,m.lcValue,LEFT(OBJNAME,AT(".",m.lcPom,lii-1))+m.lcValue)+SUBST(OBJNAME,AT(".",OBJNAME,m.lii))
*                 LOCATE FOR LEFT(OBJNAME,LEN(m.lcPom)+1)==m.lcPom+"."
                 CONTINUE
              ENDDO
              GO (m.liRecno)
           ENDIF
      ENDSCAN
      SET ORDER TO "I01" IN (m.lcAPROPS)
      DELETE TAG I05

      ***************************************************************
      * Oprava objektov hierarchie
      ***************************************************************
      * Pak mus z metod a vlastnost nast seznam objekt
      * a pokud nebude v seznamu objekt existovat, pak se zalo vta se jmnem, bez znalosti tdy

      SELE (lcAOBJ) && Sko na seznam objekt
      SET ORDER TO 
      REPL XXI03 WITH PADL(SYS(2007,UPPER(OBJNAME)),6) ALL
      GO BOTTOM
      liy=XX101
      INDEX ON BINTOC(XX101C)+XXI03 TAG I03 ADDITIVE
*      INDEX ON BINTOC(XX101C) TAG I03 ADDITIVE
      lcOBJNAME=""

      IF m.loPDMs.VFPVers<="7"
         SELECT AA.XX101C, AA.XX100R, AA.OBJNAME, OCCURS(".",AA.OBJNAME) AS XX000,"M" AS XX010 ;
                FROM (m.lcAPRC) AA ;
                WHERE AA.XX000=0 AND AT(".",AA.OBJNAME)>0;
           UNION;
         SELECT AB.XX101C, AB.XX100R, AB.OBJNAME, OCCURS(".",AB.OBJNAME) AS XX000,"P" AS XX010 ;
                FROM (m.lcAPROPS) AB ;
                WHERE AB.XX000=0 AND AT(".",AB.OBJNAME)>0;
           INTO TABLE (m.lcTable)
      ELSE
         SELECT AA.XX101C, AA.XX100R, LEFT(AA.OBJNAME,254) AS OBJNAME, OCCURS(".",AA.OBJNAME) AS XX000,"M" AS XX010 ;
                FROM (m.lcAPRC) AA ;
                WHERE AA.XX000=0 AND AT(".",AA.OBJNAME)>0;
           UNION;
         SELECT AB.XX101C, AB.XX100R, LEFT(AB.OBJNAME,254) AS OBJNAME, OCCURS(".",AB.OBJNAME) AS XX000,"P" AS XX010 ;
                FROM (m.lcAPROPS) AB ;
                WHERE AB.XX000=0 AND AT(".",AB.OBJNAME)>0;
           INTO TABLE (m.lcTable)
      ENDIF

      SELE (lcAlias) && Sko na seznam monch objekt
      INDEX ON BINTOC(XX101C)+STR(XX000,11) TAG I01 DESC

      SELECT AA.OBJNAME, AA.XX101 ;
             FROM (m.lcAOBJ) AA  ;
             WHERE AA.XX101P=0;
             INTO CURSOR (m.lcACLS)

      STORE "" TO m.Class,m.RESERVED7 && Resetuj hodnoty
      STORE 0 TO m.Flags,m.XX000,m.XX101P

      * Doplnn objektov hierarchie
      SELE (m.lcACLS) && Sko na kurzor td
      SCAN ALL
           STORE XX101 TO m.XX101C &&  Potek definice tdy
           SELE (m.lcAlias) && Sko na seznam monch objekt
           SET KEY TO BINTOC(m.XX101C) && Nastav masku dle tdy
           GO TOP && Sko na zatek
           liz=XX000 && Maximln vnoen objekt
           m.OBJNAME="" && Reset for every class
           
           FOR m.lii=1 TO m.liz
               * Jen ty vty pro konkrtn vnoen
               =SEEK(BINTOC(m.XX101C))
               SCAN WHILE BINTOC(XX101C)=BINTOC(m.XX101C) FOR XX000>=lii AND !m.OBJNAME==LEFT(OBJNAME,AT(".",OBJNAME,m.lii)-1)
                    STORE LEFT(OBJNAME,AT(".",OBJNAME,m.lii)-1) TO m.OBJNAME
                    lcXXI03=PADL(SYS(2007,UPPER(m.OBJNAME)),6)
                    SELE (m.lcAOBJ) && Sko na seznam objekt
                    =SEEK(BINTOC(m.XX101C)+lcXXI03) &&
*???????????
*                    LOCATE WHILE BINTOC(XX101C)=BINTOC(m.XX101C) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                    LOCATE WHILE BINTOC(XX101C)+XXI03=BINTOC(m.XX101C)+lcXXI03 FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                    IF !FOUND() && Pokud neexistuje
                       STORE m.liy+1 TO m.XX101,liy
                       INSERT INTO (m.lcAOBJ) (XX101C,XX101,OBJNAME,XX100R,XXI03) ;
                              VALUES ;
                               (m.XX101C,m.XX101,m.OBJNAME,RECC(m.lcAOBJ)+1,PADL(SYS(2007,UPPER(m.OBJNAME)),6)) && Pak ji pidej
                    ENDIF
                    SELE (m.lcAlias) && Sko na seznam monch objekt
               ENDSCAN   
           NEXT
           SELE (m.lcACLS) && Sko na kurzor td
      ENDSCAN

      SELE (m.lcAOBJ) && Sko na seznam objekt
      INDEX ON BINTOC(XX100R) TAG I04 ADDITIVE
      SET ORDER TO "I03"
      
      SELE (m.lcAPRC)
      INDEX ON BINTOC(XX100R) TAG I04 ADDITIVE

      SELE (m.lcAPROPS)
      INDEX ON BINTOC(XX100R) TAG I04 ADDITIVE


      * Bindovn vlastnost a metod
      SELE (m.lcACLS) && Sko na kurzor td
      SCAN ALL
           STORE XX101 TO m.XX101C &&  Potek definice tdy
           SELE (m.lcAlias) && Sko na seznam monch objekt
           SET KEY TO BINTOC(m.XX101C) && Nastav masku dle tdy
           GO TOP && Sko na zatek
           liz=XX000 && Maximln vnoen objekt
           lcOBJNAME="" && Reset for every class
           FOR m.lii=1 TO m.liz
               * Jen ty vty pro konkrtn vnoen
               SCAN FOR STR(XX000,11)=STR(m.lii,11)
                    m.OBJNAME=ALLT(LEFT(OBJNAME,AT(".",OBJNAME,m.lii)-1))
                    m.XX100R=XX100R
                    
                    IF !m.OBJNAME==m.lcOBJNAME
                       SELE (m.lcAOBJ) && Sko na seznam objekt
                       lcXXI03=PADL(SYS(2007,UPPER(m.OBJNAME)),6)
                       =SEEK(BINTOC(m.XX101C)+lcXXI03) && 
*????????????
*                       LOCATE WHILE BINTOC(XX101C)=BINTOC(m.XX101C) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                       LOCATE WHILE BINTOC(XX101C)+XXI03=BINTOC(m.XX101C)+lcXXI03 FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                       IF !FOUND() && Pokud neexistuje
                          m.loPDMs.WriteToLogFile(STRTRAN(STRTRAN(m.loPDMs.GetString(_PDM_msgCFOBJ),"%Obj%",m.OBJNAME),"%File%",m.lcFile))
                          SELE (m.lcAlias) && Sko na seznam monch objekt
                          LOOP
                       ELSE
                          m.XX101=XX101
                          SELE (m.lcAlias) && Sko na seznam monch objekt
                       ENDIF
                       lcOBJNAME=m.OBJNAME
                    ENDIF

                    =SEEK(BINTOC(m.XX100R),IIF(XX010="M",m.lcAPRC,m.lcAPROPS))
                    REPL XX101P WITH m.XX101,XX000 WITH EVAL(m.lcAlias+".XX000") IN (IIF(XX010="M",m.lcAPRC,m.lcAPROPS))
               ENDSCAN   
           NEXT
           SELE (m.lcACLS) && Sko na kurzor td
      ENDSCAN

      USE IN (m.lcAlias) && Uzavi pracovn tabulku
      DELE FILE (m.lcTable+".*") && Sma pracovn tabulku

      * Bindovn objekt
      SELECT AB.XX101C, AB.XX100R, AB.OBJNAME, OCCURS(".",AB.OBJNAME)+1 AS XX000 ;
             FROM (m.lcAOBJ) AB ;
             WHERE XX000=0 AND XX101C#0;
        INTO CURSOR (m.lcAlias)

      SELE (m.lcAlias) && Sko na seznam monch objekt
      INDEX ON BINTOC(XX101C)+STR(XX000,11) TAG I01 DESC

      SELE (m.lcACLS) && Sko na kurzor td
      SCAN ALL
           m.XX101C=XX101 &&  Potek definice tdy
           SELE (m.lcAlias) && Sko na seznam monch objekt
           SET KEY TO BINTOC(m.XX101C) && Nastav masku dle tdy
           GO TOP && Sko na zatek
           liz=XX000 && Maximln vnoen objekt
           FOR m.lii=m.liz TO 1 STEP -1
               * Jen ty vty pro konkrtn vnoen
               liy=IIF(m.lii=1,0,m.XX101C)
               SCAN FOR STR(XX000,11)=STR(m.lii,11)
                    m.XX100R=XX100R
                    m.OBJNAME=IIF(m.lii=1,ALLT(EVAL(m.lcACLS+".OBJNAME")),ALLT(LEFT(OBJNAME,AT(".",OBJNAME,m.lii-1)-1)))
                    SELE (m.lcAOBJ) && Sko na seznam objekt

                    lcXXI03=PADL(SYS(2007,UPPER(m.OBJNAME)),6)
                    SET KEY TO (BINTOC(m.liy)+lcXXI03) &&
                    GO TOP
*???????????????
                    LOCATE FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
*                    LOCATE WHILE BINTOC(XX101C)=BINTOC(liy) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                    SET KEY TO 
                    IF !FOUND() && Pokud neexistuje
                       m.loPDMs.WriteToLogFile(STRTRAN(STRTRAN(m.loPDMs.GetString(_PDM_msgCFOBJ),"%Obj%",m.OBJNAME),"%File%",m.lcFile))
                       SELE (m.lcAlias) && Sko na seznam monch objekt
                       LOOP
                    ENDIF
                    m.XX101=XX101

                    * Penastav jim XX101P dle m.XX101
                    =SEEK(BINTOC(m.XX100R),m.lcAOBJ,"I04")
                    REPL XX101P WITH m.XX101,XX000 WITH EVAL(m.lcAlias+".XX000")
                    SELE (m.lcAlias) && Sko na seznam monch objekt
               ENDSCAN   
           NEXT
           SELE (m.lcACLS) && Sko na kurzor td
      ENDSCAN

      USE IN (m.lcAlias) && Uzavi pomocn alias
      USE IN (m.lcACLS) && Uzavi pomocn alias

      SELE (m.lcAPRC)
      DELETE TAG I04

      SELE (lcAPROPS)
      DELETE TAG I04

      * Identifikace objektu zda je Inherited
      SELE (m.lcAOBJ)
      REPL Inherited WITH IIF(EMPTY(BASECLASS) AND EMPTY(CLASS),00,00)

    
      IF !m.loPDM.One AND m.loPDM.GCT.Generate=1
         * laFields
         =m.loPDM.AddFileToGCT()
         SELE (m.lcAOBJ)
         INDEX ON BINTOC(XX101) TAG I05 ADDITIVE

         SCAN FOR !CLASS==""
              SCATTER TO laFields FIELDS RESERVED4, OBJNAME, RESERVED7, XX000, CLASS, CLASSLOC, CLASS, BASECLASS, XX000, XX000 MEMO
              laFields(4)=IIF(laFields(4)>0 OR INLIST(UPPER(RIGHT(m.loObj.File,4)),".SCX",".FRX",".LBX"),1,0)
              IF laFields(4)=1 && Object - Add master object/clases 's name
                 laFields(1)=""

                 liRecno=RECNO()
                 lii=BINTOC(XX101C) && ID parent object
                 =SEEK(m.lii)
                 lcObjName=OBJNAME
                 laFields(2)=m.lcObjName+IIF(EMPTY(m.lcObjName),"",".")+laFields(2)
                 GO (m.liRecno)
              ENDIF
              laFields(6)=IIF(laFields(6)=="","",FULLPATH(laFields(6),m.loObj.File))
              laFields(7)=m.loObj.File
              =m.loPDM.AddRowToGCT(@laFields)
         ENDSCAN
         DELETE TAG I05
      ELSE
         SELE (lcAOBJ)
      ENDIF


      DELETE TAG I03
      DELETE TAG I04
      SET COLLATE TO (m.loPDMs.Collate)

      SET ORDER TO "I01" IN (m.lcAOBJ)
      SET ORDER TO "I01" IN (m.lcAPRC)
      SET ORDER TO "I01" IN (m.lcAPROPS)
      RETURN
   ENDPROC

   PROCEDURE AnalyzeProps(m.XX101C,liXX101P,lcOBJNAME,lcSC,lcPR,liType) && Projede seznam PROPERTIES/RESERVED3 a zalo seznam vlastnost/metod
      * m.XX101C  - ID tdy
      * liXX101P  - ID objektu/tdy
      * lcOBJNAME - 
      * lcSC      - Zdroj vlastnost
      * lcPR      - Seznam Protected/hidden vlastnost
      * liType    - Typ zdroje 0-Properties, 1-Reserved3
      LOCAL liCount,lii,lcAPROPS,liy,llFound,;
            m.XX101,m.OBJNAME,m.Class,m.CLASSLOC,;
            m.Flags,m.RESERVED7,m.Value,lcPom,lcAPRC,lcOBJNAME,;
            m.Params,m.XX000,m.XXSC,m.XX101P,m.XX100R_P,m.XX100R_M,m.loPDMs,m.Inherited

      LOCAL ARRAY laLines(1)
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      lcAPROPS=m.This.APROPS
      lcAPRC=m.This.APRC
      STORE "" TO m.Params,m.XXSC
      STORE 0 TO m.XX101,m.XX000
      m.Inherited=IIF(m.XX101C=liXX101P AND m.liType=0,1,0)

      m.XX100R_M=RECC(m.lcAPRC)
      m.XX100R_P=RECC(m.lcAPROPS)

      lcOBJNAME=m.lcOBJNAME+IIF(!EMPTY(m.lcOBJNAME),".","")
      liCount=ALINES(laLines,m.lcSC) && Nati dky

      SET COLLATE TO "MACHINE"
      IF m.liType=0 && Nastaven vlastnosti tdy/objektu
         m.Flags=0 && Pznaky vlastnosti
         SELE (m.lcAPROPS)
         SET ORDER TO "I02"
         FOR m.lii=1 TO m.liCount
             IF EMPTY(laLines(m.lii))
                LOOP
             ENDIF
             * Jmno, hodnota
             liy=AT("=",laLines(m.lii))
             m.OBJNAME=m.lcOBJNAME+RTRIM(LEFT(laLines(m.lii),m.liy-1)) && Nzev vlastnosti
             m.Value=LTRIM(SUBS(laLines(m.lii),m.liy+1)) && Hodnota vlastnosti

             m.XX000=IIF(OCCURS(".",m.OBJNAME)=IIF(EMPTY(m.lcOBJNAME),0,1),1,0)
             m.XX101P=IIF(m.XX000=1,m.liXX101P,m.XX101C)
             
             =SEEK(BINTOC(m.XX101P)+BINTOC(VAL(SYS(2007,m.OBJNAME)))) && Pokud tam je 
             llFound=.F.
             SCAN WHILE BINTOC(XX101P)=BINTOC(m.XX101P) AND BINTOC(SYS2007)=BINTOC(VAL(SYS(2007,m.OBJNAME)))
                  IF OBJNAME==m.OBJNAME
                     llFound=.T.
                     EXIT
                  ENDIF
             ENDSCAN
             IF m.llFound
                REPL Value WITH m.Value
             ELSE
                m.XX100R_P=m.XX100R_P+1
                INSERT INTO (m.lcAPROPS) (OBJNAME,XX101C,XX101P,XX000,FLAGS,VALUE,XX100R,SYS2007, INHERITED);
                       VALUES ;
                       (m.OBJNAME,m.XX101C,m.XX101P,m.XX000,m.FLAGS,m.VALUE,m.XX100R_P,VAL(SYS(2007,m.OBJNAME)),m.Inherited)  && Jinak ji zalo
             ENDIF
             SET FILT TO
         NEXT
         SET ORDER TO "I01"
      ELSE
         * Nov vlastnosti a metody tdy
         FOR m.lii=1 TO m.liCount
             IF EMPTY(laLines(m.lii))
                LOOP
             ENDIF
             * Pznak matice/metody(^/*), Jmno, komet,
             m.Flags=IIF(LEFT(laLines(m.lii),1)="*",BITSET(0,2),IIF(LEFT(laLines(m.lii),1)="^",BITSET(0,6),0))
             laLines(m.lii)=IIF(m.Flags#0,SUBS(laLines(m.lii),2),laLines(m.lii))
             liy=AT(" ",laLines(m.lii))
             m.OBJNAME=m.lcOBJNAME+IIF(m.liy=0,laLines(m.lii),RTRIM( LEFT(laLines(m.lii),m.liy-1))) && Nzev vlastnosti
             m.RESERVED7=IIF(m.liy=0,"",LTRIM(SUBST(laLines(m.lii),m.liy+1))) && Koment vlastnosti/metody

             lcPom=IIF(BITTEST(m.Flags,6),RTRIM(LEFT(m.OBJNAME,AT("[",m.OBJNAME)-1)),m.OBJNAME)

             * Nastav pznak Protected/Hidden
             m.Flags=IIF(AT(UPPER(m.lcPom)+CRLF,UPPER(m.lcPR))>0,BITSET(m.Flags,0),;
                     IIF(AT(UPPER(m.lcPom)+"^"+CRLF,UPPER(m.lcPR))>0,BITSET(m.Flags,1),m.Flags))

             m.XX000=IIF(OCCURS(".",m.OBJNAME)=IIF(EMPTY(m.lcOBJNAME),0,1),1,0)
             m.XX101P=IIF(m.XX000=1,liXX101P,m.XX101C)

             IF BITTEST(m.Flags,2) && Pozor, je to procedura
                m.XX100R_M=m.XX100R_M+1
                INSERT INTO (m.lcAPRC) (OBJNAME,XX101C,XX101P,XX000,FLAGS,RESERVED7,XX100R);
                       VALUES ;
                       (m.OBJNAME,m.XX101C,m.XX101P,m.XX000,m.FLAGS,m.RESERVED7,m.XX100R_M)  && Jinak ji zalo
             ELSE && Ne, jedn se o vlastnost
                m.XX100R_P=m.XX100R_P+1
                INSERT INTO (m.lcAPROPS) (OBJNAME,XX101C,XX101P,XX000,FLAGS,RESERVED7,XX100R,SYS2007);
                       VALUES ;
                       (m.OBJNAME,m.XX101C,m.XX101P,m.XX000,m.FLAGS,m.RESERVED7,m.XX100R_P,VAL(SYS(2007,m.OBJNAME)))  && Jinak ji zalo
             ENDIF
         NEXT
      ENDIF
      SET COLLATE TO (m.loPDMs.Collate)
   ENDPROC


   PROCEDURE GenerateObject(loObj,liXX101P,liLevel,lcOBJNAME,lcRecnoP,lcClassX,llSingle) && Vygeneruje HTML pro objektovou/tdn hierarchii
      * loObj     - Odkaz na objekt s informacema pro zpracovn
      * liXX101P  - ID parenta
      * liLevel   - Level vnoen
      * lcOBJNAME - Nzev objektu
      *@lcClassX  - Odkazy objekt pro hlaviku seznamu (Out)
      * llSingle  - Pznak jedn tdy bez objekt (pouze pro liLevel=0)
      LOCAL lcString,llFirst,lcMethods,lcMethodsH,lcProps,m.loPDM,;
            lcHead,lcObjectsH,lii,liCnt,lcOldOBJNAME,liy,lihFile,lcObjects,;
            lcAOBJ,lcAPROPS,lcAPRC,lcFile_d,lcPom,lcObjNX,lcRecno,lcRecnoX,luValueX,;
            liPRO,liOBJ,liMET,lcDisp,lcClass,lcClassLibF,lcClassLib,lcDir,lcFile,m.loPDMs,;
            lcHB,lcHE,lcHBf,lcSP,lcSP0,llEC_Meth,lcPict,lcScript,liz,lcPath,lcProp,lcIMG,llPicture,;
            llDBC,llDBF,lcCSS,lcJS,lcDIAMPCSS,lcDIAMPJS,luValue,lcSOFile,lix,llData,llMember,lcUProp,;
            loPIPar,lcDIAPCSS,lcDIAPJS,lihFilex,lcFile_dx,llPropA,lcDBC,lcTab,llNative,lcPropX,lcPomRel,;
            lcACT,lcPom2,lcPom3,lcDIACCSS,lcDIACJS,lcDIAC,llEx,lcDIAXF,lcDIAMPF,lcDirI,lcDIAC_cls,;
            lcDIAC_clsM,loFileLevel,liPFL,lcClassF,lcS2PM,llML,lcGUID,lcShortVal,lcHTMLVAL,lcRESERVED7,loRamCIPEM,m.SYS2007

      LOCAL ARRAY laObj(1),laObjX(1),laMember(3),laSO(1,1)
      m.loPDM=EVAL(m.This.PDM)
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      lihFile=m.This.hFile
      lcAOBJ=m.This.AOBJ
      lcAPROPS=m.This.APROPS
      lcAPRC=m.This.APRC

      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.loObj.File
      loPIPar.oPDMx=m.loObj

      SET COLLATE TO "MACHINE"
      SELE (m.lcAOBJ)
      SEEK (BINTOC(liXX101P))
      COUNT TO liCnt WHILE BINTOC(XX101P)=BINTOC(liXX101P)
      IF m.liCnt>0
         DIME laObj(m.liCnt,2)
         SEEK (BINTOC(m.liXX101P))
         lii=0
         SCAN WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
              lii=m.lii+1
              laObj(m.lii,1)=OBJNAME
              laObj(m.lii,2)=XX100R
         ENDSCAN
      ENDIF
      SET COLLATE TO (m.loPDMs.Collate)

      IF m.liCnt=0 && Pokud tam nic nen
         RETURN "" && Pak vypadni
      ENDIF
*debugout m.lcOBJNAME

      lcOldOBJNAME=m.lcOBJNAME
      =IIF(m.loObj.OL_Classes=1,ASORT(laOBJ),.T.) && Ordered? Yes/No

      llEC_Meth=m.loObj.aEC(_EC_Method,1)
      lcPict=m.loObj.aEC(_EC_Method,2)
      lcDisp=m.loObj.aEC(_EC_Method,3)

      lcPath=m.loPDM.OutDir+m.loObj.OutDir+"\"+m.loObj.FileName+"\"

      lcDir="../../" && Cesta ke sdlenm soubor
      lcDirI="../../imgs/" && Cesta ke sdlenm obrzkm
      lcFile=m.loObj.File

      SELE (m.lcAObj)


      lcSP=IIF(m.loPDM.FormatSpace=_Format_No,"",SPACE(m.liLevel))
      lcSP0=IIF(m.loPDM.FormatSpace=_Format_No,"",SPACE(m.liLevel))

      m.loPDM.GetGLCSS_JS(m.lcPath,m.loObj,@m.lcCSS,@m.lcJS)

      m.loPDM.GetPI_ENV("DIAMP",lcPath,@m.lcDIAMPCSS,@m.lcDIAMPJS)
      m.loPDM.GetPI_ENV("DIAP",lcPath,@m.lcDIAPCSS,@m.lcDIAPJS)
      m.loPDM.GetPI_ENV("DIAC",lcPath,@m.lcDIACCSS,@m.lcDIACJS)

      llFirst=.T.
      FOR m.lii=1 TO m.liCnt
          SELE (m.lcAOBJ)
          GO laObj(m.lii,2)
          lcRecno=LTRIM(STR(RECNO(),11))
          lcScript=""

          lcPom=CLASSLOC
          lcClassLibF=IIF(!EMPTY(m.lcPom),FULLPATH(m.lcPom,m.lcFile),"")
          lcClassF=CLASS

          IF m.liLevel=0
             STORE XX101 TO liXX101P
             STORE OBJNAME TO lcObjNX,lcOBJNAME
          ELSE
             STORE XX101 TO liXX101P
             STORE SUBS(OBJNAME,RAT(".",OBJNAME,1)+1) TO lcPom,lcObjNX
             lcOBJNAME=m.lcOldOBJNAME+"."+m.lcPom
          ENDIF


          =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valObjectIP),"%name%",lcObjName))

          ***************************************************
          * DIAC - Create Detail Description of Class/object
          ***************************************************
          loPIPar.Type="DIAC"
          loPIPar.FileGroup=IIF(m.liLevel=0,_PDM_FG_Class,_PDM_FG_Object)

          SCATTER NAME m.loPIPar.Ram MEMO
          loPIPar.cParent=lcOBJNAME
          loPIPar.cPEM=""
          loPIPar.lLNK=.F.

          STORE "" TO lcDIAC,lcDIAXF
          FOR liy=1 TO m.loPDM.iDIAC
              lcDIAC=m.lcDIAC+m.loPDM.aDIAC(m.liy,1).Run(@m.loPIPar,m.loPDM.aDIAC(m.liy,2))
              lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
          NEXT
          This.lLNK=m.This.lLNK OR loPIPar.lLNK
          llEx=LEN(m.lcDIAC)>0
          ***************************************************

          loFileLevel=m.loObj.oFileLevel

          IF m.liLevel=0
             * Pro zkladn rove je-li povoleno vce strnek, pak ji mus zaloit
             IF m.loObj.HTMLPage=_GSC_Multi
                m.This.lLNK=.F. && Resetuj pznak
                STORE m.This.preHTMLName+"cls."+LOWER(OBJNAME)+"."+ExtractExtensionFromFile(m.This.HTMLName) ;
                      TO lcFile_d,m.This.HTMLFileD

                STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,m.This.hFile

                IF m.lihFile<=0 && Pokud to selhalo
                   m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",m.lcPath+m.lcFile_d))
                   LOOP && Nepodailo se soubor otevt, pak sko na dal tdu
                ENDIF
                lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05148),"%name%",LOWER(OBJNAME)))+;
                         m.loPDMs.GetStyles(m.lcDir)+m.loPDM.GetSCCSS(m.lcPath)+;
                         m.lcDIAMPCSS+m.lcDIACCSS+m.lcCSS+;
                         m.loPDMs.AddExternalScript(m.lcDir+m.loPDMs.ExternJS)+;
                         m.lcDIAMPJS+m.lcDIACJS+m.lcJS+'</head>'+CRLF+'<body class="pbb_auto">'+CRLF
                =FWRITE(m.lihFile,m.lcString)
                SELE (m.lcAOBJ)
                IF m.llFirst AND EMPTY(m.This.FirstHTML)
                   m.This.FirstHTML=m.lcFile_D  && Zapi si prvn HTML soubor
                   m.This.FirstHTMLTitle=STRTRAN(m.loPDMs.aStrings(PDM_05148),"%name%",LOWER(OBJNAME))
                ENDIF
                IF ISNULL(m.loFileLevel)
                   m.loPDM.AddFile(m.loObj.nLI1,m.loObj.nLI2,m.loObj.nLI3,m.loObj.nLI4,m.loObj.OutDir+"\"+m.loObj.FileName+"\"+m.lcFile_d,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05148),"%name%",LOWER(OBJNAME)),_PDM_FG_Any+_PDM_FG_Class)
                ELSE
                   STORE EVAL("m.loFileLevel.I"+LTRIM(STR(m.loFileLevel.nLevel,6)))+1 TO ("m.loFileLevel.I"+LTRIM(STR(m.loFileLevel.nLevel,6)))
                   m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,m.loObj.OutDir+"\"+m.loObj.FileName+"\"+m.lcFile_d,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05148),"%name%",LOWER(OBJNAME)),_PDM_FG_Any+_PDM_FG_Class)
                ENDIF

             ELSE
                lcFile_d=m.This.HTMLName
             ENDIF

             lcHB=IIF(m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,'<h5 ',IIF(m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_FRX,'<h4 ','<h3 '))+'style="'+loPDMs.s_pbf+'">'
             lcHE=IIF(m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,'</h5>',IIF(m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_FRX,'</h4>','</h3>'))


             lcClassX=m.lcClassX+;
                      IIF(m.llSingle,m.loPDM.aSpace(3)+'<a href="'+IIF(m.loObj.HTMLPage=_GSC_Multi,m.lcFile_d,m.lcFile_d+'#cls.'+LOWER(m.lcOBJNAME))+'" target="'+m.This.Target+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",LOWER(m.lcOBJNAME))+'">'+OBJNAME+'</a>',;
                        m.loPDM.aSpace(4)+'<option value="'+IIF(m.loObj.HTMLPage=_GSC_Multi,m.lcFile_d,"cls."+LOWER(m.lcOBJNAME))+'">00'+OBJNAME+'</option>')+m.loPDM.aSpace(21)


             lcString=IIF(m.llFirst OR m.loObj.HTMLPage=_GSC_Multi,"",m.lcSP+'<hr size="3" style="clear:both;" />'+m.loPDM.aSpace(21))

             * Informace o td pro metody a vlastnosti
             lcDIAC_cls=;
                      m.lcSP+'<table class="clear_table">'+m.loPDM.aSpace(21)+;
                      m.lcSP+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)+;
                      m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+IIF(m.This.iSource=_ASC_SCX OR m.This.iSource=_ASC_FRX,m.loPDMs.aStrings(PDM_04763)+' ',m.loPDMs.aStrings(PDM_04769)+' ')+'</td>'+;
                      '<td><a href="'+IIF(m.loObj.HTMLPage=_GSC_Multi,m.lcFile_d,m.lcFile_d+"#cls."+LOWER(m.lcOBJNAME))+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",LOWER(m.lcOBJNAME))+'">'+m.lcOBJNAME+'</a></td></tr>'+m.loPDM.aSpace(21)+;
                      m.lcSP+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+;
                      m.lcSP+'</table>'+m.loPDM.aSpace(21)

             lcDIAC_clsM=;
                      m.loPDM.aSpace(2)+'<tr><td>'+IIF(m.This.iSource=_ASC_SCX OR m.This.iSource=_ASC_FRX,m.loPDMs.aStrings(PDM_04763)+' ',m.loPDMs.aStrings(PDM_04769)+' ')+'</td>'+;
                      '<td><a href="'+IIF(m.loObj.HTMLPage=_GSC_Multi,m.lcFile_d,m.lcFile_d+"#cls."+LOWER(m.lcOBJNAME))+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",LOWER(m.lcOBJNAME))+'">'+m.lcOBJNAME+'</a></td></tr>'+m.loPDM.aSpace(21)

             * Oprava zatku dle toho, zda-li je DIAC
             IF llEx && Yes, DIAC for file exist
                lcString=lcString+;
                         [<div class="diaxp_mhead_class">]
             ENDIF
             lcString=lcString+;
                      m.lcSP+m.lcHB+m.lcSP+'<a name="'+"cls."+LOWER(m.lcOBJNAME)+'">'+;
                      IIF(m.This.iSource=_ASC_SCX OR m.This.iSource=_ASC_FRX,m.loPDMs.aStrings(PDM_04763)+' ',m.loPDMs.aStrings(PDM_04769)+' ')+OBJNAME+'</a>'+m.lcHE+m.loPDM.aSpace(21)

             IF llEx && Yes, DIAC for file exist
                lcString=lcString+;
                         "</div>"+m.loPDM.aSpace(21)+;
                         [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                         m.lcDIAC+m.loPDM.aSpace(21)+;
                         m.loPDMs.GenerateBackReferenceHTML(m.lcFile,m.lcOBJNAME,"",lcDir)

             ENDIF

             lcString=lcString+;
                      m.lcSP+'<table>'+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)


             IF !EMPTY(CLASS)
                lcClass=m.loPDMs.GetClassAnchor(m.lcClassLibF,CLASS,"../../",@lcGUID)
                lcString=m.lcString+;
                         m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+IIF(m.loPDM.GCT.Generate=1,'<a href="../../GCT.htm#'+lcGUID+'" title="'+m.loPDMs.aStrings(PDM_05182)+'">',CLASS)+IIF(m.This.iSource=_ASC_SCX OR m.This.iSource=_ASC_FRX,m.loPDMs.aStrings(PDM_04769),m.loPDMs.aStrings(PDM_04718))+'</a></td><td>'+;
                         IIF(EMPTY(m.lcClass),CLASS,'<a href="'+m.lcClass+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_04719),"%name%",LOWER(CLASS))+'">'+CLASS+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
             ENDIF


             IF !(EMPTY(CLASSLOC) OR BaseClass==Class)
                lcClassLib=m.loPDMs.GetClassAnchor(m.lcClassLibF,"","../../")
                lcString=m.lcString+;
                         m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04774)+'</td><td>'+;
                         IIF(EMPTY(m.lcClassLib),CLASSLOC,'<a href="'+m.lcClassLib+'" target="_blank" title="'+STRTRAN(m.loPDMs.aStrings(PDM_04720),"%name%",LOWER(CLASSLOC))+'">'+CLASSLOC+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
             ENDIF

             * header file
             lcClassLib=RESERVED8
             lcClassLib=IIF(EMPTY(m.lcClassLib),"",m.loPDMs.GetAnchor(FULLPATH(m.lcClassLib,m.loObj.File),"../../"))

             lcString=m.lcString+;
                      IIF(!INLIST(m.This.iSource,_ASC_PRG,_ASC_MNX,_ASC_DBC),m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04779)+'</td><td>'+BaseClass+"</td></tr>"+m.loPDM.aSpace(21),'')+;
                      IIF(!INLIST(m.This.iSource,_ASC_SCX,_ASC_FRX),m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04731)+'</td><td><img class="imgYN" src="'+m.lcDirI+IIF(BITTEST(Flags,8),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,8),PDM_04732,PDM_04733)),"%name%",m.lcOBJNAME)+'" /></td></tr>'+m.loPDM.aSpace(21),'')+;
                      IIF(EMPTY(RESERVED7),'',;
                          m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04781)+'</td><td>'+StrTranHTMLString(RESERVED7)+"</td></tr>"+m.loPDM.aSpace(21))+;
                      IIF(EMPTY(RESERVED8),'',;
                          m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04737)+'</td><td>'+IIF(!EMPTY(m.lcClasslib),'<a href="'+m.lcClassLib+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_04721),"%name%",LOWER(RESERVED8))+'">','')+RESERVED8+IIF(!EMPTY(m.lcClasslib),"</a>",'')+"</td></tr>"+m.loPDM.aSpace(21))

             IF m.This.iSource=_ASC_VCX
                IF !EMPTY(RESERVED4)
                   lcPom=RESERVED4
                   =m.loPDM.AddFileToRepository(FULLPATH(m.lcPom,ExtractPathFromFile(m.lcFile)),m.lcPath,@m.lcPom)
                   lcString=m.lcString+;
                            m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04739)+'</td><td>'+[<img class="imgclass" src="]+m.lcPom+[" alt="]+STRTRAN(m.loPDMs.aStrings(PDM_02804),"%name%",LOWER(m.lcOBJNAME))+[" /> ]+RESERVED4+"</td></tr>"+m.loPDM.aSpace(21)
                ENDIF
   
                IF !EMPTY(RESERVED5)
                   lcPom=RESERVED5
                   =m.loPDM.AddFileToRepository(FULLPATH(m.lcPom,ExtractPathFromFile(lcFile)),m.lcPath,@m.lcPom)
                   lcString=m.lcString+;
                            m.lcSP+'<tr><td>'+m.loPDMs.aStrings(PDM_04743)+'</td><td>'+[<img class="imgclass" src="]+m.lcPom+[" alt="]+STRTRAN(m.loPDMs.aStrings(PDM_04722),"%name%",LOWER(m.lcOBJNAME))+[" /> ]+RESERVED5+"</td></tr>"+m.loPDM.aSpace(21)
                ENDIF
             ENDIF

             lcString=m.lcString+;
                      IIF(EMPTY(RESERVED6),'',;
                          m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04747)+'</td><td>'+RESERVED6+"</td></tr>"+m.loPDM.aSpace(21))+;
                      m.lcSP+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+m.lcSP+'</table>'+m.loPDM.aSpace(21)+'<br />'+m.loPDM.aSpace(21)

          ELSE && Object
             lcFile_d=IIF(m.loObj.HTMLPage=_GSC_Multi,m.This.HTMLFileD,m.This.HTMLName)

             lcClassX=m.lcClassX+m.loPDM.aSpace(4)+'<option value="'+;
                      IIF(m.loObj.HTMLPage=_GSC_Multi,m.This.HTMLFileD+"#cls.","cls.")+LOWER(m.lcOBJNAME)+'">'+;
                      STRTRAN(STR(m.liLevel*2,2)," ","0")+m.lcPom+'</option>'+m.loPDM.aSpace(21)

             lcString=IIF(m.llFirst,m.lcSP0+'<hr style="clear:both;" />','')+m.loPDM.aSpace(21)+;
                      m.lcSP0+'<div class="TreeRowE">'+m.loPDM.aSpace(21)+;
                      IIF(m.llFirst,"",m.lcSP+'<hr style="clear:both;" />')+m.loPDM.aSpace(21)

             * Informace o td pro metody a vlastnosti
             * Nzev objektu a jeho parenta + odkazy
             lcDIAC_cls=;
                      m.lcSP+'<table class="clear_table">'+m.loPDM.aSpace(21)+;
                      m.lcSP+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)+;
                      m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04763)+'</td>'+;
                      '<td><a href="'+m.lcFile_d+"#cls."+LOWER(m.lcOBJNAME)+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_02800),"%name%",LOWER(m.lcOBJNAME))+'">'+m.lcOBJNAME+'</a></td></tr>'+m.loPDM.aSpace(21)+;
                      m.lcSP+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+;
                      m.lcSP+'</table>'+m.loPDM.aSpace(21)

             lcDIAC_clsM=;
                      m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04763)+'</td>'+;
                      '<td><a href="'+m.lcFile_d+"#cls."+LOWER(m.lcOBJNAME)+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_02800),"%name%",LOWER(m.lcOBJNAME))+'">'+m.lcOBJNAME+'</a></td></tr>'+m.loPDM.aSpace(21)

             * Oprava zatku dle toho, zda-li je DIAC
             IF llEx && Yes, DIAC for file exist
                lcString=lcString+;
                         [<div class="diaxp_mhead_class">]
             ENDIF

             lcString=lcString+;
                      m.lcSP+'<strong><a name="cls.'+LOWER(m.lcOBJNAME)+'">'+m.loPDMs.aStrings(PDM_04763)+' '+m.lcPom+'</a></strong>'+m.loPDM.aSpace(21)

             IF llEx && Yes, DIAC for file exist
                lcString=lcString+;
                         "</div>"+m.loPDM.aSpace(21)+;
                         [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                         m.lcDIAC+m.loPDM.aSpace(21)
             ENDIF

             lcString=lcString+;
                      m.lcSP+'<table>'+m.loPDM.aSpace(21)+;
                      m.lcSP+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)+;
                      m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04767)+'</td><td><a href="#cls.'+m.lcRecnoP+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_04727),"%name%",LOWER(m.lcOldOBJNAME))+'">'+m.lcOldOBJNAME+'</a></td></tr>'+m.loPDM.aSpace(21)

             IF !EMPTY(CLASS)
                lcClass=m.loPDMs.GetClassAnchor(m.lcClassLibF,CLASS,"../../",@lcGUID)
                lcString=m.lcString+;
                         m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+IIF(m.loPDM.GCT.Generate=1,'<a href="../../GCT.htm#'+lcGUID+'" title="'+m.loPDMs.aStrings(PDM_05182)+'">'+m.loPDMs.aStrings(PDM_04769)+'</a>',CLASS)+'</td><td>'+;
                         IIF(EMPTY(m.lcClass),CLASS,'<a href="'+m.lcClass+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",LOWER(CLASS))+'">'+CLASS+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
             ENDIF

             IF !(EMPTY(CLASSLOC) OR BaseClass==Class)
                lcClassLib=m.loPDMs.GetClassAnchor(m.lcClassLibF,"","../../")
                lcString=m.lcString+;
                         m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04774)+'</td><td>'+;
                         IIF(EMPTY(m.lcClassLib),CLASSLOC,'<a href="'+m.lcClassLib+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05113),"%name%",LOWER(CLASSLOC))+'">'+CLASSLOC+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
             ENDIF

             lcString=m.lcString+;
                      IIF(EMPTY(BASECLASS),'',;
                          m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04779)+'</td><td>'+BaseClass+"</td></tr>"+m.loPDM.aSpace(21))+;
                      IIF(EMPTY(RESERVED7) OR m.liLevel>0,'',;
                          m.lcSP+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04781)+'</td><td>'+StrTranHTMLString(RESERVED7)+'</td></tr>'+m.loPDM.aSpace(21))+;
                      m.lcSP+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+m.lcSP+'</table>'+m.loPDM.aSpace(21)+m.lcSP+'<br />'+m.loPDM.aSpace(21)

          ENDIF

          * Vyisti bloky
          STORE "" TO lcMethods,lcMethodsH,lcProps,lcObjects,lcHead,lcObjectsH
          STORE 0 TO liPRO,liOBJ,liMET

          SET COLLATE TO "MACHINE"
          SELE (m.lcAPROPS)
          IF !INLIST(m.This.iSource,_ASC_PRG,_ASC_MNX,_ASC_DBC) AND SEEK(BINTOC(m.liXX101P)) && Hur, nco tam je
             LOCATE WHILE BINTOC(XX101P)=BINTOC(m.liXX101P) FOR UPPER(SUBS(OBJNAME,RAT(".",OBJNAME,1)+1))=="NAME" AND UPPER(Value)==CHR(34)+UPPER(m.lcObjNX)+CHR(34) && Pokud je nzev shodn
             IF FOUND()
                DELE NEXT 1 && Sma tu vtu
             ENDIF
          ENDIF

          IF SEEK(BINTOC(m.liXX101P)) && Hur, nco tam je
             COUNT TO liPRO WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
             DIME laObjX(m.liPRO,2)
             SEEK (BINTOC(m.liXX101P))
             liy=0

             STORE .F. TO llDBC,llDBF,llNative
             STORE "" TO laMember,lcDBC,lcACT,lcTab
             
             * Prove kopii do matice
             SCAN WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
                  liy=m.liy+1
                  laObjX(m.liy,1)=OBJNAME
                  laObjX(m.liy,2)=XX100R
                  
                  luValue=ALLTRIM(VALUE)

                  * Prove analzu, zda jsou tam vlastnosti Database a CursorSource
                  lcProp=UPPER(IIF(m.liLevel=0,OBJNAME,SUBS(OBJNAME,AT(".",OBJNAME,m.liLevel)+1)))

                  * Prove analzu, zda jsou tam vlastnosti Tag, Tables, DataSourceType for cursoradapter a AutoCompTable
                  DO CASE
                     CASE m.lcProp=="DATABASE"
                          llDBC=!EMPTY(m.luValue)
                          lcDBC=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)

                     CASE m.lcProp=="CURSORSOURCE"
                          llDBF=!EMPTY(m.luValue)
*!*	                          lcTab=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)

                     CASE m.lcProp=="TAG"
                          lcDBC=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)

*!*	                     CASE m.lcProp=="TABLES"
*!*	                          lcTab=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)

*!*	                     CASE m.lcProp=="AUTOCOMPTABLE"
*!*	                          lcACT=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)

                     CASE m.lcProp=="DATASOURCETYPE"
                          llNative=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)=="Native"

                     * Prove analzu, zda jsou tam vlastnosti MemberClassLibrary, HeaderClassLibrary, DEClassLibrary
                     CASE m.lcProp=="MEMBERCLASSLIBRARY"
                          luValue=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                          laMember(1)=IIF(m.luValue="\\" OR SUBS(m.luValue,2,2)=":\" OR EMPTY(m.luValue),m.luValue,FULLPATH(m.luValue,m.loObj.File))

                     CASE m.lcProp=="HEADERCLASSLIBRARY"
                          luValue=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                          laMember(2)=IIF(m.luValue="\\" OR SUBS(m.luValue,2,2)=":\" OR EMPTY(m.luValue),m.luValue,FULLPATH(m.luValue,m.loObj.File))

                     CASE m.lcProp=="DECLASSLIBRARY"
                          luValue=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                          laMember(2)=IIF(m.luValue="\\" OR SUBS(m.luValue,2,2)=":\" OR EMPTY(m.luValue),m.luValue,FULLPATH(m.luValue,m.loObj.File))

                  ENDCASE
             ENDSCAN
             SET COLLATE TO (m.loPDMs.Collate)

             =IIF(m.loObj.OL_Properties=1,ASORT(laOBJX),.T.) && Ordered? Yes/No

             lcHead=m.lcHead+'<a href="#cls.'+LOWER(m.lcOBJNAME)+'::Properties" title="'+STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 AND !INLIST(m.This.iSource,_ASC_SCX,_ASC_FRX),PDM_04723,PDM_04650)),"%name%",LOWER(m.lcOBJNAME))+'">'+m.loPDMs.aStrings(PDM_04791)+'</a>&nbsp;'

             * Te vygeneruj vlastnosti
             lcProps = m.lcSP+'<strong><a name="cls.'+LOWER(m.lcOBJNAME)+'::Properties">'+m.loPDMs.aStrings(PDM_04791)+'</a></strong>'+m.loPDM.aSpace(21)+;
                       m.lcSP+'<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                       m.lcSP+m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                       m.lcSP+m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                       m.lcSP+m.loPDM.aSpace(3)+;
                       IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,;
                          '<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04798)+'">'+m.loPDMs.aStrings(PDM_04797)+'</td>'+m.loPDM.aSpace(21)+;
                          m.lcSP+m.loPDM.aSpace(3)+'<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04926)+'">'+m.loPDMs.aStrings(PDM_04927)+'</td>'+m.loPDM.aSpace(21)+;
                          m.lcSP+m.loPDM.aSpace(3)+'<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04840)+'">'+m.loPDMs.aStrings(PDM_04839)+'</td>'+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(3),"")+;
                       IIF(m.liLevel=0 AND (m.This.iSource=_ASC_VCX OR m.This.iSource=_ASC_SCX),;
                          '<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04834)+'">'+m.loPDMs.aStrings(PDM_04833)+'</td>'+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(3),"")+;
                       '<td>'+m.loPDMs.aStrings(PDM_04928)+'</td>'+m.loPDM.aSpace(21)+m.lcSP+;
                       m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_04799)+'</td>'+m.loPDM.aSpace(21)+;
                       IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX,m.lcSP+m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_04929)+'</td>'+m.loPDM.aSpace(21),"")+;
                       m.lcSP+m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                       m.lcSP+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)



             IF m.loPDM.iVF>0 && 
                loPIPar.Type="FV"
                loPIPar.FileGroup=_PDM_FG_Property
                loPIPar.lLNK=.F.
                loPIPar.lDBC=llDBC
                loPIPar.lDBF=llDBF
                loPIPar.lNative=llNative
                loPIPar.iLevel=liLevel
                loPIPar.lLNK=.F.
                loPIPar.cPath=lcPath
                loPIPar.cDir=lcDir
                loPIPar.cDBC=lcDBC

                =ACOPY(laMember,loPIPar.laMember)
             ENDIF   

*!*	IF lcObjNX="Dataenvironment"
*!*	SUSPEND
*!*	endif
             FOR m.liy=1 TO m.liPRO
                 GO laObjX(m.liy,2)
                 STORE IIF(m.liLevel=0,OBJNAME,SUBS(OBJNAME,AT(".",OBJNAME,m.liLevel)+1)) TO lcProp,lcPropX
                 lcRESERVED7=RESERVED7

*!*	IF UPPER(lcProp)="CURSORSOURCE"
*!*	susp
*!*	ENDIF

                 IF m.This.iSource<>_ASC_SCX AND m.liLevel=0
                    m.loPDMs.GetClassPEMInfo(lcFile, lcObjNX, lcProp, @loRamCIPEM)
                 ELSE  
                    m.loPDMs.GetClassPEMInfo(lcClassLibF, lcClassF, lcProp, @loRamCIPEM)
                 ENDIF

                 IF NOT ISNULL(loRamCIPEM)
                    IF !EMPTY(loRamCIPEM.RESERVED7)
                       lcRESERVED7=loRamCIPEM.RESERVED7
                    ENDIF
                    IF !EMPTY(loRamCIPEM.DISPLAYPEM)
                       lcProp=loRamCIPEM.DISPLAYPEM
                    ENDIF
                 ENDIF

                 lcUProp=UPPER(m.lcProp)
                 luValue=VALUE
                 lcRecnoX=LTRIM(STR(RECNO(),11))


                 STORE ALLT(m.luValue) TO luValue

                 STORE .F. TO llPicture,llData,llMember
                 lcPomRel=""
                 IF m.loPDM.iVF>0 && 
                    SCATTER NAME m.loPIPar.Ram MEMO
 
                    lcPom=EVAL(m.lcAOBJ+".OBJNAME")

                    lix=RECNO(m.lcAOBJ)
                    liz=EVAL(m.lcAOBJ+".XX101C")
                    IF SEEK(BINTOC(m.liz),m.lcAOBJ,"I00")
                       lcPom=EVAL(m.lcAOBJ+".OBJNAME")
                    ENDIF
                    GO (lix) IN (m.lcAOBJ)
                    lcPom=lcPom+"."+loPIPar.Ram.ObjName
                    liz=RAT(".",lcPom)

                    loPIPar.cParent=LEFT(lcPom,liz-1)
                    loPIPar.cPEM=SUBST(lcPom,liz+1)
                    loPIPar.cValue=m.luValue
                    loPIPar.cRecnoX=lcRecnoX
                    loPIPar.cPomRel=""
                    loPIPar.cScript=""
                    loPIPar.lPicture=.F.
                    loPIPar.lData=.F.
                    loPIPar.lMember=.F.
                   
                    STORE "" To m.lcShortVal
                    FOR m.liz=1 TO m.loPDM.iVF
                        m.lcShortVal=m.lcShortVal+m.loPDM.aVF(m.liz,1).Run(@m.loPIPar,m.loPDM.aVF(m.liz,2))
                    NEXT

                    IF !EMPTY(m.lcShortVal)
                       lcHTMLVAL=m.lcShortVal
                    ENDIF

                    llPicture=loPIPar.lPicture
                    llData=loPIPar.lData
                    llMember=loPIPar.lMember
                    lcPomRel=loPIPar.cPomRel
                    This.lLNK=loPIPar.lLNK
                    lcScript=lcScript+loPIPar.cScript

                 ELSE
                    lcHTMLVAL=IIF(EMPTY(m.luValue),"&nbsp;",;
                              IIF(LEFT(m.luValue,1)="(",;
                              m.loPDM.Expr2xhtml(SUBST(m.luValue,2,LEN(m.luValue)-2)),;
                              StrTranHTMLString(m.luValue) ))

                 ENDIF

                 
                 IF !m.llData AND !m.llPicture AND !m.llMember AND m.loPDM.iDIAP>0
                    llPropA=.F.
                    * vem soubor, tdu a nzev vlastnosti
                    * Pouij plug-in DIAP pro zjitn
                    SCATTER NAME m.loPIPar.Ram MEMO
 
                    lcPom=EVAL(m.lcAOBJ+".OBJNAME")

                    lix=RECNO(m.lcAOBJ)
                    liz=EVAL(m.lcAOBJ+".XX101C")
                    IF SEEK(BINTOC(m.liz),m.lcAOBJ,"I00")
                       lcPom=EVAL(m.lcAOBJ+".OBJNAME")
                    ENDIF
                    GO (lix) IN (m.lcAOBJ)
                    lcPom=lcPom+"."+loPIPar.Ram.ObjName
                    liz=RAT(".",lcPom)

                    loPIPar.cParent=LEFT(lcPom,liz-1)
                    loPIPar.cPEM=SUBST(lcPom,liz+1)

                    loPIPar.Type="DIAP"
                    loPIPar.FileGroup=_PDM_FG_Property
                    loPIPar.lLNK=.F.

                    STORE "" To lcPom,lcDIAMPF
                    FOR m.liz=1 TO m.loPDM.iDIAP
                        lcPom=m.lcPom+m.loPDM.aDIAP(m.liz,1).Run(@m.loPIPar,m.loPDM.aDIAP(m.liz,2))
                        lcDIAMPF=m.lcDIAMPF+m.loPIPar.xhtmlFooter
                    NEXT
                        
                    IF LEN(m.lcPom)>0 && OK, nco tam nael
                       llPropA=.T.

                       * Vytvo soubor
                       * pidej hlaviku, vygenerovan tlo a patiku
                       lcFile_dx=AppendShortFileFromFile(m.lcFile_d,"."+LOWER(m.lcProp))
   
                       STORE m.loPDMs.FCreate(m.lcPath+m.lcFile_dx) TO lihFilex
                       IF m.lihFilex<=0 && Pokud to selhalo
                          m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",m.lcPath+m.lcFile_dx))
                       ELSE
                          lcPom=m.loPDMs.GetHeader(STRTRAN(STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,PDM_05150,PDM_05119)),"%name%",m.lcProp),"%cname%",m.lcOBJNAME))+;
                                m.loPDMs.GetStyles(m.lcDir)+m.loPDM.GetSCCSS(m.lcPath)+m.lcDIAPCSS+m.lcCSS+;
                                m.loPDMs.AddExternalScript(m.lcDir+m.loPDMs.ExternJS)+m.lcDIAPJS+m.lcJS+;
                                IIF(loPIPar.lLNK,m.loPDm.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDm.StopS+m.loPDM.aSpace(21),"")+;
                                '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                                [<div class="diaxp_mhead">]+STRTRAN(m.loPDMs.aStrings(PDM_04004),"%Name%",m.lcProp)+"</div>"+m.loPDM.aSpace(21)+;
                                [<div class="diaxp_mbody_class">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                                lcDIAC_cls+;
                                "</div>"+m.loPDM.aSpace(21)+;
                                [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                                m.lcPom+m.loPDM.aSpace(21)+;
                                [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                                m.loPDMs.GenerateBackReferenceHTML(m.lcFile,m.lcOBJNAME,m.lcProp,lcDir)+;
                                [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                                m.lcDIAMPF+m.loPDM.aSPace(21)+;
                                [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                                '</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21)

                                   
                          =FWRITE(m.lihFilex,m.lcPom)
                          =m.loPDMs.FClose(m.lihFileX)
                          IF ISNULL(m.loFileLevel)
                             m.loPDM.AddFile(m.loObj.nLI1,m.loObj.nLI2,m.loObj.nLI3,m.loObj.nLI4,m.loObj.OutDir+"\"+m.loObj.FileName+"\"+m.lcFile_dx,0,_PDM_EF_None,STRTRAN(STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,PDM_05150,PDM_05119)),"%name%",m.lcProp),"%cname%",m.lcOBJNAME),_PDM_FG_Property)
                          ELSE
                             liPFL=m.loFileLevel.nLevel
                             m.loFileLevel.nLevel=liPFL+1
                             STORE EVAL("m.loFileLevel.I"+LTRIM(STR(m.loFileLevel.nLevel,6)))+1 TO ("m.loFileLevel.I"+LTRIM(STR(m.loFileLevel.nLevel,6)))
                             m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,m.loObj.OutDir+"\"+m.loObj.FileName+"\"+m.lcFile_dx,0,_PDM_EF_None,STRTRAN(STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,PDM_05150,PDM_05119)),"%name%",m.lcProp),"%cname%",m.lcOBJNAME),_PDM_FG_Property)
                             m.loFileLevel.nLevel=liPFL
                          ENDIF
 
                          * Oprav nzev vlastnosti na odkaz
                          lcProp=[<a href="]+m.lcFile_dx+[" title="]+STRTRAN(m.loPDMs.aStrings(PDM_04653),"%name%",m.lcProp)+[">]+m.lcProp+[</a>]
                       ENDIF
                    ENDIF

                    IF !m.llPropA && Pokud na vlastnost neexistuje odkaz
                       * Pak hledej odkaz dle CLASS, tedy ze kter je to odvozen tdy
                       lcPom=EVAL(m.lcAObj+".CLASSLOC")
                       lcPom2=EVAL(m.lcAObj+".CLASS")
                       lcPom3=m.loObj.File
                       lcPom3=FULLPATH(m.lcPom,m.lcPom3) && Cx000000005
                       lcPom=m.loPDMs.GetMPAnchor(lcPom3,lcPom2,m.lcProp,m.lcDir)
                       IF !EMPTY(m.lcPom)
                          lcProp=[<a href="]+m.lcPom+[" target="top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_04653),"%name%",m.lcProp)+[">]+m.lcProp+[</a>]
                       ENDIF
                    ENDIF
                 ENDIF

                 lcProps=m.lcProps+;
                         m.lcSP+m.loPDM.aSpace(2)+'<tr'+;
                         IIF(m.llPicture,;
                            [ onmouseover="QuickViewIMG(1,']+m.lcPomRel+[');" onmouseout="QuickViewIMG(0,'');"],'')+">"+m.loPDM.aSpace(21)

                 lcProps=m.lcProps+;
                         IIF(liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,;
                             m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(BITTEST(Flags,6),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,6),PDM_04940,PDM_04946)),"%name%",m.lcPropX)+'" /></td>'+m.loPDM.aSpace(21)+;
                             m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(BITTEST(Flags,0),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,0),PDM_04941,PDM_04947)),"%name%",m.lcPropX)+'" /></td>'+m.loPDM.aSpace(21)+;
                             m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(BITTEST(Flags,1),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,1),PDM_04942,PDM_04948)),"%name%",m.lcPropX)+'" /></td>'+m.loPDM.aSpace(21),"")+;
                         IIF(liLevel=0 AND (m.This.iSource=_ASC_VCX OR m.This.iSource=_ASC_SCX),;
                          m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(INHERITED=1,"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(INHERITED=1,PDM_04830,PDM_04829)),"%name%",m.lcPropX)+'" /></td>'+m.loPDM.aSpace(21),"")+;
                          m.lcSP+m.loPDM.aSpace(3)+'<td>'+m.lcProp+'</td>'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(3)+'<td>'+m.lcHTMLVAL+"</td>"+m.loPDM.aSpace(21)+;
                         IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,m.lcSP+m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(lcRESERVED7),"&nbsp;",StrTranHTMLString(lcRESERVED7))+'</td>'+m.loPDM.aSpace(21),"")+m.lcSP+m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)

             NEXT


*m.lcSP+m.loPDM.aSpace(3)+'<td>'+m.luValue+"</td>"+m.loPDM.aSpace(21)+;             
*m.luValue,
* hodnota nen vidt
* hodnota je vidt cel
*  rozdlen hodnoty na dv sti, jeden span je vidt, druh ne
             
             lcProps=m.lcProps+;
                     m.lcSP+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+m.lcSP+'</table>'+m.loPDM.aSpace(21)+;
                     m.lcSP+'<br />'+m.loPDM.aSpace(21)
             liPRO=1
          ENDIF

          * Te vygeneruj metody
          SELE (m.lcAPRC)
          SET COLLATE TO "MACHINE"
          IF SEEK(BINTOC(m.liXX101P)) && Hur, nco tam je
             COUNT TO liMET WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
             DIME laObjX(m.liMET,2)
             SEEK (BINTOC(m.liXX101P))
             liy=0
             SCAN WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
                  liy=m.liy+1
                  laObjX(m.liy,1)=OBJNAME
                  laObjX(m.liy,2)=XX100R
             ENDSCAN
             SET COLLATE TO (m.loPDMs.Collate)

             =IIF(m.loObj.OL_Methods=1,ASORT(laOBJX),.T.) && Ordered? Yes/No


             lcHead=m.lcHead+'<a href="#cls.'+LOWER(m.lcOBJNAME)+'::Methods" title="'+STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 AND !INLIST(m.This.iSource,_ASC_SCX,_ASC_FRX),PDM_04724,PDM_04651)),"%name%",LOWER(m.lcOBJNAME))+'">'+m.loPDMs.aStrings(PDM_04835)+'</a>&nbsp;'
             lcMethodsH =m.lcMethodsH+;
                         m.lcSP+'<strong><a name="cls.'+LOWER(m.lcOBJNAME)+'::Methods">'+m.loPDMs.aStrings(PDM_04835)+'</a></strong>'+m.loPDM.aSpace(21)+;
                         m.lcSP+'<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(3)+;
                         IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,;
                           m.lcSP+'<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04926)+'">'+m.loPDMs.aStrings(PDM_04927)+'</td>'+;
                           '<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04840)+'">'+m.loPDMs.aStrings(PDM_04839)+'</td>',"")+;
                         IIF(m.liLevel=0 AND (m.This.iSource=_ASC_VCX OR m.This.iSource=_ASC_SCX),;
                           '<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04834)+'">'+m.loPDMs.aStrings(PDM_04833)+'</td>'+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(3),"")+;
                         '<td>'+m.loPDMs.aStrings(PDM_04928)+'</td>'+;
                         IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,'<td>'+m.loPDMs.aStrings(PDM_04929)+'</td>','')+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)


             lcMethods=''
             liz=0

*!*	IF lcObjNX="_frm1"
*!*	SUSPEND
*!*	endif

             * Metody tto tdy (ale ne child objekt)
             FOR liy=1 TO m.liMET
                 GO laObjX(m.liy,2)
                 lcRecnoX=LTRIM(STR(RECNO(),11))
                 lcRESERVED7=RESERVED7
                 lcProp=SUBS(OBJNAME,RAT(".",OBJNAME,1)+1)

                 IF m.This.iSource<>_ASC_SCX AND m.liLevel=0
                    m.loPDMs.GetClassPEMInfo(lcFile, lcObjNX, lcProp, @loRamCIPEM)
                 ELSE  
                    m.loPDMs.GetClassPEMInfo(lcClassLibF, lcClassF, lcProp, @loRamCIPEM)
                 ENDIF

                 IF NOT ISNULL(loRamCIPEM)
                    IF !EMPTY(loRamCIPEM.RESERVED7)
                       lcRESERVED7=loRamCIPEM.RESERVED7
                    ENDIF
                    IF !EMPTY(loRamCIPEM.DISPLAYPEM)
                       lcProp=loRamCIPEM.DISPLAYPEM
                    ENDIF
                 ENDIF


                 * Vytvo soubor
                 * pidej hlaviku, vygenerovan tlo a patiku
                 lcFile_dx=AppendShortFileFromFile(m.lcFile_d,"."+LOWER(OBJNAME))

                 lcMethodsH=m.lcMethodsH+;
                            m.lcSP+m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                            IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,;
                              m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(BITTEST(Flags,0),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,0),PDM_04943,PDM_04949)),"%name%",m.lcProp)+'" /></td>'+m.loPDM.aSpace(21)+;
                              m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(BITTEST(Flags,1),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,1),PDM_04944,PDM_04950)),"%name%",m.lcProp)+'" /></td>'+m.loPDM.aSpace(21),"")+;
                            IIF(liLevel=0 AND (m.This.iSource=_ASC_VCX OR m.This.iSource=_ASC_SCX),;
                             m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(INHERITED=1,"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(INHERITED=1,PDM_04832,PDM_04831)),"%name%",m.lcProp)+'" /></td>'+m.loPDM.aSpace(21),"")+;
                            m.lcSP+m.loPDM.aSpace(3)+'<td>'+;
                            IIF(EMPTY(XXDesc) AND EMPTY(XXSC) ,m.lcProp,;
                               '<a href="'+m.lcFile_dx+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_04726),"%name%",m.lcProp)+'">'+m.lcProp+'</a>')+'</td>'+m.loPDM.aSpace(21)+;
                            IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,m.lcSP+m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(lcRESERVED7),"&nbsp;",StrTranHTMLString(lcRESERVED7))+'</td>'+m.loPDM.aSpace(21),"")+;
                            m.lcSP+m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)


                 IF !EMPTY(XXSC) OR !EMPTY(XXDesc)
                    STORE m.loPDMs.FCreate(m.lcPath+m.lcFile_dx) TO lihFileX

                    IF m.lihFilex<=0 && Pokud to selhalo
                       m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",m.lcPath+m.lcFile_dx))
                    ELSE

                       m.lcS2PM=""

                       IF !UPPER(lcObjNX)==UPPER(m.lcClassF)
                          liz=0
                          IF !EMPTY(m.lcClassF)
                             DIME laSO(1,1)
                             IF EMPTY(m.lcClasslibF)
                                liz=m.loPDMs.GetMPAnchors(@laSO,m.lcClassF,m.lcProp,m.lcDir)
                             ELSE
                                laSO(1,1)=m.loPDMs.GetMPAnchor(m.lcClasslibF,m.lcClassF,m.lcProp,m.lcDir,0)
                                liz=IIF(EMPTY(laSO(1,1)),0,1)
                             ENDIF
                          ENDIF
                          llML=m.liz>1
                          IF m.liz>0
                             lcS2PM=m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04780)+'</td><td>'
                             lcPom2=LOWER(m.lcClassF)+"::"+m.lcProp
                             IF m.liz=1
                                lcS2PM=lcS2PM+;
                                       [<a href="]+laSO(1,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_04726),"%name%",m.lcPom2+"()")+[">]+m.lcPom2+"()"+[</a>]+m.loPDM.aSpace(21)
                             ELSE
                                lcS2PM=lcS2PM+;
                                       m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(4)+[<span id="SPN_M]+m.lcRecnoX+[" class="LNK_collaborative" onclick="pcLNK='M]+m.lcRecnoX+[';" title="]+STRTRAN(m.loPDMs.aStrings(PDM_04726),"%name%",m.lcPom2+"()")+[">]+m.lcPom2+"()"+"</span>"+m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(4)+[<div id="LNK_M]+m.lcRecnoX+[" class="LNK_tab"> <!-- Link Table Begin -->]+m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(5)+[<table class="a_center">]+m.loPDM.aSpace(21)
                
                                FOR lix=1 TO m.liz
                                    lcS2PM=m.lcS2PM+;
                                           m.loPDM.aSpace(6)+[<tr><td><a href="]+laSO(m.lix,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_04726),"%name%",m.lcPom2+"()")+[">]+m.lcPom2+[</a></td></tr>]+m.loPDM.aSpace(21)
                                NEXT
                                lcS2PM=m.lcS2PM+;
                                       m.loPDM.aSpace(5)+[</table>]+m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(4)+[</div> <!-- Link Table End -->]+m.loPDM.aSpace(21)
                             ENDIF
                             lcS2PM=lcS2PM+'</td></tr>'+m.loPDM.aSpace(21)
                          ELSE
                             lcS2PM=""
                          ENDIF
                       ENDIF

                       IF m.liLevel=0
                          liz=m.loPDMs.GetCAnchor(m.lcFile+CHR(0)+m.lcOBJNAME+CHR(0)+m.lcProp,@laSO,lcDir,_PDM_CA_MethodPC)
                          IF liz>0
                             lcS2PM=lcS2PM+m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04782)+'</td><td>'
                             FOR lix=1 TO m.liz
                                 li1=ATC(CHR(0),laSO(m.lix,2),1)
                                 li2=ATC(CHR(0),laSO(m.lix,2),2)

                                 lcPom2=SUBST(laSO(m.lix,2),li1+1,li2-li1-1)+"."+SUBST(laSO(m.lix,2),li2+1)+"()"
                                 lcS2PM=m.lcS2PM+;
                                        [<a href="]+laSO(m.lix,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_04726),"%name%",LOWER(m.lcPom2))+[">]+m.lcPom2+[</a>]+IIF(lix<m.liz,[ | ],"")+m.loPDM.aSpace(21)
                             NEXT
                             lcS2PM=lcS2PM+'</td></tr>'+m.loPDM.aSpace(21)
                          ENDIF
                       ENDIF

                       lcPom=m.loPDMs.GetHeader(STRTRAN(STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX,PDM_05149,PDM_05116)),"%name%",m.lcProp),"%cname%",m.lcOBJNAME))+;
                             m.loPDMs.GetStyles(m.lcDir)+m.loPDM.GetSCCSS(m.lcPath)+m.lcDIAMPCSS+m.lcCSS+;
                             m.loPDMs.AddExternalScript(m.lcDir+m.loPDMs.ExternJS)+m.lcDIAMPJS+m.lcJS+;
                             IIF(BITTEST(XX001,_PDM_MF_bLNKS) OR m.llML,m.loPDm.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDm.StopS+m.loPDM.aSpace(21),"")+;
                             '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                             [<div class="diaxp_mhead">]+STRTRAN(m.loPDMs.aStrings(PDM_04003),"%Name%",m.lcProp)+"</div>"+m.loPDM.aSpace(21)+;
                             [<div class="diaxp_mbody_class">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                             '<table class="clear_table">'+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)+;
                             m.lcDIAC_clsM+;
                             m.lcS2PM+;
                             m.loPDM.aSpace(2)+'<tr><td>'+m.loPDMs.aStrings(PDM_04879)+'</td><td>'+StrTranHTMLString(lcRESERVED7)+'</td></tr>'+m.loPDM.aSpace(21)

                       lcPom=lcPom+;
                             m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+;
                             m.lcSP+'</table>'+m.loPDM.aSpace(21)+;
                             "</div>"+m.loPDM.aSpace(21)+;
                             '<div class="diaxp_mbody">'+m.loPDM.aSpace(21)+;
                             XXDesc


                       * Generate Back Reference HTML
                       lcPom=lcPom+m.loPDMs.GenerateBackReferenceHTML(m.lcFile,m.lcOBJNAME,m.lcProp,lcDir)

                       lcPom=lcPom+;
                             IIF(EMPTY(XXSC),"",;
                             m.loPDM.aSpace(1)+[<div class="SC">]+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(2)+[<img onclick="ExpandSC('SP_]+m.lcRecno+[',-1);"class="imgEC" src="../../imgs/]+m.lcPict+[" alt="]+STRTRAN(m.loPDMs.aStrings(PDM_02717),"%name%",OBJNAME)+[" id="IMG_SP_]+m.lcRecno+[" />]+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(2)+[<span ondblclick="ExpandSC('SP_]+m.lcRecno+[',-1);" class="SCCaption"><a name="]+m.lcOBJNAME+'">'+m.loPDMs.aStrings(PDM_04880)+'</a></span>'+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(2)+[<div ]+IIF(m.loPDM.ECPMDblclick=1,[ondblclick="ExpandSC('SP_]+m.lcRecno+[',-1);"],"")+[ class="SCE"]+m.lcDisp+' id="TX_SP_'+m.lcRecno+'">'+m.loPDM.aSpace(21)+;
                             XXSC+;
                             m.loPDM.aSpace(2)+'</div>'+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(1)+'</div>'+m.loPDM.aSpace(21))+;
                             '</div>'+m.loPDM.aSpace(21)+;
                             '<div class="diaxp_mfoot">'+XXDescF+;
                             '</div>'+m.loPDM.aSpace(21)

                       lcPom=m.lcPom+;
                             IIF(EMPTY(XXSC),"",;
                                 m.loPDM.StartS+;
                                 STRTRAN(STRTRAN(STRTRAN(m.loPDM.RE,"%ID%",'TX_SP_'+m.lcRecno),"%XType%","SourceCode"),"%Dir%",m.lcDirI)+m.loPDM.aSpace(21)+;
                                 m.loPDM.StopS)+;
                             '</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21)

                       =FWRITE(m.lihFileX,m.lcPom)
                       =m.loPDMs.FClose(m.lihFileX)

                       IF ISNULL(m.loFileLevel)
                          m.loPDM.AddFile(m.loObj.nLI1,m.loObj.nLI2,m.loObj.nLI3,m.loObj.nLI4,m.loObj.OutDir+"\"+m.loObj.FileName+"\"+m.lcFile_dx,0,_PDM_EF_None,STRTRAN(STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,PDM_05149,PDM_05116)),"%name%",m.lcProp),"%cname%",m.lcOBJNAME),_PDM_FG_Any+_PDM_FG_Method)
                       ELSE
                          liPFL=m.loFileLevel.nLevel
                          m.loFileLevel.nLevel=liPFL+1
                          STORE EVAL("m.loFileLevel.I"+LTRIM(STR(m.loFileLevel.nLevel,6)))+1 TO ("m.loFileLevel.I"+LTRIM(STR(m.loFileLevel.nLevel,6)))
                          m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,m.loObj.OutDir+"\"+m.loObj.FileName+"\"+m.lcFile_dx,0,_PDM_EF_None,STRTRAN(STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 OR m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,PDM_05149,PDM_05116)),"%name%",m.lcProp),"%cname%",m.lcOBJNAME),_PDM_FG_Any+_PDM_FG_Method)
                          m.loFileLevel.nLevel=liPFL
                       ENDIF

                    ENDIF
                 ENDIF


             NEXT

             lcMethods=""
             IF liMET>1
                lcPom=m.loPDMs.aStrings(PDM_00101)
                lcMethods=m.lcMethods+;
                          [<div class="back2"><a href="#cls.]+LOWER(m.lcOBJNAME)+[::Methods" class="b2_left" title="]+m.loPDMs.aStrings(PDM_04729)+[">]+m.lcPom+[</a><a href="#cls.]+LOWER(m.lcOBJNAME)+[::Methods" class="b2_right" title="]+m.loPDMs.aStrings(PDM_04729)+[">]+m.lcPom+[</a></div>]+m.loPDM.aSpace(21)
             ENDIF

             lcMethodsH=m.lcMethodsH+m.lcSP+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+m.lcSP+'</table>'+m.loPDM.aSpace(21)+m.lcSP+'<br />'+m.loPDM.aSpace(21)
             liMET=1
          ENDIF

          * Te vygeneruj objekty
          SELE (m.lcAOBJ)
          SET COLLATE TO "MACHINE"
          IF SEEK(BINTOC(m.liXX101P))
             COUNT TO liOBJ WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
             DIME laObjX(m.liOBJ,2)
             SEEK (BINTOC(m.liXX101P))
             liy=0
             SCAN WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
                  liy=m.liy+1
                  laObjX(m.liy,1)=OBJNAME
                  laObjX(m.liy,2)=XX100R
             ENDSCAN
             SET COLLATE TO (m.loPDMs.Collate)

             =IIF(m.loObj.OL_Objects=1,ASORT(laOBJX),.T.) && Ordered? Yes/No

             lcHead=m.lcHead+'<a href="#cls.'+LOWER(m.lcOBJNAME)+'::Objects" title="'+STRTRAN(m.loPDMs.aStrings(IIF(m.liLevel=0 AND !INLIST(m.This.iSource,_ASC_SCX,_ASC_FRX),PDM_04725,PDM_04652)),"%name%",LOWER(m.lcOBJNAME))+'">'+m.loPDMs.aStrings(PDM_04921)+'</a>&nbsp;'
             lcObjectsH =m.lcObjectsH+;
                         m.lcSP+'<h5><a name="cls.'+LOWER(m.lcOBJNAME)+'::Objects">'+m.loPDMs.aStrings(PDM_04921)+'</a></h5>'+m.loPDM.aSpace(21)+;
                         m.lcSP+'<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(3)+;
                         IIF(m.liLevel=0 AND !INLIST(m.This.iSource,_ASC_SCX,_ASC_FRX),;
                            '<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04926)+'">'+m.loPDMs.aStrings(PDM_04927)+'</td><td class="a_center" title="'+m.loPDMs.aStrings(PDM_04932)+'">'+m.loPDMs.aStrings(PDM_04931)+'</td>',"")+;
                         IIF(m.liLevel=0 AND INLIST(m.This.iSource,_ASC_VCX,_ASC_SCX,_ASC_PRG),;
                            '<td class="a_center" title="'+m.loPDMs.aStrings(PDM_04834)+'">'+m.loPDMs.aStrings(PDM_04833)+'</td>'+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(3),"")+;
                         '<td>'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_04930)+'</td>'+IIF(m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,'<td>'+m.loPDMs.aStrings(PDM_04929)+'</td>','')+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                         m.lcSP+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)


             * Objekty tto tdy (ale ne child objekt)
             FOR liy=1 TO m.liOBJ
                 GO laObjX(m.liy,2)
                 lcRecnoX=LTRIM(STR(RECNO(),11))
                 lcPom=SUBS(OBJNAME,RAT(".",OBJNAME,1)+1)
                 lcObjectsH=m.lcObjectsH+;
                            m.lcSP+m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                            IIF(m.liLevel=0 AND !INLIST(m.This.iSource,_ASC_SCX,_ASC_FRX),m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(BITTEST(Flags,0),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,0),PDM_04952,PDM_04953)),"%name%",m.lcPom)+'" /></td>'+m.loPDM.aSpace(21)+;
                            m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(BITTEST(Flags,9),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,9),PDM_04945,PDM_04951)),"%name%",m.lcPom)+'" /></td>'+m.loPDM.aSpace(21),"")+;
                            IIF(m.liLevel=0 AND INLIST(m.This.iSource,_ASC_VCX,_ASC_SCX,_ASC_PRG),;
                                m.lcSP+m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+m.lcDirI+IIF(INHERITED=1,"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(INHERITED=1,PDM_04828,PDM_04827)),"%name%",m.lcPom)+'" /></td>'+m.loPDM.aSpace(21),"")+;
                            m.lcSP+m.loPDM.aSpace(3)+'<td><a href="#cls.'+LOWER(m.lcOBJNAME)+"."+LOWER(m.lcPom)+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_02800),"%name%",LOWER(m.lcPom))+'">'+m.lcPom+'</a></td>'+m.loPDM.aSpace(21)+m.lcSP+m.loPDM.aSpace(3)+'<td>'+;
                            IIF(EMPTY(Class),"&nbsp;",Class)+m.lcSP+m.loPDM.aSpace(3)+'</td>'+m.loPDM.aSpace(21)+;
                            IIF(m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_MNX OR m.This.iSource=_ASC_DBC,m.lcSP+m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(RESERVED7),"&nbsp;",StrTranHTMLString(RESERVED7))+'</td>'+m.loPDM.aSpace(21),"")+m.lcSP+m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)

             NEXT
             lcObjectsH=m.lcObjectsH+m.lcSP+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+m.lcSP+'</table>'+m.loPDM.aSpace(21)+m.lcSP+'<br />'+m.loPDM.aSpace(21)
             liOBJ=1
          ENDIF
          SET COLLATE TO (m.loPDMs.Collate)

          * seti kompletn obsah
          lcString=m.lcString+;
                   IIF(m.liPRO+m.liMET+m.liOBJ>1 OR llEx,m.lcSP+m.lcHead+'<br />'+m.loPDM.aSpace(21),'')+;
                   m.lcProps+m.lcMethodsH+m.lcObjectsH+m.lcMethods

          =FWRITE(m.lihFile,m.lcString)
          =IIF(m.liOBJ>0,m.This.GenerateObject(m.loObj,m.liXX101P,m.liLevel+1,m.lcOBJNAME,LOWER(m.lcOBJNAME),@m.lcClassX),.T.)

          =FWRITE(m.lihFile,IIF(m.liLevel=0,"",m.loPDM.aSpace(21)+m.lcSP0+'</div>'+m.loPDM.aSpace(21)))

          IF m.liLevel=0 AND m.loObj.HTMLPage=_GSC_Multi
             lcPom=m.loPDMs.aStrings(PDM_00100)
             lcString=[<div class="back2"><a href="#cls.]+LOWER(m.lcOBJNAME)+[" class="b2_left" title="]+m.loPDMs.aStrings(PDM_04728)+[">]+m.lcPom+[</a><a href="#cls.]+LOWER(m.lcOBJNAME)+[" class="b2_right" title="]+m.loPDMs.aStrings(PDM_04728)+[">]+m.lcPom+[</a></div>]+m.loPDM.aSpace(21)
             =FWRITE(m.lihFile,m.lcString)
          ENDIF

          IF llEx && Yes, DIAC for class exist
             lcString="</div>"+m.loPDM.aSpace(21)+;
                      [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                      m.lcDIAXF+m.loPDM.aSPace(21)+;
                      [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)
             =FWRITE(m.lihFile,m.lcString)
          ENDIF

          llFirst=.F.

          IF m.liLevel=0 AND m.This.lLNK AND (m.lii=m.liCnt OR m.loObj.HTMLPage=_GSC_Multi)
             =FWRITE(m.lihFile,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS)
          ENDIF

          IF LEN(lcScript)>0
             =FWRITE(m.lihFile,m.loPDM.StartS+lcScript+m.loPDM.StopS)
          ENDIF

          * Pro zkladn rove je-li povoleno vce strnek, pak ji mus zavt
          IF m.liLevel=0 AND m.loObj.HTMLPage=_GSC_Multi
             =FWRITE(m.lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))
             =m.loPDMs.FClose(m.lihFile)
          ENDIF
      NEXT && sko na dal tdu/objekt

      RETURN
   ENDPROC

   PROCEDURE GenerateAnchors && Vygeneruje seznam kotev td
      LPARAMETERS m.loObj, m.lcMasterKey
      * loObj  - Odkaz na objekt s informacema pro zpracovn
      
      LOCAL m.loPDMs,m.loPDM, m.lcAOBJ, m.lcAPRC, m.liXX101P, m.lcOBJNAME, m.lcFile, m.lcExt, m.llMulti, m.loPIPar,;
            m.lcRecno, m.lcAPROPS, m.liXX101C, m.lcClass, m.llDC, m.lii, m.luValue, m.lcDBC,;
            m.lcProp, m.llCA, m.lcTab, m.llNative, m.liy, m.lcSF, m.liType, m.lcClassLib, m.lcClassF, m.lcObjF, m.lcKey, m.lcKeyM

      LOCAL ARRAY laRows(1)

      m.loPDMs=EVAL(m.This.PDMs)
      m.loPDM=EVAL(m.This.PDM)

      =m.loPDMs.WriteMSG(m.loPDMs.GetString(_PDM_valGenerateAnchorsPI))

      lcAOBJ=m.This.AOBJ
      lcAPRC=m.This.APRC
      lcAPROPS=m.This.APROPS
      lcExt=ExtractExtensionFromFile(m.This.HTMLName)
      llMulti=m.loObj.HTMLPage=_GSC_Multi
      lcFile=m.loObj.File
      lcSF=ExtractShortFileFromFile(m.This.HTMLName)
      m.lcMasterKey=IIF(EMPTY(m.lcMasterKey), m.loObj.Stats_Key, m.lcMasterKey)


      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.loObj.File
      loPIPar.Type="DCOP"
      loPIPar.oPDMx=m.loObj
      loPIPar.oASC=m.This
      loPIPar.FileGroup=_PDM_FG_None
      FOR lii=1 TO m.loPDM.iDCOP
          =m.loPDM.aDCOP(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDCOP(lii,2))
      NEXT

      * Tdy a jejich metody
      SET COLLATE TO "MACHINE"

      SELE (m.lcAOBJ)
      INDEX ON BINTOC(XX101) TAG I03 ADDITIVE
      SCAN ALL
           liXX101P=XX101
           lcOBJNAME=OBJNAME
           lcRecno=LTRIM(STR(RECNO(),11))
           liXX101C=BINTOC(XX101C)
           llDC=UPPER(CLASS)=="CURSOR" OR UPPER(BASECLASS)=="CURSOR"
           llCA=UPPER(BASECLASS)=="CURSORADAPTER" OR UPPER(CLASS)=="CURSORADAPTER"
           liType=IIF(INLIST(m.This.iSource,_ASC_VCX,_ASC_PRG,_ASC_DBC,_ASC_MNX) AND XX101P=0,_PDM_FG_Class,_PDM_FG_Object)
           lcClassLib=CLASSLOC
           lcClassF=CLASS
           lcObjF=OBJNAME

*!* IF m.This.iSource=_ASC_VCX AND xx101=35
*!* SUSPEND
*!* endif

           IF XX101P>0
              =SEEK(m.liXX101C)
              m.lcKey=m.loPDM.AddToStats(m.loObj, XXKey, m.liType, m.lcOBJNAME, "", 0)
              lcClass=OBJNAME
              lcClassLib=CLASSLOC
              lcObjName="."+m.lcObjName
              GO (VAL(m.lcRecno))
           ELSE
              m.lcKey=m.loPDM.AddToStats(m.loObj, m.lcMasterKey, m.liType, m.lcObjName, "", 0)
              lcClass=m.lcObjName
              lcObjName=""
              REPLACE XXKEY WITH m.lcKey
           ENDIF
            
           lcFile=m.loObj.OutDir+"/"+m.loObj.FileName+"/"+IIF(m.llMulti,"cls."+LOWER(m.lcClass)+"."+m.lcExt,m.This.HTMLName)
           =m.loPDMs.AddAnchor(m.loObj.File,m.lcClass+m.lcOBJNAME,"",m.lcFile,"cls."+m.lcClass+LOWER(m.lcOBJNAME),m.liType,RESERVED7)

           SELE (m.lcAPRC)
           =SEEK(BINTOC(m.liXX101P))
           SCAN WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
                =m.loPDMs.AddAnchor(m.loObj.File, m.lcClass+m.lcOBJNAME,;
                                    SUBS(OBJNAME, RAT(".", OBJNAME, 1)+1), AppendShortFileFromFile(m.lcFile, "."+OBJNAME), "",_PDM_FG_Method, RESERVED7)
                =IIF(!EMPTY(m.lcClassLib),;
                     m.loPDMs.AddCAnchor(FULLPATH(m.lcClassLib,ExtractPathFromFile(m.loObj.File))+CHR(0)+m.lcClassF+CHR(0)+SUBS(OBJNAME,RAT(".",OBJNAME,1)+1),;
                                         m.loObj.File+CHR(0)+m.lcObjF+CHR(0)+SUBS(OBJNAME,RAT(".",OBJNAME,1)+1),_PDM_CA_MethodPC),.T.)

                m.lcKeyM=m.loPDM.AddToStats(m.loObj, m.lcKey, _PDM_FG_Method, SUBS(OBJNAME, RAT(".", OBJNAME, 1)+1), "", 0)
                
                =m.loPDM.AddToStats(m.loObj, m.lcKeyM, 0, "", "lines", XXCNTA)
                =m.loPDM.AddToStats(m.loObj, m.lcKeyM, 0, "", "emptylines", XXCNTE)
                =m.loPDM.AddToStats(m.loObj, m.lcKeyM, 0, "", "commentlines", XXCNTC)
                =m.loPDM.AddToStats(m.loObj, m.lcKeyM, 0, "", "linesbytes", XXSIZEA)
                =m.loPDM.AddToStats(m.loObj, m.lcKeyM, 0, "", "emptylinesbytes", XXSIZEE)
                =m.loPDM.AddToStats(m.loObj, m.lcKeyM, 0, "", "commentlinesbytes", XXSIZEC)

           ENDSCAN

           STORE "" TO lcDBC,lcTab
           llNative=.F.
           SELE (m.lcAPROPS)
           =SEEK(BINTOC(m.liXX101P))
           SCAN WHILE BINTOC(XX101P)=BINTOC(m.liXX101P)
                =m.loPDMs.AddAnchor(m.loObj.File,m.lcClass+m.lcOBJNAME,;
                                    SUBS(OBJNAME, RAT(".", OBJNAME, 1)+1), AppendShortFileFromFile(m.lcFile, "."+OBJNAME), "", _PDM_FG_Property, RESERVED7)

                IF !m.llDC AND !m.llCA
                   LOOP
                ENDIF

                luValue=ALLT(VALUE)
                * Prove analzu, zda jsou tam vlastnosti Database a CursorSource
                lcProp=UPPER(IIF(AT(".",OBJNAME)<=0,OBJNAME,SUBS(OBJNAME,RAT(".",OBJNAME)+1)))

                IF m.llDC
                   IF m.lcProp=="DATABASE"
                      lcDBC=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                   ELSE
                      IF m.lcProp=="CURSORSOURCE"
                         * Odstra z luValue uvozujc znaky etzce
                         lcTab=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                      ENDIF
                   ENDIF
                ENDIF

                IF m.llCA
                   IF m.lcProp=="TAG"
                      lcDBC=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                   ELSE
                      IF m.lcProp=="TABLES"
                         lcTab=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)
                      ELSE
                         IF m.lcProp=="DATASOURCETYPE"
                            llNative=IIF(INLIST(LEFT(m.luValue,1),["],['],"["),SUBST(m.luValue,2,LEN(m.luValue)-2),m.luValue)=="Native"
                         ENDIF
                      ENDIF
                   ENDIF
                ENDIF

           ENDSCAN

           * Add cross-link to form (cursor)
           IF m.llDC
              luValue=FULLPATH(IIF(EMPTY(m.lcDBC),m.lcTab,m.lcDBC+"!"+m.lcTab),ExtractPathFromFile(m.loObj.File))
              =m.loPDMs.AddCAnchor(m.luValue,m.loObj.File,_PDM_CA_ApplyTo)
           ENDIF

           * Add cross-link to form (cursoradapter)
           IF m.llCA AND m.llNative
              * variable lcTab contines list of tables, local views and remote views
              liy=ALINES(laRows,STRTRAN(m.lcTab,",",CRLF))
              FOR lii=1 TO m.liy
                  IF !EMPTY(laRows(m.lii))
                     luValue=FULLPATH(m.lcDBC+"!"+laRows(m.lii),ExtractPathFromFile(m.loObj.File))
                     =m.loPDMs.AddCAnchor(m.luValue,m.loObj.File,_PDM_CA_ApplyTo)
                  ENDIF
              NEXT
           ENDIF

           SELE (m.lcAOBJ)
      ENDSCAN
      DELETE TAG I03
      SET ORDER TO "I01" IN (m.lcAOBJ)

      * Jen procedury - hlavn procedura (kd)
      SELE (m.lcAPRC)
      =SEEK(BINTOC(-2))
      lcFile=m.loObj.OutDir+"/"+m.loObj.FileName+"/"+m.lcSF+"."
      SCAN WHILE BINTOC(XX101P)=BINTOC(-2)
           =m.loPDMs.AddAnchor(m.loObj.File, "", OBJNAME, m.lcFile+LOWER(OBJNAME)+"."+m.lcExt, "", _PDM_FG_Proced, "")
           m.lcKey=m.loPDM.AddToStats(m.loObj, m.lcMasterKey, _PDM_FG_Proced, OBJNAME, "", 0)
           
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "lines", XXCNTA)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "emptylines", XXCNTE)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "commentlines", XXCNTC)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "linesbytes", XXSIZEA)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "emptylinesbytes", XXSIZEE)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "commentlinesbytes", XXSIZEC)
      ENDSCAN

      * Jen procedury
      =SEEK(BINTOC(-1))
      lcFile=m.loObj.OutDir+"/"+m.loObj.FileName+"/"+m.lcSF+"."
      SCAN WHILE BINTOC(XX101P)=BINTOC(-1)
           =m.loPDMs.AddAnchor(m.loObj.File, "", OBJNAME, m.lcFile+LOWER(OBJNAME)+"."+m.lcExt, "", _PDM_FG_Proced, "")
           m.lcKey=m.loPDM.AddToStats(m.loObj, m.lcMasterKey, _PDM_FG_Proced, OBJNAME, "", 0)
           
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "lines", XXCNTA)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "emptylines", XXCNTE)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "commentlines", XXCNTC)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "linesbytes", XXSIZEA)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "emptylinesbytes", XXSIZEE)
           =m.loPDM.AddToStats(m.loObj, m.lcKey, 0, "", "commentlinesbytes", XXSIZEC)
      ENDSCAN
 
      SELE (m.lcAPRC)
      SET KEY TO 
      SET COLLATE TO (m.loPDMs.Collate)
   ENDPROC

   PROCEDURE QuickAnalyse(loObj,lcSC,m.XX101C,liXX101P,lcOBJNAME) && Return list of clasess in Source code
      * loObj  - Odkaz na objekt s informacema pro zpracovn
      *@lcSC  - Source code as string

      IF EMPTY(m.lcSC) && Pokud je to przdn, pak se vra
         RETURN
      ENDIF

      LOCAL m.lcAOBJ, m.lcLine, m.lcLineX, m.liCount, m.liCRLF, m.lcPom, m.liy, m.liz, m.lii, m.lia,;
            m.XX101, m.OBJNAME, m.Class, m.CLASSLOC, m.Flags, m.RESERVED7,;
            m.Params, m.llPRC, m.loPDMs, m.llExit, m.loSA, m.XX101P, m.XX100R, m.XX000, m.lcAPRC,;
            m.llOne, m.loPDM, m.lcAPROPS, m.llFound, m.Value, m.llIgnoreXXX, m.liXX000, m.lcRESERVED7, m.liPCOUNT,;
            m.XXSIZEA, m.XXCNTA, m.XXCNTE, m.XXCNTC, m.XXSIZEC, m.XXSIZEE

      LOCAL ARRAY laRows(1),laComments(1)

      m.liPCOUNT=PCOUNT()
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt

      * Nejdve provedu analzu PRG soubou
      * Jako prvn budu hledat definici td
      * a potom definici procedur a funkc

      lcAOBJ=m.This.AOBJ && Alias tabulky tdy/objekt
      lcAPRC=m.This.APRC
      lcAPROPS=m.This.APROPS
      llOne=m.loPDM.One

      STORE "" TO m.Params,m.CLASSLOC,m.RESERVED7,m.OBJNAME
      STORE 0 TO m.Flags, m.XXSIZEA, m.XXCNTA, m.XXCNTE, m.XXCNTC, m.XXSIZEC, m.XXSIZEE

      IF m.liPCOUNT=5 && Pat pod njakou tdu/objekt
         lcOBJNAME=m.lcOBJNAME+IIF(!EMPTY(m.lcOBJNAME),".","")
      ELSE
         m.XX101P=-2 && Main program
         m.XX101C=-2 && Main program

         * Pro jistotu zalo proceduru Main_PRG
         m.XX100R=RECC(m.lcAPRC)+1
         m.XX000=1
         m.XX101=1
         m.OBJNAME="Main Program"
         INSERT INTO (m.lcAPRC) FROM MEMVAR && zalo vtu do pomocnho kurzoru
         llPRC=.T.

         m.XX101P=-1 && Nen tda (ist procedury)
         m.XX101C=-1 && Nen tda (ist procedury)
      ENDIF

      ***************************
      * Analza zdrojovho kdu *
      ***************************

      ********************************************
      ** Nat se dek po dku, ale pokud je v dku stednk oznaujc prokraovn na dalm dku
      ** pak se nate dal dek, a tak dle dokud dek je ukonen stednkem.
      ** Pokud se na inkriminovanch dcch nachz komet, pak se pit do dal promnn
      ********************************************
      =RepairSource(@m.lcSC)
      liCRLF=OCCURS(CRLF,m.lcSC) && Zjisti poet enter
      IF m.liCRLF<=64000 OR VAL(m.loPDMs.VFPVers)>8
         liCount=ALINES(laRows,m.lcSC)
      ELSE      
         loSA=CREATEOBJECT("_SupperArray") && Vytvo objekt pro prci a Super maticemi
         liCount=m.loSA.ALines(@m.lcSC) && Nati zdrojov kd do matice
      ENDIF
      lcSC=""

      laComments(1)="&"+"&"

      m.XX000=0 && nebindovan M/P/O
      FOR m.XX101=1 TO m.liCount

          STORE "" TO lcLine,m.RESERVED7
          STORE IIF(m.liCRLF<=64000 OR VAL(m.loPDMs.VFPVers)>8,laRows(m.XX101),m.loSA.GetRow(m.XX101)) TO m.lcPom, m.lcLine

          lii=Trim_SC(@m.lcPom,@paComments,@m.lcRESERVED7) && Odezej koment a zjisti, kde je stednk

          m.XXSIZEA=m.XXSIZEA+LEN(m.lcLine)
          m.XXCNTA=m.XXCNTA+1
          IF EMPTY(m.lcLine)
             m.XXCNTE=m.XXCNTE+1
             m.XXSIZEE=m.XXSIZEE+LEN(m.lcLine)
          ENDIF
          IF EMPTY(m.lcPom) AND NOT EMPTY(m.lcRESERVED7)
             m.XXCNTC=m.XXCNTC+1
             m.XXSIZEC=m.XXSIZEC+LEN(m.lcLine)
          ENDIF

          lcLine=ALLTRIM(m.lcPom)
          * Cykluj zde tak dlouho, dokud je stednk ped komentem
          m.RESERVED7=m.RESERVED7+m.lcRESERVED7
          DO WHILE m.lii=1 AND m.XX101<m.liCount
             m.XX101=m.XX101+1 && Inkrementuj ta
             STORE IIF(m.liCRLF<=64000 OR VAL(m.loPDMs.VFPVers)>8,laRows(m.XX101),m.loSA.GetRow(m.XX101)) TO m.lcPom, m.lcLineX

             * Otestuj dek, co je za
             * Pokud tam nen stednk ped komentem
             lii=Trim_SC(@m.lcPom,@laComments,@m.lcRESERVED7)
             
             m.XXSIZEA=m.XXSIZEA+LEN(m.lcLineX)
             m.XXCNTA=m.XXCNTA+1
             IF EMPTY(m.lcPom)
                m.XXCNTE=m.XXCNTE+1
             ENDIF
             IF EMPTY(m.lcPom) AND NOT EMPTY(m.lcRESERVED7)
                m.XXCNTC=m.XXCNTC+1
                m.XXSIZEC=m.XXSIZEC+LEN(m.lcLineX)
             ENDIF
             
             lcLine=m.lcLine+IIF(!EMPTY(m.lcPom)," "+ALLT(m.lcPom),"")
             m.RESERVED7=m.RESERVED7+m.lcRESERVED7
          ENDDO

          IF m.lii=2 && Pokud je tam stednk za komentem
             * Pak tento koment nati
             llExit=.F.
             DO WHILE m.XX101<m.liCount AND !m.llExit
                m.XX101=m.XX101+1 && Inkrementuj ta
                STORE IIF(m.liCRLF<=64000 OR VAL(m.loPDMs.VFPVers)>8,laRows(m.XX101),m.loSA.GetRow(m.XX101)) TO m.lcPom
                liz=AT_NonSpace(@m.lcPom,1,LEN(m.lcPom))
                liy=RAT_NonSpace(@m.lcPom,LEN(m.lcPom),m.liz)
                lcRESERVED7=IIF(m.liz=0,m.lcPom,SUBS(m.lcPom,m.liz,m.liy-m.liz+1))
                llExit=RIGHT(m.lcRESERVED7,1)#";"

                m.XXSIZEA=m.XXSIZEA+LEN(m.lcPom)
                m.XXCNTA=m.XXCNTA+1
                m.XXCNTC=m.XXCNTC+1
                m.XXSIZEC=m.XXSIZEC+LEN(m.lcPom)

                lcRESERVED7=IIF(RIGHT(m.lcRESERVED7,1)=";",LEFT(m.lcRESERVED7,LEN(m.lcRESERVED7)-1),m.lcRESERVED7)
                m.RESERVED7=m.RESERVED7+IIF(LEN(m.lcRESERVED7)>0," "+RTRIM(m.lcRESERVED7),"")
             ENDDO
          ENDIF

          * Pokud je dek przdn
          * - i pokud je na dku SC jen koment, pak ve pouit kd vrt przdn dek a koment
          * je vrcen zvl᚝
          IF EMPTY(m.lcLine)
             LOOP && Then loop to next row
          ENDIF

          m.Flags=0
          =QuickParseRowSC(@m.lcLine,m.llPRC,@m.Flags,@m.OBJNAME,@m.Params,@m.Class,@m.CLASSLOC)

          IF (BITTEST(m.Flags,25) OR BITTEST(m.Flags,27)) AND !(m.This.iSource=_ASC_PRG OR m.This.iSource=_ASC_DBC)
             llIgnoreXXX=.T.
          ENDIF
          
          IF llIgnoreXXX AND (BITTEST(m.Flags,26) OR BITTEST(m.Flags,28))
             llIgnoreXXX=.F.
          ENDIF


          DO CASE
             CASE llIgnoreXXX
             
             CASE BITTEST(m.Flags,11) &&  Je to tda
                  * v m.OBJNAME je jej nzev
                  IF m.llPRC && ENDPROC missing
                     SELECT (m.lcAPRC)
                     GATHER MEMVAR FIELDS XXSIZEA, XXCNTA, XXCNTE, XXCNTC, XXSIZEC, XXSIZEE 
                  ENDIF
                  m.CLASSLOC=IIF(!EMPTY(m.CLASSLOC),;
                             IIF(AT(".FXP",UPPER(m.CLASSLOC))>0,ChangeExtensionFromFile(FULLPATH(m.CLASSLOC,m.loObj.File),"PRG"),FULLPATH(m.CLASSLOC,m.loObj.File)),;
                             m.CLASSLOC)

                  =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valClassIP),"%name%",m.OBJNAME))

                  STORE 0 TO m.XX101P,m.XX101C && Je to tda
                  llPRC=.F. && Resetuj pznak tla metody
                  * v m.OBJNAME je jej nzev
                  m.XX100R=RECC(m.lcAOBJ)+1
                  INSERT INTO (m.lcAOBJ) FROM MEMVAR && zalo vtu do pomocnho kurzoru

                  STORE m.XX101 TO m.XX101P,m.XX101C

                  liXX000=m.loPDMs.AddClassInfo(m.loObj.File, m.OBJNAME, m.CLASS, m.CLASSLOC, "") &&m.RESERVED7
                  
                  LOOP && Sko na dal dek

             CASE BITTEST(m.Flags,13) && Je to konec tdy
                  IF m.llPRC AND m.XX100R>0 AND m.XX100R<=RECCOUNT(m.lcAPRC)&& ENDPROC missing
                     SELECT (m.lcAPRC)
                     GO (m.XX100R)
                     GATHER MEMVAR FIELDS XXSIZEA, XXCNTA, XXCNTE, XXCNTC, XXSIZEC, XXSIZEE 
                  ENDIF

                  llPRC=.F. && Resetuj pznak tla metody
                  * Je

                  * 
                  SET COLLATE TO "MACHINE"
                  SELECT (m.lcAPROPS)
                  SET KEY TO BINTOC(m.XX101C)
                  SCAN ALL
                       m.loPDMs.AddClassPEMInfo(liXX000, OBJNAME, RESERVED7) && Add class PEM info to global list
                  ENDSCAN
                  SET KEY TO

                  SELECT (m.lcAPRC)
                  SET KEY TO BINTOC(m.XX101C)
                  SCAN ALL
                       m.loPDMs.AddClassPEMInfo(liXX000, OBJNAME, RESERVED7) && Add class PEM info to global list
                  ENDSCAN
                  SET KEY TO
                  SET COLLATE TO (m.loPDMs.Collate)


                  * Find memberdata property
                  SET COLLATE TO "MACHINE"
                  SELECT (m.lcAPROPS)
                  SET ORDER TO "I02"
                  SET KEY TO BINTOC(m.XX101C)+BINTOC(VAL(SYS(2007,"_memberdata")))
                  GO TOP
                  IF !EOF()
                     m.loPDMs.UpdateClassInfo_MD(liXX000,VALUE) 
                  ENDIF
                  SET ORDER TO "I01"
                  SET KEY TO
                  SET COLLATE TO (m.loPDMs.Collate)

                  STORE -1 TO m.XX101P,m.XX101C
                  LOOP && Pak sko na dal dek

             CASE BITTEST(m.Flags,12) && Je to konec procedury
                  llPRC=.F. && Resetuj pznak tla metody
                  SELECT (m.lcAPRC)
                  GATHER MEMVAR FIELDS XXSIZEA, XXCNTA, XXCNTE, XXCNTC, XXSIZEC, XXSIZEE 
                  LOOP && A sko na dal vtu

             CASE BITTEST(m.Flags,2) OR BITTEST(m.Flags,3) && Je to procedura/funkce
                  * v m.OBJNAME je jej nzev
                  IF m.llPRC && ENDPROC missing
                     SELECT (m.lcAPRC)
                     GATHER MEMVAR FIELDS XXSIZEA, XXCNTA, XXCNTE, XXCNTC, XXSIZEC, XXSIZEE 
                  ENDIF
                  llPRC=.T. && Nastav pznak tla metody

                  =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(IIF(m.liPCOUNT=5 OR m.XX101C=0,_PDM_valMethodIP,_PDM_valProcedureIP)),"%name%",m.OBJNAME))

                  * me se jednat o metodu objektu (objekt.metoda)
                  * pak mus nejdve najt objekt a z nj pevzt XX101 jako XX101P

                  m.OBJNAME=IIF(m.liPCOUNT=5,m.lcOBJNAME,"")+m.OBJNAME
*!*                   IF ATC("opgsc",m.OBJNAME)>0
*!*                   SUSPEND
*!*                   endif
                  m.XX000=IIF(OCCURS(".", m.OBJNAME)=IIF(EMPTY(m.lcOBJNAME), 0, 1), 1, 0)
                  llFound=.F.
                  IF m.liPCOUNT=5 && Pokud provd analzu SC z VCX/SCX
                     *m.XX101P=IIF(m.XX000=1, m.liXX101P, m.XX101C)
                     m.XX101P=m.liXX101P
                     * Pak mus nejdve metodu najt (mla by tam bt)
                     SELE (m.lcAPRC)
                     =SEEK(BINTOC(m.XX101P))
                     LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                     llFound=FOUND()
                  ELSE
                     SELE (m.lcAOBJ)
                     lii=RAT(".",m.OBJNAME)
                     IF lii=0
                        m.XX101P=m.XX101C
                     ELSE
                        LOCATE FOR XX101P=m.XX101P AND OBJNAME=LEFT(m.OBJNAME,lii-1)
                        m.XX101P=XX101
                     ENDIF
                  ENDIF

                  IF m.llFound
                     REPL XX101 WITH m.XX101
                  ELSE
                     m.XX100R=RECC(m.lcAPRC)+1
                     INSERT INTO (m.lcAPRC) FROM MEMVAR && zalo vtu do pomocnho kurzoru
                  ENDIF
                  STORE 0 TO m.XXSIZEA, m.XXCNTA, m.XXCNTE, m.XXCNTC, m.XXSIZEC, m.XXSIZEE
                  m.XX101P=m.XX101C
                  LOOP && Pak sko na dal vtu

             CASE BITTEST(m.Flags,5) && Je to definice objektu
                  * Test na objekt - ADD OBJExCT [PROTxECTED/HIDDxEN] name AS class [NOINxIT] [WITH left=5, top=1,...]
                  * m.OBJNAME  obsahuje nzev objektu
                  * m.Class  obsahuje nzev tdy
                  * m.Flags  obsahuje pznaky
                  * m.Params obsahuje seznam vlastnost

                  =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valObjectIP),"%name%",m.OBJNAME))
                  * Zalo vtu do tabulky objekt
                  m.XX000=1 && Znm rove (XX101 udv definici objektu, xx101x pak id tdy)
                  m.XX100R=RECC(m.lcAOBJ)+1
                  INSERT INTO (m.lcAOBJ) FROM MEMVAR
                  m.XX000=0
                  LOOP


                  * Je to include soubor a nen zpracovvn jeden soubor
             CASE BITTEST(m.Flags,14) AND !llOne AND !EMPTY(m.CLASSLOC)
                  * Promnn m.CLASSLOC obsahuje nzev souboru
                  =m.loPDM.AddFileToProject("T",m.loPDM.FullPath(ALLT(m.CLASSLOC),m.loObj.File))

                  * Je-li definovna tda a nen to tlo procedury/metody
                  * Pak se jedn (mon o piazen hodnoty do vlastnosti)
             CASE  m.Flags=0 AND m.XX101C>-1 AND !m.llPRC AND !EMPTY(m.lcLine)
                   m.Value=""

                   lii=AT("=",m.lcPom)
                   m.OBJNAME=CHRTRAN(LEFT(m.lcPom,lii-1)," "+CHR(9),"")
                   m.Value=ALLT(SUBST(m.lcPom,lii+1))
                   * Nejdve mus otestovat, zda tam ona vlastnost existuje
                   * Pokud ne, pak ji zalo

                   SELE (m.lcAOBJ)
                   lii=RAT(".",m.OBJNAME)
                   IF lii=0
                      m.XX101P=m.XX101C
                   ELSE
                      LOCATE FOR XX101P=m.XX101P AND OBJNAME=LEFT(m.OBJNAME,lii-1)
                      m.XX101P=XX101
                   ENDIF

                   SELE (m.lcAPROPS)
                   =SEEK(BINTOC(m.XX101P))

                   lia=ATC("(",m.OBJNAME)
                   lia=IIF(lia=0,ATC("[",m.OBJNAME),lia)

                   IF m.lia=0 OR m.lia>0 AND loPDM.Array_RemoveCells=0
                      LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                      IF !FOUND()
                         m.XX100R=RECC()+1
                         m.SYS2007=VAL(SYS(2007,m.OBJNAME))
                         INSERT INTO (m.lcAPROPS) FROM MEMVAR
                      ELSE
                         REPLACE Value WITH m.Value
                      ENDIF
                   ENDIF

                   IF loPDM.Array_AddAsProperty=1 AND m.lia>0
                      m.OBJNAME=LEFT(m.OBJNAME,m.lia-1)
                      =SEEK(BINTOC(m.XX101P))
                      LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                      IF !FOUND()
                         m.XX100R=RECC()+1
                         m.SYS2007=VAL(SYS(2007,m.OBJNAME))
                         INSERT INTO (m.lcAPROPS) FROM MEMVAR
                      ENDIF
                   ENDIF
                   m.XX101P=m.XX101C
                   m.SYS2007=0

             CASE BITTEST(m.Flags,4) OR BITTEST(m.Flags,6) && Je to seznam vlastnost/matic
                  m.Value=""
                  * A pak to parsuj na nzvy vlastnost
                  STORE 1 TO liy,lii && Nastav potek
                  DO WHILE m.liy>0
                     * Najdi oddlova
                     liy=FindMDSC(@m.Params,",",m.lii)
                     m.OBJNAME=CHRTRAN(IIF(m.liy=0,SUBST(m.Params,m.lii),;
                                  IIF(m.lii=1,LEFT(m.Params,m.liy-1),SUBST(m.Params,m.lii+1,m.liy-m.lii-1));
                                  )," "+CHR(9),"")

                     lii=m.liy+1

                     IF !EMPTY(m.OBJNAME)
                        SELE (m.lcAPROPS)

                        lia=ATC("(",m.OBJNAME)
                        lia=IIF(lia=0,ATC("[",m.OBJNAME),lia)

                        * Nejdve mus otestovat, zda tam ona vlastnost existuje
                        * Pokud ne, pak ji zalo
                        IF m.lia=0 OR m.lia>0 AND loPDM.Array_RemoveCells=0
                           =SEEK(BINTOC(m.XX101P))
                           LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                           IF !FOUND()
                              m.XX100R=RECC()+1
                              INSERT INTO (m.lcAPROPS) FROM MEMVAR
                              m.RESERVED7="" && Vyma poznmku (bude jen u prvn vlastnosti)
                           ENDIF
                        ENDIF

                        IF loPDM.Array_AddAsProperty=1 AND m.lia>0
                           m.OBJNAME=LEFT(m.OBJNAME,m.lia-1)
                           =SEEK(BINTOC(m.XX101P))
                           LOCATE WHILE BINTOC(XX101P)=BINTOC(m.XX101P) FOR UPPER(OBJNAME)==UPPER(m.OBJNAME)
                           IF !FOUND()
                              m.XX100R=RECC()+1
                              INSERT INTO (m.lcAPROPS) FROM MEMVAR
                           ENDIF
                        ENDIF
                     ENDIF
                  ENDDO
                  LOOP

          ENDCASE
      NEXT
      RETURN
   ENDPROC


   PROCEDURE QuickAnalyse_FLL(loObj,loDump) && Provede analzu DUMP objektu
      * loObj  - Odkaz na objekt s informacema pro zpracovn
      *@loDump - Dump objekt

      LOCAL lcAPRC,lcName,lii,;
            m.XX101,m.OBJNAME, m.XX000,;
            m.Flags,m.RESERVED7,m.XX001,m.Inherited,m.XXDescF,;
            m.Params,m.XX101P,m.XX101C,m.XX100R,;
            m.loPDM,m.loPDMs,loFN

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      * Nejdve provedu analzu PRG soubou
      * Jako prvn budu hledat definici td
      * a potom definici procedur a funkc
      * a na konec piazen hodnot vlastnostem

      lcAPRC=m.This.APRC && Alias tabulky procedur
   
      STORE -1 TO m.XX101P,m.XX101C
      STORE 0 TO m.XX000,m.XX001,m.Inherited
      STORE "" TO m.RESERVED7,m.Params,m.XXSC,m.XXDesc,m.XXDescF,m.XXMC,m.XXMI,m.XXSCN
      m.Flags=BITSET(0,3)

      FOR m.XX101=1 TO IIF(loDump.iFoxTable>0 AND loDump.aFoxTable(_aFT_Count)>0,loDump.aFoxTable(_aFT_Count),0)
          loFN=loDump.aFoxInfo(m.XX101)
          m.OBJNAME=loFN.cFuncName
          =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valProcedureIP),"%name%",m.OBJNAME))
          m.XX100R=RECC(m.lcAPRC)+1
          INSERT INTO (m.lcAPRC) FROM MEMVAR && zalo vtu do pomocnho kurzoru
      NEXT
      RETURN
   ENDPROC

   PROCEDURE GenerateClassTree(loObj,llHead,lcScript) && 
      *@loObj    - Objekt s informacema
      *@llHead   - Pznak, zda je aspo jedno vnoen
      *@lcScript - Vygenerovan skripty
      LOCAL lcAObj,lcATree,lcFile,m.XX100R,m.XX100RP,liRecno,lcObjName,m.loPDMs,m.loPDM,lcHTML
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt

      =m.loPDMs.WriteDMSG(m.loPDMs.GetString(_PDM_valGenerateCTPI))

      lcATree=SYS(2015)
      lcAObj=m.This.AObj
      SET COLLATE TO "MACHINE"

      CREATE CURSOR (m.lcATree) (XX100RP I,XX100R I)
      INDEX ON BINTOC(XX100RP) TAG I01
      lcFile=UPPER(ExtractFileFromFile(m.loObj.File))

      SELE (m.lcAObj)
      SEEK (BINTOC(0)) && Find only class
      SCAN WHILE BINTOC(XX101P)=BINTOC(0)
           STORE XX100R TO m.XX100R,m.XX100RP
           IF CLASSLOC=="" OR !UPPER(CLASSLOC)==m.lcFile && Nen-li to tda z tto knihovny, nebo je to zkladn knihovna
              m.XX100RP=0 && Pak je to nejv postaven tda
              INSERT INTO (m.lcATree) FROM MEMVAR
              LOOP
           ENDIF

           liRecno=RECNO() && Zapamatuj si vtu
           lcObjName=UPPER(CLASS) && Nzev tdy
           LOCATE FOR UPPER(OBJNAME)==m.lcObjName
           IF FOUND()
              m.XX100RP=XX100R
              INSERT INTO (m.lcATree) FROM MEMVAR
           ENDIF
           GO (liRecno) && Sko na pvodn vtu
      ENDSCAN
      INDEX ON BINTOC(XX100R) TAG I04 ADDITIVE
      SET COLLATE TO (m.loPDMs.Collate)

      lcHTML=""
      =m.This._GenerateClassTree(0,0,@m.loObj,lcATree,@m.lcHTML,@m.llHead,@m.lcScript)
 
      SELE (m.lcAObj)
      DELETE TAG I04
      SET ORDER TO "I01" IN (m.lcAOBJ)
      USE IN (m.lcATree)   

      RETURN m.lcHTML
   ENDPROC


   PROCEDURE _GenerateClassTree(liLevel,liXX100RP,loObj,lcATree,lcHTML,llHead,lcScript) && Vygeneruje HTML a scripty pro strom td
      * liLevel   - rove vnoen
      * liXX100RP - Parent tda
      *@m.loObj     - Objekt s informacema
      * lcATree   - Alias stromu td
      *@lcHTML    - Vygenerovan HTML kd
      *@llHead    - Pznak, zda je aspo jedno vnoen
      *@lcScript  - Vygenerovan skripty
      LOCAL lcPom,lcRecno,lcDisp,lcPict,liCount,liCnt,lcSP,liCntX,m.loPDM,;
            lcPicture,lc_Script,m.loPDMs,lii,lcFile_d,lcPom2
      LOCAL ARRAY laObj(1)

      m.loPDM=EVAL(m.This.PDM)
      m.loPDMs=EVAL(m.This.PDMs)
      lcPict=m.loObj.aEC(_EC_Cls,2)
      lcDisp=m.loObj.aEC(_EC_Cls,3)
      
      liLevel=m.liLevel+1 && Inkrementuj level (pouze doasn)
      lcSP=IIF(m.loPDM.FormatSpace=_Format_No,"",SPACE(m.liLevel*1))

      STORE 0 TO liCntX,lii
      * Nyn budu prochzet strom a vytvet HTML

      SELE (m.lcATree)
      SET COLLATE TO "MACHINE"
      SEEK BINTOC(m.liXX100RP)
      COUNT TO liCount WHILE BINTOC(XX100RP)==BINTOC(m.liXX100RP)
      IF m.liCount=0 && Pokud tam nic nen
         SELE (m.This.AObj)
         RETURN 0 && Pak vypadni
      ENDIF
      DIME laObj(m.liCount,2)
      SEEK BINTOC(m.liXX100RP)
      SET RELA TO BINTOC(XX100R) INTO (m.This.AObj)
      SCAN WHILE BINTOC(XX100RP)=BINTOC(m.liXX100RP)
           lii=m.lii+1
           laObj(m.lii,1)=EVAL(m.This.AObj+".OBJNAME")
           laObj(m.lii,2)=XX100R
      ENDSCAN
      SET RELA TO 

      IF m.loObj.OL_Classes=1 && Ordered? Yes/No
         SET COLLATE TO "MACHINE"
         =ASORT(laOBJ)
      ENDIF
      SET COLLATE TO (m.loPDMs.Collate)

      SELE (m.This.AObj)
      FOR lii=1 TO m.liCount
          lcRecno=LTRIM(STR(laOBJ(m.lii,2),11))
          STORE "" TO lcPom,lc_Script
          liCnt=m.This._GenerateClassTree(m.liLevel,laOBJ(m.lii,2),@m.loObj,m.lcATree,@m.lcPom,@m.llHead,@m.lc_Script)
          liCntX=m.liCntX+m.liCnt

          =SEEK(BINTOC(laOBJ(m.lii,2)))
          lcPicture=""
          =IIF(!EMPTY(RESERVED4),m.loPDM.AddFileToRepository(FULLPATH(RESERVED4,ExtractPathFromFile(m.loObj.File)),m.loPDM.OutDir+m.loObj.OutDir+"\"+m.loObj.FileName+"\",@m.lcPicture),.T.)

          lcPom2=LOWER(OBJNAME)

          lcFile_d=IIF(m.loObj.HTMLPage=_GSC_Single,m.This.HTMLName,;
                       m.This.preHTMLName+"cls."+m.lcPom2+"."+ExtractExtensionFromFile(m.This.HTMLName))


          lcHTML=m.lcHTML+IIF(m.lii=1,"",m.loPDM.aSpace(21))+;
                 m.lcSP+[<div class="TreeRow"]+IIF(m.liCnt=0,"",[ ondblclick="onExpandTreeRow(']+m.lcRecno+[');"])+[>]+m.loPDM.aSpace(21)+;
                 m.lcSP+IIF(m.liCnt=0,m.loPDM.aSpace(1)+[<div class="imgEC"><img class="imgECh" alt="" /></div>],[ <img class="imgEC" src="../../imgs/]+m.lcPict+[" id="IMG_]+m.lcRecno+[" alt="]+STRTRAN(m.loPDMs.aStrings(PDM_02798),"%name%",m.lcPom2)+[" />])+m.loPDM.aSpace(21)+;
                 m.lcSP+IIF(EMPTY(m.lcPicture),m.loPDM.aSpace(1)+[<div class="imgclass"><img class="imgclassh" alt="" /></div>],[ <img class="imgclass" src="]+m.lcPicture+[" alt="]+STRTRAN(m.loPDMs.aStrings(PDM_02804),"%name%",m.lcPom2)+[" />])+m.loPDM.aSpace(21)+;
                 m.lcSP+m.loPDM.aSpace(1)+[<span class="TreeRow"><a href="]+IIF(m.loObj.HTMLPage=_GSC_Multi,m.lcFile_d,m.lcFile_d+"#"+m.lcPom2)+[" title="]+STRTRAN(m.loPDMs.aStrings(PDM_02799),"%name%",m.lcPom2)+[">]+OBJNAME+'</a></span>'+m.loPDM.aSpace(21)+;
                 m.lcSP+m.loPDM.aSpace(1)+[<span class="TreeRow">]+IIF(EMPTY(RESERVED7),"&nbsp;",StrTranHTMLString(RESERVED7))+[</span>]+m.loPDM.aSpace(21)+;
                 m.lcSP+[</div>]+m.loPDM.aSpace(21)+;
                 IIF(m.liCnt=0,'',m.loPDM.aSpace(21)+;
                 m.lcSP+[<div class="TreeRowE" id="TX_]+m.lcRecno+["]+lcDisp+[>]+m.loPDM.aSpace(21)+;
                 m.lcPom+;
                 m.lcSP+'</div>'+m.loPDM.aSpace(21))

          IF m.liCnt>0
             lcScript=m.lcScript+;
                      STRTRAN(STRTRAN(STRTRAN(m.loPDM.RE,"%ID%",'TX_'+m.lcRecno),"%XType%","Tree"),"%Dir%","../../imgs/")+m.lc_Script
          ENDIF
      NEXT
      IF m.liLevel=1
         llHead=m.liCntX>0
      ENDIF
      RETURN m.liCount
   ENDPROC


   PROCEDURE GenerateProcedures(loObj,lcHTML,lcHTMLH,lcProc,llOne,laObjX)
      *@loObj   - Main Object
      *@lcHTML  - Main HTML
      *@lcHTMLH - Head
      *@lcProc  - List of Procedures
      *@laObjX

      LOCAL lcAPRC,m.loPDM,m.loPDMs,liCnt,liz,lii,lcRecno,lcLOBJNAME,lcFile_dx,lihFile,lcFile_d,;
            lcCSS,lcJS,lcDIAMPCSS,lcDIAMPJS,lcPath,lihFile,lcDir,lcPom,llEC_Proc,lcPict,lcDisp,;
            loFileLevel,liCntM,llFirstIn

      LOCAL ARRAY laObj(1),laObjM(1)
      lcAPRC=m.This.APRC
      m.loPDMs=EVAL(m.loObj.PDMs)
      m.loPDM=EVAL(m.lOObj.PDM)

      STORE "" TO lcCSS,lcJS,lcDIAMPCSS,lcDIAMPJS
      lcDir="../../"
      lcPath=m.loPDM.OutDir+m.loObj.OutDir+"\"+m.loObj.FileName+"\"

      =m.loPDM.GetGLCSS_JS(m.lcPath,m.loObj,@m.lcCSS,@m.lcJS)
      =m.loPDM.GetPI_ENV("DIAMP",lcPath,@m.lcDIAMPCSS,@m.lcDIAMPJS)

      SELE (m.lcAPRC)

      loFileLevel=m.loObj.oFileLevel

      llEC_Proc=m.loObj.aEC(_EC_Procedure,1)
      lcPict=m.loObj.aEC(_EC_Procedure,2)
      lcDisp=m.loObj.aEC(_EC_Procedure,3)

      SET COLLATE TO "MACHINE"
      SELECT OBJNAME,XX100R FROM (m.lcAPRC);
             WHERE BINTOC(XX101P)=BINTOC(-1) ;
             INTO ARRAY laObj
      SET COLLATE TO (m.loPDMs.Collate)
      liCnt=_TALLY

      =IIF(m.loObj.OL_Procedures=1,ASORT(laOBJ),.T.) && Ordered? Yes/No

      SET COLLATE TO "MACHINE"
      SELECT OBJNAME,XX100R FROM (m.lcAPRC);
             WHERE BINTOC(XX101P)=BINTOC(-2) AND !EMPTY(XXSC);
             INTO ARRAY laObjM
      SET COLLATE TO (m.loPDMs.Collate)
      liCntM=_TALLY

      IF m.liCntM>0
         DIME laObj(m.liCnt+m.liCntM,2)
         =AINS(laObj,1)
         =ACOPY(laObjM,laObj,1,ALEN(laObjM),1)
      ENDIF

      IF m.liCnt+m.liCntM>0
         DIME laObjX(m.liCnt+m.liCntM,2)
         =ACOPY(laObj,laObjX)
      ENDIF

      lcFile_d=m.This.HTMLName

      llFirstIn=.T.
      liz=0 && Resetuj ta
      FOR lii=1 TO m.liCnt+m.liCntM
          GO laObj(m.lii,2)
          lcRecno="P"+LTRIM(STR(RECNO(),11))
          lcLOBJNAME="pm."+LOWER(OBJNAME)
          STORE AppendShortFileFromFile(m.lcFile_d,"."+LOWER(OBJNAME)) TO lcFile_dx,laObjX(lii,2)

          lcHTMLH=m.lcHTMLH+;
                  m.loPDM.aSpace(2)+'<tr><td>'+IIF(BITTEST(Flags,2),"P","F")+'</td><td>'+IIF(EMPTY(XXDesc) AND EMPTY(XXSC),OBJNAME,'<a href="'+m.lcFile_dx+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05158),"%name%",OBJNAME)+'">'+OBJNAME+'</a>')+'</td>'+;
                  '<td>'+IIF(EMPTY(RESERVED7),"&nbsp;",StrTranHTMLString(RESERVED7))+'</td></tr>'+m.loPDM.aSpace(21)

          IF !EMPTY(XXSC) OR !EMPTY(XXDesc)
             lcProc=m.lcProc+IIF(m.llOne,m.loPDM.aSpace(3)+'<a href="'+m.lcFile_dx+'" target="'+m.This.Target+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05158),"%name%",OBJNAME)+'">'+OBJNAME+'</a>',m.loPDM.aSpace(4)+'<option value="'+m.lcFile_dx+'">'+OBJNAME+'</option>')+m.loPDM.aSpace(21)

             STORE m.loPDMs.FCreate(m.lcPath+m.lcFile_dx) TO lihFile

             IF m.llFirstIn AND EMPTY(m.This.FirstHTML)
                m.This.FirstHTML=m.lcFile_dx  && Zapi si prvn HTML soubor
                m.This.FirstHTMLTitle=STRTRAN(m.loPDMs.aStrings(PDM_05147),"%name%",OBJNAME)
             ENDIF

             IF m.lihFile<=0 && Pokud to selhalo
                =m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",m.lcPath+m.lcFile_dx))
             ELSE
                lcPom=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05147),"%name%",OBJNAME))+;
                      m.loPDMs.GetStyles(lcDir)+m.loPDM.GetSCCSS(m.lcPath)+m.lcDIAMPCSS+m.lcCSS+;
                      m.loPDMs.AddExternalScript(m.lcDir+m.loPDMs.ExternJS)+m.lcDIAMPJS+m.lcJS+;
                      IIF(BITTEST(XX001,_PDM_MF_bLNKS),m.loPDm.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDm.StopS+m.loPDM.aSpace(21),"")+;
                      '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                      [<div class="diaxp_mhead">]+IIF(XX101P=-2,OBJNAME,STRTRAN(m.loPDMs.aStrings(IIF(BITTEST(Flags,2),PDM_04005,PDM_04006)),"%Name%",OBJNAME))+"</div>"+m.loPDM.aSpace(21)+;
                      '<div class="diaxp_mbody">'+m.loPDM.aSpace(21)+;
                      XXDesc+;
                      m.loPDMs.GenerateBackReferenceHTML(m.loObj.File,"",OBJNAME,lcDir)+;
                      IIF(EMPTY(XXSC),"",;
                       m.loPDM.aSpace(1)+[<div class="SC">]+m.loPDM.aSpace(21)+;
                       m.loPDM.aSpace(2)+[<img onclick="ExpandSC('SP_]+m.lcRecno+[',-1);" class="imgEC" src="../../imgs/]+m.lcPict+[" alt="]+STRTRAN(m.loPDMs.aStrings(PDM_02717),"%name%",OBJNAME)+[" id="IMG_SP_]+m.lcRecno+[" />]+m.loPDM.aSpace(21)+;
                       m.loPDM.aSpace(2)+[<span onclick="ExpandSC('SP_]+m.lcRecno+[',-1);" class="SCCaption"><a name="]+m.lcLOBJNAME+'">'+m.loPDMs.aStrings(PDM_04880)+'</a></span>'+m.loPDM.aSpace(21)+;
                       m.loPDM.aSpace(2)+[<div ]+IIF(m.loPDM.ECPMDblclick=1,[ondblclick="ExpandSC('SP_]+m.lcRecno+[',-1);"],"")+[ class="SCE"]+lcDisp+' id="TX_SP_'+m.lcRecno+'">'+m.loPDM.aSpace(21)+;
                       XXSC+;
                       m.loPDM.aSpace(2)+'</div>'+m.loPDM.aSpace(21)+;
                       m.loPDM.aSpace(1)+'</div>'+m.loPDM.aSpace(21))+;
                       "</div>"+m.loPDM.aSpace(21)+;
                       '<div class="diaxp_mfoot">'+XXDescF+'</div>'+m.loPDM.aSpace(21)

                lcPom=m.lcPom+IIF(EMPTY(XXSC),"",;
                      m.loPDM.StartS+;
                      STRTRAN(STRTRAN(STRTRAN(m.loPDM.RE,"%ID%",'TX_SP_'+m.lcRecno),"%XType%","SourceCode"),"%Dir%",m.lcDir+"imgs/")+m.loPDM.aSpace(21)+;
                      m.loPDM.StopS)+;
                      '</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21)

                =FWRITE(m.lihFile,m.lcPom)
                =m.loPDMs.FClose(m.lihFile)

                IF ISNULL(m.loFileLevel)
                   =m.loPDM.AddFile(m.loObj.nLI1,m.loObj.nLI2,m.loObj.nLI3,m.loObj.nLI4,m.loObj.OutDir+"\"+m.loObj.FileName+"\"+m.lcFile_dx,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05147),"%name%",OBJNAME),_PDM_FG_Any+_PDM_FG_Proced)
                ELSE
                   STORE EVAL("m.loFileLevel.I"+LTRIM(STR(m.loFileLevel.nLevel,11)))+1 TO ("m.loFileLevel.I"+LTRIM(STR(m.loFileLevel.nLevel,11)))
                   =m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,m.loObj.OutDir+"\"+m.loObj.FileName+"\"+m.lcFile_dx,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05147),"%name%",OBJNAME),_PDM_FG_Any+_PDM_FG_Proced)
                ENDIF
             ENDIF
          ENDIF
          llFirstIn=.F.
      NEXT
   ENDPROC
ENDDEFINE

