**************************************************************************
** Program name: PDM_DBC.PRG
** Version: 1.3.0
** Create date: 2010-01-01
** Description: Class for process VFP Database Container
** Author: Martina Jindrov
** E-mail: jindra@egservis.cz
** JID: gorila@dione.zcu.cz
** CP: 1250

#INCLUDE "Main.h"
#INCLUDE "RegAPI.h"
#INCLUDE "winnt.h"
#INCLUDE "procthrd.h"
#INCLUDE "dumpfll.h"


******************************************
** Definice tdy pro vygenerovn strnek dabz a volnch tabulek
DEFINE CLASS _pdm_DBC AS _pdm_Session
   Name="_pdm_DBC"
   OutDir="data"
   Type=_PDM_FG_DBC && type of file group
   
   nLI1=4 && Level index

   hFile=0 && Handle na oteven soubor

   OL_Fields=0 && Zda se m seznam poloek setdit
   OL_Indexes=0 && Zda se m seznam index setdit
   OL_Relations=0 && Zda se m seznam relac setdit

   OL_Procedures=1 && Zda se m seznam procedur setdit
   OL_Classes=1 && Zda se m seznam td setdit
   OL_Objects=1 && Zda se m seznam objekt setdit
   OL_Methods=1 && Zda se m seznam metod setdit
   OL_Properties=1 && Zda se m seznam vlastnost setdit
   OL_Tables=1 && Zda se m seznam tabulek setdit
   OL_Views=1 && Zda se m seznam pohled setdit
   OL_Connections=1 && Zda se m seznam spojen setdit
   OL_DBC=1 && Zda se m seznam databz setdit
   OL_Queries=1 && Zda se m seznam dotaz setdit


   QFL_FreeTables=1  && Zda se m seznam free tabulek generovat do quick file list
   QFL_Queries=1     && Zda se m seznam dotaz generovat do quick file list
   QFL_DBC=1         && Zda se m seznam databz generovat do quick file list
   QFL_Views=1       && Zda se m seznam pohled generovat do quick file list
   QFL_Tables=1      && Zda se m seznam tabulek generovat do quick file list
   QFL_Connections=1 && Zda se m seznam spojen generovat do quick file list
   QFL_Procedures=1  && Zda se m seznam procedur generovat do quick file list
   QFL_EventFile=1   && Zda se m seznam procedur event file generovat do quick file list


   GEN_SP=1 && Zda se m seznam uloench procedur generovat
   GEN_EF=1 && Zda se m soubor udlost generovat
   GEN_Tables=1 && Zda se m seznam tabulek generovat
   GEN_Views=1 && Zda se m seznam pohled generovat
   GEN_Connections=1 && Zda se m seznam spojen generovat
   GEN_Queries=1 && Zda se m seznam dotaz generovat

   GEN_Fields=1 && Zda se m seznam poloek generovat
   GEN_Indexes=1 && Zda se m seznam index generovat
   GEN_Relations=1 && Zda se m seznam relac generovat

   EC_Procedure=_SC_Collapse
   EC_Main=_SC_Collapse
   EC_Method=_SC_Collapse
   EC_Cls=_SC_Collapse
   EC_Tab=_SC_Collapse
   EC_Expr=_SC_Collapse
   IncludeSC=_SC_Include
   IncludeDD=_DD_Include

   HTMLMain="Data.htm"
   HTMLDetail="DBC_Page.htm"
   HTMLList="DBC_List.htm"
   HTMLUni="DBC_Uni.htm"


   HTMLPage=_GSC_Single && Pznak, zda se m generovat jedna strnka pro celou VCX knihovnu, ;
                        && nebo co tda, to strnka

   FPL=.NULL.
   oAPRG=.NULL.

   DIME aTF(3)
   aTF(1)="d"
   aTF(2)="D"
   aTF(3)="Q"

   DIME aPF(3)
   aPF(1)=""
   aPF(2)="FreeTables"
   aPF(3)="Queries"

   DBCName=""

   lLNK=.F. && Flag of multilinks
   
   _headerlinks=""
   
   PROCEDURE Init(pcCollate) && Inicializace objektu
      =DODEFAULT(pcCollate) && Voln pvodn metody
      This.FPL=CREATEOBJECT("_FileProcessList")
      This.FPL.Name="DBC_FPL"
      This.oAPRG=CREATEOBJECT("_PDM_AnalyseSC",.NULL.,.NULL.)
   ENDPROC

   PROCEDURE GetBasePathForFile(lcGroup,lcFile)
      * lcGroup - group file
      * lcFile  - base file name
      FOR lii=1 TO ALEN(This.aTF)
          IF This.aTF(m.lii)==lcGroup
             RETURN LOWER(This.OutDir)+"/"+IIF(EMPTY(This.aPF(m.lii)),"",This.aPF(m.lii)+"/")+LOWER(lcFile)
          ENDIF
      NEXT
      RETURN lcFile
   ENDPROC

   PROCEDURE GenerateHTML() && Vygeneruje HTML strnky
      LOCAL ARRAY laDBCs(1),laDBFs(1),laQPRs(1)
      LOCAL lii, lcString,lcPom,lcPath,loPDM,loRam,lcFile,lihFile,liCount,;
            lcHead,lcCom,llProcess,lcAnchor,loPDMs,lcPath,;
            lcFile_h,lcFile_dDBC,lcFile_dDBF,lcFile_dQPR,lcFile_d,llDBC,llDBF,llQPR,;
            lcFileX,llChange,llOne,lcCSS,lcJS,lcSF,lcPathX,lcHeadersLinks,lcStringFL,lcStringFLD,lcStringUNI,;
            llQFL_Database

      loPDM=EVAL(m.This.PDM) && Zskej odkaz na PDM objekt
      loPDMs=EVAL(m.This.PDMs) && Zskej odkaz na PDMs objekt
      llOne=loPDM.One

      lcFile=m.This.HTMLDetail
      lcFile_h=AppendShortFileFromFile(lcFile,"_h")
      lcFile_dDBC=AppendShortFileFromFile(lcFile,"_dDBC")
      lcFile_dDBF=AppendShortFileFromFile(lcFile,"_dDBF")
      lcFile_dQPR=AppendShortFileFromFile(lcFile,"_dQPR")
      lcFile_d=AppendShortFileFromFile(lcFile,"_d")

      This.aEC(_EC_Tab,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND This.EC_Tab=_SC_Expand
      This.aEC(_EC_Tab,2)=IIF(m.This.aEC(_EC_Tab,1),"uptab.gif","dotab.gif")
      This.aEC(_EC_Tab,3)=IIF(m.This.aEC(_EC_Tab,1),'',' style="display: none;"')

      This.aEC(_EC_Procedure,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Procedure=_SC_Expand
      This.aEC(_EC_Procedure,2)=IIF(m.This.aEC(_EC_Procedure,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      This.aEC(_EC_Procedure,3)=IIF(m.This.aEC(_EC_Procedure,1),'',' style="display: none;"')

      This.aEC(_EC_Main,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Main=_SC_Expand
      This.aEC(_EC_Main,2)=IIF(m.This.aEC(_EC_Main,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      This.aEC(_EC_Main,3)=IIF(m.This.aEC(_EC_Main,1),'',' style="display: none;"')

      This.aEC(_EC_Method,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Method=_SC_Expand
      This.aEC(_EC_Method,2)=IIF(m.This.aEC(_EC_Method,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      This.aEC(_EC_Method,3)=IIF(m.This.aEC(_EC_Method,1),'',' style="display: none;"')

      This.aEC(_EC_Cls,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Cls=_SC_Expand
      This.aEC(_EC_Cls,2)=IIF(m.This.aEC(_EC_Cls,1),"uptab.gif","dotab.gif")
      This.aEC(_EC_Cls,3)=IIF(m.This.aEC(_EC_Cls,1),'',' style="display: none;"')

      m.This.aEC(_EC_Expr,1)=m.loPDM.ExpandAllPM=_EPM_Expand OR m.loPDM.ExpandAllPM=_EPM_User AND m.This.EC_Expr=_SC_Expand
      m.This.aEC(_EC_Expr,2)=IIF(m.This.aEC(_EC_Expr,1),"uptab.gif","dotab.gif") && "redarrd.gif","redarr.gif"
      m.This.aEC(_EC_Expr,3)=IIF(m.This.aEC(_EC_Expr,1),'',' style="display: none;"')

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"
      lcPathX=m.This.OutDir+"\"


      STORE CREATEOBJECT("_pdm_FileLevel") TO loFileLevel,This.oFileLevel

      This.lLNK=.F.
      m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)


      * Free tables
      This.nLI2=4 && Increment counter
      This.nLI3=0
      This.nLI4=0

      loFileLevel.Reset()
      loFileLevel.I1=m.This.nLI1
      loFileLevel.I2=m.This.nLI2
      loFileLevel.nLevel=3

      lcStringFL=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_05140))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                 '</head>'+m.loPDM.aSpace(21)+'<body class="quickfilelist">'+m.loPDM.aSpace(21)+;
                 '<table border="0" cellspacing="0">'+m.loPDM.aSpace(21)+;
                 m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)



      liCount=m.loPDM.GetListOfObject(m.This.aTF(2),@laDBFs) && Vrt seznam volnch DBF tabulek

      STORE IIF(m.This.GEN_Tables=0 OR liCount=0,0,m.loPDMs.FCreate(lcPath+lcFile_dDBF)) TO lihFile,This.hFile
      IF lihFile>0
         This.HTMLOMMain=IIF(llOne,lcPathX+lcFile_dDBF,"")
         llDBF=.T.
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00779))+;
                  m.loPDMs.GetStyles('../')+m.loPDM.GetSCCSS(m.lcPath)+lcCSS+;
                  m.loPDMs.AddExternalScript('../'+m.loPDMs.ExternJS)+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body  '+IIF(llDBC,'style="'+loPDMs.s_pbf+'"','')+'>'+m.loPDM.aSpace(21)
         =FWRITE(lihFile,lcString)

         * seznam volnch tabulek
         =IIF(m.This.OL_Tables=1,ASORT(laDBFs,1),.T.)&& M se to setdit ?

         lcString='<h2><a name="2">'+m.loPDMs.aStrings(PDM_00779)+'</a></h2>'+m.loPDM.aSpace(21)+;
                  '<table border="1" cellspacing="0" >'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<td title="'+m.loPDMs.aStrings(PDM_04536)+'">'+m.loPDMs.aStrings(PDM_04538)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04537)+'">'+m.loPDMs.aStrings(PDM_04539)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04543)+'">'+m.loPDMs.aStrings(PDM_04542)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05172)+'">'+m.loPDMs.aStrings(PDM_04540)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05173)+'">'+m.loPDMs.aStrings(PDM_04541)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

         lcStringFLD=""
         FOR lii = 1 TO liCount
             IF m.loPDM.GetPropertiesOfObject(laDBFs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                llProcess=!(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(NullTermined(loRam.Name)))
                STORE FULLPATH(NullTermined(loRam.Name),m.loPDM.PJXPath) TO lcPom,laDBFs(lii,4)

                laDBFs(lii,3)=FILE(lcPom) && Test, if file exists
*!*	                lcAnchor=IIF(!laDBFs(lii,3),"",IIF(llProcess,"FreeTables/"+LOWER(ExtractFileFromFile(lcPom))+".htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcAnchor=IIF(!laDBFs(lii,3),"",IIF(llProcess,"FreeTables/"+loRam.GUID+".htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcCom=NullTermined(loRam.Comments)
                lcSF=ExtractFileFromFile(lcPom)
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="../imgs/'+IIF(!laDBFs(lii,3),"fne.gif",IIF(loRam.Exclude,"fy.gif","fn.gif"))+'" alt="'+IIF(loRam.Exclude,m.loPDMs.aStrings(PDM_05170),m.loPDMs.aStrings(PDM_05171))+'" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(loRam.CPId),"&nbsp;",LTRIM(STR(loRam.CPId,5)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="a_right">'+IIF(loRam.Size=-1,"&nbsp;",loPDMs.SizeToS(loRam.Size))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05167),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+ExtractPathFromFile(lcPom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         IIF(EMPTY(lcCom),"",;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="brzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="blzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td colspan="3">'+StrTranHTMLString(@m.lcCom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21))

                IF This.QFL_FreeTables=1 AND llProcess
                   lcStringFLD=lcStringFLD+;
                              m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td colspan="3">'+IIF(lcAnchor=="",lcSF,'<a href="'+This.HTMLUni+"?next="+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05167),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
                ENDIF              
                         
             ENDIF
         ENDFOR
         =FWRITE(lihFile,lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))
         =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,This.nLI2,This.nLI3,This.nLI4,lcPathX+lcFile_dDBF,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00779),_PDM_FG_Any)

         IF This.QFL_FreeTables=1 AND LEN(lcStringFLD)>0
            lcStringFL=lcStringFL+m.loPDM.aSpace(2)+'<tr><td colspan="4">'+m.loPDMs.aStrings(PDM_00779)+'</td></tr>'+m.loPDM.aSpace(21)+lcStringFLD
         ENDIF


         IF liCount>0 
            IF !INLIST(m.loPDMs.MKD(lcPath+"FreeTables"),0,1) && Zalo podadres pro voln tabulky
               m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcPath+"FreeTables"))
            ELSE
               * Generovn HTML kdu pro voln tabulky
               FOR lii = 1 TO liCount
                   IF laDBFs(lii,3) AND m.loPDM.GetPropertiesOfObject(laDBFs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                      This.RamPJX=loRam
                      lcPom=NullTermined(loRam.Name)

                      IF !(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(lcPom))

                         m.loPDMs.WriteMSG(STRTRAN(m.loPDMs.GetString(_PDM_valFileInProcess),"%File%",lcPom))

                         STORE m.This.nLI3+1 TO This.nLI3,loFileLevel.I3  && Increment counter

                         This.File=laDBFs(lii,4)
*!*	                         This.FileName=LOWER(ExtractFileFromFile(m.This.File))
                         This.FileName=loRam.GUID
                         This.GenerateHTML_DBF(m.This.File,This.FileName+".htm", ALLT(loRam.KEY))
                         This.File="" && Reset name of file
                      ENDIF
                   ENDIF
               ENDFOR
            ENDIF
         ENDIF
      ELSE
         =IIF(llOne OR liCount=0,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dDBF)))
      ENDIF


      =m.loPDMs.WriteDMSG("")

      * Queries
      This.nLI2=5
      This.nLI3=0
      This.nLI4=0

      liCount=m.loPDM.GetListOfObject(m.This.aTF(3),@laQPRs) && Vrt seznam dotaz
      STORE IIF(m.This.GEN_Queries=0 OR liCount=0,0,m.loPDMs.FCreate(lcPath+lcFile_dQPR)) TO lihFile,m.This.hFile
      IF lihFile>0 AND liCount>0
         m.This.HTMLOMMain=IIF(llOne,lcPathX+lcFile_dQPR,"")
         llQPR=.T.
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00781))+;
                  m.loPDMs.GetStyles('../')+lcCSS+;
                  lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body '+IIF(llDBC OR llDBF,'style="'+loPDMs.s_pbf+'"','')+'>'+m.loPDM.aSpace(21)
         =FWRITE(lihFile,lcString)

         * Seznam dotaz
         =IIF(m.This.OL_Queries=1,ASORT(laQPRs,1),.T.) && M se to setdit ?

         lcString='<h2><a name="2">'+m.loPDMs.aStrings(PDM_00781)+'</a></h2>'+m.loPDM.aSpace(21)+;
                  '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<td title="'+m.loPDMs.aStrings(PDM_04536)+'">'+m.loPDMs.aStrings(PDM_04538)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04537)+'">'+m.loPDMs.aStrings(PDM_04539)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04543)+'">'+m.loPDMs.aStrings(PDM_04542)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05172)+'">'+m.loPDMs.aStrings(PDM_04540)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05173)+'">'+m.loPDMs.aStrings(PDM_04541)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

         lcStringFLD=""
         
         FOR lii = 1 TO liCount
             IF m.loPDM.GetPropertiesOfObject(laQPRs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                llProcess=!(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(NullTermined(loRam.Name)))
                STORE FULLPATH(NullTermined(loRam.Name),m.loPDM.PJXPath) TO lcPom,laQPRs(lii,4)
                laQPRs(lii,3)=FILE(lcPom) && Test, if file exists
*!*	                lcAnchor=IIF(!laQPRs(lii,3),"",IIF(llProcess,"Queries/"+LOWER(ExtractFileFromFile(lcPom))+".htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcAnchor=IIF(!laQPRs(lii,3),"",IIF(llProcess,"Queries/"+loRam.GUID+".htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcCom=NullTermined(loRam.Comments)
                lcSF=ExtractFileFromFile(lcPom)
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="../imgs/'+IIF(!laQPRs(lii,3),"fne.gif",IIF(loRam.Exclude,"fy.gif","fn.gif"))+'" alt="'+IIF(loRam.Exclude,m.loPDMs.aStrings(PDM_05170),m.loPDMs.aStrings(PDM_05171))+'" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(loRam.CPId),"&nbsp;",LTRIM(STR(loRam.CPId,5)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="a_right">'+IIF(loRam.Size=-1,"&nbsp;",loPDMs.SizeToS(loRam.Size))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05157),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+ExtractPathFromFile(lcPom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         IIF(EMPTY(lcCom),"",;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="brzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="blzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td colspan="3">'+StrTranHTMLString(@m.lcCom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21))
                         
                IF This.QFL_Queries=1 AND llProcess
                   lcStringFLD=lcStringFLD+;
                              m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td colspan="3">'+IIF(lcAnchor=="",lcSF,'<a href="'+This.HTMLUni+"?next="+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05157),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
                ENDIF              
                         
             ENDIF
         ENDFOR
         =FWRITE(lihFile,lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))
         =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,This.nLI2,This.nLI3,This.nLI4,lcPathX+lcFile_dQPR,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00781),_PDM_FG_Any)

         IF This.QFL_Queries=1 AND LEN(lcStringFLD)>0
            lcStringFL=lcStringFL+m.loPDM.aSpace(2)+'<tr><td colspan="4">'+m.loPDMs.aStrings(PDM_00781)+'</td></tr>'+m.loPDM.aSpace(21)+lcStringFLD
         ENDIF

         * Generovn kdu pro dotazy
         IF liCount>0 
            IF !INLIST(m.loPDMs.MKD(lcPath+"Queries"),0,1) && Zalo podadres pro voln tabulky
               m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcPath+"Queries"))
            ELSE
               This.nLI3=0
               FOR lii = 1 TO liCount
                   IF laQPRs(lii,3) AND m.loPDM.GetPropertiesOfObject(laQPRs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                      This.RamPJX=m.loRam
                      lcPom=NullTermined(loRam.Name)
                      IF !(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(lcPom))
                         This.File=laQPRs(lii,4)
*!*	                         This.FileName=LOWER(ExtractFileFromFile(m.This.File))
                         This.FileName=loRam.GUID

                         m.loPDMs.WriteMSG(STRTRAN(m.loPDMs.GetString(_PDM_valFileInProcess),"%File%",lcPom))
                         This.nLI3=m.This.nLI3+1 && Increment counter

                         This.GenerateHTML_QPR(This.File, This.FileName+".htm",ALLT(loRam.KEY))
                         This.File="" && Reset name of file
                      ENDIF
                   ENDIF
               ENDFOR
            ENDIF
         ENDIF
      ELSE
         =IIF(llOne OR liCount=0,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dQPR)))
      ENDIF

      * DBC containers
      liCount=m.loPDM.GetListOfObject(m.This.aTF(1),@laDBCs) && Vrt seznam DBC konteiner
      STORE IIF(liCount=0,0,IIF(llOne,1,m.loPDMs.FCreate(lcPath+lcFile_dDBC))) TO lihFile,m.This.hFile

      llDBC=lihFile>0 AND liCount>0

      This._headerLinks=IIF(llDBF,m.loPDM.aSpace(3)+IIF(!llDBC AND !llQPR,m.loPDMs.aStrings(PDM_00779),'<a href="../'+lcFile_dDBF+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00779))+[">]+m.loPDMs.aStrings(PDM_00779)+'</a><br />')+m.loPDM.aSpace(21),"")+;
                        IIF(llQPR,m.loPDM.aSpace(3)+IIF(!llDBC AND !llDBF,m.loPDMs.aStrings(PDM_00781),'<a href="../'+lcFile_dQPR+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00781))+[">]+m.loPDMs.aStrings(PDM_00781)+'</a>')+m.loPDM.aSpace(21),"")

      lcheaderLinks=IIF(llDBF,m.loPDM.aSpace(3)+IIF(!llDBC AND !llQPR,m.loPDMs.aStrings(PDM_00779),'<a href="'+lcFile_dDBF+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00779))+[">]+m.loPDMs.aStrings(PDM_00779)+'</a><br />')+m.loPDM.aSpace(21),"")+;
                    IIF(llQPR,m.loPDM.aSpace(3)+IIF(!llDBC AND !llDBF,m.loPDMs.aStrings(PDM_00781),'<a href="'+lcFile_dQPR+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00781))+[">]+m.loPDMs.aStrings(PDM_00781)+'</a>')+m.loPDM.aSpace(21),"")

      IF llDBC
         This._headerLinks=m.loPDM.aSpace(3)+IIF(!llDBF AND !llQPR,m.loPDMs.aStrings(PDM_00777),'<a href="../'+lcFile_dDBC+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00777))+[">]+m.loPDMs.aStrings(PDM_00777)+'</a> ')+m.loPDM.aSpace(21)+;
                           This._headerLinks

         lcheaderLinks=m.loPDM.aSpace(3)+IIF(!llDBF AND !llQPR,m.loPDMs.aStrings(PDM_00777),'<a href="'+lcFile_dDBC+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05101),"%Data%",m.loPDMs.aStrings(PDM_00777))+[">]+m.loPDMs.aStrings(PDM_00777)+'</a> ')+m.loPDM.aSpace(21)+;
                       lcheaderLinks
                       
         IF !llOne
            lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00777))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
            '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
            =FWRITE(lihFile,lcString)
         ENDIF

         * Seznam DBC konteiner
         lcString=IIF(llOne,"",'<h2><a name="1">'+m.loPDMs.aStrings(PDM_00777)+'</a></h2><br />'+m.loPDM.aSpace(21)+'<table border="1" cellspacing="0" >'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<td title="'+m.loPDMs.aStrings(PDM_04536)+'">'+m.loPDMs.aStrings(PDM_04538)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04537)+'">'+m.loPDMs.aStrings(PDM_04539)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_04543)+'">'+m.loPDMs.aStrings(PDM_04542)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05172)+'">'+m.loPDMs.aStrings(PDM_04540)+'</td>'+;
                  '<td title="'+m.loPDMs.aStrings(PDM_05173)+'">'+m.loPDMs.aStrings(PDM_04541)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21))


         =IIF(m.This.OL_DBC=1,ASORT(laDBCs,1),.T.) && M se to setdit ?
         llQFL_Database=.F.
         
         FOR lii = 1 TO liCount
             IF m.loPDM.GetPropertiesOfObject(laDBCs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                llProcess=!(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(NullTermined(loRam.Name)))
                STORE FULLPATH(NullTermined(loRam.Name),m.loPDM.PJXPath) TO lcPom,laDBCs(lii,4)
                laDBCs(lii,3)=FILE(lcPom) && Test, if file exists
*!*	                lcAnchor=IIF(!laDBCs(lii,3),"",IIF(llProcess,LOWER(ExtractFileFromFile(lcPom))+"/Main.htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcAnchor=IIF(!laDBCs(lii,3),"",IIF(llProcess,loRam.GUID+"/Main.htm",m.loPDMs.GetAnchor(lcPom,"../")))
                lcCom=NullTermined(loRam.Comments)
                lcSF=ExtractFileFromFile(lcPom)
                lcString=IIF(llOne,"",lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="../imgs/'+IIF(!laDBCs(lii,3),"fne.gif",IIF(loRam.Exclude,"fy.gif","fn.gif"))+'" alt="'+IIF(loRam.Exclude,m.loPDMs.aStrings(PDM_05170),m.loPDMs.aStrings(PDM_05171))+'" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(loRam.CPId),"&nbsp;",LTRIM(STR(loRam.CPId,5)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="a_right">'+IIF(loRam.Size=-1,"&nbsp;",loPDMs.SizeToS(loRam.Size))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05161),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+ExtractPathFromFile(lcPom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         IIF(EMPTY(lcCom),"",;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="brzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="brzero">&nbsp;</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td colspan="3">'+StrTranHTMLString(@m.lcCom)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)))
                         
                IF This.QFL_DBC=1 AND llProcess
                   llQFL_Database=.T.
                   laDBCs(lii,5)=m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td colspan="3">'+IIF(lcAnchor=="",lcSF,'<a href="'+lcAnchor+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05161),"%name%",lcSF)+'">'+lcSF+'</a>')+'</td></tr>'+m.loPDM.aSpace(21)
                ENDIF              
                         

             ENDIF
         ENDFOR
         lcString=IIF(llOne,"",lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>')

         IF !llOne
            =FWRITE(lihFile,lcString+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,3,0,0,lcPathX+lcFile_dDBC,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_00777),1)
         ENDIF

         This.nLI2=3
         loFileLevel.Reset()
         loFileLevel.I1=m.This.nLI1
         loFileLevel.I2=m.This.nLI2
         loFileLevel.I3=0

         * Vytvo strnky DBC konteiner
         FOR lii = 1 TO liCount
             This.File="" && Reset name of file
             IF laDBCs(lii,3) AND m.loPDM.GetPropertiesOfObject(laDBCs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                This.RamPJX=loRam
                IF !(loRam.Exclude AND m.loPDM.NP_ExcludeFiles=1) AND (m.loPDM.SourceType=_PDM_ST_OMFiles OR m.This.FPL.Type=1 OR m.This.FPL.IsFileProcess(lcPom))
                   STORE laDBCs(lii,4) TO This.File,lcFileX
                   llChange=m.loPDM.ICL_TestFile(lcFileX)
                   IF m.loPDM.Incremental=1 AND !llChange && Pokud je inkrementln generovn a nen zmna na souboru
                      LOOP && Pak sko na dal
                   ENDIF
                   
*!*	                   This.FileName=LOWER(ExtractFileFromFile(lcFileX))
                   This.FileName=loRam.GUID
                   IF !INLIST(m.loPDMs.MKD(lcPath+m.This.FileName),0,1) && Zalo podadres pro DBC konteiner
                      m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcPath+m.This.FileName))
                      LOOP
                   ELSE
                      m.loPDMs.WriteMSG(STRTRAN(m.loPDMs.GetString(_PDM_valFileInProcess),"%File%",lcPom))
                      STORE 1 TO m.This.nLI4,loFileLevel.I4 && Reset counter
                      STORE m.This.nLI3+1 TO This.nLI3,loFileLevel.I3 && Increment counter
                      lcStringFLD=""
                      This.GenerateHTML_DBC(lcFileX, "Main.htm", ALLT(loRam.KEY),@lcStringFLD)
                      
                      IF This.QFL_DBC=1
                         laDBCs(lii,5)=laDBCs(lii,5)+lcStringFLD
                      ENDIF   
                   ENDIF
                ENDIF
             ENDIF
         ENDFOR

         IF This.QFL_DBC=1 AND llQFL_Database
            lcStringFL=lcStringFL+m.loPDM.aSpace(2)+'<tr><td colspan="4">'+m.loPDMs.aStrings(PDM_00777)+'</td></tr>'+m.loPDM.aSpace(21)
            FOR lii = 1 TO liCount
                IF LEN(laDBCs(lii,5))>0
                   lcStringFL=lcStringFL+laDBCs(lii,5)
                ENDIF
            NEXT
         ENDIF

      ELSE
         =IIF(llOne OR liCount=0,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dDBC)))
      ENDIF


      * Vygenerovn istho detailu
      IF !llOne AND !llDBC AND !llDBF AND !llQPR
         STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_04607))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                     '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                     m.loPDMs.aStrings(PDM_04607)+'<br />'+m.loPDM.aSpace(21)+;
                     '</body>'+m.loPDM.aSpace(21)+'</html>'
            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,6,0,0,lcPathX+lcFile_d,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_04607),_PDM_FG_None)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_d))
         ENDIF
      ENDIF

      =m.loPDMs.WriteDMSG("")

      * Header definition
      STORE IIF(llOne,0,m.loPDMs.FCreate(lcPath+lcFile_h)) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_05140))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<table class="file_head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="70%">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<h1>'+m.loPDMs.aStrings(PDM_00758)+'</h1>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="30%" class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                  lcheaderLinks+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'
               
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,2,0,0,lcPathX+lcFile_h,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_05140),_PDM_FG_None)
      ELSE
         =IIF(llOne,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_h)))
      ENDIF


      * Generovn DBC_List - jen uloen
      STORE m.loPDMs.FCreate(lcPath+This.HTMLList) TO lihFile
      IF lihFile>0
         =FWRITE(lihFile,lcStringFL+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+This.HTMLList))
      ENDIF

      * Generovn DBC_Uni - jen uloen
      STORE m.loPDMs.FCreate(lcPath+This.HTMLUni) TO lihFile
      IF lihFile>0
         TEXT TO lcStringUNI TEXTMERGE NOSHOW 
<<m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_05140))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+'</head>'>>
<<m.loPDM.StartS>>
var lcSearch=document.location.search;
var laSearch = lcSearch.split("&");
var laParams = laSearch[0].split("=");
var lcPom= laParams[1];
if (laSearch.length==2)
   {
   lcPom=lcPom+"?"+laSearch[1];
   }
document.writeln('<frameset framespacing="0" frameborder="1" rows="100%" cols="<<IIF(m.loPDM.ShowQuickFileList=1,'333','122')>>,*" title="Data">');
document.writeln('<frame name="F1" src="../MainMenu.htm?QUICKLIST=<<IIF(m.loPDM.ShowQuickFileList=0,"Blank_QL.htm",m.This.OutDir+'/'+m.This.HTMLList)>>" noresize="true" title="Main menu">');
document.writeln(' <frameset framespacing="0" frameborder="1" rows="100,*" cols="100%">');
document.writeln('  <frame name="F2" src="DBC_Page_h.htm" >');
document.writeln('  <frame name="F3" src="'+lcPom+'" >');
document.writeln(' <//frameset>');
document.writeln('<//frameset>');
<<m.loPDM.StopS>>
</html>
         ENDTEXT
      
         =FWRITE(lihFile,lcStringUNI)
         =m.loPDMs.FClose(lihFile)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+This.HTMLUni))
      ENDIF

      * Definice frames
      STORE IIF(llOne,0,m.loPDMs.FCreate(lcPath+lcFile)) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_00758))+m.loPDMs.GetStyles('../')+lcCSS+lcJS+m.loPDM.aSpace(21)+'</head>'+m.loPDM.aSpace(21)+;
                  [<frameset framespacing="0" frameborder="1" rows="100,*" cols="100%" title="]+m.loPDMs.aStrings(PDM_00758)+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+[<frame name="F2" src="]+lcFile_h+[" title="]+m.loPDMs.aStrings(PDM_05140)+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+[<frame name="F3" src="]+IIF(!llDBC,IIF(!llDBF,IIF(!llQPR,lcFile_d,lcFile_dQPR),lcFile_dDBF),lcFile_dDBC)+[" title="]+m.loPDMs.aStrings(PDM_05111)+[">]+m.loPDM.aSpace(21)+;
                  [</frameset>]+m.loPDM.aSpace(21)+;
                  [</html>]
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,1,0,0,lcPathX+lcFile,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00758),_PDM_FG_None)
      ELSE
         =IIF(llOne,.T.,m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile)))
      ENDIF

      This.oFileLevel=.NULL.
   ENDPROC

   PROCEDURE GenerateHTML_DBC(lcDBC,lcHTML,lcDBName,lcStringFLD) && Vygeneruje strnku DBC konteineru
      * lcDBC    - Umstn a nzev DBC konteineru
      * lcHTML   - Zkladn nzev HTML strnky
      * lcDBName - Nzev DBC konteineru
      *@lcStringFLD - Data for quick file list

      LOCAL lcADBC,lcString,luValue,lcCode,liCount,liCount2,liCountX,;
            lcPom,lcName,lii,liy,liz,lix,loAPRG,lcAlias,;
            liObjectID, llExpand,lihFile,;
            m.loPDM,lcFile,lcFile_h,lcFile_d,lcBody,lcSize,lcRecno,llEC_Tab,;
            llGEN_Tables,llGEN_Views,llGEN_Connections,llGEN_SP,lcRecno,lcPict,lcDisp,m.loPDMs,;
            lcScript,lcPict,lcDisp,lcPath,lcPathX,;
            lcFile_dT,lcFile_dV,lcFile_dC,lcFile_dSP,lcFile_dEF,llOne,lcCSS,lcJS,llDBCEvents,;
            lcDIAFCSS,lcDIAFJS,lcDIAF,lcDIAXF,lcFile_dex,llEx,loPIPar,loFileLevel,lcHTML_Uni,lcHTML_dSP_Uni,lcHTML_dEF_Uni,;
            lcStringFLD_SP,lcStringFLD_EV
            


      LOCAL ARRAY laObj(1),laObj2(1),laPRC(1),laSO(1),laStrings(10)
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      loAPRG=m.This.oAPRG
      loAPRG.Reset()
      llOne=m.loPDM.One


      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"
      This.HTMLOMMain=IIF(llOne,lcPathX+lcHTML,"")
            
      lcHTML_Uni=AppendShortFileFromFile(lcHTML,"_Uni")
      lcFile_h=AppendShortFileFromFile(lcHTML,"_h")
      lcFile_d=AppendShortFileFromFile(lcHTML,"_d")

      lcFile_dT=AppendShortFileFromFile(lcHTML,"_dT")
      lcFile_dV=AppendShortFileFromFile(lcHTML,"_dV")
      lcFile_dC=AppendShortFileFromFile(lcHTML,"_dC")
      lcFile_dSP=AppendShortFileFromFile(lcHTML,"_dSP")
      lcFile_dEF=AppendShortFileFromFile(lcHTML,"_dEF")
      lcFile_dex=AppendShortFileFromFile(lcHTML,"_dEx")

      lcHTML_dSP_Uni=AppendShortFileFromFile(lcFile_dSP,"_Uni")
      lcHTML_dEF_Uni=AppendShortFileFromFile(lcFile_dEF,"_Uni")

      lcADBC=SYS(2015)
      lcAlias=SYS(2015)

      STORE "" TO lcStringFLD_SP,lcStringFLD_EV
      
      This.DBCName=lcDBName

      * Nyn se pokus otevt DBC konteiner jako tabulku
      IF m.loPDMs.OpenTable(m.This.DataSessionID,lcDBC,lcADBC," AGAIN SHARE")>0 &&  NOUPDATE
         RETURN _PDM_FileNO
      ENDIF

      SELE (lcADBC)
      liDBCID=DBC_GetIDObject(lcADBC,_DBC_DataBase,"Database")
      =DBC_GetProperty(lcADBC,liDBCID,_DBCID_DBCEvents,@m.llDBCEvents)
      IF m.llDBCEvents
         =DBC_SetProperty(lcADBC,liDBCID,_DBCID_DBCEvents,.F.)
      ENDIF

      loFileLevel=This.oFileLevel

      * A zrove jako databzi
      IF m.loPDMs.OpenDBC(m.This.DataSessionID,lcDBC," SHARE NOUPDATE")>0
         m.loPDMs.CloseTable(m.This.DataSessionID,lcADBC)
         RETURN _PDM_FileNO
      ENDIF

      m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)
      m.loPDM.GetPI_ENV("DIAF",lcPath,@m.lcDIAFCSS,@m.lcDIAFJS)

      liCountX=0 && Resetuj poet vt
      SET DATABASE TO (lcDBC) && Pepni se na databzi

      *****************************************************
      * Analza uloench procedur
      *
      * + Vytvoen seznamu uloench procedur pro vytvoen odkaz z triger a default value
      *******************************************************
      SELE (lcADBC)
      LOCATE FOR UPPER(ObjectName)==PADR(UPPER("StoredProceduresSource"),128)
      IF FOUND() AND !EMPTY(Code) AND m.This.GEN_SP=1 && Generate ? Yes/No
         lcCode=CODE

         =m.loPDMs.WriteDMSG(m.loPDMs.GetString(_PDM_valSTProcedIP))
         This.GenerateHTML_PRG(0,@m.lcCode,lcFile_dSP,@laPRC)
         FOR lii=1 TO ALEN(laPRC,1)
*             laPRC(lii,2)=LTRIM(STR(laPRC(lii,2),11))

             IF This.QFL_Procedures=1
                lcStringFLD_SP=lcStringFLD_SP+;
                               m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><a target="_top" href="'+This.FileName+"/"+lcHTML_Uni+"?next=Main_dSP_Uni.htm&next="+laPRC(lii,2)+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05158),"%name%",laPRC(lii,1))+'">'+laPRC(lii,1)+'</a></td></tr>'+m.loPDM.aSpace(21)
             ENDIF

             laPRC(lii,1)=UPPER(laPRC(lii,1))
         NEXT
         
         llGEN_SP=.T.
      ENDIF



      *********************************
      * Tabulky
      *********************************
      STORE m.loPDMs.FCreate(lcPath+lcFile_dT) TO lihFile,m.This.hFile
      IF lihFile>0
         llGEN_Tables=.T.

         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_01245))+;
                  m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+lcCSS+;
                  m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
         =FWRITE(lihFile,lcString)

         IF m.This.GEN_Tables=1 && Generate ? Yes/No
            SELECT ObjectName,RECNO() FROM (lcADBC);
                   WHERE ObjectType==_DBC_Table ;
                   INTO ARRAY laObj
            liCount=_TALLY
         ELSE
            liCount=0
         ENDIF

         IF liCount>0
            IF This.QFL_Tables=1
               lcStringFLD=lcStringFLD+;
                           m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td colspan="2">'+m.loPDMs.aStrings(PDM_01245)+'</td></tr>'+m.loPDM.aSpace(21)
            ENDIF

            lcString='<h4><a name="Tables">'+m.loPDMs.aStrings(PDM_01245)+'</a></h4>'+m.loPDM.aSpace(21)+;
                     '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_04929)+'</td>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)
                     

            =IIF(m.This.OL_Tables=1,ASORT(laObj),.T.) && Ordered? Yes/No

            SELE (lcADBC)
            FOR lii=1 TO liCount
                GO (laObj(lii,2))
                lcName=ALLT(ObjectName)
                lcComment=DBGETPROP(lcName,"TABLE","COMMENT")
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr><td><a href="'+LOWER(STRTRAN(lcName," ","."))+'.htm" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05167),"%name%",lcName)+'">'+lcName+'</a></td><td>'+;
                         IIF(EMPTY(lcComment),"&nbsp;",StrTranHTMLString(lcComment))+'</td></tr>'+m.loPDM.aSpace(21)

                IF This.QFL_Tables=1
                   lcStringFLD=lcStringFLD+;
                               m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><a target="_top" href="'+This.FileName+"/"+lcHTML_Uni+"?next="+LOWER(STRTRAN(lcName," ","."))+'.htm" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05167),"%name%",lcName)+'">'+lcName+'</a></td></tr>'+m.loPDM.aSpace(21)
                ENDIF
                         
            NEXT
            =FWRITE(lihFile,lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))
         ELSE
            =FWRITE(lihFile,m.loPDMs.aStrings(PDM_00813)+m.loPDM.aSpace(21))
         ENDIF

         =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,3,lcPathX+lcFile_dT,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_01245),_PDM_FG_Any)

         m.loFileLevel.I4=3
         m.loFileLevel.I5=0
         m.loFileLevel.nLevel=5
         FOR lii=1 TO liCount
             SELE (lcADBC)
             GO (laObj(lii,2))
             lcName=ALLT(ObjectName)
             m.loFileLevel.I5=m.loFileLevel.I5+1
             =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valTableIP),"%name%",lcName))
             =m.This.GenerateHTML_DBF(lcDBC+"!"+lcName,LOWER(STRTRAN(lcName," ","."))+".htm",lcName,lcADBC,@laPRC,lcFile_dSP)
         NEXT

         liCountX=liCount
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dT))
      ENDIF


      *********************************
      * Pohledy
      *********************************
      STORE m.loPDMs.FCreate(lcPath+lcFile_dV) TO lihFile,This.hFile
      IF lihFile>0
         llGEN_Views=.T.
         IF m.This.GEN_Views=1 && Generate ? Yes/No
            SELECT ObjectName,RECNO() FROM (lcADBC);
                   WHERE ObjectType==_DBC_View ;
                   INTO ARRAY laObj
            liCount=_TALLY
         ELSE
            liCount=0
         ENDIF

         IF liCount>0
            * Create Detail Description of File, DIAF Plug-in
            loPIPar=m.loPDM.oPIPar

            IF This.QFL_Views=1
               lcStringFLD=lcStringFLD+;
                           m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td colspan="2">'+m.loPDMs.aStrings(PDM_01247)+'</td></tr>'+m.loPDM.aSpace(21)
            ENDIF               

            lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_01247))+;
                     m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+lcCSS+;
                     m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+lcJS+;
                     '</head>'+m.loPDM.aSpace(21)+'<body '+IIF(liCountX>0,'style="'+loPDMs.s_pbf+'" ','')+'>'+m.loPDM.aSpace(21)+;
                     '<h4><a name="Views">'+m.loPDMs.aStrings(PDM_01247)+'</a></h4>'+m.loPDM.aSpace(21)

            =IIF(m.This.OL_Views=1,ASORT(laObj),.T.) && Ordered? Yes/No

            lcString=lcString+'<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_04929)+'</td>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

            FOR lii=1 TO liCount
                SELE (lcADBC)
                GO (laObj(lii,2))

                liObjectID=ObjectID && ID pohledu
                lcName=ALLT(ObjectName)
                lcComment=DBGETPROP(lcName,"VIEW","COMMENT")
                =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valViewIP),"%name%",m.lcName))

                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><a href="'+STRTRAN(lcName," ",".")+'.htm" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05168),"%name%",lcName)+'">'+lcName+'</a></td><td>'+;
                         IIF(EMPTY(lcComment),"&nbsp;",StrTranHTMLString(lcComment))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)

                IF This.QFL_Views=1
                   lcStringFLD=lcStringFLD+;
                               m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><a target="_top" href="'+This.FileName+"/"+lcHTML_Uni+"?next="+LOWER(STRTRAN(lcName," ","."))+'.htm" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05168),"%name%",lcName)+'">'+lcName+'</a></td></tr>'+m.loPDM.aSpace(21)
                ENDIF               

            NEXT
            =FWRITE(lihFile,lcString)
         ELSE
            =FWRITE(lihFile,m.loPDMs.aStrings(PDM_01062)+m.loPDM.aSpace(21))
         ENDIF
         liCountX=liCountX+liCount

         =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,4,lcPathX+lcFile_dV,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_01247),_PDM_FG_Any)

         m.loFileLevel.I4=4
         m.loFileLevel.I5=0
         m.loFileLevel.nLevel=5
         FOR lii=1 TO liCount
             SELE (lcADBC)
             GO (laObj(lii,2))
             lcName=ALLT(ObjectName)
             m.loFileLevel.I5=m.loFileLevel.I5+1
             =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valViewIP),"%name%",m.lcName))
             =m.This.GenerateHTML_View(ObjectID,LOWER(STRTRAN(lcName," ","."))+".htm",lcName,lcADBC)
         NEXT
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dV))
      ENDIF

      *********************************
      * Spojen
      *********************************
      STORE m.loPDMs.FCreate(lcPath+lcFile_dC) TO lihFile,m.This.hFile
      IF lihFile>0
         llGEN_Connections=.T.
         IF m.This.GEN_Connections=1 && Generate ? Yes/No
            SELECT ObjectName,RECNO() FROM (lcADBC);
                   WHERE ObjectType==_DBC_Connection ;
                   INTO ARRAY laObj
            liCount=_TALLY
         ELSE
            liCount=0
         ENDIF

         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_01249))+;
                  m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+lcCSS+;
                  m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body '+IIF(liCountX>0,'style="'+loPDMs.s_pbf+'" ','')+'>'+m.loPDM.aSpace(21)

         IF liCount>0
            IF This.QFL_Connections=1
               lcStringFLD=lcStringFLD+;
                           m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td colspan="2">'+m.loPDMs.aStrings(PDM_01249)+'</td></tr>'+m.loPDM.aSpace(21)
            ENDIF

            lcString=lcString+;
                     '<h4><a name="Connections">'+m.loPDMs.aStrings(PDM_01249)+'</a></h4>'+m.loPDM.aSpace(21)+;
                     '<table border="1" cellspacing="0">'+;
                     m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_04929)+'</td>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

            =IIF(m.This.OL_Connections=1,ASORT(laObj),.T.) && Ordered? Yes/No

            lcBody=""
            SELE (lcADBC)
            FOR lii=1 TO liCount
                GO (laObj(lii,2))
                lcName=ALLT(ObjectName)
                lcComment=DBGETPROP(lcName,"CONNECTION","COMMENT")
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr><td><a href="'+STRTRAN(lcName," ",".")+'.htm" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05169),"%name%",lcName)+'">'+lcName+'</a></td><td>'+;
                         IIF(EMPTY(lcComment),"&nbsp;",StrTranHTMLString(lcComment))+'</td></tr>'+m.loPDM.aSpace(21)
                         
                IF This.QFL_Connections=1
                   lcStringFLD=lcStringFLD+;
                               m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><a target="_top" href="'+This.FileName+"/"+lcHTML_Uni+"?next="+LOWER(STRTRAN(lcName," ","."))+'.htm" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05169),"%name%",lcName)+'">'+lcName+'</a></td></tr>'+m.loPDM.aSpace(21)
                ENDIF               
                         

            NEXT
            =FWRITE(lihFile,lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))
         ELSE
            =FWRITE(lihFile,lcString+m.loPDMs.aStrings(PDM_01158)+m.loPDM.aSpace(21))
         ENDIF

         =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,5,lcPathX+lcFile_dC,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_01249),_PDM_FG_Any)

         m.loFileLevel.I4=5
         m.loFileLevel.I5=0
         m.loFileLevel.nLevel=5
         SELE (lcADBC)
         FOR lii=1 TO liCount
             GO (laObj(lii,2))
             lcName=ALLT(ObjectName)
             =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valConnectionIP),"%name%",m.lcName))
             m.loFileLevel.I5=m.loFileLevel.I5+1
             =m.This.GenerateHTML_Connection(ObjectID,LOWER(STRTRAN(lcName," ","."))+".htm",lcName,lcADBC)
         NEXT

         liCountX=liCountX+liCount
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_dC))
      ENDIF


      * Create Detail Description of File, DIAF Plug-in
      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.This.File
      loPIPar.Type="DIAF"
      loPIPar.FileGroup=_PDM_FG_DBC
      loPIPar.RamPJX=This.RamPJX
      loPIPar.oPDMx=This

      SELE (lcADBC)
      LOCATE FOR OBJECTID=1 AND PARENTID=1
      SCATTER NAME loPIPar.RamFile MEMO
      
      STORE "" TO lcDIAF,lcDIAXF
      FOR lii=1 TO m.loPDM.iDIAF
          lcDIAF=m.lcDIAF+m.loPDM.aDIAF(lii,1).Run(@m.loPIPar,m.loPDM.aDIAF(lii,2))
          lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
      NEXT
      IF LEN(m.lcDIAF)>0 && Yes, DIAF for file exist
         lihFile=m.loPDMs.FCreate(lcPath+lcFile_dex)
         IF lihFile>0
      
            llEx=.T.
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcDBName))+;
                     m.loPDMs.GetStyles("../../")+m.lcDIAFCSS+m.lcCSS+m.lcDIAFJS+m.lcJS+m.loPDM.aSpace(21)+;
                     IIF(m.loPIPar.lLNK,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS,"")+;
                     '</head>'+m.loPDM.aSpace(21)+;
                     '<body>'+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_05046)+"</div>"+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcDIAF+m.loPDM.aSpace(21)+;
                     m.loPDMs.GenerateBackReferenceHTML(m.This.File,"","","../../")+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     m.lcDIAXF+m.loPDM.aSPace(21)+;
                     [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                     "</body></html>"

            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,2,lcPathX+lcFile_dex,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcDBName),_PDM_FG_Any+_PDM_FG_DIAX)
         ELSE
            =m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%name%",lcPath+lcFile_dex))
         ENDIF
      ENDIF


      STORE m.loPDMs.FCreate(lcPath+lcFile_h) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_01240),"%name%",lcDBName))+m.loPDMs.GetStyles('../../')+lcCSS+lcJS+;
                  '</head><body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                  '<table class="file_head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="70%">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'<h3>'+m.loPDMs.aStrings(PDM_01240)+' '+lcDBName+"</h3>"+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="30%" class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                  IIF(llGEN_Tables,m.loPDM.aSpace(3)+IIF(!llGEN_Views AND !llGEN_Connections AND !llGEN_SP AND !m.llEx,m.loPDMs.aStrings(PDM_01245),'<a href="'+lcFile_dT+'" target="F3" title="'+m.loPDMs.aStrings(PDM_05050)+'">'+m.loPDMs.aStrings(PDM_01245)+'</a> ')+m.loPDM.aSpace(21),"")+;
                  IIF(llGEN_Views,m.loPDM.aSpace(3)+IIF(!llGEN_Tables AND !llGEN_Connections AND !llGEN_SP AND !m.llEx,m.loPDMs.aStrings(PDM_01247),'<a href="'+lcFile_dV+'" target="F3" title="'+m.loPDMs.aStrings(PDM_05051)+'">'+m.loPDMs.aStrings(PDM_01247)+'</a><br />')+m.loPDM.aSpace(21),"")+;
                  IIF(llGEN_Connections,m.loPDM.aSpace(3)+IIF(!llGEN_Tables AND !llGEN_Views AND !llGEN_SP AND !m.llEx,m.loPDMs.aStrings(PDM_01249),'<a href="'+lcFile_dC+'" target="F3" title="'+m.loPDMs.aStrings(PDM_05052)+'">'+m.loPDMs.aStrings(PDM_01249)+'</a> ')+m.loPDM.aSpace(21),"")+;
                  IIF(llGEN_SP,m.loPDM.aSpace(3)+IIF(!llGEN_Tables AND !llGEN_Views AND !llGEN_Connections AND !m.llEx,m.loPDMs.aStrings(PDM_01251),'<a href="'+lcFile_dSP+'" target="F3" title="'+m.loPDMs.aStrings(PDM_05053)+'">'+m.loPDMs.aStrings(PDM_01251)+'</a>')+m.loPDM.aSpace(21),"")+;
                  IIF(m.llEx,m.loPDM.aSpace(3)+IIF(!llGEN_Tables AND !llGEN_Views AND !llGEN_Connections AND !llGEN_SP,m.loPDMs.aStrings(PDM_05046),'<a href="'+lcFile_dex+[" target="F3" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcDBName)+[">]+m.loPDMs.aStrings(PDM_05046)+'</a>')+m.loPDM.aSpace(21),"")+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td>('+lcDBC+')</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<td rowspan="2" class="a_right a_middle">'+""+'</td></tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr><td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<table border="0" cellpadding="0" cellspacing="2">'+m.loPDM.aSpace(21)
 
         * Pidej pznak Events a soubor Events
         =DBC_GetProperty(lcADBC,liDBCID,_DBCID_DBCEventFileName,@m.lcName)
         =m.loPDMs.WriteDMSG(m.loPDMs.GetString(_PDM_valDBEventsIP))
         m.lcName=m.loPDM.FullPath(m.lcName,lcDBC)

         IF !EMPTY(lcName) AND FILE(lcName) AND m.This.GEN_EF=1
            DIME laPRC(1)
            m.This.GenerateHTML_PRG(1,lcName,lcFile_dEF,@laPRC)
            FOR lii=1 TO ALEN(laPRC,1)
                IF This.QFL_EventFile=1
                   lcStringFLD_EV=lcStringFLD_EV+;
                                  m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td><a target="_top" href="'+This.FileName+"/"+lcHTML_Uni+"?next=Main_dEF_Uni.htm&next="+laPRC(lii,2)+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05158),"%name%",laPRC(lii,1))+'">'+laPRC(lii,1)+'</a></td></tr>'+m.loPDM.aSpace(21)
                ENDIF                 

            NEXT
         ENDIF
            
         lcString=lcString+;
                  m.loPDM.aSpace(3)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(4)+'<td>'+m.loPDMs.aStrings(PDM_00850)+'</td><td>'+'<img class="imgYN" src="../../imgs/'+IIF(m.llDBCEvents,"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(m.llDBCEvents,PDM_00853,PDM_00854))+'" /></td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(4)+'<td>'+IIF(EMPTY(lcName),IIF(!m.llDBCEvents,"&nbsp;",m.loPDMs.aStrings(PDM_00851)),IIF(m.This.GEN_EF=1,'<a href="'+lcFile_dEF+'" target="F3" title="'+m.loPDMs.aStrings(PDM_05054)+'">'+StrTranHTMLString(lcName)+'</a>',StrTranHTMLString(lcName)))+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(3)+'</tr>'+m.loPDM.aSpace(21)

         lcString=lcString+;
                  m.loPDM.aSpace(2)+'</table>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</td></tr>'+m.loPDM.aSpace(21)+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'
               
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,1,lcPathX+lcFile_h,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_01240),_PDM_FG_None)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_h))
      ENDIF


      IF !llGEN_Tables AND !llGEN_Views AND llGEN_Connections AND !llGEN_SP AND !llEx
         * Generovn istho detailu
         STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,m.This.hFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_01242),"%name%",lcDBName))+;
                     m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+lcCSS+lcJS+;
                     '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                     m.loPDMs.aStrings(PDM_01241)+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'
            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,1,lcPathX+lcFile_d,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(PDM_01242),"%name%",lcDBName),_PDM_FG_None)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_h))
         ENDIF
      ENDIF

      * Generovn frameu
      STORE m.loPDMs.FCreate(lcPath+lcHTML) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_01240)+" "+lcDBName)+m.loPDMs.GetStyles('../../')+lcCSS+lcJS+'</head>'+m.loPDM.aSpace(21)+;
                  IIF(llOne,"",[<frameset framespacing="0" frameborder="1" rows="100%" cols="]+IIF(m.loPDM.ShowQuickFileList=1,'333','112')+[,*" title="]+m.loPDMs.aStrings(PDM_01240)+" "+lcDBName+[">]+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(1)+[<frame name="F1" src="../../MainMenu.htm?QUICKLIST="]+IIF(m.loPDM.ShowQuickFileList=0,"Blank_QL.htm",This.OutDir+[/]+This.HTMLList)+[" noresize="true" title="]+m.loPDMs.aStrings(PDM_05102)+[">]+m.loPDM.aSpace(21))+;
                  m.loPDM.aSpace(1)+[<frameset framespacing="0" frameborder="1" rows="120,*" cols="100%" title="]+m.loPDMs.aStrings(PDM_01240)+" "+lcDBName+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<frame name="F2" src="'+lcFile_h+[" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05145),"%name%",lcDBName)+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<frame name="F3" src="'+;
                          IIF(LEN(m.lcDIAF)>0,lcFile_dex+'" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05048),"%name%",lcDBName),;
                          IIF(!llGEN_Tables AND !llGEN_Views AND llGEN_Connections AND !llGEN_SP,lcFile_d,lcFile_dT)+[" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05146),"%name%",lcDBName))+[">]+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</frameset>'+m.loPDM.aSpace(21)+;
                  IIF(llOne,"",'</frameset>'+m.loPDM.aSpace(21))+;
                  '</html>'
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,0,lcPathX+lcHTML,0,_PDM_EF_Frame,m.This.FileName,_PDM_FG_Any+_PDM_FG_DBC)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcHTML))
      ENDIF


      IF llGEN_SP AND This.QFL_Procedures=1
         lcStringFLD=lcStringFLD+;
                     m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td colspan="2">'+m.loPDMs.aStrings(PDM_01251)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     lcStringFLD_SP
      ENDIF

      IF m.llDBCEvents AND m.This.GEN_EF=1 AND This.QFL_EventFile=1
         lcStringFLD=lcStringFLD+;
                     m.loPDM.aSpace(2)+'<tr><td>&nbsp;</td><td>&nbsp;</td><td colspan="2">'+m.loPDMs.aStrings(PDM_00852)+'</td></tr>'+m.loPDM.aSpace(21)+;
                     lcStringFLD_EV
      ENDIF



      laStrings(1)=m.loPDMs.aStrings(PDM_01240)
      laStrings(2)=m.loPDMs.aStrings(PDM_05102)
      laStrings(3)=m.loPDMs.aStrings(PDM_05145)
      * stored procedures
      laStrings(4)=m.loPDMs.aStrings(PDM_05151)
      laStrings(5)=m.loPDMs.aStrings(PDM_05066)
      laStrings(6)=m.loPDMs.aStrings(PDM_05153)
      * event file
      laStrings(7)=m.loPDMs.aStrings(PDM_05154)
      laStrings(8)=m.loPDMs.aStrings(PDM_05067)
      laStrings(9)=m.loPDMs.aStrings(PDM_05156)

      * Generovn main_Uni - jen uloen
      STORE m.loPDMs.FCreate(lcPath+lcHTML_Uni) TO lihFile
      IF lihFile>0
         TEXT TO lcStringUNI TEXTMERGE NOSHOW 
<<m.loPDMs.GetHeader(lcPom)+m.loPDMs.GetStyles('../')+lcCSS+lcJS+'</head>'>>
<<m.loPDM.StartS>>
var lcSearch=document.location.search;
var laSearch = lcSearch.split("&");
var laParams = laSearch[0].split("=");
var lcPom= laParams[1];
if (laSearch.length==2)
   {
   lcPom=lcPom+"?"+laSearch[1];
   }
document.writeln('<frameset framespacing="0" frameborder="1" rows="100%" cols="<<IIF(m.loPDM.ShowQuickFileList=1,'333','122')>>,*" title="<<StrTranHTMLString(laStrings(1)+' '+lcDBName)>>" >');
document.writeln(' <frame name="F1" src="../../MainMenu.htm?QUICKLIST=<<IIF(m.loPDM.ShowQuickFileList=0,"Blank_QL.htm",This.OutDir+'/'+This.HTMLList)>>" noresize="true" title="<<StrTranHTMLString(laStrings(2))>>">');
document.writeln(' <frameset framespacing="0" frameborder="1" rows="120,*" cols="100%" title="<<StrTranHTMLString(laStrings(1)+" "+lcDBName)>>">');
document.writeln('  <frame name="F2" src="<<lcFile_h>>" title="<<StrTranHTMLString(STRTRAN(laStrings(3),"%name%",lcDBName))>>">');
document.writeln('  <frame name="F3" src="'+lcPom+'" >');
document.writeln(' <//frameset>');
document.writeln('<//frameset>');
<<m.loPDM.StopS>>
</html>
         ENDTEXT
      
         =FWRITE(lihFile,lcStringUNI)
         =m.loPDMs.FClose(lihFile)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcHTML_Uni))
      ENDIF


      * Generovn main_dSP_Uni - jen uloen
      IF llGEN_SP
         STORE m.loPDMs.FCreate(lcPath+lcHTML_dSP_Uni) TO lihFile
         IF lihFile>0
            TEXT TO lcStringUNI TEXTMERGE NOSHOW 
<<m.loPDMs.GetHeader(lcPom)+m.loPDMs.GetStyles('../')+lcCSS+lcJS+'</head>'>>
<<m.loPDM.StartS>>
var lcSearch=document.location.search;
var laCookies = lcSearch.split("=");
lcPom=laCookies[1];
document.writeln('<frameset framespacing="0" frameborder="1" rows="80,*" cols="100%" title="<<StrTranHTMLString(STRTRAN(laStrings(6),"%name%",m.This.DBCName))>>">');
document.writeln(' <frame name="F31" src="Main_dSP_h.htm" title="<<StrTranHTMLString(STRTRAN(laStrings(4),"%name%",m.This.DBCName))>>">');
document.writeln(' <frame name="F32" src="'+lcPom+'" title="<<StrTranHTMLString(STRTRAN(laStrings(5),"%name%",m.This.DBCName))>>">');
document.writeln('<//frameset>');
<<m.loPDM.StopS>>
</html>
            ENDTEXT
            =FWRITE(lihFile,lcStringUNI)
            =m.loPDMs.FClose(lihFile)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcHTML_dSP_Uni))
         ENDIF
      ENDIF   

      * Generovn main_dEF_Uni - jen uloen
      IF m.llDBCEvents AND m.This.GEN_EF=1
         STORE m.loPDMs.FCreate(lcPath+lcHTML_dEF_Uni) TO lihFile
         IF lihFile>0
            TEXT TO lcStringUNI TEXTMERGE NOSHOW 
<<m.loPDMs.GetHeader(lcPom)+m.loPDMs.GetStyles('../')+lcCSS+lcJS+'</head>'>>
<<m.loPDM.StartS>>
var lcSearch=document.location.search;
var laCookies = lcSearch.split("=");
lcPom=laCookies[1];
document.writeln('<frameset framespacing="0" frameborder="1" rows="80,*" cols="100%" title="<<StrTranHTMLString(STRTRAN(laStrings(9),"%name%",m.This.DBCName))>>">');
document.writeln(' <frame name="F31" src="Main_dEF_h.htm" title="<<StrTranHTMLString(STRTRAN(laStrings(7),"%name%",m.This.DBCName))>>">');
document.writeln(' <frame name="F32" src="'+lcPom+'" title="<<StrTranHTMLString(STRTRAN(laStrings(8),"%name%",m.This.DBCName))>>">');
document.writeln('<//frameset>');
<<m.loPDM.StopS>>
</html>
            ENDTEXT
      
            =FWRITE(lihFile,lcStringUNI)
            =m.loPDMs.FClose(lihFile)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcHTML_dEF_Uni))
         ENDIF
      ENDIF   


      IF m.llDBCEvents
         =DBC_SetProperty(lcADBC,liDBCID,_DBCID_DBCEvents,.T.)
      ENDIF
      USE IN (lcADBC) && Uzavi DBC konteiner
      CLOSE DATABASES ALL && Uzavi oteven DBC konteiner
      loAPRG.CreateCursors()

   ENDPROC
   
   PROCEDURE QuickAnalyse_DBC(lcDBC,lcHTML) && Rychl analza objekt
      * lcDBC    - Umstn a nzev DBC konteineru
      * lcHTML   - Zkladn nzev HTML strnky

      LOCAL m.lcADBC, m.liCount, m.lii, m.loAPRG, m.luValue, m.liy,;
            m.loPDM, m.loPDMs, m.lcFile, m.lcPath, m.lcPathX,;
            m.lcFile_dT, m.lcFile_dV, m.lcFile_dC, m.lcFile_dSP, m.lcFile_dEF, m.llOne, m.loPIPar, m.lcKey

      LOCAL ARRAY laObj(1),laPRC(1)

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      loAPRG=m.This.oAPRG
      llOne=m.loPDM.One

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"
            
      lcFile_dT=AppendShortFileFromFile(lcHTML,"_dT")
      lcFile_dV=AppendShortFileFromFile(lcHTML,"_dV")
      lcFile_dC=AppendShortFileFromFile(lcHTML,"_dC")
      lcFile_dSP=AppendShortFileFromFile(lcHTML,"_dSP")
      lcFile_dEF=AppendShortFileFromFile(lcHTML,"_dEF")

      lcADBC=SYS(2015)

      * Nyn se pokus otevt DBC konteiner jako tabulku
      IF m.loPDMs.OpenTable(m.This.DataSessionID,lcDBC,lcADBC," AGAIN SHARE NOUPDATE")>0
         RETURN _PDM_FileNO
      ENDIF


      SELE (lcADBC)
      liDBCID=DBC_GetIDObject(lcADBC,_DBC_DataBase,"Database")

      *****************************************************
      * Analza uloench procedur
      *
      * -(+) Vytvoen seznamu uloench procedur pro vytvoen odkaz z triger a default value
      *******************************************************
      =m.loPDMs.WriteDMSG(m.loPDMs.GetString(_PDM_valSTProcedIP))
      LOCATE FOR UPPER(ObjectName)==PADR(UPPER("StoredProceduresSource"),128)
      IF FOUND() AND !EMPTY(Code) AND m.This.GEN_SP=1 && Generate ? Yes/No
         m.loPDMs.AddAnchor(m.lcDBC+"!!Stored Procedures", "", "", m.This.OutDir+"\"+m.This.FileName+"\"+m.lcFile_dSP, "", _PDM_FG_SP, "")
         
         This.QuickAnalyse_PRG(0, CODE, m.lcFile_dSP)
      ENDIF

      IF m.This.GEN_EF=1
         m.lii=DBC_GetIDObject(m.lcADBC, _DBC_DataBase, "Database")
         =DBC_GetProperty(m.lcADBC, m.lii, _DBCID_DBCEventFileName, @m.luValue)
         m.luValue=m.loPDM.FullPath(m.luValue, m.lcDBC)
         IF LEN(m.luValue)>0
            m.loPDMs.AddAnchor(m.lcDBC+"!!Events", "", "", m.This.OutDir+"\"+m.This.FileName+"\"+m.lcFile_dEF, "", _PDM_FG_EF, "")

            m.This.QuickAnalyse_PRG(1, m.luValue, m.lcFile_dEF)
         ENDIF
      ENDIF

      *********************************
      * Tables
      *********************************
      SELECT ObjectName,RECNO() FROM (lcADBC);
             WHERE ObjectType==_DBC_Table ;
             INTO ARRAY laObj
      liCount=_TALLY
 
      FOR lii=1 TO liCount
          *m.loPDMs.AddAnchor(lcDBC+"!"+ALLT(laObj(lii,1)),"","",lcPathX+"Main_Uni.htm?next="+STRTRAN(ALLT(laObj(lii,1))," ",".")+".htm","",_PDM_FG_DBF,"")
          This.QuickAnalyse_DBF(m.lcADBC, m.lcDBC, ALLT(m.laObj(m.lii, 1)), m.lcPathX+"Main_Uni.htm?next="+STRTRAN(ALLT(m.laObj(m.lii, 1))," ",".")+".htm")
      NEXT


      *********************************
      * Views (local and remote)
      *********************************
      SELECT ObjectName,RECNO() FROM (lcADBC);
             WHERE ObjectType==_DBC_View ;
             INTO ARRAY laObj
      liCount=_TALLY

      FOR lii=1 TO liCount
          *=m.loPDMs.AddAnchor(lcDBC+"!"+ALLT(laObj(lii,1)),"","",lcPathX+"Main_Uni.htm?next="+STRTRAN(ALLT(laObj(lii,1))," ",".")+".htm","",_PDM_FG_View,"")
          This.QuickAnalyse_View(m.lcADBC, m.lcDBC, ALLT(m.laObj(m.lii, 1)), m.lcPathX+"Main_Uni.htm?next="+STRTRAN(ALLT(m.laObj(m.lii, 1))," ",".")+".htm")

          liy=DBC_GetIDObject(lcADBC,_DBC_View,ALLT(laObj(lii,1)))
          =DBC_GetProperty(lcADBC,liy,_DBCID_SubType,@m.luValue)
          IF luValue#6
             =DBC_GetProperty(lcADBC,liy,_DBCID_ConnectName,@m.luValue)
             =m.loPDMs.AddCAnchor(lcDBC+"!"+m.luValue,lcDBC+"!"+ALLT(laObj(lii,1)),_PDM_CA_ApplyTo)
          ENDIF

      NEXT

      *********************************
      * Conections
      *********************************
      SELECT ObjectName,RECNO() FROM (lcADBC);
             WHERE ObjectType==_DBC_Connection ;
             INTO ARRAY laObj
      liCount=_TALLY

      FOR m.lii=1 TO m.liCount
          m.loPDMs.AddAnchor(m.lcDBC+"!"+ALLT(m.laObj(m.lii, 1)), "", "", m.lcPathX+STRTRAN(ALLT(m.laObj(m.lii, 1)), " ", ".")+".htm", "", _PDM_FG_Conn, "")
          =m.loPDM.AddToStats(This, This.Stats_Key, _PDM_FG_Conn, ALLT(m.laObj(m.lii, 1)), "", 0)
      NEXT


      USE IN (lcADBC) && Uzavi DBC konteiner
      CLOSE DATABASES ALL && Uzavi oteven DBC konteiner
      loAPRG.CreateCursors()
   ENDPROC

   PROCEDURE QuickAnalyse_DBF && Rychl analza objekt
      LPARAM m.lcADBC, m.lcDBC, m.lcName, m.lcHTMLName
      * m.lcADBC     - alias DBC 
      * m.lcDBC      - cesta k DBC
      * lcName       - Nzev DBF
      * m.lcHTMLName - Zkladn nzev HTML strnky

      LOCAL m.loPDM, m.loPDMs, m.lcKey, m.lcFile, m.liID
      LOCAL ARRAY m.laObj2(1)
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      m.loPDMs.AddAnchor(m.lcDBC+"!"+m.lcName, "", "", m.lcHTMLName, "", _PDM_FG_DBF, "")

      m.liID=DBC_GetIDObject(m.lcADBC, _DBC_Table, m.lcName)
      =DBC_GetProperty(m.lcADBC, m.liID, _DBCID_Path, @m.lcFile)

      m.lcKey=m.loPDM.AddToStats(This, This.Stats_Key, _PDM_FG_DBF, FULLPATH(m.lcFile, m.lcDBC), "", 0)

      SELECT COUNT(1) FROM (m.lcADBC) WHERE ParentID=m.liID AND ObjectType==_DBC_Field INTO ARRAY laObj2
      =m.loPDM.AddToStats(This, m.lcKey, 0, "", "fields", m.laObj2(1))

      SELECT COUNT(1) FROM (m.lcADBC) WHERE ParentID=m.liID AND ObjectType==_DBC_Index INTO ARRAY laObj2
      =m.loPDM.AddToStats(This, m.lcKey, 0, "", "indexes", m.laObj2(1))

      SELECT COUNT(1) FROM (m.lcADBC) WHERE ParentID=m.liID AND ObjectType==_DBC_Relation INTO ARRAY laObj2
      =m.loPDM.AddToStats(This, m.lcKey, 0, "", "relations", m.laObj2(1))

   ENDPROC

   PROCEDURE QuickAnalyse_VIEW && Rychl analza objekt
      LPARAM m.lcADBC, m.lcDBC, m.lcName, m.lcHTMLName
      * m.lcADBC     - alias DBC 
      * m.lcDBC      - cesta k DBC
      * lcName       - Nzev pohledu
      * m.lcHTMLName - Zkladn nzev HTML strnky

      LOCAL m.loPDM, m.loPDMs, m.lcKey, m.liID
      LOCAL ARRAY m.laObj2(1)
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      m.loPDMs.AddAnchor(m.lcDBC+"!"+m.lcName, "", "", m.lcHTMLName, "", _PDM_FG_View, "")

      m.lcKey=m.loPDM.AddToStats(This, This.Stats_Key, _PDM_FG_VIEW, m.lcDBC+"!"+m.lcName, "", 0)

      m.liID=DBC_GetIDObject(m.lcADBC, _DBC_View, m.lcName)
      SELECT COUNT(1) FROM (m.lcADBC) WHERE ParentID=m.liID AND ObjectType==_DBC_Field INTO ARRAY laObj2
      =m.loPDM.AddToStats(This, m.lcKey, 0, "", "fields", m.laObj2(1))

      SELECT COUNT(1) FROM (m.lcADBC) WHERE ParentID=m.liID AND ObjectType==_DBC_Relation INTO ARRAY laObj2
      =m.loPDM.AddToStats(This, m.lcKey, 0, "", "relations", m.laObj2(1))

   ENDPROC

   PROCEDURE QuickAnalyse_FDBF && Rychl analza objekt
      LPARAMETERS m.lcDBF, m.lcHTML
      * lcDBF    - Umstn a nzev free DBF souboru
      * lcHTML   - Zkladn nzev HTML strnky

      LOCAL m.loPDM, m.loPDMs, m.lcKey, m.lcAlias, m.liCount
      LOCAL ARRAY m.laObj2(1)
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      m.lcAlias=SYS(2015)

      IF m.loPDMs.OpenTable(m.This.DataSessionID, m.lcDBF, m.lcAlias, " AGAIN SHARE NOUPDATE")>0
         RETURN 
      ENDIF


      m.liCount=AFIELDS(m.laObj2, m.lcAlias)
      =m.loPDM.AddToStats(This, This.Stats_Key, 0, "", "fields", m.liCount)

      m.liCount=ATAGINFO(m.laObj2, m.lcAlias)
      =m.loPDM.AddToStats(This, This.Stats_Key, 0, "", "indexes", m.liCount)
      
      USE IN (m.lcAlias)
   ENDPROC

   PROCEDURE QuickAnalyse_QPR(lcQPR,lcHTML) && Rychl analza objekt
      * lcQPR    - Umstn a nzev QPR souboru
      * lcHTML   - Zkladn nzev HTML strnky

      LOCAL m.loPDM, m.loPDMs, m.lcKey
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

   ENDPROC


   PROCEDURE PI_QuickAnalyse_DBC(lcDBC,lcHTML)
      * lcDBF    - Umstn a nzev DBC konteineru
      * lcHTML   - Zkladn nzev HTML strnky

      LOCAL lcADBC,liCount,lii,luValue,liy,;
            m.loPDM,m.loPDMs,loPIPar

      LOCAL ARRAY laObj(1)

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      lcADBC=SYS(2015)

      * Nyn se pokus otevt DBC konteiner jako tabulku
      IF m.loPDMs.OpenTable(m.This.DataSessionID,lcDBC,lcADBC," AGAIN SHARE NOUPDATE")>0
         RETURN _PDM_FileNO
      ENDIF


      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.This.File
      loPIPar.FileGroup=_PDM_FG_DBC
      loPIPar.RamPJX=This.RamPJX
      loPIPar.oPDMx=This

      LOCATE FOR OBJECTID=1 AND PARENTID=1
      SCATTER NAME loPIPar.RamFile MEMO
      

      *********************************
      * DBC
      loPIPar.Type="DIAF"
      FOR lii=1 TO m.loPDM.iDIAF
          =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(m.lii,2))
      NEXT

      *********************************
      * View
      SELECT ObjectName,RECNO() FROM (lcADBC);
             WHERE ObjectType==_DBC_View ;
             INTO ARRAY laObj
      liCount=_TALLY
      loPIPar.FileGroup=_PDM_FG_View
      FOR liy=1 TO liCount
          loPIPar.File=lcDBC+"!"+ALLT(laObj(liy,1))
          FOR lii=1 TO m.loPDM.iDIAF
              =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(m.lii,2))
          NEXT
      NEXT

      *********************************
      * Table
      SELECT ObjectName,RECNO() FROM (lcADBC);
             WHERE ObjectType==_DBC_Table ;
             INTO ARRAY laObj
      liCount=_TALLY
      loPIPar.FileGroup=_PDM_FG_DBF
      FOR liy=1 TO liCount
          loPIPar.File=lcDBC+"!"+ALLT(laObj(liy,1))
          FOR lii=1 TO m.loPDM.iDIAF
              =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(m.lii,2))
          NEXT
      NEXT
      

      *********************************
      * Connection
      SELECT ObjectName,RECNO() FROM (lcADBC);
             WHERE ObjectType==_DBC_Connection ;
             INTO ARRAY laObj
      liCount=_TALLY
      loPIPar.FileGroup=_PDM_FG_Conn
      FOR liy=1 TO liCount
         loPIPar.File=lcDBC+"!"+ALLT(laObj(liy,1))
         FOR lii=1 TO m.loPDM.iDIAF
             =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(m.lii,2))
         NEXT
      NEXT


      *********************************
      loPIPar.File=m.This.File
      loPIPar.Type="DIAC"
      FOR lii=1 TO m.loPDM.iDIAC
          =m.loPDM.aDIAC(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAC(m.lii,2))
      NEXT

      loPIPar.Type="DIAP"
      FOR lii=1 TO m.loPDM.iDIAP
          =m.loPDM.aDIAP(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAP(m.lii,2))
      NEXT

      loPIPar.Type="DIAMP"
      FOR lii=1 TO m.loPDM.iDIAMP
          =m.loPDM.aDIAMP(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAC(m.lii,2))
      NEXT

      USE IN (lcADBC) && Uzavi DBC konteiner
      CLOSE DATABASES ALL && Uzavi oteven DBC konteiner
      =This.oAPRG.CreateCursors()
   ENDPROC

   PROCEDURE PI_QuickAnalyse_DBF(lcDBF,lcHTML)
      * lcDBF    - Umstn a nzev DBF souboru
      * lcHTML   - Zkladn nzev HTML strnky

      LOCAL loPIPar,loPDM
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt

      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=lcDBF
      loPIPar.Type="DIAF"
      loPIPar.FileGroup=_PDM_FG_DBF
      loPIPar.RamPJX=This.RamPJX
      loPIPar.oPDMx=This

      FOR lii=1 TO m.loPDM.iDIAF
          =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(m.lii,2))
      NEXT
   ENDPROC

   PROCEDURE PI_QuickAnalyse_QPR(lcQPR,lcHTML)
      * lcQPR    - Umstn a nzev QPR souboru
      * lcHTML   - Zkladn nzev HTML strnky

      LOCAL loPIPar,loPDM
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt

      loPIPar=m.loPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=lcQPR
      loPIPar.Type="DIAF"
      loPIPar.FileGroup=_PDM_FG_QPR
      loPIPar.RamPJX=This.RamPJX
      loPIPar.oPDMx=This

      FOR lii=1 TO m.loPDM.iDIAF
          =m.loPDM.aDIAF(lii,1).QuickAnalyse(@m.loPIPar,m.loPDM.aDIAF(m.lii,2))
      NEXT

   ENDPROC

   PROCEDURE GenerateHTML_Connection(liObjectID,lcHTML, lcConName,lcADBC) && Vygeneruje strnku DBF tabulek (Free and in DBC container)
      * liObjectID - ID objektu

      * lcDBName - jmno pohledu
      * lcADBC   - Alias otevenho DBC konteineru jako tabulka

      LOCAL lcCSS,lcJS,lcDIAFCSS,lcDIAFJS,lcDIAF,lcDIAXF,loPIPar,lcPath,lcPathX,llOne,lcFile_d,;
            lihFile,lcString,llEC_Tab,lcPict,lcDisp,lcRPath,loPDMs,loPDM,lii,liy,lcPom

      LOCAL ARRAY laSO(1)
      lihFile=m.This.hFile && Handle otevenho souboru
      m.loPDM=EVAL(m.This.PDM) && Zskej odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"

      llOne=m.loPDM.One
*      This.HTMLOMMain=IIF(llOne,lcPathX+lcHTML,"") && ???
      lcFile_d=lcHTML

      STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,This.hFile
      IF lihFile>0

         m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)
         m.loPDM.GetPI_ENV("DIAF",lcPath,@m.lcDIAFCSS,@m.lcDIAFJS)

         lcPom=DBGETPROP(lcConName,"CONNECTION","COMMENT")
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_00961),"%name%",m.lcConName))+;
                  m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+m.lcDIAFCSS+lcCSS+;
                  m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+m.lcDIAFJS+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                  '<h5><a name="'+STRTRAN(lcConName," ",".")+'">'+m.loPDMs.aStrings(PDM_01085)+' '+lcConName+'</a></h5>'+m.loPDM.aSpace(21)+;
                  IIF(LEN(m.lcPom)>0,"&nbsp;"+m.lcPom,"")+m.loPDM.aSpace(21)
                  
         =FWRITE(m.lihFile,m.lcString)

         lcRPath="../../imgs/"

         * Create Detail Description of File, DIAF Plug-in
         loPIPar=m.loPDM.oPIPar
         loPIPar.Reset()
         loPIPar.File=DBF(lcADBC)+"!"+lcConName
         loPIPar.Type="DIAF"
         loPIPar.FileGroup=_PDM_FG_Conn
         loPIPar.RamPJX=This.RamPJX
         loPIPar.oPDMx=This

         STORE "" TO lcDIAF,lcDIAXF
         FOR lii=1 TO m.loPDM.iDIAF
             lcDIAF=m.lcDIAF+m.loPDM.aDIAF(lii,1).Run(@m.loPIPar,m.loPDM.aDIAF(lii,2))
             lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
         NEXT

         llEC_Tab=This.aEC(_EC_Tab,1)
         lcPict=This.aEC(_EC_Tab,2)
         lcDisp=This.aEC(_EC_Tab,3)

         lcBody=[<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_05046)+"</div>"+m.loPDM.aSpace(21)+;
                [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                m.lcDIAF+m.loPDM.aSpace(21)+;
                m.loPDMs.GenerateBackReferenceHTML(m.loPIPar.File,"","","../../")+;
                [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                m.lcDIAXF+m.loPDM.aSPace(21)+;
                [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)

         lii=m.loPDMs.GetCAnchor(DBC()+"!"+lcConName,@laSO,"../../",_PDM_CA_ApplyTo)
  
         IF lii>0
            lcBody=lcBody+;
                   [<div class="pdm_crosslinks"> <!-- Link Table start -->]+m.loPDM.aSpace(21)+;
                   [<span>]+m.loPDMs.aStrings(PDM_01303)+[</span>]+m.loPDM.aSpace(21)

            FOR liy=1 TO lii
                lcBody=lcBody+;
                       [ <a href="]+laSO(liy,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05168),"%name%",ExtractFileFromFile(laSO(liy,2)))+[">]+ExtractFileFromFile(laSO(liy,2))+[</a>]+IIF(liy#lii," | ","")+m.loPDM.aSpace(21)
            NEXT
            lcBody=lcBody+;
                   [</div><br /> <!-- Link Table End -->]+m.loPDM.aSpace(21)
         ENDIF
         =FWRITE(m.lihFile,lcBody)

         * Nejdve hlavika pohledu
         * pak koment
         * Pak SQL pkaz
         lcBody='<table>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01091)+'</td><td>'+StrTranHTMLString(DBGETPROP(lcConName,"CONNECTION","DataSource"))+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01094)+'</td><td>'+DBGETPROP(lcConName,"CONNECTION","UserId")+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01098)+'</td><td>'+DBGETPROP(lcConName,"CONNECTION","Password")+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01102)+'</td><td>'+DBGETPROP(lcConName,"CONNECTION","Database")+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01105)+'</td><td>'+StrTranHTMLString(DBGETPROP(lcConName,"CONNECTION","ConnectString"))+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01109)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcConName,"CONNECTION","Asynchronous"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcConName,"CONNECTION","Asynchronous"),PDM_01110,PDM_01111))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01115)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcConName,"CONNECTION","BatchMode"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcConName,"CONNECTION","BatchMode"),PDM_01116,PDM_01117))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01121)+'</td><td>'+LTRIM(STR(DBGETPROP(lcConName,"CONNECTION","ConnectTimeOut"),11))+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01125)+'</td><td>'+LTRIM(STR(DBGETPROP(lcConName,"CONNECTION","DispLogin"),3))+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01129)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcConName,"CONNECTION","DispWarnings"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcConName,"CONNECTION","DispWarnings"),PDM_01130,PDM_01131))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01135)+'</td><td>'+LTRIM(STR(DBGETPROP(lcConName,"CONNECTION","IdleTimeout"),11))+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01139)+'</td><td>'+LTRIM(STR(DBGETPROP(lcConName,"CONNECTION","QueryTimeout"),11))+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01143)+'</td><td>'+LTRIM(STR(DBGETPROP(lcConName,"CONNECTION","Transactions"),3))+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01147)+'</td><td>'+LTRIM(STR(DBGETPROP(lcConName,"CONNECTION","WaitTime"),11))+'</td></tr>'+m.loPDM.aSpace(21)+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01151)+'</td><td>'+LTRIM(STR(DBGETPROP(lcConName,"CONNECTION","PacketSize"),11))+'</td></tr>'+m.loPDM.aSpace(21)

         =DBC_GetProperty(lcADBC,liObjectID,_DBCID_DisconnectRollback,@m.lcPom)
         lcBody=lcBody+;
                m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01160)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(m.lcPom,"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(m.lcPom,PDM_01161,PDM_01162))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                '</table>'+m.loPDM.aSpace(21)

         =FWRITE(m.lihFile,lcBody)

         =FWRITE(m.lihFile,IIF(loPIPar.lLNK,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS,"")+;
                 '</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.oFileLevel,.NULL.,.NULL.,.NULL.,lcPathX+lcFile_d,0,_PDM_EF_None,m.lcConName,_PDM_FG_Any+_PDM_FG_Conn)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_d))
      ENDIF
   ENDPROC

   PROCEDURE GenerateHTML_View(liObjectID,lcHTML, lcDBName,lcADBC) && Vygeneruje strnku DBF tabulek (Free and in DBC container)
      * liObjectID - ID objektu

      * lcDBName - jmno pohledu
      * lcADBC   - Alias otevenho DBC konteineru jako tabulka

      LOCAL lii,liy,lcDBType,liCount,luValue,lihFile,m.loPDM,;
            lcCaption,lcInputMask,lcFormat,lcDisplayClass,lcDisplayClassLibrary,lcComment,;
            lcChildTag,lcParentTable,lcParentTag,lcRecno,llEC_Tab,llExpand,lcClass,lcClassLib,;
            llGEN_Fields,llGEN_Indexes,llXXHead,lcPict,lcDisp,m.loPDMs,lcScript,lcPom,lcRPath,;
            liz,lix,liID,lcDIAF,lcDIAXF,loPIPar,lcPath,lcPathX,llOne,lcFile_d,;
            lcCSS,lcJS,lcDIAFCSS,lcDIAFJS,;
            lcFields,lcUpdatableFieldList,lcUpdateNameList,lcKeyFieldList,lcField,;
       	    lcDefaultValue,lcRuleExpression,lcRuleText,;
            llBinnary,lcBody

      LOCAL ARRAY laFields(1),laObj2(1),laSO(1)
      lihFile=m.This.hFile && Handle otevenho souboru
      m.loPDM=EVAL(m.This.PDM) && Zskej odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"

      llOne=m.loPDM.One
*      This.HTMLOMMain=IIF(llOne,lcPathX+lcHTML,"") && ???
      lcFile_d=lcHTML

      STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,This.hFile
      IF lihFile>0

         m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)
         m.loPDM.GetPI_ENV("DIAF",lcPath,@m.lcDIAFCSS,@m.lcDIAFJS)

         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_01248),"%name%",m.lcDBName))+;
                  m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+m.lcDIAFCSS+lcCSS+;
                  m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+m.lcDIAFJS+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
         =FWRITE(m.lihFile,m.lcString)


         lcRPath="../../imgs/" && IIF(EMPTY(lcADBC),"../","../../")+"imgs/"


         * Create Detail Description of File, DIAF Plug-in
         loPIPar=m.loPDM.oPIPar
         loPIPar.Reset()
         loPIPar.File=DBF(lcADBC)+"!"+lcDBName
         loPIPar.Type="DIAF"
         loPIPar.FileGroup=_PDM_FG_View
         loPIPar.RamPJX=This.RamPJX
         loPIPar.oPDMx=This

         STORE "" TO lcDIAF,lcDIAXF
         FOR lii=1 TO m.loPDM.iDIAF
             lcDIAF=m.lcDIAF+m.loPDM.aDIAF(lii,1).Run(@m.loPIPar,m.loPDM.aDIAF(lii,2))
             lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
         NEXT

         llEC_Tab=This.aEC(_EC_Tab,1)
         lcPict=This.aEC(_EC_Tab,2)
         lcDisp=This.aEC(_EC_Tab,3)


         STORE "" TO lcFields,lcUpdatableFieldList,lcUpdateNameList,lcKeyFieldList,lcScript,lcBody

         * Nati poloky pohledu
         SELECT ObjectName,RECNO(),RECNO() FROM (lcADBC) ;
                WHERE ParentID=liObjectID AND ObjectType==_DBC_Field ;
                INTO ARRAY laObj2
         liCount2=_TALLY

         FOR liy=1 TO liCount2
             laObj2(liy,3)=liy
         NEXT

         =IIF(m.This.OL_Fields=1,ASORT(laObj2),.T.) && Ordered ? Yes/No

         FOR liy=1 TO liCount2
             SELE (lcADBC)
             GO (laObj2(liy,2))
             lcRecno=LTRIM(STR(RECNO(),11))

             lcField=ALLT(ObjectName)
             * Pokud tato poloka tvo primrn kl
             lcKeyFieldList=lcKeyFieldList+;
                            IIF(DBGETPROP(lcDBName+"."+lcField,"FIELD","KeyField"),lcField+", ","") && Pak ji pidej do seznamu

             * Seznam poloek, kter se updateuj
             lcUpdatableFieldList=lcUpdatableFieldList+;
                                  IIF(DBGETPROP(lcDBName+"."+lcField,"FIELD","Updatable"),lcField+", ","") && Pak ji pidej do seznamu

             * Mapovn poloek v pohledu a datov stran
             lcUpdateNameList=lcUpdateNameList+lcField+" "+DBGETPROP(lcDBName+"."+lcField,"FIELD","UpdateName")+", " && Pak ji pidej do seznamu

             IF m.This.GEN_Fields#1 && Nem li se generovat ?
                LOOP && Pak sko na dal
             ENDIF

             * Tvorba seznamu poloek pro pohled
             lcDefaultValue=DBGETPROP(lcDBName+"."+lcField,"FIELD","DefaultValue")
             lcRuleExpression=DBGETPROP(lcDBName+"."+lcField,"FIELD","RuleExpression")
             lcRuleText=DBGETPROP(lcDBName+"."+lcField,"FIELD","RuleText")
             lcCaption=DBGETPROP(lcDBName+"."+lcField,"FIELD","Caption")
             lcInputMask=DBGETPROP(lcDBName+"."+lcField,"FIELD","InputMask")
             lcFormat=DBGETPROP(lcDBName+"."+lcField,"FIELD","Format")
             lcDisplayClass=DBGETPROP(lcDBName+"."+lcField,"FIELD","DisplayClass")
             lcDisplayClassLibrary=DBGETPROP(lcDBName+"."+lcField,"FIELD","DisplayClassLibrary")
             lcComment=DBGETPROP(lcDBName+"."+lcField,"FIELD","Comment")

             llExpand=!EMPTY(lcDefaultValue) OR !EMPTY(lcRuleExpression) OR !EMPTY(lcRuleText) OR ;
                      !EMPTY(lcCaption) OR !EMPTY(lcInputMask) OR !EMPTY(lcFormat) OR !EMPTY(lcDisplayClass) OR ;
                      !EMPTY(lcDisplayClassLibrary) OR !EMPTY(lcComment)
                    
             llXXHead=llXXHead OR llExpand
                    
             lcPom=DBGETPROP(lcDBName+"."+lcField,"FIELD","DataType")
             liz=AT("NOCPT",lcPom)
             llBinnary=liz>0
             lcPom=IIF(liz>0,LEFT(lcPom,liz-1),lcPom)
             lcSize=STRTRAN(STRTRAN(STRTRAN(SUBS(lcPom,2),"(",""),")","")," ","")

             lcClass=IIF(!EMPTY(lcDisplayClass) AND llExpand,m.loPDMs.GetClassAnchor(lcDisplayClassLibrary,lcDisplayClass,"../../"),"")
             lcClassLib=IIF(!EMPTY(lcDisplayClassLibrary) AND llExpand,m.loPDMs.GetClassAnchor(lcDisplayClassLibrary,"","../../"),"")

             lcFields=lcFields+;
                      m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+'<td>'+LTRIM(STR(laObj2(liy,3),11))+'.</td>'+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+'<td width="20px" class="brzero">'+IIF(llExpand,[<img class="imgEC" src="../../imgs/]+lcPict+[" id="IMG_]+lcDBName+lcRecno+[" alt="]+STRTRAN(m.loPDMs.aStrings(PDM_01395),"%name%",lcDBName)+[" onclick="ExpandTab(']+lcDBName+lcRecno+[',-1);" />],'&nbsp;')+'</td>'+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+'<td class="blzero">'+UPPER(lcField)+'</td>'+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+'<td>'+LEFT(lcPom,1)+'</td>'+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(lcSize),"&nbsp;",lcSize)+'</td>'+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(3)+'<td>'+IIF(INLIST(LEFT(lcPom,1),"C","M","V"),'<img class="imgYN" src="../../imgs/'+IIF(llBinnary,"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(llBinnary,PDM_01397,PDM_01399)),"%name%",lcDBName)+'" />',"&nbsp;")+'</td>'+m.loPDM.aSpace(21)+;
                      m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                      IIF(!llExpand,'',;
                          m.loPDM.aSpace(2)+[<tr id="TX_]+lcDBName+lcRecno+[" ondblclick="ExpandTab(']+lcDBName+lcRecno+[',-1);"]+lcDisp+[>]+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(3)+[<td class="brzero">&nbsp;</td>]+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(3)+[<td class="blzero" colspan="5">]+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(4)+[<table border="0" cellpadding="2" cellspacing="0" id="TAB_]+lcDBName+lcRecno+[">]+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(5)+[<tbody>]+m.loPDM.aSpace(21)+;
                          IIF(EMPTY(lcDefaultValue),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01350)  +'</td><td id="ID_'+lcDBName+lcRecno+'_1">'+m.loPDM.Expr2xhtml(@m.lcDefaultValue)+'</td></tr>'+m.loPDM.aSpace(21))+;
                          IIF(EMPTY(lcRuleExpression),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01352)+'</td><td id="ID_'+lcDBName+lcRecno+'_2">'+m.loPDM.Expr2xhtml(@m.lcRuleExpression)+'</td></tr>'+m.loPDM.aSpace(21))+;
                          IIF(EMPTY(lcRuleText),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01354)+'</td><td>'+StrTranHTMLString(lcRuleText)+'</td></tr>'+m.loPDM.aSpace(21))+;
                          IIF(EMPTY(lcCaption),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01356)+'</td><td>'+IIF(LEFT(lcCaption,1)="=",m.loPDM.Expr2xhtml(lcCaption),StrTranHTMLString(lcCaption))+'</td></tr>'+m.loPDM.aSpace(21))+;
                          IIF(EMPTY(lcInputMask),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01358)+'</td><td>'+StrTranHTMLString(lcInputMask)+'</td></tr>'+m.loPDM.aSpace(21))+;
                          IIF(EMPTY(lcFormat),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01360)+'</td><td>'+StrTranHTMLString(lcFormat)+'</td></tr>'+m.loPDM.aSpace(21))+;
                          IIF(EMPTY(lcDisplayClass),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01362)+'</td><td>'+IIF(EMPTY(lcClass),lcDisplayClass,'<a href="'+lcClass+'" target="_top">'+lcDisplayClass+'</a>')+'</td></tr>'+m.loPDM.aSpace(21))+;
                          IIF(EMPTY(lcDisplayClassLibrary),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01367)+'</td><td>'+IIF(EMPTY(lcClassLib),lcDisplayClassLibrary,'<a href="'+lcClassLib+'" target="_top">'+lcDisplayClassLibrary+'</a>')+'</td></tr>'+m.loPDM.aSpace(21))+;
                          IIF(EMPTY(lcComment),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_03326)+'</td><td>'+StrTranHTMLString(lcComment)+'</td></tr>'+m.loPDM.aSpace(21))+;
                          m.loPDM.aSpace(5)+'</tbody>'+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(4)+'</table>'+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(3)+'</td>'+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21))


             lcScript=lcScript+;
                      IIF(!EMPTY(lcDefaultValue),STRTRAN(m.loPDM.SNW,"%ID%",'ID_'+lcDBName+lcRecno+'_1')+m.loPDM.aSpace(21),'')+;
                      IIF(!EMPTY(lcRuleExpression),STRTRAN(m.loPDM.SNW,"%ID%",'ID_'+lcDBName+lcRecno+'_2')+m.loPDM.aSpace(21),'')+;
                      IIF(llExpand,STRTRAN(STRTRAN(STRTRAN(m.loPDM.RE,"%ID%",'TAB_'+lcDBName+lcRecno),"%XType%","Property"),"%Dir%","../../imgs/")+m.loPDM.aSpace(21),'')

         NEXT

         IF m.This.GEN_Fields=1
            lcFields='<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_01449)+'</td><td colspan="2">'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_01389)+'</td><td>'+m.loPDMs.aStrings(PDM_01390)+'</td><td>'+m.loPDMs.aStrings(PDM_01392)+'</td>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                     IIF(!llXXHead,'',;
                          m.loPDM.aSpace(2)+[<tr class="Head" ondblclick="ExpandAllObjects(']+lcDBName+[',1);">]+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(3)+[<td><img class="imgEC" src="../../imgs/]+lcPict+[" id="IMGX_]+lcDBName+[" alt="]+m.loPDMs.aStrings(PDM_01394)+[" /></td><td colspan="5">]+m.loPDMs.aStrings(PDM_01394)+[</td>]+m.loPDM.aSpace(21)+;
                          m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21))+;
                     m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<tbody'+IIF(llXXHead,' id="TBODY_'+lcDBName+'"','')+'>'+m.loPDM.aSpace(21)+;
                     lcFields+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21)

            IF llXXHead
               lcFields=lcFields+m.loPDM.aSpace(21)+;
                        m.loPDM.StartS+;
                        STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.loPDM.RME,"%ID%","TBODY_"+lcDBName),"%XType%","Main"),"%Value%",IIF(llEC_Tab,"true","false")),"%Dir%","../../imgs/")+;
                        lcScript+;
                        m.loPDM.StopS+m.loPDM.aSpace(21)
            ENDIF
         ENDIF
        
         * Oe seznamy
         lcKeyFieldList=IIF(RIGHT(lcKeyFieldList,2)=", ",LEFT(lcKeyFieldList,LEN(lcKeyFieldList)-2),lcKeyFieldList)
         lcUpdatableFieldList=IIF(RIGHT(lcUpdatableFieldList,2)=", ",LEFT(lcUpdatableFieldList,LEN(lcUpdatableFieldList)-2),lcUpdatableFieldList)
         lcUpdateNameList=IIF(RIGHT(lcUpdateNameList,2)=", ",LEFT(lcUpdateNameList,LEN(lcUpdateNameList)-2),lcUpdateNameList)

         * Identifikuj podtyp pohledu
         =DBC_GetProperty(lcADBC,liObjectID,_DBCID_SubType,@m.luValue)


         lcPom=DBGETPROP(lcDBName,"VIEW","COMMENT")
         * Nejdve hlavika pohledu
         * pak koment
         * Pak SQL pkaz
         lcBody=lcBody+m.loPDM.aSpace(21)+'<h5><a name="'+STRTRAN(lcDBName," ",".")+'">'+m.loPDMs.aStrings(PDM_00950)+' '+lcDBName+'</a></h5>'+m.loPDM.aSpace(21)+;
                IIF(LEN(m.lcPom)>0,"&nbsp;"+m.lcPom,"")+m.loPDM.aSpace(21)+;
                [<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_05046)+"</div>"+m.loPDM.aSpace(21)+;
                [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                m.lcDIAF+m.loPDM.aSpace(21)+;
                m.loPDMs.GenerateBackReferenceHTML(m.loPIPar.File,"","","../../")+;
                [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                m.lcDIAXF+m.loPDM.aSPace(21)+;
                [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)

         liz=m.loPDMs.GetCAnchor(DBC()+"!"+lcDBName,@laSO,"../../",_PDM_CA_ApplyTo)
  
         IF liz>0
            lcBody=lcBody+;
                   [<div class="pdm_crosslinks"> <!-- Link Table start -->]+m.loPDM.aSpace(21)+;
                   [<span>]+m.loPDMs.aStrings(PDM_01303)+[</span>]+m.loPDM.aSpace(21)

            FOR lix=1 TO liz
                lcBody=lcBody+;
                       [ <a href="]+laSO(lix,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05049),"%name%",ExtractFileFromFile(laSO(lix,2)))+[">]+ExtractFileFromFile(laSO(lix,2))+[</a>]+IIF(lix#liz," | ","")+m.loPDM.aSpace(21)
            NEXT
            lcBody=lcBody+;
                   [</div><br /> <!-- Link Table End -->]+m.loPDM.aSpace(21)
         ENDIF
         =FWRITE(m.lihFile,lcBody)

         lcPom=DBGETPROP(lcDBName,"VIEW","ConnectName")
         lcBody='<table>'+m.loPDM.aSpace(21)+;   
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00956)+'</td><td>'+IIF(luValue=6,m.loPDMs.aStrings(PDM_00957),m.loPDMs.aStrings(PDM_00958))+'</td></tr>'+m.loPDM.aSpace(21)+;
                IIF(luValue=6,'',;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00960)+'</td><td><a href="'+STRTRAN(lcPom," ",".")+'.htm" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05169),"%name%",m.lcPom)+'">'+m.lcPom+'</a></td></tr>'+m.loPDM.aSpace(21))+;
                m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00964)+'</td><td>'+StrTranHTMLString(DBGETPROP(lcDBName,"VIEW","SQL"))+'</td></tr>'+m.loPDM.aSpace(21)+;
                IIF(luValue=6,'',;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00968)+'</td><td>'+LTRIM(STR(DBGETPROP(lcDBName,"VIEW","BatchUpdateCount"),3))+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00972)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcDBName,"VIEW","FetchMemo"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcDBName,"VIEW","FetchMemo"),PDM_00973,PDM_00974))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00978)+'</td><td>'+LTRIM(STR(DBGETPROP(lcDBName,"VIEW","FetchSize"),3))+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00982)+'</td><td>'+LTRIM(STR(DBGETPROP(lcDBName,"VIEW","MaxRecords"),3))+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00986)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcDBName,"VIEW","ShareConnection"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcDBName,"VIEW","ShareConnection"),PDM_00987,PDM_00988))+'" /></td></tr>'+m.loPDM.aSpace(21))+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_00992)+'</td><td>'+IIF(DBGETPROP(lcDBName,"VIEW","SourceType")=1,"Local","Remote")+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_00998)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcDBName,"VIEW","SendUpdates"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcDBName,"VIEW","SendUpdates"),PDM_00999,PDM_01000))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01004)+'</td><td>'+LTRIM(STR(DBGETPROP(lcDBName,"VIEW","UpdateType"),3))+'</td></tr>'+m.loPDM.aSpace(21)+;
                    IIF(luValue=6,'',;
                       m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01008)+'</td><td>'+LTRIM(STR(DBGETPROP(lcDBName,"VIEW","UseMemoSize"),11))+'</td></tr>'+m.loPDM.aSpace(21))+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01012)+'</td><td>'+LTRIM(STR(DBGETPROP(lcDBName,"VIEW","WhereType"),3))+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01016)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcDBName,"VIEW","Prepared"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcDBName,"VIEW","Prepared"),PDM_01017,PDM_01018))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01022)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcDBName,"VIEW","CompareMemo"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcDBName,"VIEW","CompareMemo"),PDM_01023,PDM_01024))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01028)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcDBName,"VIEW","FetchAsNeeded"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcDBName,"VIEW","FetchAsNeeded"),PDM_01029,PDM_01030))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01034)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(DBGETPROP(lcDBName,"VIEW","Offline"),"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(DBGETPROP(lcDBName,"VIEW","Offline"),PDM_01035,PDM_01036))+'" /></td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01040)+'</td><td>'+StrTranHTMLString(DBGETPROP(lcDBName,"VIEW","RuleExpression"))+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01044)+'</td><td>'+StrTranHTMLString(DBGETPROP(lcDBName,"VIEW","RuleText"))+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01048)+'</td><td>'+StrTranHTMLString(DBGETPROP(lcDBName,"VIEW","Tables"))+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01052)+'</td><td>'+StrTranHTMLString(lcKeyFieldList)+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01054)+'</td><td>'+StrTranHTMLString(lcUpdatableFieldList)+'</td></tr>'+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(1)+'<tr><td class="a_top">'+m.loPDMs.aStrings(PDM_01056)+'</td><td>'+StrTranHTMLString(lcUpdateNameList)+'</td></tr>'+m.loPDM.aSpace(21)

         =DBC_GetProperty(lcADBC,liObjectID,_DBCID_AllowSimultaneousFetch,@m.lcPom)

         lcBody=lcBody+; 
                IIF(luValue=6,'',;
                  m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01057)+'</td><td><img class="imgYN" src="../../imgs/'+IIF(m.lcPom,"fy.gif","fn.gif")+'" alt="'+m.loPDMs.aStrings(IIF(m.lcPom,PDM_01058,PDM_01059))+'" /></td></tr>'+m.loPDM.aSpace(21))+;
                '</table>'+m.loPDM.aSpace(21)+'<br />'+m.loPDM.aSpace(21)+lcFields

         =FWRITE(m.lihFile,lcBody)

         =FWRITE(m.lihFile,IIF(loPIPar.lLNK,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS,"")+;
                 '</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.oFileLevel,.NULL.,.NULL.,.NULL.,lcPathX+lcFile_d,0,_PDM_EF_None,m.lcDBName,_PDM_FG_Any+_PDM_FG_View)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_d))
      ENDIF
   ENDPROC


   PROCEDURE GenerateHTML_DBF(lcDBPath,lcHTML, lcDBName,lcADBC,laPRC,lcFile_dSP) && Vygeneruje strnku DBF tabulek (Free and in DBC container)
      * lcDBPath - Cesta a nzev tabulky
      * lcDBName - jmno tabulky bez cesty a ppony
      * lcADBC   - Alias otevenho DBC konteineru jako tabulka
      *@laPRC    - Matice uloench procedur na vygenerovn odkaz
      * lcFile_dSP - Nzev HTML souboru s Stored Procedures

      LOCAL lii,liy,lcDBType,lcAlias,lcString,liCount,luValue,lihFile,m.loPDM,;
            lcCaption,lcInputMask,lcFormat,lcDisplayClass,lcDisplayClassLibrary,lcComment,;
            lcChildTag,lcParentTable,lcParentTag,lcRecno,llEC_Tab,llExpand,lcClass,lcClassLib,;
            llGEN_Fields,llGEN_Indexes,llGEN_Relations,llXXHead,lcPict,lcDisp,m.loPDMs,lcScript,lcPom,lcRPath,;
            liz,lix,liID,lcDIAF,lcDIAXF,lcFile_dex,llEx,loPIPar,lcPath,lcPathX,llOne,lcFile_d,;
            lcCSS,lcJS,lcDIAFCSS,lcDIAFJS,lcName


      LOCAL ARRAY laFields(1),laObj(1),laSO(1),laRel(1),laRelX(1)
      lcAlias=SYS(2015)
      lihFile=m.This.hFile && Handle otevenho souboru
      m.loPDM=EVAL(m.This.PDM) && Zskej odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      * Nyn se pokus otevt potebn DBF tabulky
      IF m.loPDMs.OpenTable(m.This.DataSessionID,lcDBPath,lcAlias," AGAIN SHARE NOUPDATE")>0
         RETURN _PDM_FileNO
      ENDIF

      llOne=m.loPDM.One
      IF EMPTY(lcADBC)
         lcPath=m.loPDM.OutDir+m.This.OutDir+"\FreeTables\" && +m.This.FileName+"\"
         lcPathX=m.This.OutDir+"\FreeTables\" && +m.This.FileName+"\"
         lcName=This.FileName
         This.HTMLOMMain=IIF(llOne,lcPathX+lcHTML,"") && ???
      ELSE
         lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
         lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"
         lcName=SUBST(lcDBPath,AT("!",lcDBPath)+1)
      ENDIF
      lcFile_d=lcHTML

      STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,This.hFile
      IF lihFile>0

         m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)
         m.loPDM.GetPI_ENV("DIAF",lcPath,@m.lcDIAFCSS,@m.lcDIAFJS)

         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_01246),"%name%",lcName))+;
                  m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+m.lcDIAFCSS+lcCSS+;
                  m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+m.lcDIAFJS+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
         =FWRITE(m.lihFile,m.lcString)


         SELE (lcAlias)
         lcDBType=IIF(EMPTY(CURSORGETPROP("Database")) OR EMPTY(lcADBC),"F","D")
         * Nati seznam poloek do tabulky
         liCount=AFIELDS(laFields)
         lcRPath="../../imgs/" && IIF(EMPTY(lcADBC),"../","../../")+"imgs/"

         lcString=m.loPDM.aSpace(21)+;
                  IIF(lcDBType=="D",'<h5>','<h3>')+'<a name="'+STRTRAN(lcDBName," ",".")+'">'+m.loPDMs.aStrings(PDM_01283)+' '+lcDBName+'</a>'+IIF(lcDBType=="D",'</h5>','</h3>')+m.loPDM.aSpace(21)

         * Create Detail Description of File, DIAF Plug-in
         loPIPar=m.loPDM.oPIPar
         loPIPar.Reset()
         loPIPar.File=IIF(lcDBType=="D",DBF(lcADBC)+"!"+lcDBName,lcDBPath)
         loPIPar.Type="DIAF"
         loPIPar.FileGroup=_PDM_FG_DBF
         loPIPar.RamPJX=This.RamPJX
         loPIPar.oPDMx=This

         STORE "" TO lcDIAF,lcDIAXF
         FOR lii=1 TO m.loPDM.iDIAF
             lcDIAF=m.lcDIAF+m.loPDM.aDIAF(lii,1).Run(@m.loPIPar,m.loPDM.aDIAF(lii,2))
             lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
         NEXT

      
         lcString=lcString+;
                  [<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_05046)+"</div>"+m.loPDM.aSpace(21)+;
                  [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                  m.lcDIAF+m.loPDM.aSpace(21)+;
                  m.loPDMs.GenerateBackReferenceHTML(m.loPIPar.File,"","","../../")+;
                  [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                  [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                  m.lcDIAXF+m.loPDM.aSPace(21)+;
                  [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)


         STORE .T. TO llGEN_Fields,llGEN_Indexes,llGEN_Relations

         llEC_Tab=m.This.aEC(_EC_Tab,1)
         lcPict=m.This.aEC(_EC_Tab,2)
         lcDisp=m.This.aEC(_EC_Tab,3)

         *****************************************
         * Poloky
         IF lcDBType=="D" && Tabulka v databzi
            SET DATABASE TO (CURSORGETPROP("Database")) && Nastav aktuln databzi

            lcString=lcString+;
                    IIF(!EMPTY(laFields(16)),"&nbsp;"+laFields(16)+"<br />","")+m.loPDM.aSpace(21)+;
                    '<table cellpadding="2">'+m.loPDM.aSpace(21)+;
                     IIF(!EMPTY(laFields(12)),m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_01292)+"</td><td>" +laFields(12)+"</td></tr>"+m.loPDM.aSpace(21),"")+;
                     IIF(!EMPTY(laFields(10)),m.loPDM.aSpace(1)+'<tr><td>'+m.loPDMs.aStrings(PDM_01294)+"</td><td>"+m.loPDM.Expr2xhtml(laFields(10))+"</td></tr>"+m.loPDM.aSpace(21),"")+;
                     IIF(!EMPTY(laFields(11)),m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_01296)+"</td><td>" + StrTranHTMLString(laFields(11))+"</td></tr>"+m.loPDM.aSpace(21),"")

            IF !EMPTY(laFields(13))
               lcPom=UPPER(laFields(13))
               lii=AT("(",lcPom)
               lii=m.loPDMs.AScan(IIF(lii=0,lcPom,ALLT(LEFT(lcPom,lii-1))),@laPRC) && Najdi trigger
               lcString=lcString+;
                        m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_01298)+"</td><td>"+;
                        IIF(lii>0,'<a href="'+laPRC(lii,2)+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05158),"%name%",laFields(13))+'">','')+;
                        laFields(13)+IIF(lii>0,'</a>','')+"</td></tr>"+m.loPDM.aSpace(21)
            ENDIF

            IF !EMPTY(laFields(14))
               lcPom=UPPER(laFields(14))
               lii=AT("(",lcPom)
               lii=m.loPDMs.AScan(IIF(lii=0,lcPom,ALLT(LEFT(lcPom,lii-1))),@laPRC) && Najdi trigger
               lcString=lcString+;
                        m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_01300)+"</td><td>"+;
                        IIF(lii>0,'<a href="'+laPRC(lii,2)+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05158),"%name%",laFields(14))+'">','')+;
                        laFields(14)+IIF(lii>0,'</a>','')+"</td></tr>"+m.loPDM.aSpace(21)
            ENDIF

            IF !EMPTY(laFields(15))
               lcPom=UPPER(laFields(15))
               lii=AT("(",lcPom)
               lii=m.loPDMs.AScan(IIF(lii=0,lcPom,ALLT(LEFT(lcPom,lii-1))),@laPRC) && Najdi trigger
               lcString=lcString+;
                        m.loPDM.aSpace(1)+"<tr><td>"+m.loPDMs.aStrings(PDM_01302)+"</td><td>"+;
                        IIF(lii>0,'<a href="'+laPRC(lii,2)+'" target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05158),"%name%",laFields(15))+'">','')+;
                        laFields(15)+IIF(lii>0,'</a>','')+"</td></tr>"+m.loPDM.aSpace(21)
            ENDIF
            lcString=lcString+;
                     "</table>"+m.loPDM.aSpace(21)
         ENDIF

         liz=m.loPDMs.GetCAnchor(IIF(lcDBType=="D",DBF(lcADBC)+"!"+lcDBName,lcDBPath),@laSO,"../../",_PDM_CA_ApplyTo)

         IF liz>0
            lcString=lcString+;
                     [<div class="pdm_crosslinks"> <!-- Link Table start -->]+m.loPDM.aSpace(21)+;
                     [<span>]+m.loPDMs.aStrings(PDM_01303)+[</span>]+m.loPDM.aSpace(21)

            FOR lix=1 TO liz
                lcString=lcString+;
                          [ <a href="]+laSO(lix,1)+[" target="_top" title="]+STRTRAN(m.loPDMs.aStrings(PDM_05049),"%name%",ExtractFileFromFile(laSO(lix,2)))+[">]+ExtractFileFromFile(laSO(lix,2))+[</a>]+IIF(lix#liz," | ","")+m.loPDM.aSpace(21)
       
            NEXT
            lcString=lcString+;
                     [</div><br /> <!-- Link Table End -->]+m.loPDM.aSpace(21)
         ENDIF

         =FWRITE(lihFile,lcString+m.loPDM.aSpace(21))

         IF m.This.GEN_Fields=1 && M se generovat ?
            STORE "" TO lcString,lcScript

            DIME laObj(liCount,2)
            FOR lii=1 TO liCount
                laObj(lii,1)=UPPER(laFields(lii,1))
                laObj(lii,2)=lii
            NEXT
            =IIF(m.This.OL_Fields=1,ASORT(laObj),.T.) && Ordered ? Yes/No

            STORE "" TO lcCaption,lcInputMask,lcFormat,lcDisplayClass,lcDisplayClassLibrary,lcComment
            FOR liy=1 TO liCount
                lii=laObj(liy,2)

                lcRecno=LTRIM(STR(lii,11))
                IF lcDBType=="D" && Tabulka v databzi
                   lcCaption=DBGETPROP(lcDBName+"."+laFields(lii,1),"FIELD","Caption")
                   lcInputMask=DBGETPROP(lcDBName+"."+laFields(lii,1),"FIELD","InputMask")
                   lcFormat=DBGETPROP(lcDBName+"."+laFields(lii,1),"FIELD","Format")
                   lcDisplayClass=DBGETPROP(lcDBName+"."+laFields(lii,1),"FIELD","DisplayClass")
                   lcDisplayClassLibrary=DBGETPROP(lcDBName+"."+laFields(lii,1),"FIELD","DisplayClassLibrary")
                   lcComment=DBGETPROP(lcDBName+"."+laFields(lii,1),"FIELD","COMMENT")
                ENDIF

                llExpand=lcDBType="D" AND ;
                         (!EMPTY(laFields(lii,9)) OR !EMPTY(laFields(lii,7)) OR !EMPTY(laFields(lii,8)) OR ;
                          !EMPTY(lcCaption) OR !EMPTY(lcInputMask) OR !EMPTY(lcFormat) OR !EMPTY(lcDisplayClass) OR ;
                          !EMPTY(lcDisplayClassLibrary) OR !EMPTY(lcComment) OR m.loPDMs.VFPVers=>"8" AND !EMPTY(laFields(lii,18)))

                llXXHead=llXXHead OR llExpand

                lcClass=IIF(!EMPTY(lcDisplayClass) AND llExpand,m.loPDMs.GetClassAnchor(lcDisplayClassLibrary,lcDisplayClass,"../../"),"")
                lcClassLib=IIF(!EMPTY(lcDisplayClassLibrary) AND llExpand,m.loPDMs.GetClassAnchor(lcDisplayClassLibrary,"","../../"),"")

                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+LTRIM(STR(lii,11))+'.</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td width="20px" class="brzero">'+IIF(llExpand,[<img class="imgEC" src="]+lcRPath+lcPict+[" id="IMG_]+lcDBName+lcRecno+[" alt="]+STRTRAN(m.loPDMs.aStrings(PDM_01395),"%name%",laFields(lii,1))+[" onclick="ExpandTab(']+lcDBName+lcRecno+[',-1);" />],'&nbsp;')+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td class="blzero">'+UPPER(laFields(lii,1))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+laFields(lii,2)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+LTRIM(STR(laFields(lii,3),11))+IIF(laFields(lii,4) = 0,"",","+LTRIM(STR(laFields(lii,4),11)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+lcRPath+IIF(laFields(lii,5),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(laFields(lii,5),PDM_01396,PDM_01398)),"%name%",laFields(lii,1))+'" />'+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(INLIST(laFields(lii,2),"C","M","V"),'<img class="imgYN" src="'+lcRPath+IIF(laFields(lii,6),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(laFields(lii,6),PDM_01397,PDM_01399)),"%name%",laFields(lii,1))+'" />',"&nbsp;")+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                         IIF(!llExpand,'',;
                             m.loPDM.aSpace(2)+[<tr id="TX_]+lcDBName+lcRecno+["]+lcDisp+[>]+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(3)+[<td class="brzero">&nbsp;</td>]+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(3)+[<td class="blzero" colspan="6">]+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(4)+[<table border="0" cellpadding="2" cellspacing="0" id="TAB_]+lcDBName+lcRecno+[">]+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(5)+[<tbody>]+m.loPDM.aSpace(21)+;
                             IIF(EMPTY(laFields(lii,9)),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01350)+'</td><td id="ID_'+lcDBName+lcRecno+'_1">'+m.loPDM.Expr2xhtml(laFields(lii,9))+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(EMPTY(laFields(lii,7)),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01352)+'</td><td id="ID_'+lcDBName+lcRecno+'_2">'+m.loPDM.Expr2xhtml(laFields(lii,7))+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(EMPTY(laFields(lii,8)),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01354)+'</td><td>'+StrTranHTMLString(laFields(lii,8))+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(EMPTY(lcCaption),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01356)+'</td><td>'+IIF(LEFT(lcCaption,1)="=",m.loPDM.Expr2xhtml(lcCaption),StrTranHTMLString(lcCaption))+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(EMPTY(lcInputMask),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01358)+'</td><td>'+StrTranHTMLString(lcInputMask)+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(EMPTY(lcFormat),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01360)+'</td><td>'+StrTranHTMLString(lcFormat)+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(EMPTY(lcDisplayClass),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01362)+'</td><td>'+IIF(EMPTY(lcClass),lcDisplayClass,'<a href="'+lcClass+'" target="_top">'+lcDisplayClass+'</a>')+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(EMPTY(lcDisplayClassLibrary),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01367)+'</td><td>'+IIF(EMPTY(lcClassLib),lcDisplayClassLibrary,'<a href="'+lcClassLib+'" target="_top">'+lcDisplayClassLibrary+'</a>')+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(EMPTY(lcComment),'',m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_03326)+'</td><td>'+StrTranHTMLString(lcComment)+'</td></tr>'+m.loPDM.aSpace(21))+;
                             IIF(VAL(m.loPDMs.VFPVers)>=8 AND !EMPTY(laFields(lii,18)),m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01368)+'</td><td>'+LTRIM(STR(laFields(lii,17),11))+'</td></tr>'+m.loPDM.aSpace(21),'')+;
                             IIF(VAL(m.loPDMs.VFPVers)>=8 AND !EMPTY(laFields(lii,18)),m.loPDM.aSpace(6)+'<tr><td>'+m.loPDMs.aStrings(PDM_01369)+'</td><td>'+LTRIM(STR(laFields(lii,18),11))+'</td></tr>'+m.loPDM.aSpace(21),'')+;
                             m.loPDM.aSpace(5)+'</tbody>'+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(4)+'</table>'+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(3)+'</td>'+m.loPDM.aSpace(21)+;
                             m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21))


                lcScript=lcScript+;
                         IIF(!EMPTY(laFields(lii,9)),STRTRAN(m.loPDM.SNW,"%ID%",'ID_'+lcDBName+lcRecno+'_1')+m.loPDM.aSpace(21),'')+;
                         IIF(!EMPTY(laFields(lii,7)),STRTRAN(m.loPDM.SNW,"%ID%",'ID_'+lcDBName+lcRecno+'_2')+m.loPDM.aSpace(21),'')+;
                         IIF(llExpand,STRTRAN(STRTRAN(STRTRAN(m.loPDM.RE,"%ID%",'TAB_'+lcDBName+lcRecno),"%XType%","Property"),"%Dir%",lcRPath)+m.loPDM.aSpace(21),'')
            NEXT

            lcString='<strong>'+m.loPDMs.aStrings(PDM_01385)+'</strong>'+m.loPDM.aSpace(21)+;
                     '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_01449)+'</td><td colspan="2">'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_01389)+'</td><td>'+m.loPDMs.aStrings(PDM_01390)+'</td><td>'+m.loPDMs.aStrings(PDM_01391)+'</td><td>'+m.loPDMs.aStrings(PDM_01392)+'</td>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                     IIF(!llXXHead,'',;
                     m.loPDM.aSpace(2)+[<tr class="Head" ondblclick="ExpandAllObjects(']+lcDBName+[',1);">]+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+[<td><img class="imgEC" src="]+lcRPath+lcPict+[" id="IMGX_]+lcDBName+[" alt="]+m.loPDMs.aStrings(PDM_01394)+[" /></td><td colspan="6">]+m.loPDMs.aStrings(PDM_01394)+[</td>]+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+[</tr>]+m.loPDM.aSpace(21))+;
                     m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<tbody'+IIF(llXXHead,' id="TBODY_'+lcDBName+'"','')+'>'+m.loPDM.aSpace(21)+lcString+;
                     m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+;
                     '</table>'+m.loPDM.aSpace(21)

            IF llXXHead
               lcString=lcString+m.loPDM.aSpace(21)+;
                        m.loPDM.StartS+;
                        STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.loPDM.RME,"%ID%","TBODY_"+lcDBName),"%XType%","Main"),"%Value%",IIF(llEC_Tab,"true","false")),"%Dir%",lcRPath)+;
                        lcScript+;
                        m.loPDM.StopS+m.loPDM.aSpace(21)
            ENDIF
            =FWRITE(lihFile,lcString)
         ELSE
            llGEN_Fields=.F.
         ENDIF
 
         *****************************************
         * Indexy
         SELE (lcAlias)
         liCount=TAGCOUNT()
         IF m.This.GEN_Indexes=1 AND liCount>0 && M se generovat ?
            lcString='<strong>'+m.loPDMs.aStrings(PDM_01410)+'</strong>'+m.loPDM.aSpace(21)+;
                     '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_01449)+'</td><td>'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_01414)+'</td><td>'+m.loPDMs.aStrings(PDM_01415)+'</td><td>'+m.loPDMs.aStrings(PDM_01416)+'</td><td>'+m.loPDMs.aStrings(PDM_01417)+'</td><td>'+m.loPDMs.aStrings(PDM_01418)+'</td>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

            DIME laObj(liCount,2)
            FOR lii=1 TO liCount
                laObj(lii,1)=TAG(lii)
                laObj(lii,2)=lii
            NEXT
            =IIF(m.This.OL_Indexes=1,ASORT(laObj),.T.) && Ordered ? Yes/No

            FOR liy=1 TO liCount
                lii=laObj(liy,2)
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+LTRIM(STR(lii,11))+'.</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+TAG(lii)+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+lcRPath+IIF(PRIMARY(lii),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(PRIMARY(lii),PDM_01400,PDM_01401)),"%name%",TAG(lii))+'" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td><img class="imgYN" src="'+lcRPath+IIF(CANDIDATE(lii),"fy.gif","fn.gif")+'" alt="'+STRTRAN(m.loPDMs.aStrings(IIF(CANDIDATE(lii),PDM_01402,PDM_01403)),"%name%",TAG(lii))+'" /></td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(SYS(14,lii)),"&nbsp;",m.loPDM.Expr2xhtml(SYS(14,lii)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(IDXCOLLATE(lii)),"&nbsp;",IDXCOLLATE(lii))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+IIF(EMPTY(SYS(2021,lii)),"&nbsp;",m.loPDM.Expr2xhtml(SYS(2021,lii)))+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)
            ENDFOR
 
            =FWRITE(lihFile,lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))
         ELSE
            llGEN_Indexes=.F.
         ENDIF
         USE IN (lcAlias)

         *****************************************
         ** Relations from child table
         IF m.lcDBType=="D" AND !EMPTY(m.lcADBC) AND m.This.GEN_Relations=1
            SELE (m.lcADBC)
            ** Vrt ID tabulky
            liID=DBC_GetIDObject(m.lcADBC,_DBC_Table,m.lcDBName)
            * Vyfiltruj vechny relace
            SET FILT TO ParentId=m.liID AND ObjectType=_DBC_Relation
            COUNT TO liCount
         ENDIF

         IF lcDBType=="D" AND !EMPTY(lcADBC) AND m.liCount>0 AND m.This.GEN_Relations=1
            DIME laRel(m.liCount,3)
            COPY TO ARRAY laRel FIELDS ObjectName,ObjectID,ObjectID && Vyber
            SET FILT TO 

            lcString='<strong>'+m.loPDMs.aStrings(PDM_01445)+'</strong>'+m.loPDM.aSpace(21)+;
                     '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_01449)+'</td><td>'+m.loPDMs.aStrings(PDM_01450)+'</td><td>'+m.loPDMs.aStrings(PDM_01451)+'</td><td>'+m.loPDMs.aStrings(PDM_01452)+'</td>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

            FOR lii=1 TO liCount
                laRel(lii,3)=lii
            NEXT

            =IIF(m.This.OL_Relations=1,ASORT(laRel),.T.) && Ordered ? Yes/No

*!*	         IF (m.lcDBName)=UPPER("ORDERS")
*!*	         SUSPEND
*!*	         ENDIF

            FOR lii=1 TO liCount
                =DBC_GetProperty(lcADBC,laRel(lii,2),_DBCID_ChildTag,@m.lcChildTag)
                =DBC_GetProperty(lcADBC,laRel(lii,2),_DBCID_ParentTable,@m.lcParentTable)
                =DBC_GetProperty(lcADBC,laRel(lii,2),_DBCID_ParentTag,@m.lcParentTag)
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+LTRIM(STR(laRel(lii,3),11))+'.</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+lcChildTag+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+;
                             '<a href="'+m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\Main_uni.htm?next="+LOWER(STRTRAN(lcParentTable," ","."))+'.htm'+'"'+;
                             ' target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05143),"%name%",lcParentTable)+'">'+StrTranHTMLString(lcParentTable)+'</a>'+;
                             '</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+lcParentTag+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)

            ENDFOR
      
            =FWRITE(lihFile,lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))
         ELSE
            llGEN_Relations=.F.
         ENDIF


         *****************************************
         ** Relations from masters table
         liCount=0
         IF m.lcDBType=="D" AND !EMPTY(m.lcADBC) AND m.This.GEN_Relations=1
            SELE (m.lcADBC)
            * Vyfiltruj vechny relace
            SET FILT TO ObjectType=_DBC_Relation
            COUNT TO liCount
            IF liCount>0
               DIME laRelX(m.liCount,3),laRel(m.liCount,4)
               COPY TO ARRAY laRelX FIELDS ObjectName,ObjectID,ParentID 
            ENDIF   
            SET FILT TO 
            liy=0
            FOR lii=1 TO m.liCount
                =DBC_GetProperty(m.lcADBC,m.laRelX(m.lii,2),_DBCID_ParentTable,@m.lcParentTable)
                IF UPPER(m.lcParentTable)==UPPER(m.lcDBName)
                   m.liy=m.liy+1
                   laRel(m.liy,1)=laRelX(m.lii,1)
                   laRel(m.liy,2)=laRelX(m.lii,2)
                   
                   LOCATE FOR ObjectID=laRelX(m.lii,3) AND ObjectType=_DBC_Table
                   laRel(m.liy,4)=ObjectName
                ENDIF
            ENDFOR
            liCount=m.liy
            IF m.liy>0
               DIMENSION laRel(m.liy,4)
            ENDIF
         ENDIF

         IF lcDBType=="D" AND !EMPTY(lcADBC) AND m.liCount>0 AND m.This.GEN_Relations=1
            llGEN_Relations=.T.

            lcString='<strong>'+m.loPDMs.aStrings(PDM_01454)+'</strong>'+m.loPDM.aSpace(21)+;
                     '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_01449)+'</td><td>'+m.loPDMs.aStrings(PDM_01450)+'</td><td>'+m.loPDMs.aStrings(PDM_01453)+'</td><td>'+m.loPDMs.aStrings(PDM_01452)+'</td>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                     m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

            FOR lii=1 TO liCount
                laRel(lii,3)=lii
            NEXT

            =IIF(m.This.OL_Relations=1,ASORT(laRel),.T.) && Ordered ? Yes/No

            FOR lii=1 TO liCount
                =DBC_GetProperty(lcADBC,laRel(lii,2),_DBCID_ChildTag,@m.lcChildTag)
                m.lcParentTable=ALLTRIM(laRel(lii,4))
                =DBC_GetProperty(lcADBC,laRel(lii,2),_DBCID_ParentTag,@m.lcParentTag)
                lcString=lcString+;
                         m.loPDM.aSpace(2)+'<tr>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+LTRIM(STR(laRel(lii,3),11))+'.</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+lcChildTag+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+;
                                           '<a href="'+m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\Main_uni.htm?next="+LOWER(STRTRAN(lcParentTable," ","."))+'.htm'+'"'+;
                                           ' target="_top" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05143),"%name%",lcParentTable)+'">'+StrTranHTMLString(lcParentTable)+'</a>'+;
                                           '</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(3)+'<td>'+lcParentTag+'</td>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)
            ENDFOR
      
            =FWRITE(lihFile,lcString+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21))
         ELSE
            llGEN_Relations=llGEN_Relations OR .F.
         ENDIF


         =FWRITE(m.lihFile,IIF(loPIPar.lLNK,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS,"")+;
                 '</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.oFileLevel,.NULL.,.NULL.,.NULL.,lcPathX+lcFile_d,0,_PDM_EF_None,m.lcName,_PDM_FG_Any+_PDM_FG_DBF)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_d))
      ENDIF


		
      IF lcDBType=="D" AND !EMPTY(lcADBC)
         SET FILT TO  && Zru filtr
      ENDIF
   ENDPROC


   PROCEDURE GenerateHTML_QPR(lcQRPPath, lcHTML, lcQRPName) && Vygeneruje strnku DBF tabulek (Free and in DBC container)
      * lcQRPPath - Cesta a nzev QRP souboru
      * lcQRPName - jmno QRP souboru bez cesty a ppony

      LOCAL lcString,m.loPDMs,m.loPDM,luCatch,lcDIAF,lcDIAXF,lcFile_dex,llEx,loPIPar,;
            lcPath,lcPathX,llOne,lcFile_d,lihFile,lcCSS,lcJS,lcDIAFCSS,m.lcDIAFJS

      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\Queries\" && +m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\Queries\" && +m.This.FileName+"\"
      llOne=m.loPDM.One
      This.HTMLOMMain=IIF(llOne,lcPathX+lcHTML,"") && ???
      lcFile_d=lcHTML

      STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,This.hFile
      IF lihFile>0
         llGEN_Tables=.T.

         m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)
         m.loPDM.GetPI_ENV("DIAF",lcPath,@m.lcDIAFCSS,@m.lcDIAFJS)

         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(PDM_00782),"%name%",This.FileName))+;
                  m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+m.lcDIAFCSS+lcCSS+;
                  m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+m.lcDIAFJS+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
         =FWRITE(m.lihFile,m.lcString)

         =m.loPDMs.WriteDMSG(STRTRAN(m.loPDMs.GetString(_PDM_valQueryIP),"%name%",m.This.FileName))

         luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         lcString=FILETOSTR(lcQRPPath)
         m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby

         * Create Detail Description of File, DIAF Plug-in
         loPIPar=m.loPDM.oPIPar
         loPIPar.Reset()
         loPIPar.File=m.This.File
         loPIPar.Type="DIAF"
         loPIPar.FileGroup=_PDM_FG_QPR
         loPIPar.RamPJX=This.RamPJX
         loPIPar.oPDMx=This

         STORE "" TO lcDIAF,lcDIAXF
         FOR lii=1 TO m.loPDM.iDIAF
             lcDIAF=m.lcDIAF+m.loPDM.aDIAF(lii,1).Run(@m.loPIPar,m.loPDM.aDIAF(lii,2))
             lcDIAXF=m.lcDIAXF+m.loPIPar.xhtmlFooter
         NEXT

         lcString=m.loPDM.aSpace(21)+'<h3><a name="'+lcQRPName+'">'+m.loPDMs.aStrings(PDM_01468)+' '+lcQRPName+'</a></h3>'+m.loPDM.aSpace(21)+;
                  [<div class="diaxp_mhead">]+m.loPDMs.aStrings(PDM_05046)+"</div>"+m.loPDM.aSpace(21)+;
                  [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                  m.lcDIAF+m.loPDM.aSpace(21)+;
                  m.loPDMs.GenerateBackReferenceHTML(m.This.File,"","","../../")+;
                  [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                  [<div class="diaxp_mbody">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                  m.loPDMs.aStrings(PDM_01470)+'<pre>'+m.loPDM.aSpace(21)+;
                  IIF(!EMPTY(lcString),lcString,'')+'</pre><br />'+m.loPDM.aSpace(21)+;
                  [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                  [<div class="diaxp_mfoot">]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)+;
                  m.lcDIAXF+m.loPDM.aSPace(21)+;
                  [</div>]+m.loPDM.aSpace(21)+m.loPDM.aSpace(21)

         =FWRITE(m.lihFile,lcString)
         =FWRITE(m.lihFile,IIF(loPIPar.lLNK,m.loPDM.StartS+m.loPDMs.AddRowScript("LNK_Init")+m.loPDM.StopS,"")+;
                 '</body>'+m.loPDM.aSpace(21)+'</html>')
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,m.This.nLI4,lcPathX+lcFile_d,0,_PDM_EF_None,This.FileName,_PDM_FG_Any+_PDM_FG_QPR)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_d))
      ENDIF
   ENDPROC


   PROCEDURE GenerateHTML_PRG(liType,lcFile, lcHTMLName,laObjX) && Vygeneruje strnku pro uloen procedury s vkonm zdrojovm kdem
      * liType      - Typ zdroje dat (0-zdrojov kd, 1-PRG soubor)
      * lcFile      - Nzev PRG souboru
      * lcHTMLName  - Zkladn nzev HTML souboru
      *@laObjX      - Matice pro seznam procedur
      *@lcStringFLD - 
      LOCAL lcCode,lcString,lcAPRC,lcAOBJ,lcPom,liy,liCnt,liz,;
            m.XX101,liPRC,liCLS,luCatch,lcAPROPS,;
            lcMethods,lcMethodsH,lii,lcLine,lcHTML,llLNKS,;
            lcProc,lcClass,lcClassX,lcPath,lcPathX,lcLOBJNAME,;
            m.loPDM,lihFile,lcFile_d,lcFile_h,lcFile_t,lcFile_f,lcFile,loAPRG,llPRC,lcRecno,m.loPDMs,;
            lcScript,llHead,lcScript,lcCSS,lcJS,lcDIAMPCSS,lcDIAMPJS,;
            lcDIACCSS,lcDIACJS,loFileLevel

      LOCAL ARRAY laObj(1)
      m.loPDM=EVAL(m.This.PDM) && Odkaz na PDM objekt
      m.loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt

      lcPath=m.loPDM.OutDir+m.This.OutDir+"\"+m.This.FileName+"\"
      lcPathX=m.This.OutDir+"\"+m.This.FileName+"\"

      m.loPDM.GetGLCSS_JS(lcPath,m.This,@m.lcCSS,@m.lcJS)

      m.loPDM.GetPI_ENV("DIAMP",lcPath,@m.lcDIAMPCSS,@m.lcDIAMPJS)
      m.loPDM.GetPI_ENV("DIAC",lcPath,@m.lcDIACCSS,@m.lcDIACJS)

      loAPRG=m.This.oAPRG
      loAPRG.Reset()
      loAPRG.Target="F32"
      loAPRG.iSource=_ASC_DBC

      lcFile_h=AppendShortFileFromFile(lcHTMLName,"_h")
      lcFile_d=AppendShortFileFromFile(lcHTMLName,"_d")
      lcFile_t=AppendShortFileFromFile(lcHTMLName,"_t")
      lcFile_f=AppendShortFileFromFile(lcHTMLName,"_f")

      STORE 0 TO liPRC,liCLS,lihFile
      STORE "" TO lcProc,lcClass,lcString,lcClassX,lcPom,lcScript

      loFileLevel=m.This.oFileLevel
      m.loFileLevel.I4=6

      IF liType=0 && Zdrojov kd
         lcCode=lcFile
         lcFile=""
      ELSE
         * PRG soubor
         STORE FULLPATH(lcFile,m.loPDM.PJXPath) TO lcFile && Zskej plnou cestu k programu
         luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         lcCode=FILETOSTR(lcFile)
         m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby
      ENDIF

      lcAPRC=loAPRG.APRC
      lcAOBJ=loAPRG.AOBJ
      lcAPROPS=loAPRG.APROPS

      IF m.This.HTMLPage=_GSC_Single AND !EMPTY(lcCode)
         STORE m.loPDMs.FCreate(lcPath+lcFile_d) TO lihFile,m.This.hFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05152,PDM_05155)),"%name%",m.This.DBCName))+;
                     m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+;
                     m.lcDIAMPCSS+m.lcDIACCSS+m.lcCSS+;
                     m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+;
                     m.lcDIAMPJS+m.lcDIACJS+m.lcJS+;
                     m.loPDM.StartS+m.loPDMs.AddScript("ExpandSPHead")+m.loPDM.StopS+'</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
            =FWRITE(lihFile,lcString)
         ENDIF
      ENDIF

      IF !EMPTY(lcCode) AND lihFile>0
         loAPRG.HTMLName=lcFile_d && Zkladn nzev pro jednotliv HTML strnky
         loAPRG.preHTMLName=ExtractShortFileFromFile(lcHTMLName) && prefix nzvu pro jednotliv HTML strnky

         =loAPRG.Analyse(m.This,@m.lcCode) && prove analzu
         =loAPRG.RepairObjectHierarchy(m.This) && Oprav objektovou hierarchii

         SELE (lcAPRC)
         COUNT TO liPRC FOR BINTOC(XX101P)==BINTOC(-1) OR BINTOC(XX101P)==BINTOC(-2) AND !EMPTY(XXSC) && Spotej poet volnch procedur/funkc

         SELE (lcAOBJ)
         COUNT TO liCLS FOR BINTOC(XX101P)==BINTOC(0) && Spotej poet td

         ****************************************************
         * Nyn budu generovat obsah procedur a funkc   
         ****************************************************
         IF liPRC>0
            SELE (lcAPRC)

            lcMethods=''
            lcMethodsH ='<h5><a name="Procedures">'+m.loPDMs.aStrings(PDM_02662)+'</a></h5>'+m.loPDM.aSpace(21)+;
                        '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(3)+'<td>'+m.loPDMs.aStrings(PDM_04933)+'</td><td>'+m.loPDMs.aStrings(PDM_04928)+'</td><td>'+m.loPDMs.aStrings(PDM_04929)+'</td>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                        m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)

            loAPRG.HTMLName=lcFile_d && Zkladn nzev pro jednotliv HTML strnky
            lii=m.This.nLI4
            This.nLI4=9

            m.loFileLevel.I5=4
            m.loFileLevel.I6=0
            m.loFileLevel.nLevel=6

            =loAPRG.GenerateProcedures(m.This,@m.lcMethods,@m.lcMethodsH,@m.lcProc,liPRC=1,@laObj)
            This.nLI4=lii


            *=IIF(liType=0,ACOPY(laObj,laObjX),.T.)
            =ACOPY(laObj,laObjX)

            lcMethodsH=lcMethodsH+m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21)+'<br />'+m.loPDM.aSpace(21)


            ****************************************************
            * Generovn hlavnho programu
            ****************************************************
            DO CASE
               CASE liPRC=1
                    lcProc=m.loPDM.aSpace(2)+'<td>'+m.loPDMs.aStrings(PDM_02651)+'</td>'+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                           lcProc+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)
                       
               CASE liPRC>1
                    lcProc=m.loPDM.aSpace(2)+'<td><label class="FP_List" for="SEL_P">'+m.loPDMs.aStrings(PDM_02657)+'</label></td>'+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(3)+'<select class="FP_List" id="SEL_P">'+m.loPDM.aSpace(21)+;
                           lcProc+;
                           m.loPDM.aSpace(3)+'</select>'+m.loPDM.aSpace(21)+;
                           m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)
   
            ENDCASE

            =FWRITE(lihFile,lcString+lcMethodsH+lcMethods+m.loPDM.aSpace(21))
         ENDIF

         ****************************************************
         * Nyn budu natat seznam td
         ****************************************************
         IF liCLS>0
            ***************************************************************
            * Zpracovn objektov hierarchie
            ***************************************************************

            lcScript=""
            loAPRG.hFile=lihFile
*            loAPRG.HTMLName=lcFile_d && Zkladn nzev pro jednotliv HTML strnky
*            loAPRG.preHTMLName=ExtractShortFileFromFile(lcHTMLName) && prefix nzvu pro jednotliv HTML strnky
            lii=m.This.nLI4
            This.nLI4=8

            m.loFileLevel.I5=5
            m.loFileLevel.I6=liPRC+1
            m.loFileLevel.nLevel=6

            =loAPRG.GenerateObject(m.This,0,0,"","",@m.lcClassX,RECC(lcAOBJ)=1)
            lcHTML=loAPRG.GenerateClassTree(m.This,@m.llHead,@m.lcScript)
            This.nLI4=lii

            IF RECC(lcAOBJ)>0
               lcClass=m.loPDM.aSpace(2)+'<td><label class="OC_Tree" for="SEL_O">'+m.loPDMs.aStrings(PDM_02739)+'</label></td>'+m.loPDM.aSpace(21)
            ENDIF
            lcClass=lcClass+;
                    m.loPDM.aSpace(2)+'<td class="a_right a_middle">'+m.loPDM.aSpace(21)+;
                    IIF(RECC(lcAOBJ)>1,m.loPDM.aSpace(3)+'<select class="OC_Tree" id="SEL_O">'+m.loPDM.aSpace(21)+lcClassX+m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(3)+'</select>'+m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(3)+m.loPDM.StartS+;
                                       m.loPDM.aSpace(3)+'LoadForm("SEL_O")'+m.loPDM.aSpace(21)+;
                                       m.loPDM.aSpace(3)+m.loPDM.StopS,lcClassX)+m.loPDM.aSpace(21)+;
                    m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)

         ENDIF

         IF m.This.HTMLPage=_GSC_Single
            =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))
            =m.loPDMs.FClose(lihFile)
            m.loFileLevel.I5=3
            m.loFileLevel.nLevel=5
            m.loFileLevel.I6=0
            m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,lcPathX+lcFile_d,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05152,PDM_05155)),"%name%",m.This.DBCName),_PDM_FG_Any)
         ENDIF
      ELSE
         IF !EMPTY(lcCode)
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_d))
         ENDIF
      ENDIF
      
      STORE m.loPDMs.FCreate(lcPath+lcFile_h) TO lihFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05151,PDM_05154)),"%name%",m.This.DBCName))+;
                  m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+lcCSS+;
                  IIF(liPRC>0 OR RECC(lcAOBJ)>1,m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS),'')+lcJS+;
                  '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                  '<table class="file_head">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%"><h4>'+m.loPDMs.aStrings(PDM_01251)+'</h4></td>'+m.loPDM.aSpace(21)+;
                  IIF(liPRC=0,m.loPDM.aSpace(2)+'<td></td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td></td>',lcProc)+;
                  IIF(liPRC>1,m.loPDM.aSpace(2)+'<td class="a_right"><input type="image" class="imgGO" '+[src="../../imgs/go.gif" onmouseover="this.src='../../imgs/gol.gif'" onmouseout="this.src='../../imgs/go.gif'" onmousedown="this.src='../../imgs/gold.gif'" onmouseup="this.src='../../imgs/gol.gif'"]+[ onclick="go_proc('F32',']+lcFile_d+[','SEL_P')" alt="]+m.loPDMs.aStrings(PDM_02659)+[" /></td>],m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td></td>')+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%"></td>'+m.loPDM.aSpace(21)+;
                  IIF(EMPTY(lcClass),m.loPDM.aSpace(2)+'<td></td>'+m.loPDM.aSpace(21)+m.loPDM.aSpace(2)+'<td></td>',lcClass)+m.loPDM.aSpace(21)+;
                  IIF(RECC(lcAOBJ)>1,m.loPDM.aSpace(2)+'<td class="a_right"><input type="image" class="imgGO" '+[src="../../imgs/go.gif" onmouseover="this.src='../../imgs/gol.gif'" onmouseout="this.src='../../imgs/go.gif'" onmousedown="this.src='../../imgs/gold.gif'" onmouseup="this.src='../../imgs/gol.gif'"]+' onclick="'+IIF(m.This.HTMLPage=_GSC_Multi,[go_class_m('F32','SEL_O')],[go_class('F32',']+lcFile_d+[','SEL_O')])+[" alt="]+m.loPDMs.aStrings(PDM_02658)+[" /></td>],m.loPDM.aSpace(2)+'<td></td>')+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21)+;
                  IIF(liCls=0,'',;
                  m.loPDM.aSpace(1)+'<tr>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td width="50%"></td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td></td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td class="a_right">'+m.loPDM.aSpace(21)+;
                  IIF(liPRC<=1,'',;
                  m.loPDM.aSpace(3)+'<a href="'+lcFile_f+'" target="F32" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05063),"%name%",m.This.DBCName)+'">'+m.loPDMs.aStrings(PDM_05065)+'</a>'+m.loPDM.aSpace(21))+;
                  IIF(liCls=1,'',;
                  m.loPDM.aSpace(3)+'<a href="'+lcFile_t+'" target="F32" title="'+STRTRAN(m.loPDMs.aStrings(PDM_05181),"%name%",m.This.DBCName)+'">'+m.loPDMs.aStrings(PDM_02790)+'</a> '+m.loPDM.aSpace(21))+;
                  IIF(liCls=>1 AND m.loPDM.iGOBJ>0 AND m.loPDM.GCT.Generate=1,m.loPDM.aSpace(3)+'<a href="../../GCT.htm" target="F32" title="'+m.loPDMs.aStrings(PDM_05182)+'">'+m.loPDMs.aStrings(PDM_02791)+'</a> '+m.loPDM.aSpace(21),"")+;
                  m.loPDM.aSpace(2)+'</td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(2)+'<td></td>'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'</tr>'+m.loPDM.aSpace(21))+;
                  '</table>'+m.loPDM.aSpace(21)+'</body>'+m.loPDM.aSpace(21)+'</html>'

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)

         m.loFileLevel.I5=1
         m.loFileLevel.I6=0
         m.loFileLevel.nLevel=5

         m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,lcPathX+lcFile_h,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05151,PDM_05154)),"%name%",m.This.DBCName),_PDM_FG_None)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_h))
      ENDIF

* ========== I4   I5   I6
* frame   -  6
* header  -  6     1
* filedes -  6     2   -   
* detail  -  6     3   -   

* funclist-  6     4   
* tree    -  6     5
* classes -  6     5   x
* proced  -  6     4   x

      IF liCLS>1
         STORE m.loPDMs.FCreate(lcPath+lcFile_t) TO lihFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_02790))+;
                     m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+lcCSS+;
                     m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+lcJS+;
                     m.loPDM.StartS+;
                     m.loPDMs.AddScript("ResetE_Tab")+;
                     m.loPDM.StopS+;
                     '</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)+;
                     '<h5 style="'+loPDMs.s_pbf+'">'+m.loPDMs.aStrings(PDM_02790)+'</h5>'+m.loPDM.aSpace(21)+;
                     [<div id="DIVX_0" ondblclick="window.E_Tab='.';">]+m.loPDM.aSpace(21)+;
                     IIF(!llHead,'',;
                         m.loPDM.aSpace(1)+[<div class="TreeRowH" ondblclick="ExpandAllDIV('0',4);">]+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+[<img class="imgEC" src="../../imgs/]+m.This.aEC(_EC_Cls,2)+[" id="IMGX_0" alt="]+m.loPDMs.aStrings(PDM_02797)+[" />]+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(2)+'<span class="TreeRow">'+m.loPDMs.aStrings(PDM_02797)+'</span>'+m.loPDM.aSpace(21)+;
                         m.loPDM.aSpace(1)+'</div>'+m.loPDM.aSpace(21))+;
                     lcHTML+;
                     '</div>'+m.loPDM.aSpace(21)+;
                     IIF(!llHead,'',;
                         m.loPDM.StartS+;
                         STRTRAN(STRTRAN(STRTRAN(STRTRAN(m.loPDM.RME,"%ID%","DIVX_0"),"%XType%","Main"),"%Value%",IIF(m.This.aEC(_EC_Procedure,1),"true","false")),"%Dir%","../../imgs/")+;
                         lcScript+;
                         m.loPDM.StopS)+m.loPDM.aSpace(21)+;
                     '</body>'+m.loPDM.aSpace(21)+;
                     '</html>'+m.loPDM.aSpace(21)

            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)

            m.loFileLevel.I5=5
            m.loFileLevel.I6=0
            m.loFileLevel.nLevel=5

            m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,lcPathX+lcFile_t,0,_PDM_EF_None,m.loPDMs.aStrings(PDM_02790),_PDM_FG_Any)
         ELSE
           m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_t))
         ENDIF
      ELSE
         m.loFileLevel.I5=5
         m.loFileLevel.I6=0
         m.loFileLevel.nLevel=5
         =IIF(liCLS=0,.T.,m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,"",0,_PDM_EF_None,m.loPDMs.aStrings(PDM_02790),_PDM_FG_Any))
      ENDIF

      m.loFileLevel.I5=4
      m.loFileLevel.I6=0
      m.loFileLevel.nLevel=5
      IF liPRC>1
         STORE m.loPDMs.FCreate(lcPath+lcFile_f) TO lihFile
         IF lihFile>0
            lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05066,PDM_05067)),"%name%",m.This.DBCName))+;
                     m.loPDMs.GetStyles('../../')+m.loPDM.GetSCCSS(lcPath)+;
                     m.lcDIAMPCSS+m.lcDIACCSS+m.lcCSS+;
                     m.loPDMs.AddExternalScript('../../'+m.loPDMs.ExternJS)+;
                     m.lcDIAMPJS+m.lcDIACJS+m.lcJS+'</head>'+m.loPDM.aSpace(21)+'<body>'+m.loPDM.aSpace(21)
            =FWRITE(lihFile,lcString)

            =FWRITE(lihFile,lcMethodsH+lcMethods+m.loPDM.aSpace(21))
            =FWRITE(lihFile,'</body>'+m.loPDM.aSpace(21)+'</html>'+m.loPDM.aSpace(21))

            =m.loPDMs.FClose(lihFile)
            m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,lcPathX+lcFile_f,0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05066,PDM_05067)),"%name%",m.This.DBCName),_PDM_FG_Any)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcFile_f))
         ENDIF
      ELSE
         m.loPDM.AddFile(m.loFileLevel,.NULL.,.NULL.,.NULL.,"",0,_PDM_EF_None,STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05066,PDM_05067)),"%name%",m.This.DBCName),_PDM_FG_Any)
      ENDIF


      STORE m.loPDMs.FCreate(lcPath+lcHTMLName) TO lihFile,m.This.hFile
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05153,PDM_05156)),"%name%",m.This.DBCName))+m.loPDMs.GetStyles('../../')+lcCSS+lcJS+m.loPDM.aSpace(21)+;
                  '</head>'+m.loPDM.aSpace(21)
         lcString=lcString+;
                  '<frameset framespacing="0" frameborder="1" rows="'+IIF(RECC(lcAOBJ)>1,'100','80')+',*" cols="100%" title="'+STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05153,PDM_05156)),"%name%",m.This.DBCName)+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<frame name="F31" src="'+lcFile_h+'" title="'+STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05151,PDM_05154)),"%name%",m.This.DBCName)+'">'+m.loPDM.aSpace(21)+;
                  m.loPDM.aSpace(1)+'<frame name="F32" src="'+;
                          IIF(liPRC>1,lcFile_f+'" title="'+STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05066,PDM_05067)),"%name%",m.This.DBCName),;
                          IIF(liCLS>1 AND liPRC=0,lcFile_t+'" title="'+m.loPDMs.aStrings(PDM_02790),;
                          loAPRG.FirstHTML+'" title="'+loAPRG.FirstHTMLTitle))+'">'+m.loPDM.aSpace(21)+;
                  '</frameset>'+m.loPDM.aSpace(21)+;
                  '</html>'

*                          IIF(LEN(m.lcDIAF)>0,lcFile_dex+'" title="'+,;
*

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
         m.loPDM.AddFile(m.This.nLI1,m.This.nLI2,m.This.nLI3,6,lcPathX+lcHTMLName,0,_PDM_EF_Frame,STRTRAN(m.loPDMs.aStrings(IIF(liType=0,PDM_05153,PDM_05156)),"%name%",m.This.DBCName),_PDM_FG_Any)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcPath+lcHTMLName))
      ENDIF
   ENDPROC

   PROCEDURE QuickAnalyse_PRG(liType,lcFile, lcHTMLName) && Quick Analyse Stored procedure or Events file
      * liType     - Typ zdroje dat (0-zdrojov kd, 1-PRG soubor)
      * lcFile     - Nzev PRG souboru
      * lcHTMLName - Zkladn nzev HTML souboru

      LOCAL luSC,luCatch,loPDMs,loPDM,loAPRG,lcFile_d,lcCode, m.lcKey
      loPDMs=EVAL(m.This.PDMs) && Odkaz na PDMs objekt
      loPDM=EVAL(m.This.PDM) && Odkaz na PDMs objekt

      * Analyze PRG file
      IF liType=0 && Zdrojov kd
         lcCode=lcFile
         lcFile=""
      ELSE
         * PRG soubor
         STORE FULLPATH(lcFile,m.loPDM.PJXPath) TO lcFile && Zskej plnou cestu k programu
         luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         lcCode=FILETOSTR(lcFile)
         m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby
      ENDIF


      IF EMPTY(lcCode)
         RETURN _PDM_OK
      ENDIF
      lcFile_d=AppendShortFileFromFile(lcHTMLName,"_d")

      m.lcKey=m.loPDM.AddToStats(This, This.Stats_Key, IIF(m.liType=0, _PDM_FG_SP, _PDM_FG_EF), IIF(m.liType=0, "Stored Procedures", m.lcFile), "", 0)


      loAPRG=m.This.oAPRG
      loAPRG.Reset()
      loAPRG.iSource=_ASC_DBC
      loAPRG.HTMLName=lcFile_d && Zkladn nzev pro jednotliv HTML strnky
      loAPRG.preHTMLName=ExtractShortFileFromFile(lcHTMLName) && prefix nzvu pro jednotliv HTML strnky
      loAPRG.QuickAnalyse(This,@m.lcCode)
      loAPRG.GenerateAnchors(This, m.lcKey)
      RETURN _PDM_OK
   ENDPROC

   * Nastav zkladn nastaven
   PROCEDURE SetDefSets()
      STORE 1 TO This.Generate,This.OL_DBC,This.OL_Tables,;
                 This.OL_Queries,This.OL_Views,This.OL_Connections,;
                 This.OL_Procedures,This.OL_Classes,;
                 This.OL_Objects,This.OL_Methods,This.OL_Properties,;
                 This.GEN_SP,This.GEN_EF,This.GEN_Tables,;
                 This.GEN_Views,This.GEN_Connections,This.GEN_Queries,;
                 This.GEN_Fields,This.GEN_Indexes,This.GEN_Relations

      STORE 0 TO This.OL_Fields,This.OL_Indexes,This.OL_Relations
      STORE _SC_Collapse TO This.EC_Procedure,This.EC_Main,This.EC_Method,This.EC_Cls,This.EC_Tab,m.This.EC_Expr
      This.IncludeSC=_SC_Include
      This.IncludeDD=_DD_Include
      This.GLCSS=""
      This.GLJS=""
      This.FPL.SetDefSets()
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile)
      * lcFile - PDM File
      This.Generate=GetINIInt("DBC","Generate",This.Generate,@m.lcFile)
      This.OL_DBC=GetINIInt("DBC","OL_DBC",This.OL_DBC,@m.lcFile)
      This.OL_Tables=GetINIInt("DBC","OL_Tables",This.OL_Tables,@m.lcFile)
      This.OL_Queries=GetINIInt("DBC","OL_Queries",This.OL_Queries,@m.lcFile)
      This.OL_Views=GetINIInt("DBC","OL_Views",This.OL_Views,@m.lcFile)
      This.OL_Connections=GetINIInt("DBC","OL_Connections",This.OL_Connections,@m.lcFile)
      This.OL_Procedures=GetINIInt("DBC","OL_Procedures",This.OL_Procedures,@m.lcFile)
      This.OL_Classes=GetINIInt("DBC","OL_Classes",This.OL_Classes,@m.lcFile)
      This.OL_Objects=GetINIInt("DBC","OL_Objects",This.OL_Objects,@m.lcFile)
      This.OL_Methods=GetINIInt("DBC","OL_Methods",This.OL_Methods,@m.lcFile)
      This.OL_Properties=GetINIInt("DBC","OL_Properties",This.OL_Properties,@m.lcFile)
      This.OL_Fields=GetINIInt("DBC","OL_Fields",This.OL_Fields,@m.lcFile)
      This.OL_Indexes=GetINIInt("DBC","OL_Indexes",This.OL_Indexes,@m.lcFile)
      This.OL_Relations=GetINIInt("DBC","OL_Relations",This.OL_Relations,@m.lcFile)
      This.GEN_SP=GetINIInt("DBC","GEN_SP",This.GEN_SP,@m.lcFile)
      This.GEN_EF=GetINIInt("DBC","GEN_SP",This.GEN_EF,@m.lcFile)
      This.GEN_Tables=GetINIInt("DBC","GEN_Tables",This.GEN_Tables,@m.lcFile)
      This.GEN_Views=GetINIInt("DBC","GEN_Views",This.GEN_Views,@m.lcFile)
      This.GEN_Connections=GetINIInt("DBC","GEN_Connections",This.GEN_Connections,@m.lcFile)
      This.GEN_Queries=GetINIInt("DBC","GEN_Queries",This.GEN_Queries,@m.lcFile)
      This.GEN_Fields=GetINIInt("DBC","GEN_Fields",This.GEN_Fields,@m.lcFile)
      This.GEN_Indexes=GetINIInt("DBC","GEN_Indexes",This.GEN_Indexes,@m.lcFile)
      This.GEN_Relations=GetINIInt("DBC","GEN_Relations",This.GEN_Relations,@m.lcFile)
      This.EC_Procedure=GetINIInt("DBC","EC_Procedure",This.EC_Procedure,@m.lcFile)
      This.EC_Main=GetINIInt("DBC","EC_Main",This.EC_Main,@m.lcFile)
      This.EC_Method=GetINIInt("DBC","EC_Method",This.EC_Method,@m.lcFile)
      This.EC_Cls=GetINIInt("DBC","EC_Cls",This.EC_Cls,@m.lcFile)
      This.EC_Tab=GetINIInt("DBC","EC_Tab",This.EC_Tab,@m.lcFile)
      m.This.EC_Expr=GetINIInt("DBC","EC_Expr",m.This.EC_Expr,@m.lcFile)
      This.IncludeSC=GetINIInt("DBC","IncludeSC",This.IncludeSC,@m.lcFile)
      This.IncludeDD=GetINIInt("DBC","IncludeDD",This.IncludeDD,@m.lcFile)
      This.GLCSS=GetINIString("DBC","GLCSS",This.GLCSS,32000,@m.lcFile)
      This.GLJS=GetINIString("DBC","GLJS",This.GLJS,32000,@m.lcFile)

      This.QFL_FreeTables=GetINIInt("DBC","QFL_FreeTables",This.QFL_FreeTables,@m.lcFile)
      This.QFL_Queries=GetINIInt("DBC","QFL_Queries",This.QFL_Queries,@m.lcFile)
      This.QFL_DBC=GetINIInt("DBC","QFL_DBC",This.QFL_DBC,@m.lcFile)
      This.QFL_Views=GetINIInt("DBC","QFL_Views",This.QFL_Views,@m.lcFile)
      This.QFL_Tables=GetINIInt("DBC","QFL_Tables",This.QFL_Tables,@m.lcFile)
      This.QFL_Connections=GetINIInt("DBC","QFL_Connections",This.QFL_Connections,@m.lcFile)
      This.QFL_Procedures=GetINIInt("DBC","QFL_Procedures",This.QFL_Procedures,@m.lcFile)
      This.QFL_EventFile=GetINIInt("DBC","QFL_EventFile",This.QFL_EventFile,@m.lcFile)
      
      This.FPL.Open(lcFile,"DBC")
      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile)
      * lcFile - PDM File
      LOCAL lcCSS,lcJS,loPDM
      =WriteINIString("DBC","Generate",STR(This.Generate,1),@m.lcFile)
      =WriteINIString("DBC","OL_DBC",STR(This.OL_DBC,1),@m.lcFile)
      =WriteINIString("DBC","OL_Tables",STR(This.OL_Tables,1),@m.lcFile)
      =WriteINIString("DBC","OL_Queries",STR(This.OL_Queries,1),@m.lcFile)
      =WriteINIString("DBC","OL_Views",STR(This.OL_Views,1),@m.lcFile)
      =WriteINIString("DBC","OL_Connections",STR(This.OL_Connections,1),@m.lcFile)
      =WriteINIString("DBC","OL_Procedures",STR(This.OL_Procedures,1),@m.lcFile)
      =WriteINIString("DBC","OL_Classes",STR(This.OL_Classes,1),@m.lcFile)
      =WriteINIString("DBC","OL_Objects",STR(This.OL_Objects,1),@m.lcFile)
      =WriteINIString("DBC","OL_Methods",STR(This.OL_Methods,1),@m.lcFile)
      =WriteINIString("DBC","OL_Properties",STR(This.OL_Properties,1),@m.lcFile)
      =WriteINIString("DBC","OL_Fields",STR(This.OL_Fields,1),@m.lcFile)
      =WriteINIString("DBC","OL_Indexes",STR(This.OL_Indexes,1),@m.lcFile)
      =WriteINIString("DBC","OL_Relations",STR(This.OL_Relations,1),@m.lcFile)
      =WriteINIString("DBC","GEN_SP",STR(This.GEN_SP,1),@m.lcFile)
      =WriteINIString("DBC","GEN_EF",STR(This.GEN_EF,1),@m.lcFile)
      =WriteINIString("DBC","GEN_Tables",STR(This.GEN_Tables,1),@m.lcFile)
      =WriteINIString("DBC","GEN_Views",STR(This.GEN_Views,1),@m.lcFile)
      =WriteINIString("DBC","GEN_Connections",STR(This.GEN_Connections,1),@m.lcFile)
      =WriteINIString("DBC","GEN_Queries",STR(This.GEN_Queries,1),@m.lcFile)
      =WriteINIString("DBC","GEN_Fields",STR(This.GEN_Fields,1),@m.lcFile)
      =WriteINIString("DBC","GEN_Indexes",STR(This.GEN_Indexes,1),@m.lcFile)
      =WriteINIString("DBC","GEN_Relations",STR(This.GEN_Relations,1),@m.lcFile)
      =WriteINIString("DBC","EC_Procedure",STR(This.EC_Procedure,1),@m.lcFile)
      =WriteINIString("DBC","EC_Main",STR(This.EC_Main,1),@m.lcFile)
      =WriteINIString("DBC","EC_Method",STR(This.EC_Method,1),@m.lcFile)
      =WriteINIString("DBC","EC_Cls",STR(This.EC_Cls,1),@m.lcFile)
      =WriteINIString("DBC","EC_Tab",STR(This.EC_Tab,1),@m.lcFile)
      =WriteINIString("DBC","EC_Expr",STR(m.This.EC_Expr,1),@m.lcFile)
      =WriteINIString("DBC","IncludeSC",STR(This.IncludeSC,1),@m.lcFile)
      =WriteINIString("DBC","IncludeDD",STR(This.IncludeDD,1),@m.lcFile)
      =WriteINIString("DBC","QFL_FreeTables",STR(This.QFL_FreeTables,1),@m.lcFile)
      =WriteINIString("DBC","QFL_Queries",STR(This.QFL_Queries,1),@m.lcFile)
      =WriteINIString("DBC","QFL_DBC",STR(This.QFL_DBC,1),@m.lcFile)
      =WriteINIString("DBC","QFL_Views",STR(This.QFL_Views,1),@m.lcFile)
      =WriteINIString("DBC","QFL_Tables",STR(This.QFL_Tables,1),@m.lcFile)
      =WriteINIString("DBC","QFL_Connections",STR(This.QFL_Connections,1),@m.lcFile)
      =WriteINIString("DBC","QFL_Procedures",STR(This.QFL_Procedures,1),@m.lcFile)
      =WriteINIString("DBC","QFL_EventFile",STR(This.QFL_EventFile,1),@m.lcFile)

      loPDM=EVALUATE(This.PDM)
      lcCSS=This.GLCSS
      lcJS=This.GLJS
      =loPDM.FormalyzeGLCSS_JS(ExtractPathFromFile(m.lcFile),@lcCSS,@lcJS)
      =WriteINIString("DBC","GLCSS",m.lcCSS,@m.lcFile)
      =WriteINIString("DBC","GLJS",m.lcJS,@m.lcFile)

      This.FPL.Save(lcFile,"DBC")
      RETURN _PDM_OK
   ENDPROC

ENDDEFINE
