**************************************************************************
** Program name: PDMClass.PRG
** Version: 1.3.4
** Create date: 2015-04-16
** Description: Definition classes for process VFP project
** Author: Martina Jindrov
** E-mail: jindra@egservis.cz
** JID: gorila@dione.zcu.cz
** CP: 1250

#INCLUDE "Main.h"
#INCLUDE "RegAPI.h"
#INCLUDE "winnt.h"
#INCLUDE "procthrd.h"
#INCLUDE "dumpfll.h"


** wininet.dll
*!*	lcurl="http://gorila.netlab.cz/main a.html"+CHR(0)
*!*	lcbuff=SPACE(LEN(lcurl)*2)
*!*	lilen=len(lcbuff)
*!*	?InternetCanonicalizeUrl(@lcUrl, @lcBuff, @liLen,0 )
*!*	?at(chr(0),lcbuff)



*******************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In

****************************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings


******************************************
** Definition class private data session
DEFINE CLASS _pdm_Session AS Session
   Name="_pdm_Session"
   Generate = 1 && Flag generation
   OutDir="" && Output subdirectory

   PDMs=.NULL. && Name PUBLIC reference PDMs object
   PDM=.NULL. && Name PUBLIC reference PDM object
   RamPJX=.NULL. && Ram object from PJX file

   nLI1=0 && 
   nLI2=0 && 
   nLI3=0 && 
   nLI4=0 && 

   File="" && Name file process
   FileName="" && Nzev souboru

   OL_Files=1 && If file list sort by name
   HTMLMain="" && Name of main HTML page
   HTMLOMMain="" && Name of main HTML page if generate One or more files
   HTMLDetail="" && Name of detail HTML page

   Pict=""
   Disp=""
   lEC_Tab=.T.

   Type=0 && type of file group
   Stats_Key="" && base file key for statistics
   Stats_FileID=0 && base file id for statistics


   DIME aGLCSS(1), aGLJS(1)
   GLCSS=""  && Global and local CSS file
   GLJS=""   && Global and local JS file
*   gGLCSS=""  && Global and local CSS file (repository)
*   gGLJS=""   && Global and local JS file (repository)

   _GLCSS=""  && Internal Global and local CSS file
   _GLJS=""   && Internal Global and local JS file
   _gGLCSS=""  && Internal Global and local CSS file (repository)
   _gGLJS=""   && Internal Global and local JS file (repository)

   DIME aEC(6,3) && Array of flags EC??
   *[x,1] - Flag (.T./.F.)
   *[x,2] - Picture
   *[x,3] - Display


   Platform="WINDOWS"
   UNIX=.F.
   DOS=.F.
   WIN=.F.
   MAC=.F.
   lCR=.F. && Pznak dk a sloupc
   

   oFileLevel=.NULL.

   PROCEDURE Init(pcCollate)
      * pcCollate - COLLATE for...

      * Set basic SETs for private session
      SET EXACT OFF
      SET TALK OFF
      SET DELE ON
      SET SAFETY OFF
*      SET ESCAPE OFF
      SET COLLATE TO (pcCollate)
      SET DECI TO 4
      SET POINT TO "."
      SET BLOCKSIZE TO 1 && For memo pole
      STORE "" TO This.aEC
      STORE .F. TO This.aEC(1,1),This.aEC(2,1),This.aEC(3,1),This.aEC(4,1),This.aEC(5,1),This.aEC(6,1)
   ENDPROC

   PROCEDURE GenerateHTML() && Generate HTML files
   ENDPROC

   PROCEDURE SetDefSets() && Set default values settings
   ENDPROC

   PROCEDURE Open(lcFile) && Read values settings
      * lcFile - PDM File
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile) && Save settings
      * lcFile - PDM File
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE ReadLocalizedString() && Copy special localized strings from array aStrings[]
   ENDPROC


   PROCEDURE InitResources()
      LOCAL lcOut,lcPath,lii,liCount
*      STORE "" TO This.gGLCSS,This.gGLJS
      lcPath=ExtractPathFromFile(IIF(UPPER(m.This.Class)=="_PDM", m.This.PDM_File, EVAL(m.This.PDM+".PDM_File")))
      

      IF !EMPTY(m.This.GLCSS)
         liCount=ALINES(m.This.aGLCSS,STRTRAN(STRTRAN(m.This.GLCSS,",",CRLF),";",CRLF))
         FOR lii=1 TO m.liCount
	         =m.This.AddFileToRepository(IIF(AT("\\",m.This.aGLCSS(m.lii))>0 OR AT(":",m.This.aGLCSS(m.lii))>0,"",m.lcPath)+m.This.aGLCSS(m.lii),"","",@m.lcOut)
	         m.This.aGLCSS(m.lii)=m.lcOut
         NEXT
      ENDIF

      IF !EMPTY(m.This.GLJS)
         liCount=ALINES(m.This.aGLJS,STRTRAN(STRTRAN(m.This.GLJS,",",CRLF),";",CRLF))
         FOR lii=1 TO m.liCount
	         =m.This.AddFileToRepository(IIF(AT("\\",m.This.aGLJS(m.lii))>0 OR AT(":",m.This.aGLJS(m.lii))>0,"",m.lcPath)+m.This.aGLJS(m.lii),"","",@m.lcOut)
	         m.This.aGLJS(m.lii)=m.lcOut
         NEXT
      ENDIF


*!*	      IF !EMPTY(m.This.GLCSS)
*!*	         =m.This.AddFileToRepository(IIF(AT("\\",m.This.GLCSS)>0 OR AT(":",m.This.GLCSS)>0,"",lcPath)+m.This.GLCSS,"","",@m.lcOut)
*!*	         m.This.gGLCSS=lcOut
*!*	      ENDIF
*!*	      IF !EMPTY(m.This.GLJS)
*!*	         =m.This.AddFileToRepository(IIF(AT("\\",m.This.GLJS)>0 OR AT(":",m.This.GLJS)>0,"",lcPath)+m.This.GLJS,"","",@m.lcOut)
*!*	         m.This.gGLJS=lcOut
*!*	      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE GetBasePathForFile(lcGroup,lcFile)
      * lcGroup - group file
      * lcFile  - base file name
      RETURN ""
   ENDPROC

ENDDEFINE


******************************************
** Definition class shared data session
DEFINE CLASS _pdm_Custom AS Custom
   Name="_pdm_Custom"
   Generate = 1 && Generation flags
   OutDir="" && Output subdirectory

   PDMs=.NULL. && Name PUBLIC reference PDMs object
   PDM=.NULL. && Name PUBLIC reference PDM object
   RamPJX=.NULL. && Ram object from PJX file

   Type=0 && type of file group
   Stats_Key="" && base file key for statistics
   Stats_FileID=0 && base file id for statistics

   nLI1=0 && 
   nLI2=0 && 
   nLI3=0 && 
   nLI4=0 && 

   File="" && Name file process
   FileName="" && Nzev souboru

   OL_Files=1 && If file list sort by name
   HTMLMain="" && Name of main HTML page
   HTMLOMMain="" && Name of main HTML page if generate One or more files
   HTMLDetail="" && Name of detail HTML page
   HTMLList="" && Name of Quick file list 


   DIME aGLCSS(1), aGLJS(1)
   GLCSS=""  && Global and local CSS file
   GLJS=""   && Global and local JS file
*   gGLCSS=""  && Global and local CSS file (repository)
*   gGLJS=""   && Global and local JS file (repository)

   _GLCSS=""  && Internal Global and local CSS file
   _GLJS=""   && Internal Global and local JS file
   _gGLCSS=""  && Internal Global and local CSS file (repository)
   _gGLJS=""   && Internal Global and local JS file (repository)

   DIME aEC(6,3) && Array of flags EC??
   *[x,1] - Flag (.T./.F.)
   *[x,2] - Picture
   *[x,3] - Display

   Pict=""
   Disp=""
   lEC_Tab=.T.

   Platform="WINDOWS"
   UNIX=.F.
   DOS=.F.
   WIN=.F.
   MAC=.F.
   lCR=.F. && Pznak dk a sloupc

   oFileLevel=.NULL.

   PROCEDURE Init()
      STORE "" TO This.aEC
      STORE .F. TO This.aEC(1,1),This.aEC(2,1),This.aEC(3,1),This.aEC(4,1),This.aEC(5,1),This.aEC(6,1)
   ENDPROC

   PROCEDURE GenerateHTML() && Generate HTML files
   ENDPROC

   PROCEDURE SetDefSets() && Set default value settings
   ENDPROC

   PROCEDURE Open(lcFile) && Read values settings
      * lcFile - PDM File
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile) && Save values settings
      * lcFile - PDM File
      RETURN _PDM_OK
   ENDPROC



   PROCEDURE ReadLocalizedString() && Copy special localized strings from array aStrings[]
   ENDPROC

   PROCEDURE InitResources()
      LOCAL lcOut,lcPath,liCount,lii
*      STORE "" TO This.gGLCSS,This.gGLJS
      lcPath=ExtractPathFromFile(IIF(UPPER(m.This.Class)=="_PDM", m.This.PDM_File, EVAL(m.This.PDM+".PDM_File")))

      IF !EMPTY(m.This.GLCSS)
         liCount=ALINES(m.loSetting.aGLCSS,STRTRAN(STRTRAN(m.This.GLCSS,",",CRLF),";",CRLF))
         FOR lii=1 TO m.liCount
	         =m.This.AddFileToRepository(IIF(AT("\\",m.This.aGLCSS(m.lii))>0 OR AT(":",m.This.aGLCSS(m.lii))>0,"",m.lcPath)+m.This.aGLCSS(m.lii),"","",@m.lcOut)
	         m.This.aGLCSS(m.lii)=m.lcOut
         NEXT
      ENDIF

      IF !EMPTY(m.This.GLJS)
         liCount=ALINES(m.loSetting.aGLJS,STRTRAN(STRTRAN(m.This.GLJS,",",CRLF),";",CRLF))
         FOR lii=1 TO m.liCount
	         =m.This.AddFileToRepository(IIF(AT("\\",m.This.aGLJS(m.lii))>0 OR AT(":",m.This.aGLJS(m.lii))>0,"",m.lcPath)+m.This.aGLJS(m.lii),"","",@m.lcOut)
	         m.This.aGLJS(m.lii)=m.lcOut
         NEXT
      ENDIF
      
*!*	      IF !EMPTY(m.This.GLCSS)
*!*	         =m.This.AddFileToRepository(IIF(AT("\\",m.This.GLCSS)>0 OR AT(":",m.This.GLCSS)>0,"",lcPath)+m.This.GLCSS,"","",@m.lcOut)
*!*	         m.This.gGLCSS=lcOut
*!*	      ENDIF
*!*	      IF !EMPTY(m.This.GLJS)
*!*	         =m.This.AddFileToRepository(IIF(AT("\\",m.This.GLJS)>0 OR AT(":",m.This.GLJS)>0,"",lcPath)+m.This.GLJS,"","",@m.lcOut)
*!*	         This.gGLJS=lcOut
*!*	      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE GetBasePathForFile(lcGroup,lcFile)
      * lcGroup - group file
      * lcFile  - base file name
      RETURN ""
   ENDPROC

ENDDEFINE

******************************************
** Definition class _PDMs
DEFINE CLASS _pdms AS _pdm_Session
   Name="_pdms"

   Version="1.3.4" && Version PDM
   FileVersion="0.0.2" && Base file version

   InitErr=0 && Chyba pi zavdn objektu
   Index=0 && (Do not remove)

   lCoverageLog=.T.
   cCoverageLog="" && "d:\temp\pdm_1.2.0_002.log"

   Schemes="" && Alias Schemes table
   LangC="" && Alias LangC table
   CLang="" && Content language for HTML
   HTMLCLang="" && Content language for HTML from HTML table
   Collate="" && Collate for HTML
   GUICLang="" && Content language for GUI

   Catch=.F. && Pznak, e se m chyba zachytit
   ErrCount=0 &&  Hard error count
   ErrStopCount=-1 && Max hard error count for cancel processing

   WarnCount=0 && Warning count
   DbgCount=0 && Debug count

   ErrToDebug=0 && Pesmrovn chyb do debugu
   LogToDebug=0 && Pesmrovn logu do debugu

   nErr=0 && Error number
   cErrMSG="" && Message error
   
   LOGErr="" && Umstn a nzev LOG souboru chyb
   LOGFile="" && Umstn a nzev LOGovacho souboru

   hLOGErr=0 && Handle otevenho LOG souboru chyb
   hLOGFile=0 && Handle otevenho LOGovacho souboru

   MainPath =""  && Main folder PDM
   AppData="" && Application Data folder

   ExternJS="js/pdm.js" && Odkaz na extern soubor s JavaScripty
   SCCSS="css/SC.css" && Odkaz na definici styl pro Syntax Coloring
   MenuCSS="css/menu.css" && Odkaz na definici styl menu

   iWWD="" && Odkaz na rozhran pro zobrazen hlky
   iDWWD="" && Odkaz na rozhran pro zobrazen detailn hlky
   iWE="" && Odkaz na rozhran pro zobrazen potu chyb
   iWW="" && Odkaz na rozhran pro zobrazen potu hlen
   GUI=.F. && Active GUI flag
   oGUI=.NULL. && Active GUI interface
   GUI_path="" && Cesta ke GUI (v INI me bt relativn, zde je vak absolutn)
   GUI_vcx="" && Hlavn VCX knihovna
 


   SC_Code="" && Begin tag for source code
   SC_Code_Close="" && End tag for source code
   SC_Expr="" && Begin tag for expression
   SC_Expr_Close="" && End tag for expression
   SC_Expr_1="" && Begin tag for expression
   SC_Expr_1_Close="" && End tag for expression
   SC_Expr_2="" && Begin tag for expression
   SC_Expr_2_Close="" && End tag for expression

   PHTML=.NULL. && Object reference for print HTML files

   
   PpIX=0 && Pixel per Inch (X coordinate)
   PpIY=0 && Pixel per Inch (Y coordinate)


   AFiles="" && Cursor of files
   Anchors="" && Cursor alias for File and clases anchors
   CAnchors="" && Cursor alias for cross anchors
   AnchorsCSS="" && Special cursor alias for CSS'clases anchors
   AClasses="" && Special cursor alias for classes
   AClassesPEM="" && Special cursor alias for classes PEM



   RCTab="" && Alias oteven tabulky lokalizovanch string
   RCTabHTML="" && Alias oteven tabulky lokalizovanch string pro HTML
   RCDir="" && Adres s lokalizovanmi zdroji

   CP=0 && Kdov strnka lokalizace
   
   Canceled=.F. && Flag of canceled process
   CancelRet=0 &&
   
   OnlyPDM=.F. && Flag of only PDM & Runtime
   
   PROTECTED ARRAY aFile(1), aReg(1) && List opened files cross FCREATE()
   DIME aPDMs(1,2), aStrings(1)

   PROTECTED iFile,iPDMs,iReg && Item count in array
   iFile=0
   iPDMs=0
   iReg=0

   PlugIns=.NULL.


   DIME aComments[2]
   aComments[1]="*"
   aComments[2]="note"
   
   VFPVers="6"

   s_pbf="" && "page-break-before:auto;"


   DIME aSG(8,2)
   aSG(_PDMSG_DBC,1)=1
   aSG(_PDMSG_DBC,2)="d,D,Q,"
   aSG(_PDMSG_SCX,1)=2
   aSG(_PDMSG_SCX,2)="K,"
   aSG(_PDMSG_FRX,1)=3
   aSG(_PDMSG_FRX,2)="R,"
   aSG(_PDMSG_PRG,1)=4
   aSG(_PDMSG_PRG,2)="P,Z,L,"
   aSG(_PDMSG_VCX,1)=5
   aSG(_PDMSG_VCX,2)="V,"
   aSG(_PDMSG_LBX,1)=6
   aSG(_PDMSG_LBX,2)="B,"
   aSG(_PDMSG_XXX,1)=7
   aSG(_PDMSG_XXX,2)="T,x,"
   aSG(_PDMSG_MNX,1)=8
   aSG(_PDMSG_MNX,2)="M,"

   PROCEDURE Destroy() && Uvolnn knihoven
      * Pokud je otevena tabulka lokalizovanch string
      IF USED(m.This.RCTab)
         USE IN (m.This.RCTab) && Pak ji uzavi
      ENDIF

      * If open table with localized strings for HTML
      IF USED(m.This.RCTabHTML)
         USE IN (m.This.RCTabHTML) && Close it
      ENDIF

      IF USED(m.This.LangC)
         USE IN (m.This.LangC)
      ENDIF

      IF "DFO.FXP"$SET("PROCED")
         RELEASE PROCED dfo
      ENDIF
      IF "PDMKERNEL.FXP"$SET("PROCED")
         RELEASE PROCED pdmkernel
      ENDIF
      IF "STRING.FXP"$SET("PROCED")
         RELEASE PROCED string
      ENDIF
      IF "FILE.FXP"$SET("PROCED")
         RELEASE PROCED file
      ENDIF
      IF "PRGAN.FXP"$SET("PROCED")
         RELEASE PROCED prgAn
      ENDIF
      IF "REGAPI.FXP"$SET("PROCED")
         RELEASE PROCED regapi
      ENDIF

      IF "STRING.FLL"$SET("LIBRARY")
         RELEASE LIBRARY (m.This.MainPath+"string.fll")
      ENDIF
      IF "PDM.FLL"$SET("LIBRARY")
         RELEASE LIBRARY (m.This.MainPath+"pdm.fll")
      ENDIF
   ENDPROC


   PROCEDURE Init(lcPName,lcRCDir,llSilent) && Inicializace tdy
      * lcPName   - Nzev PUBLIC reference tohoto objektu
      * lcRCDir   - Adres, kde jsou umstny lokalizovan zdroje
      * llSilent  - Silent mode
      =DODEFAULT("MACHINE") && Voln pvodn metody
      
      LOCAL lcCollate,lcAlias,luCatch,lcPom,lii,lcMainPath,lcAPPData,liRCDir
      LOCAL ARRAY laLang(2)

      This.SetCatch(.NULL.)

      * Zave potebn PRG a VCX 
      SET PROCED TO dfo,pdm,pdmkernel,string,file,prgAn,regapi,procthrd ADDITIVE

      * Inicializace API funkc
      =File_WINAPIInit()
      =PDMKernel_WINAPIInit()
      =RegAPIInit()
      =ProcthrdAPIInit()

      This.VFPVers=TABO_GetVersion()

      * Zjisti cestu, kde se nachz APP
      lcMainPath=SYS(16,PROGRAM(-1)-1)
      lcMainPath=IIF(RAT("\",lcMainPath)>0,LEFT(lcMainPath,RAT("\",lcMainPath)),lcMainPath)
      STORE IIF(!DIRECTORY(lcMainPath+"\res"),lcMainPath+"..\",lcMainPath) TO lcMainPath,This.MainPath

      lcAPPData=SPACE(254)+CHR(0)
      =SHGetSpecialFolderPath(0,@lcAPPData,0x1a,0)
      STORE AddBackSlashInPath(NullTermined(m.lcAPPData))+"pdm\" TO lcAPPData,This.APPData

      * Nyn zave zbyl FLL knihovny 

      * Test na adres zdroj
      * pozdji pesun do INI souboru
      IF !DIRECTORY(lcMainPath+"\res")
         =IIF(llSilent,.T.,MESSAGEBOX(_PDMc_msgRES_NF,0+16+0,_PDMc_msgMain))
         This.InitErr=_PDMc_RES_NF
         RETURN
      ENDIF

      IF !FILE(lcMainPath+"string.fll")
         =IIF(llSilent,.T.,MESSAGEBOX(STRTRAN(_PDMc_msgFLL_NF,"%File%",lcMainPath+"string.fll"),0+16+0,_PDMc_msgMain))
         This.InitErr=_PDMc_FLL_NF_S
         RETURN
      ENDIF

      IF !FILE(lcMainPath+"pdm.fll")
         =IIF(llSilent,.T.,MESSAGEBOX(STRTRAN(_PDMc_msgFLL_NF,"%File%",lcMainPath+"pdm.fll"),0+16+0,_PDMc_msgMain))
         This.InitErr=_PDMc_FLL_NF_P
         RETURN
      ENDIF

      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      SET LIBRARY TO (lcMainPath+"pdm.fll") ADDITIVE
      m.This.SetCatch(luCatch) && Zru zachycen chyby
      IF m.This.nErr#0
         =IIF(llSilent,.T.,MESSAGEBOX(STRTRAN(_PDMc_msgFLL_NO,"%File%",lcMainPath+"pdm.fll"),0+16+0,_PDMc_msgMain))
         This.InitErr=_PDMc_FLL_NO_P
         RETURN
      ENDIF

      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      SET LIBRARY TO (lcMainPath+"string.fll") ADDITIVE
      m.This.SetCatch(luCatch) && Zru zachycen chyby
      IF m.This.nErr#0
         =IIF(llSilent,.T.,MESSAGEBOX(STRTRAN(_PDMc_msgFLL_NO,"%File%",lcMainPath+"string.fll"),0+16+0,_PDMc_msgMain))
         This.InitErr=_PDMc_FLL_NO_S
         RETURN
      ENDIF

      This.SynchronizeINI() && Synchronizuj obsah vzorovho INI souboru s uivatelskm INI souborem

      This.ErrToDebug=GetINIInt("SYSTEM","ErrToDebug",This.ErrToDebug,lcAPPData+"pdm.ini")
      This.LogToDebug=GetINIInt("SYSTEM","LogToDebug",This.LogToDebug,lcAPPData+"pdm.ini")
      This.cCoverageLog=GetINIString("SYSTEM","Coverage",This.cCoverageLog,254,lcAPPData+"pdm.ini")

      ************
      ** Naten cesty ke GUI a hlavn VCX knihovny
      * Nati z INI souboru daje
      lcPom=GetINIString("SYSTEM","GUI","",254,lcAPPData+"pdm.ini")
      IF !EMPTY(lcPom)
         lii=AT(",",lcPom)
         IF lii>0
            m.This.GUI_VCX=RTRIM(SUBST(lcPom,lii+1))
            lcPom=LEFT(lcPom,lii-1)
            This.GUI_Path=IIF(AT("\\",lcPom)>0 OR AT(":",lcPom)>0,"",lcMainPath)+AddBackSlashInPath(lcPom) && Zskej plnou cestu (pokud je relativn)
         ENDIF
      ENDIF

      * Read deault language from INI file
      IF EMPTY(lcRCDir)
         lcRCDir=GetINIString("SYSTEM","DefLang","lang\en",254,lcAPPData+"pdm.ini")
      ENDIF


      ************
      ** Zaveden lokalizovanch zdroj pro PDM
      * Nyn se pokus zavst lokalizovan zdroje
      laLang(1)="lang\en\"
      laLang(2)=lcRCDir

      FOR lii=ALEN(laLang) TO 1 STEP -1
          liRCDir=_PDMc_OK

          lcRCDir=laLang(m.lii)
          lcRCDir=IIF(AT("\\",m.lcRCDir)>0 OR AT(":",m.lcRCDir)>0,"",m.lcMainPath)+AddBackSlashInPath(m.lcRCDir) && Zskej plnou cestu (pokud je relativn)
          IF !DIRECTORY(m.lcRCDir)
             liRCDir=_PDMc_LR_DnE
             LOOP
          ENDIF

          * Kontrola, zda existuje tabulka lokalizovanch string
          IF !FILE(m.lcRCDir+"pdm.dbf")
             liRCDir=_PDMc_LR_TnE
             LOOP
          ENDIF

          * Nyn se pokus otevt tabulku
          STORE SYS(2015) TO lcAlias, m.This.RCTab
          IF m.This.OpenTable(-1,lcRCDir+"pdm.dbf",m.lcAlias,"SHARE NOUPDATE ORDER XXI000")#0 && Oteve tabulku
             liRCDir=_PDMc_LR_TnO
             LOOP
          ENDIF
          EXIT
      NEXT

      IF m.lii<ALEN(laLang)
         =IIF(llSilent,.T.,MESSAGEBOX(STRTRAN(_PDMc_msgLR_TnOD,"%File%",laLang(ALEN(laLang))+"pdm.dbf"),0+16+0,_PDMc_msgMain))
      ENDIF

      IF liRCDir#_PDMc_OK
         This.InitErr=m.liRCDir
         DO CASE
            CASE m.liRCDir=_PDMc_LR_DnE
                 =IIF(llSilent,.T.,MESSAGEBOX(STRTRAN(_PDMc_msgLR_DnE,"%Dir%",m.lcRCDir),0+16+0,_PDMc_msgMain))

            CASE m.liRCDir=_PDMc_LR_TnE
                 =IIF(llSilent,.T.,MESSAGEBOX(STRTRAN(_PDMc_msgLR_TnE,"%File%",m.lcRCDir+"pdm.dbf"),0+16+0,_PDMc_msgMain))

            CASE m.liRCDir=_PDMc_LR_TnO
                 =IIF(llSilent,.T.,MESSAGEBOX(STRTRAN(_PDMc_msgLR_TnO,"%File%",m.lcRCDir+"pdm.dbf"),0+16+0,_PDMc_msgMain))
         ENDCASE
         RETURN
      ENDIF
      
      This.RCDir=m.lcRCDir && Zapi si adres


      STORE SYS(2015) TO This.RCTabHTML

      This.LangC=SYS(2015)
      IF m.This.OpenTable(-1,"LangC",m.This.LangC," AGAIN SHARE NOUPDATE ORDER I01")>0
         =IIF(llSilent,.T.,MESSAGEBOX(m.This.GetString(_PDM_msgLangCNO),0+16+0,_PDMc_msgMain))
         This.InitErr=_PDM_LangCNO
         RETURN
      ENDIF

      * Nyn zjisti Collate a kdovou strnku
      SELE (m.This.RCTab)
      =SEEK(_PDM_Collate) && Najdi Collate
      STORE XX001 TO This.Collate,lcCollate

      =SEEK(_PDM_CodePage) && Najdi Code Page
*      STORE VAL(XX001) TO This.CP
      STORE CPCURRENT() TO This.CP

      This.GUICLang=IIF(SEEK(_PDM_Locale),ALLT(XX001),"en")

      SELE (m.This.LangC) && sko na seznam jazyk a nastav jazykov kontext
      This.CLang=IIF(SEEK(GetThreadLocale()),ALLT(lc),"en")

      SET COLLATE TO (lcCollate)

      This.PlugIns=CREATEOBJECT("_pdms_PlugIns")
      STORE lcPName TO m.This.Name,This.PlugIns.PDMs

      This.OnlyPDM=PROGRAM(-1)=2 AND VERSION(2)=0

      This.InitErr=_PDMc_OK
   ENDPROC


   PROCEDURE SynchronizeINI() && Synchronizace obsahu INI souboru dle vzoru
      LOCAL lcMainPath,lcAPPData,lcData,liCountS,liCountU,lii,liy,lcKey,liSection,liz,;
             lcSection
      LOCAL ARRAY laDataS(1),laDataU(1),laSections(1)
      lcMainPath=m.This.MainPath

      STORE 0 TO liCountS,liCountU,liSection

      lcAPPData=m.This.APPData
      =m.This.Mkd(m.lcAPPData)

      * Nati seznam sekc ze vzorovho souboru
      lcData=GetINISectionNames(30000,lcMainPath+"pdm.ini")
      IF !EMPTY(lcData) && Pokud to nen przdn
         lcData=STRTRAN(m.lcData,CHR(0),CHR(13)+CHR(10))
         liSection=ALINES(laSections,m.lcData) && Nati dky
      ENDIF

      * Nyn prochzej jednotliv sekce a kontroluj obsah
      FOR liz=1 TO m.liSection
          lcSection=laSections(m.liz)

          * Nati sekci ve vzoru a v uivatelskm souboru
          lcData=GetINISection(@m.lcSection,32000,m.lcMainPath+"PDM.INI") && Cel sekce
          IF !EMPTY(m.lcData) && Pokud to nen przdn
             lcData=STRTRAN(m.lcData,CHR(0),CHR(13)+CHR(10))
             liCountS=ALINES(laDataS,m.lcData) && Nati dky
          ENDIF

          lcData=GetINISection(@m.lcSection,32000,m.lcAPPData+"pdm.ini") && Cel sekce
          IF !EMPTY(lcData) && Pokud to nen przdn
             lcData=STRTRAN(m.lcData,CHR(0),CHR(13)+CHR(10))
             liCountU=ALINES(laDataU,m.lcData) && Nati dky
          ENDIF

          * Nyn projdi matici vzorovch dat a hledej kl v uivatelskch datech
          * Pokud tam kl nen, pak jej zalo do uivatelskch dat
          FOR lii=1 TO m.liCountS
              IF EMPTY(laDataS(m.lii))
                 LOOP
              ENDIF
              lcKey=LEFT(laDataS(m.lii),AT("=",laDataS(m.lii))-1)
              FOR liy=1 TO m.liCountU
                  IF EMPTY(laDataU(m.liy))
                     LOOP
                  ENDIF
                  IF lcKey==LEFT(laDataU(m.liy),AT("=",laDataU(m.liy))-1)
                     EXIT
                  ENDIF
              NEXT
              * Kl tam nen, zalo ho
              =IIF(m.liy<=m.liCountU,.T.,;
                  WriteINIString(@m.lcSection,m.lcKey,SUBS(laDataS(m.lii),AT("=",laDataS(m.lii))+1),m.lcAPPData+"pdm.ini"))
          NEXT
      NEXT
   ENDPROC

   PROCEDURE Initialize() && Doplkov Inicializace tdy
      This.PlugIns.Requery()
      This.PlugIns.SetPDMRef(This.Name)
   ENDPROC

   PROCEDURE Cancel() && 
      IF MESSAGEBOX(m.This.GetString(_PDM_msgCancelProcess),4+32+0,m.This.GetString(_PDM_msgMain))=6
         m.This.FCloseAll()
         This.Canceled=.T. && Set flag of canceled process
         IF m.This.CancelRet=0
            RETURN TO WorkPJXs
         ELSE
            RETURN TO WorkPJX
         ENDIF
      ENDIF
   ENDPROC


   PROCEDURE OpenHTMLS(liDS,lcFile,lcAlias,lcLang) && Oteve tabulku s HTML etzci
      * liDS   - ID Datasession
      * lcFile - Nzev a umstn tabulky
      * lcAlias - Alias
      *@lcLang - Vrt lang
      LOCAL lcFile,liRet,lii,lcTag
      LOCAL ARRAY laFields(1)
      lcFile=IIF(AT("\\",m.lcFile)>0 OR AT(":",m.lcFile)>0,"",m.This.MainPath)+m.lcFile
      liRet=m.This.OpenTable(m.liDS,m.lcFile,m.lcAlias,"SHARE NOUPDATE ORDER XXI000")
      IF liRet=_PDM_OK && Oteve tabulku
         * Nyn zkontroluj strukturu - velmi striktn
         SELE (m.lcAlias)
         * zkontroluj poloky
         liRet=_PDM_HTMLSFailed
         IF AFIELDS(laFields)=2 AND ;
               (laFields(1,1)=="XX000" AND (laFields(1,2)=="I" OR laFields(1,2)=="N") AND ;
               laFields(2,1)=="XX001" AND laFields(2,2)=="M") OR ;
               (laFields(2,1)=="XX000" AND (laFields(2,2)=="I" OR laFields(2,2)=="N") AND ;
                laFields(1,1)=="XX001" AND laFields(1,2)=="M")
            liRet=_PDM_OK
         ENDIF

         * zkontroluj index
         IF m.liRet=_PDM_OK
            lii=1
            lcTag=TAG(m.lii)
            liRet=_PDM_HTMLSFailed
            DO WHILE !EMPTY(m.lcTag)
               IF m.lcTag=="XXI000" AND SYS(14,m.lii)=="XX000"
                  liRet=_PDM_OK
                  EXIT
               ENDIF
               lii=m.lii+1
               lcTag=TAG(m.lii)
            ENDDO
         ENDIF

         IF m.liRet=_PDM_OK
            lcLang=IIF(SEEK(_PDM_Locale),ALLT(XX001),"en")
         ELSE
            =m.This.CloseTable(m.liDS,m.lcAlias)
         ENDIF
      ENDIF
      RETURN m.liRet
   ENDPROC


   PROCEDURE ReadLocalizedString() && Nate lokalizovan stringy z tabulky do matice
      STORE "UFS" TO m.This.aStrings
      IF USED(m.This.RCTabHTML)
         SELE (m.This.RCTabHTML)
         SCAN FOR XX000>0 AND XX000<100000
              m.This.aStrings(XX000)=XX001
         ENDSCAN
      ENDIF
   ENDPROC

   PROCEDURE ReadLocalizedStringEx(laString,liFrom,liTo) && Nate lokalizovan stringy z tabulky do matice
      LOCAL lii
      lii=0
      IF USED(m.This.RCTabHTML)
         SELE (m.This.RCTabHTML)
         DIMENSION laString(32000,2)
         SCAN FOR BETWEEN(XX000,liFrom,liTo)
              lii=lii+1
              laString(lii,1)=XX000
              laString(lii,2)=XX001
         ENDSCAN
         DIMENSION laString(lii,2)
      ENDIF
      RETURN lii
   ENDPROC

   PROCEDURE WorkPJXs(loSPDM) && Run processing PDM project
      * loSPDM -  Single PDM
      loSPDM=IIF(PCOUNT()=0,.NULL.,loSPDM)
      IF m.This.lCoverageLog AND !EMPTY(m.This.cCoverageLog)
         SET COVERAGE TO (m.This.cCoverageLog)
      ENDIF

      STORE 0 TO This.ErrCount,This.WarnCount,This.DbgCount
      LOCAL liErr,lcAlias,lcMessage,lihwnd,lihdc,loRam,loPDM,lii,llSimple,lcESC,llSeverally,;
            lcString,lihFile,lcPom,liy,liz,liPDMs,llOneLng,lcLang,llWorkPJXF,lihThread,lihThreadP
      LOCAL ARRAY laExt(9),laPDMs(1),laPDMsI(1),laPDMsP(1),laPDMsID(1),laPDMsL(1),laString(1)


      lihThread=GetCurrentThread()
      lihThreadP=GetThreadPriority(lihThread)
      =SetThreadPriority(lihThread,THREAD_PRIORITY_IDLE)

      SET DATASESSION TO (m.This.DataSessionID)

      liErr=_PDM_OK
      This.Schemes=SYS(2015)
      lcAlias=SYS(2015)
      This.Canceled=.F.
      lcPom=""
      
      * Nyn se pokus otevt potebn DBF tabulky
      IF liErr=_PDM_OK AND m.This.OpenTable(-1,"Schemes",m.This.Schemes," AGAIN SHARE NOUPDATE ORDER 1")>0
         lcMessage=m.This.GetString(_PDM_msgSchemesNO)
         liErr=_PDM_SchemesNO
      ENDIF

      IF liErr=_PDM_OK
         * Test for autoprint
         FOR lii=1 TO m.This.iPDMs
             IF !ISNULL(loSPDM) AND !loSPDM.PDM==m.This.aPDMs(lii,2).PDM
                LOOP
             ENDIF

             IF m.This.aPDMs(lii,2).AutoPrint=1
                This.PHTML=CREATEOBJECT("_PrintHTML") 
                This.PHTML.CreateIE()
                EXIT
             ENDIF
         NEXT

         This.AFiles=SYS(2015) && Cursor of files
         CREATE CURSOR (m.This.AFiles) (XX000 I,FILE M, CLASS M, PEM M)
         SELE (m.This.AFiles)
         INDEX ON STR(XX000,11) TAG I01
 
         This.Anchors=SYS(2015) && Cursor alias of classes VCX/PRG classlib
         CREATE CURSOR (m.This.Anchors) (CLASS M, CLASSLOC M, METHOD M, BFILE M, FILE M, ANCHOR M, XX006 M, XX007 I, PFLAG L NULL, XXGUID C(30), XXI02 C(18), RESERVED7 M)
         SELE (m.This.Anchors)
         INDEX ON XXI02 TAG I02
         INDEX ON SUBST(XXI02,7) TAG I03
         INDEX ON SUBST(XXI02,13) TAG I04
         INDEX ON STR(LEN(BFILE),11)+STR(XX007,11) TAG I01

         This.AnchorsCSS=SYS(2015) && 
         CREATE CURSOR (m.This.AnchorsCSS) (CLASS M, CLASSLOC M, PCLASS M, PCLASSLOC M, BFILE M, FILE M, XX000 INTEGER NULL)

         This.CAnchors=SYS(2015) && Cursor alias of classes VCX/PRG classlib
         CREATE CURSOR (m.This.CAnchors) (XX000 I, XX000D I, XX020 N(1))
         INDEX ON STR(XX000,11)+STR(XX020,1)+STR(XX000D,11) TAG I01


         SET COLLATE TO "MACHINE" && Nastav tdn MACHINE

         This.AClasses=SYS(2015) && Cursor of files
         CREATE CURSOR (m.This.AClasses) (XX000 I,XX010 I,FILE M, CLASS M, PARENTCLASS M, PARENTLIB M, MEMBERDATA M, RESERVED7 M)
         SELE (m.This.AClasses)
         INDEX ON XX000 TAG I01
         INSERT INTO (m.This.AClasses) (XX000 ,XX010 ,FILE, CLASS, PARENTCLASS, PARENTLIB, MEMBERDATA, RESERVED7) VALUES;
            (-2000000001,-2000000002,"","","","","","")

         This.AClassesPEM=SYS(2015) && Cursor of files
         CREATE CURSOR (m.This.AClassesPEM) (XX000 I, PEM M, DISPLAYPEM M, RESERVED7 M, PEM07 I, OVERRIDE I)
         SELE (m.This.AClassesPEM)
         INDEX ON BINTOC(XX000)+BINTOC(PEM07) TAG I01 FOR NOT DELETED()


         
         SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn
         

         * Zjitn pomru pixel na palec
         lihwnd = GetActiveWindow() && Get handle active window
         liHDC  = GetDC(lihwnd) && Get DC okna
         This.PpIX=GetDeviceCaps(liHDC, cnLOG_PIXELS_X)
         This.PpIY=GetDeviceCaps(liHDC, cnLOG_PIXELS_Y)
         =ReleaseDC(lihwnd,liHDC) && Release handle


         DIME This.aReg(1)
         This.iReg=0

         * Escape to workpjxs
         IF m.This.GUI
            SET ESCAPE ON
            lcESC="ON ESCAPE ="+m.This.Name+".Cancel()"
            This.CancelRet=0
            &lcESC.
         ENDIF

         DIME This.aStrings(6000) && DIME array for strings puts in HTML code
         STORE "UFS" TO This.aStrings

         * Open PJX File
         liPDMs=0
         llOneLng=.T.
         FOR lii=1 TO m.This.iPDMs
             IF !ISNULL(loSPDM) AND !loSPDM.PDM==m.This.aPDMs(lii,2).PDM
                LOOP
             ENDIF

             STORE m.This.aPDMs(lii,2) TO m.loPDM,poPDM
             This.PlugIns.SetPDMRef(loPDM.PDM)
             IF m.loPDM.OpenPJX()#_PDM_OK
                LOOP
             ENDIF
             
             llOneLng=llOneLng AND EMPTY(m.loPDM.HTMLS)

             loPDM.Simple=m.loPDM.FrP.Count=0 && Set flag PDM Simple project
             llSimple=llSimple OR m.loPDM.Simple && Global Simple flag

             IF m.loPDM.SourceType=_PDM_ST_Project OR m.loPDM.SourceType=_PDM_ST_OMFiles AND m.loPDM.Severally=0
                liPDMs=liPDMs+1
                DIME laPDMs(liPDMs)
                DIME laPDMsID(liPDMs)
                laPDMs(liPDMs)=m.loPDM
                laPDMsID(liPDMs)=lii
             ELSE
                liy=m.loPDM.GetRecount()
                DIME laPDMs(liPDMs+liy)
                DIME laPDMsI(liPDMs+liy)
                DIME laPDMsP(liPDMs+liy)
                DIME laPDMsID(liPDMs+liy)
                DIME laPDMsL(liPDMs+liy)
                FOR liz=1 TO liy
                    laPDMsI(liPDMs+liz)=liz
                    laPDMs(liPDMs+liz)=m.loPDM
                    laPDMsP(liPDMs+liz)=AddBackSlashInPath(ALLT(m.loPDM.OutDir)) && Remember out folder
                    laPDMsID(liPDMs+liz)=lii
                    laPDMsL(liPDMs+liz)=liz=liy
                NEXT
                liPDMs=liPDMs+liy
             ENDIF

             IF m.This.Canceled
                EXIT
             ENDIF
         NEXT


         IF llOneLng
            lcPom=m.This.RCDir+"HTML.dbf"
            IF USED(m.This.RCTabHTML)
               USE IN (m.This.RCTabHTML)
            ENDIF
            IF m.This.OpenHTMLS(-1,m.lcPom,m.This.RCTabHTML,@lcLang)=_PDM_OK && Oteve tabulku
               This.HTMLCLang=lcLang
            ELSE
               =This.WriteToLogFile(STRTRAN(m.This.GetString(_PDM_msgHTMLSNot),"%File%",m.lcPom))
            ENDIF
            This.ReadLocalizedString()
            This.AutoFillClassPEMInfo()
         ENDIF

         * Now Process simple PDM files
         liy=0
         FOR lii=1 TO liPDMs
             IF m.This.Canceled OR liErr#_PDM_OK
                EXIT
             ENDIF
             loPDM=laPDMs(lii)
             IF m.loPDM.PJX_Opened AND !m.loPDM.Simple
                LOOP
             ENDIF

             m.This.PlugIns.SetPDMRef(laPDMs(lii).PlugIns.PDM)

             * Zjisti, zda je to jednotliv
             IF liy#laPDMsID(lii) && Dolo ke zmn PDM souboru
                liy=laPDMsID(lii)
                IF m.loPDM.SourceType=_PDM_ST_OMFiles AND m.loPDM.Severally=1
                   lcPom=""
                   * Zapamatuj si nastaven pznak
                   laExt(1)=m.loPDM.DBC.Generate
                   laExt(2)=m.loPDM.SCX.Generate
                   laExt(3)=m.loPDM.FRX.Generate
                   laExt(4)=m.loPDM.PRG.Generate
                   laExt(5)=m.loPDM.VCX.Generate
                   laExt(6)=m.loPDM.LBX.Generate
                   laExt(7)=m.loPDM.XXX.Generate
                   laExt(8)=m.loPDM.MNX.Generate
                ENDIF
             ENDIF

             llSeverally=m.loPDM.SourceType=_PDM_ST_OMFiles AND m.loPDM.Severally=1
             =IIF(llSeverally,m.loPDM.SetPDMToOMFile(laPDMsP(lii),laPDMsI(lii)),.T.)

             This.ErrStopCount=m.loPDM.ErrStopCount
             STORE 0 TO This.hLOGFile,This.hLOGErr,This.ErrCount,This.WarnCount,This.DbgCount
             This.Index=lii
             This.WriteMSG(STRTRAN(This.GetString(_PDM_msgPrepare),"%PJX%",m.loPDM.PJXFile))

             loPDM.CreateAnchorsD(CREATEOBJECT("_uList")) && Create Anchors for file and classes

             * Call plug-in DIAP for quick analysing
             =loPDM.PI_QuickAnalysingD()

             This.WriteMSG(STRTRAN(This.GetString(_PDM_msgPrepare),"%PJX%",m.loPDM.PJXFile))

             This.FixClassInfo()

             IF !m.This.Canceled
                * Try open table with HTML strings
                IF !llOneLng
                   IF EMPTY(m.loPDM.HTMLS)
                      lcPom=m.This.RCDir+"HTML.dbf"
                   ELSE
                      lcPom=IIF(AT("\\",m.loPDM.HTMLS)>0 OR AT(":",m.loPDM.HTMLS)>0,"",m.This.MainPath)+m.loPDM.HTMLS
                   ENDIF
                   IF USED(m.This.RCTabHTML)
                      USE IN (m.This.RCTabHTML)
                   ENDIF
                ENDIF

                IF llOneLng OR m.This.OpenHTMLS(-1,m.lcPom,m.This.RCTabHTML,@lcLang)=_PDM_OK && Oteve tabulku
                   IF !llOneLng
                      This.HTMLCLang=lcLang
                      This.ReadLocalizedString()
                      This.AutoFillClassPEMInfo()
                   ENDIF
                   loPDM.FRX.ReadLocalizedString()
                   loPDM.MNX.ReadLocalizedString()
                   m.This.CancelRet=1
                   liErr=m.loPDM.WorkPJX()
                   llWorkPJXF=liErr#_PDM_OK
                   m.This.CancelRet=0
                ELSE
                   =IIF(!llOneLng,This.WriteToLogFile(STRTRAN(m.This.GetString(_PDM_msgHTMLSNot),"%File%",m.lcPom)),.T.)
                ENDIF
             ENDIF


             IF !llSeverally
                =m.loPDM.ClosePJX() && Close PJX File
                LOOP
             ENDIF

             lcPom=lcPom+m.loPDM.aSpace(2)+[<tr><td><a href="]+m.loPDM.FileName+"\"+m.loPDM.FirstPage+[">]+m.loPDM.FileName+[</a></td></tr>]+m.loPDM.aSpace(21)

             IF laPDMsL(lii) && Je to posledn soubor
                * Vra nastaven pznak
                loPDM.DBC.Generate=laExt(1)
                loPDM.SCX.Generate=laExt(2)
                loPDM.FRX.Generate=laExt(3)
                loPDM.PRG.Generate=laExt(4)
                loPDM.VCX.Generate=laExt(5)
                loPDM.LBX.Generate=laExt(6)
                loPDM.XXX.Generate=laExt(7)
                loPDM.MNX.Generate=laExt(8)

                loPDM.OutDir=laPDMsP(lii)

                * Vygeneruj hlavn strnku
                STORE This.FCreate(m.loPDM.OutDir+"Main.htm") TO lihFile
                IF lihFile>0
                   lcString=m.This.GetHeader('')+m.This.GetStyles("")+'</head>'+m.loPDM.aSpace(21)+;
                            '<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                            '<h1>'+m.This.aStrings(PDM_00900)+'</h1>'+m.loPDM.aSpace(21)+;
                            '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                            m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                            m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                            m.loPDM.aSpace(3)+'<td>'+m.This.aStrings(PDM_04540)+'</td>'+m.loPDM.aSpace(21)+;
                            m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                            m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                            m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)+;
                            lcPom+;
                            m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21)+;
                            '</body>'+m.loPDM.aSpace(21)+'</html>'

                   =FWRITE(lihFile,lcString)
                   =This.FClose(lihFile)
                ELSE
                   =IIF(!llOneLng,This.WriteToLogFile(STRTRAN(m.This.GetString(_PDM_msgHTMLSNot),"%File%",m.lcPom)),.T.)
                ENDIF
     
                loPDM.FirstPage="Main.htm"
                loPDM.Save_FirstPage(m.loPDM.PDM_File)
                loPDM.ClosePJX()
             ENDIF
             SELE (m.This.AFiles)
             ZAP && Clear list classes anchor
             SELE (m.This.CAnchors)
             ZAP && Clear list classes anchor
             SELE (m.This.Anchors) && Select to Anchors cursor
             ZAP && Clear list classes anchor
             SELE (m.This.AnchorsCSS) && Select to CSS Anchors cursor
             ZAP && Clear list classes anchor

             SELE (m.This.AClasses)
             ZAP && Clear list classes anchor
             SELE (m.This.AClassesPEM)
             ZAP && Clear list classes anchor
         NEXT

         liy=0
         IF !llSimple
            * Create Anchors for not any simple PDM 
            FOR lii=1 TO liPDMs
                IF m.This.Canceled
                   EXIT
                ENDIF

                loPDM=laPDMs(lii)
                IF m.loPDM.PJX_Opened AND !m.loPDM.Simple
                   This.WriteMSG(STRTRAN(This.GetString(_PDM_msgPrepare),"%PJX%",m.loPDM.PJXFile))
                   loPDM.CreateAnchors()
                   This.WriteMSG(STRTRAN(This.GetString(_PDM_msgPrepare),"%PJX%",m.loPDM.PJXFile))
                ENDIF
            NEXT

            * Plugin Quick analysing
            FOR lii=1 TO liPDMs
                IF m.This.Canceled
                   EXIT
                ENDIF

                loPDM=laPDMs(lii)
                IF m.loPDM.PJX_Opened AND !m.loPDM.Simple
                   This.WriteMSG(STRTRAN(This.GetString(_PDM_msgPrepare),"%PJX%",m.loPDM.PJXFile))
                   loPDM.PI_QuickAnalysing()
                   This.WriteMSG(STRTRAN(This.GetString(_PDM_msgPrepare),"%PJX%",m.loPDM.PJXFile))
                ENDIF
            NEXT

            This.FixClassInfo()
            
            * Process PDM files
            FOR lii=1 TO liPDMs
                IF m.This.Canceled OR liErr#_PDM_OK
                   EXIT
                ENDIF
                STORE laPDMs(lii) TO m.loPDM,poPDM
                IF m.loPDM.PJX_Opened AND m.loPDM.Simple
                   LOOP
                ENDIF

                This.PlugIns.SetPDMRef(laPDMs(lii).PlugIns.PDM)

                * Zjisti, zda je to jednotliv
                IF liy#laPDMsID(lii) && Dolo ke zmn PDM souboru
                   liy=laPDMsID(lii)
                   IF m.loPDM.SourceType=_PDM_ST_OMFiles AND m.loPDM.Severally=1
                      lcPom=""
                      * Zapamatuj si nastaven pznak
                      laExt(1)=m.loPDM.DBC.Generate
                      laExt(2)=m.loPDM.SCX.Generate
                      laExt(3)=m.loPDM.FRX.Generate
                      laExt(4)=m.loPDM.PRG.Generate
                      laExt(5)=m.loPDM.VCX.Generate
                      laExt(6)=m.loPDM.LBX.Generate
                      laExt(7)=m.loPDM.XXX.Generate
                      laExt(8)=m.loPDM.MNX.Generate
                   ENDIF
                ENDIF

                llSeverally=m.loPDM.SourceType=_PDM_ST_OMFiles AND m.loPDM.Severally=1
                =IIF(llSeverally,m.loPDM.SetPDMToOMFile(laPDMsP(lii),laPDMsI(lii)),.T.)

                This.ErrStopCount=m.loPDM.ErrStopCount
                This.Index=lii
                This.CancelRet=1
                This.PlugIns.PDM=m.loPDM

                IF !llOneLng
                   IF EMPTY(m.loPDM.HTMLS)
                      lcPom=m.This.RCDir+"HTML.dbf"
                   ELSE
                      lcPom=IIF(AT("\\",m.loPDM.HTMLS)>0 OR AT(":",m.loPDM.HTMLS)>0,"",m.This.MainPath)+m.loPDM.HTMLS
                   ENDIF
                   IF USED(m.This.RCTabHTML)
                      USE IN (m.This.RCTabHTML)
                   ENDIF
                ENDIF

                IF llOneLng OR m.This.OpenHTMLS(-1,m.lcPom,m.This.RCTabHTML,@lcLang)=_PDM_OK && Oteve tabulku
                   IF !llOneLng
                      This.HTMLCLang=lcLang
                      This.ReadLocalizedString()
                      This.AutoFillClassPEMInfo()
                   ENDIF
                   loPDM.FRX.ReadLocalizedString()
                   loPDM.MNX.ReadLocalizedString()
                   liErr=m.loPDM.WorkPJX()
                   llWorkPJXF=liErr#_PDM_OK
                ELSE
                   =IIF(!llOneLng AND m.This.GUI,MESSAGEBOX(STRTRAN(m.This.GetString(_PDM_msgHTMLSNot),"%File%",m.lcPom),0+16+0,_PDMc_msgMain),.T.)
                ENDIF
                This.PlugIns.PDM=.NULL.
                This.CancelRet=0

                IF !llSeverally
                   =m.loPDM.ClosePJX() && Close PJX File
                   LOOP
                ENDIF

                lcPom=lcPom+m.loPDM.aSpace(2)+[<tr><td><a href="]+m.loPDM.FileName+"\"+m.loPDM.FirstPage+[">]+m.loPDM.FileName+[</a></td></tr>]+m.loPDM.aSpace(21)

                IF laPDMsL(lii) && If last PDM file from ...
                   * Vra nastaven pznak
                   loPDM.DBC.Generate=laExt(1)
                   loPDM.SCX.Generate=laExt(2)
                   loPDM.FRX.Generate=laExt(3)
                   loPDM.PRG.Generate=laExt(4)
                   loPDM.VCX.Generate=laExt(5)
                   loPDM.LBX.Generate=laExt(6)
                   loPDM.XXX.Generate=laExt(7)
                   loPDM.MNX.Generate=laExt(8)
                
                   loPDM.OutDir=laPDMsP(lii)
                 
                   * Vygeneruj hlavn strnku
                   STORE This.FCreate(m.loPDM.OutDir+"Main.htm") TO lihFile
                   IF lihFile>0
                      lcString=m.This.GetHeader('')+m.This.GetStyles("")+'</head>'+m.loPDM.aSpace(21)+;
                               '<body class="pbb_auto">'+m.loPDM.aSpace(21)+;
                               '<h1>'+m.This.aStrings(PDM_00900)+'</h1>'+m.loPDM.aSpace(21)+;
                               '<table border="1" cellspacing="0">'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(1)+'<thead>'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(2)+'<tr class="Head">'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(3)+'<td>'+m.This.aStrings(PDM_04540)+'</td>'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(2)+'</tr>'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(1)+'</thead>'+m.loPDM.aSpace(21)+;
                               m.loPDM.aSpace(1)+'<tbody>'+m.loPDM.aSpace(21)+;
                               lcPom+;
                               m.loPDM.aSpace(1)+'</tbody>'+m.loPDM.aSpace(21)+'</table>'+m.loPDM.aSpace(21)+;
                               '</body>'+m.loPDM.aSpace(21)+'</html>'

                      =FWRITE(lihFile,lcString)
                      =This.FClose(lihFile)
                   ELSE
                      m.This.WriteToLogFile(STRTRAN(m.This.GetString(_PDM_msgFileNC),"%File%",m.loPDM.OutDir+"Main.htm"))
                   ENDIF
                  
                   loPDM.FirstPage="Main.htm"
                   loPDM.Save_FirstPage(m.loPDM.PDM_File)
                   loPDM.ClosePJX()
                ENDIF
            NEXT
         ENDIF

         IF m.This.Canceled
            FOR lii=1 TO liPDMs
                loPDM=laPDMs(lii)
                =IIF(m.loPDM.PJX_Opened,m.loPDM.ClosePJX(),.T.) && Close PJX File
            NEXT
         ENDIF

         m.This.PlugIns.SetPDMRef("poPDM")

         IF USED(m.This.AFiles) && Pokud je oteven
            USE IN (m.This.AFiles) && Pak jej uzavi
         ENDIF

         IF USED(m.This.Anchors) && Pokud je oteven
            USE IN (m.This.Anchors) && Pak jej uzavi
         ENDIF

         IF USED(m.This.AnchorsCSS) && Pokud je oteven
            USE IN (m.This.AnchorsCSS) && Pak jej uzavi
         ENDIF

         IF USED(m.This.CAnchors) && Pokud je oteven
            USE IN (m.This.CAnchors) && Pak jej uzavi
         ENDIF

         IF USED(m.This.AClasses) && Pokud je oteven
            USE IN (m.This.AClasses) && Pak jej uzavi
         ENDIF
         IF USED(m.This.AClassesPEM) && Pokud je oteven
            USE IN (m.This.AClassesPEM) && Pak jej uzavi
         ENDIF

         =IIF(!ISNULL(m.This.PHTML),m.This.PHTML.RemoveIE(),.T.)
         STORE .NULL. TO This.PHTML

         IF m.This.GUI
            SET ESCAPE OFF
            ON ESCAPE 
         ENDIF
      ENDIF

      * Uzavi oteven DBF tabulky a pracovn soubory
      IF USED(m.This.Schemes)
         USE IN (m.This.Schemes)
      ENDIF

      IF !m.This.Canceled AND liErr#_PDM_OK AND m.This.GUI AND !llWorkPJXF
         =MESSAGEBOX(lcMessage,16,m.This.GetString(_PDM_msgMain))
      ENDIF

      m.This.SetCatch(.NULL.)

      IF m.This.lCoverageLog AND !EMPTY(m.This.cCoverageLog)
         SET COVERAGE TO
      ENDIF
      =SetThreadPriority(lihThread,lihThreadP)

      RETURN liErr
   ENDPROC


   PROCEDURE ParseSCColor(lcData,lcFC,lcBC) && Parse data from registry to Fore Color and Backgroud Color
      * lcData - Data value from registry
      *@lcFC   - Out, RGB Fore color or AUTO
      *@lcBC   - Out, RGB Background color or AUTO
      
      LOCAL lcRGB,liE,liB,liRed,liGreen,liBlue
      liE=RAT(",",lcData,2)
      lcRGB=SUBST(lcData,5,liE-5-1) && U jen ist sloky

      liB=liE
      liE=RAT(",",lcData,1)
      lcFC=LTRIM(UPPER(SUBS(lcData,liB+1,liE-liB-1)))

      liB=liE
      lcBC=LTRIM(UPPER(SUBS(lcData,liB+1)))

      IF lcFC=="NOAUTO" && Fore Color
         liE=AT(",",lcRGB,1)
         liRed=VAL(LEFT(lcRGB,liE-1))

         liB=liE
         liE=AT(",",lcRGB,2)
         liGreen=VAL(SUBS(lcRGB,liB+1,liE-liB-1))

         liB=liE
         liE=AT(",",lcRGB,3)
         liBlue=VAL(SUBS(lcRGB,liB+1,liE-liB-1))
         
         lcFC=RIGHT(TRANSFORM(RGB(liBlue,liGreen,liRed),'@0'),6)
      ENDIF

      IF lcBC=="NOAUTO"  && BackGround Color 
         liB=AT(",",lcRGB,3)
         liE=AT(",",lcRGB,4)
         liRed=VAL(SUBS(lcRGB,liB+1,liE-liB-1))

         liB=liE
         liE=AT(",",lcRGB,5)
         liGreen=VAL(SUBS(lcRGB,liB+1,liE-liB-1))

         liB=liE
         liBlue=VAL(SUBS(lcRGB,liB+1))

         lcBC=RIGHT(TRANSFORM(RGB(liBlue,liGreen,liRed),'@0'),6)
      ENDIF

   ENDPROC

   PROCEDURE Error && Chybov rutina
      * nError  - slo chyby
      * cMethod - Nzev metody ve kter dolo k chyb
      * nLine   - slo dku na kterm dolo k chyb
      LPARAMETERS m.nError, m.cMethod, m.nLine

      LOCAL m.loObj, m.lcPom

      IF ISNULL(m.This.Catch) && Pokud nen definovno
         * Pak zavi, nebo jde o chybu mimo provdn
         This.nErr=nError && slo chyby
         This.cErrMSG=MESSAGE() && Hlen chyby
         IF m.This.GUI && If GUI active
            
            m.lcPom=PROGRAM(PROGRAM(-1)-1)+CRLF+;
                        SYS(16,PROGRAM(-1)-1)+CRLF+;
                        "Lineno: "+LTRIM(STR(m.nLine, 11))+CRLF+;
                        cmethod+" "+TRANSFORM(m.nerror)+" "+MESSAGE(1)
            DEBUGOUT m.This.cErrMSG
            DEBUGOUT m.lcPom

            *=MESSAGEBOX(m.This.cErrMSG, 0+48+0, m.This.GetString(_PDM_msgMain))
            *=MESSAGEBOX(m.lcPom, 0+48+0, m.This.GetString(_PDM_msgMain))
         ENDIF
         RETURN && A vysko ven
      ENDIF

      IF This.Catch && M ji zachytit
         This.nErr=nError && slo chyby
         This.cErrMSG=MESSAGE() && Hlen chyby
         This.WriteToLogFile(CHR(9)+MESSAGE()+CRLF+CHR(9)+MESSAGE(1),_PDM_WrnLog)
         =IIF(m.This.GUI AND !EMPTY(m.This.iWW),EVAL(m.This.iWW+"(m.This.WarnCount)"),.T.)
      ELSE

         This.ErrCount=m.This.ErrCount+1 && Inkrementuj ta chyb
         =IIF(m.This.GUI AND !EMPTY(m.This.iWE),EVAL(m.This.iWE+"(m.This.ErrCount)"),.T.)
         IF m.This.hLOGErr>0
            * Zapi chybu do LOGErr
            lcPom=LTRIM(STR(nError,11))+" - "+PROGRAM(PROGRAM(-1)-1)+" - "+LTRIM(STR(nLine,11))
            =FPUTS(m.This.hLOGErr,lcPom)
            IIF(This.ErrToDebug=1,OutputDebugString(@lcPom),.F.)

            IF m.This.Index>0 && If any PDM file in proces
               loObj=m.This.aPDMs(m.This.Index,2) && Reference on PDM file
               IF !EMPTY(loObj.oProcessing)
                  loObj=EVAL("loObj."+loObj.oProcessing) && Reference on block PDM file (VCX/DBC/SCX/ etc...)
                  IF !EMPTY(loObj.File)&& If any file in process
                     =FPUTS(m.This.hLOGErr,CHR(9)+loObj.File)
                  ENDIF
               ENDIF
            ENDIF
            =FPUTS(m.This.hLOGErr,CHR(9)+MESSAGE()+CRLF+CHR(9)+MESSAGE(1)+CRLF)
         ENDIF
         * Pokud se m testovat maximln poet chyb a je toho doshnuto
         IF m.This.ErrStopCount>0 AND m.This.ErrCount=m.This.ErrStopCount
            This.WriteToLogFile(m.This.GetString(_PDM_msgProcessCancel))
            m.This.FCloseAll() && Uzavi vechny soubory
            RETURN TO WorkPJX && Pak ukoni zpracovn aktuln PDM projektu
         ENDIF
      ENDIF
   ENDPROC

   PROCEDURE WriteToLogFile(lcMessage,liCounter) && Write string to LOG File
      * lcMessage - Chybov/oznamovac hlen
      IF m.This.hLOGFile>0
         IF PCOUNT()=2 AND liCounter=_PDM_WrnLog
            m.This.WarnCount=m.This.WarnCount+1 && Inkrement counter
         ENDIF
         IF PCOUNT()=2 AND liCounter=_PDM_DbgLog
            m.This.DbgCount=m.This.DbgCount+1 && Inkrement counter
         ENDIF
         =FPUTS(m.This.hLOGFile,lcMessage)
         =IIF(This.LogToDebug=1,OutputDebugString(@lcMessage),.F.)
      ENDIF
   ENDPROC

   PROCEDURE SetCatch(llCatch) && Nastaven zachycen chyby
      LOCAL luCatch
      luCatch=m.This.Catch
      This.Catch=llCatch
      IF llCatch && Pokud m chybu zachytit
         * Pak vyresetuj nastaven chyby
         This.nErr=0 && slo chyby
         This.cErrMSG="" && Hlen chyby
      ENDIF
      RETURN luCatch && Vra pvodn nastaven
   ENDPROC

   PROCEDURE OpenTable(liDSID,lcFile,lcAlias,lcParam) && Oteve tabulku
      * liDSID  - ID Data Session
      * lcFile  - Umstn a nzev DBF souboru
      * lcAlias - Alias 
      * lcParam - Parametry

      LOCAL liDSIDOld,luCatch
      liDSIDOld=m.This.DataSessionID
      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      IF liDSID>=0
         SET DATASESSION TO liDSID && Nastav poadovanou DS
      ENDIF
      USE (lcFile) ALIAS (lcAlias) IN 0 &lcParam.
      SET DATASESSION TO (liDSIDOld) && Nastav 
      m.This.SetCatch(luCatch) && Zru zachycen chyby
      RETURN m.This.nErr
   ENDPROC

   PROCEDURE CloseTable(liDSID,lcAlias) && Uzave tabulku
      * liDSID  - ID Data Session
      * lcAlias - Alias 
      LOCAL liDSIDOld
      liDSIDOld=m.This.DataSessionID
      IF liDSID>=0
         SET DATASESSION TO liDSID && Nastav poadovanou DS
      ENDIF
      IF USED(lcAlias)
         USE IN (lcAlias)
      ENDIF
      SET DATASESSION TO (liDSIDOld) && Nastav 
      RETURN m.This.nErr
   ENDPROC

   * Close missing Alias
   PROCEDURE CloseAlias(liDSID)
      * liDSID - ID Data Session
      LOCAL liDSIDOld,lii
      LOCAL ARRAY laUsed(1)
      liDSIDOld=m.This.DataSessionID
      IF liDSID>=0
         SET DATASESSION TO liDSID && Nastav poadovanou DS
      ENDIF
      FOR lii=1 TO AUSED(laUsed)
          USE IN (laUsed(lii,2)) && Close Alias
      NEXT
      SET DATASESSION TO (liDSIDOld) && Nastav 
   ENDPROC

   PROCEDURE FCreate(lcFile) && Create file
      * lcFile  - Directory and name of file

      LOCAL lihFile,luCatch
      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      lihFile=FCREATE(lcFile,0)
      This.SetCatch(luCatch) && Zru zachycen chyby
      IF lihFile>0
         This.iFile=m.This.iFile+1 && Inkrementuj ta
         DIME m.This.aFile(m.This.iFile) && Pedimenzuj matici
         This.aFile(m.This.iFile)=lihFile && Zapi handle
      ENDIF
      RETURN lihFile
   ENDPROC

   PROCEDURE FOpen(lcFile) && Open file
      * lcFile  - Directory and name of file

      LOCAL lihFile,luCatch
      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      lihFile=FOPEN(lcFile,2)
      This.SetCatch(luCatch) && Zru zachycen chyby
      IF lihFile>0
         This.iFile=m.This.iFile+1 && Inkrementuj ta
         DIME m.This.aFile(m.This.iFile) && Pedimenzuj matici
         This.aFile(m.This.iFile)=lihFile && Zapi handle
      ENDIF
      RETURN lihFile
   ENDPROC

   PROCEDURE FClose(lihFile) && Uzave soubor
      * lchFile - VFP Handle otevenho souboru

      LOCAL lii
      =FCLOSE(lihFile) && Uzavi soubor
      lii=ASCAN(m.This.aFile,lihFile) && Najdi zznam
      IF lii>0
         =ADEL(m.This.aFile,lii) && Sma zznam
         IF m.This.iFile>0
            This.iFile=m.This.iFile-1 && Dekrementuj ta
            IF m.This.iFile>0
               DIME m.This.aFile(m.This.iFile) && Pedimenzuj matici
            ENDIF
         ENDIF
      ENDIF
      
      RETURN lihFile
   ENDPROC

   PROCEDURE FCloseAll(lihFile) && Uzave vechny soubory (vol se pi dosaen maximlnho potu chyb)
      * lchFile - VFP Handle otevenho souboru
      LOCAL lii
      FOR lii=1 TO m.This.iFile
          =FFLUSH(m.This.aFile(lii)) && Ulo zmny
          =FCLOSE(m.This.aFile(lii)) && Uzavi soubor
      NEXT
      This.iFile=0 && Resetuj ta
      DIME m.This.aFile(1) && Pedimenzuj matici
   ENDPROC

   PROCEDURE OpenDBC(liDSID,lcDBC,lcParam) && Open DBC konteiner
      * liDSID  - ID Data Session
      * lcDBC  -  Directory and Name DBC container
      * lcParam - Parameters

      LOCAL liDSIDOld,luCatch
      liDSIDOld=m.This.DataSessionID &&  Remember Datasession ID
      luCatch=m.This.SetCatch(.T.) && Set chatch error
      IF liDSID>=0
         SET DATASESSION TO liDSID && Set new Datasession ID
      ENDIF
      OPEN DATA (lcDBC) &lcParam.
      SET DATASESSION TO (liDSIDOld) && Set datasession ID
      m.This.SetCatch(luCatch) && Cancel chatch error
      RETURN m.This.nErr && Return number Error
   ENDPROC

   PROCEDURE GetStyles(lcRelPath) && Vrt piazen stylu
       * lcRelPath - Relativn cesta k souboru CSS
	   RETURN '<link rel="stylesheet" href="'+IIF(EMPTY(lcRelPath),'',lcRelPath)+'css/foxw.css" type="text/css" />'+IIF(LEN(m.poPDM.aSpace(21))=0,"",CRLF)
   ENDPROC

   PROCEDURE GetStylesEx(lcRelPath,lcCSS) && Vrt piazen stylu
       * lcRelPath - Relativn cesta k souboru CSS
       * lcCSS     - Konkrtn soubor se styly
	   RETURN '<link rel="stylesheet" href="'+IIF(EMPTY(lcRelPath),'',lcRelPath)+lcCSS+'" type="text/css" />'+IIF(LEN(m.poPDM.aSpace(21))=0,"",CRLF)
   ENDPROC

   PROCEDURE AddExternalStyle(lcCSS) && Vrt piazen externho stylu
       * lcRelPath - Relativn cesta k souboru CSS
       * lcCSS     - Konkrtn soubor se styly
	   RETURN '<link rel="stylesheet" href="'+lcCSS+'" type="text/css" />'+IIF(LEN(m.poPDM.aSpace(21))=0,"",CRLF)
   ENDPROC

   PROCEDURE GetHeader(lcTitle,llH100) && Vrt hlaviku pro HTML dokument
      * lcTitle - Titulek HTML souboru
      RETURN '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'+m.poPDM.aSpace(21)+;
		     '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="'+m.This.CLang+'" lang="'+m.This.CLang+'"'+IIF(llH100,' class="html_h100"','')+'>'+CRLF+;
		     '<head>'+m.poPDM.aSpace(21)+;
		     '<title>'+IIF(EMPTY(lcTitle),'',lcTitle)+'</title>'+m.poPDM.aSpace(21)+;
		     '<meta content="text/html; charset=windows-'+LTRIM(STR(m.This.CP,5))+'" http-equiv="Content-Type" />'+m.poPDM.aSpace(21)+;
		     '<meta name="Generator" content="Project Documenting Machine" />'+m.poPDM.aSpace(21)+;
		     '<meta name="Version" content="'+m.This.Version+'" />'+m.poPDM.aSpace(21)

   ENDPROC

   PROCEDURE OutPage(lcName, lcOutName,lcMain, laTitles,lcQFL, m.liShowQuickFileList) && Vytvo HTML strnku dle tabulky schmat
      * lcName    - Kdov nzev strnky
      * lcOutName - Umstn a nzev strnky
      * lcMain    - Nzev hlavn strnky (detailu)
      *@laTitles  - titles
      ** Date: 2002-01-07 (MJ)
      LOCAL lcPom,liSele,lii,luCatch
      liSele=SELE() && Remember session
      SELE (m.This.Schemes)
      IF SEEK(lcName)
         lcPom=STRTRAN(STRTRAN(STRTRAN(STRTRAN(STRTRAN(memo,;
               "%CP%",LTRIM(STR(m.This.CP,11))),;
               "%CL%",m.This.CLang),;
               "%version%",m.This.Version),;
               "%cssstyle%",m.This.GetStyles()),;
               "%quickfilelist%",IIF(m.liShowQuickFileList=0,"Blank_QL.htm",lcQFL))
         
         IF m.liShowQuickFileList=0
            m.lcPom=STRTRAN(m.lcPom,'cols="333,*"','cols="112,*"')
         ENDIF
               
         lcPom=STRTRAN(lcPom,"%title0%",laTitles(1))
         FOR lii=2 TO ALEN(laTitles)
             lcPom=STRTRAN(lcPom,"%title"+LTRIM(STR(lii-1,11))+"%",laTitles(lii))
         NEXT

         IF LEN(m.poPDM.aSpace(21))=0
            lcPom=STRTRAN(lcPom,CRLF,"")
         ENDIF

         luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
         =STRTOFILE(IIF(EMPTY(lcMain),lcPom,STRTRAN(lcPom,"%Main%",lcMain)),lcOutName)
         =m.This.SetCatch(luCatch) && Nastav zachycen chyby
      ENDIF
      SELE (liSele)
   ENDPROC


   PROCEDURE StartScript && Vrt hlaviku skript
	  RETURN '<script language="JavaScript" type="text/javascript">'+IIF(LEN(m.poPDM.aSpace(21))=0,"",CRLF)
   ENDPROC

   PROCEDURE AddExternalScript(lcFile) && Pid odkaz na extern skript
      * lcFile - Umstn a nzev souboru skript
	  RETURN '<script src="'+lcFile+'" language="JavaScript" type="text/javascript"></script>'+IIF(LEN(m.poPDM.aSpace(21))=0,"",CRLF)
   ENDPROC

   PROCEDURE StopScript && Vrt patiku skript
      RETURN '</script>'+IIF(LEN(m.poPDM.aSpace(21))=0,"",CRLF)
   ENDPROC

   PROCEDURE AddScript(lcName, lcRepWhat, lcRepWith) && Vrt skript z tabulky schmat
      * lcName    - Nzev skriptu
      * lcRepWhat - Co se m nahradit
      * lcRepWith - m se m nahradit
      LOCAL lcCode
      SELECT (m.This.Schemes)
      IF SEEK(lcName)
         lcCode=IIF(EMPTY(lcRepWhat),Memo,STRTRAN(Memo,lcRepWhat,lcRepWith))
         RETURN IIF(LEN(m.poPDM.aSpace(21))=0,lcCode,lcCode+IIF(RIGHT(lcCode,4)#CRLF+CRLF,IIF(RIGHT(lcCode,2)=CRLF,CRLF,CRLF+CRLF),""))
      ENDIF
      RETURN ""
   ENDPROC

   PROCEDURE AddRowScript(lcName, lcRepWhat, lcRepWith) && Vrt skript z tabulky schmat (nepidv CRLF)
      * lcName    - Nzev skriptu
      * lcRepWhat - Co se m nahradit
      * lcRepWith - m se m nahradit
      SELECT (m.This.Schemes)
      RETURN IIF(SEEK(lcName),IIF(EMPTY(lcRepWhat),Memo,STRTRAN(Memo,lcRepWhat,lcRepWith)),"")
   ENDPROC

   PROCEDURE GetString(liID) && Vrt string z lokalizan tabulky
      * liID - ID lokalizovanho stringu
      RETURN IIF(SEEK(liID,m.This.RCTab),LTRIM(EVAL(m.This.RCTab+".XX001")),_PDMc_NA)
   ENDPROC


   PROCEDURE RunGUI(pcPDMs,pcPDM,loRGUI) && Zobraz hlavn formul
      * pcPDMs - Name object reference on PDMs object
      * pcPDM  - Name object reference on PDM object
      * loRGUI - Comamnd & Data
      LOCAL luCatch,llProcess

      IF !FILE(m.This.GUI_Path+m.This.GUI_VCX)
         =MESSAGEBOX(STRTRAN(_PDMc_msgVCX_NF,"%File%",m.This.GUI_Path+m.This.GUI_VCX),0+16+0,_PDMc_msgMain)
         RETURN
      ENDIF

      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      SET CLASSLIB TO (m.This.GUI_Path+m.This.GUI_VCX) ADDITIVE
      m.This.SetCatch(luCatch) && Zru zachycen chyby
      IF m.This.nErr#0
         =MESSAGEBOX(STRTRAN(_PDMc_msgVCX_NO,"%File%",m.This.GUI_Path+m.This.GUI_VCX),0+16+0,_PDMc_msgMain)
         RETURN
      ENDIF

      luCatch=m.This.SetCatch(.T.) && Nastav zachycen chyby
      m.This.oGUI=CREATEOBJECT("_PDMGUI")
      m.This.SetCatch(luCatch) && Zru zachycen chyby
      IF m.This.nErr#0
         =MESSAGEBOX(m.This.GetString(_PDM_msgLoadClassFailed),0+16+0,_PDMc_msgMain)
         RETURN
      ENDIF

      This.GUI=.T.
      PUSH MENU _msysmenu
      IF VERSION(2)=0
         SET SYSMENU TO
      ENDIF

      IF This.oGUI.Setup(pcPDMs,pcPDM)
         llProcess=IIF(loRGUI.Command>0 AND loRGUI.Command#6,This.oGUI.RunCommand(loRGUI),.F.)

         IF !llProcess
            IF This.oGUI.SetupGUI()
               IF loRGUI.Command=0
                  loRGUI.Command=6
               ENDIF
               =This.oGUI.RunCommand(loRGUI)
               IF _Screen.Visible=.F.
                  _Screen.Visible=.T.
               ENDIF
               READ EVENTS
            ENDIF
            This.oGUI.CleanupGUI()
         ENDIF
      ENDIF
      This.oGUI.CleanUp()

      POP MENU _msysmenu
      IF VERSION(2)#0
         SHOW WINDOW COMMAND
      ENDIF

      IF UPPER(m.This.GUI_VCX) $ SET("CLASSLIB")
         RELEASE CLASSLIB (m.This.GUI_Path+m.This.GUI_VCX) ALIAS PDM
         CLEAR CLASSLIB (m.This.GUI_Path+m.This.GUI_VCX)
      ENDIF
      This.GUI=.F.
   ENDPROC

   PROCEDURE GetFreePDMName() && Return free PDM name
      LOCAL lii,liMax
      liMax=0
      FOR lii=1 TO m.This.iPDMs
          IF LEFT(m.This.aPDMs(lii,1),6)=="NATIVE"
             liMax=MAX(liMax,VAL(SUBST(m.This.aPDMs(lii,1),7)))
          ENDIF
      NEXT
      RETURN "NATIVE"+LTRIM(STR(liMax+1,11))
   ENDPROC

   PROCEDURE AddPDM(lcFile,liIndex) && Add PDM file to list
      * lcFile  - PDM file
      *@liIndex - Return index of array
      lcFile=UPPER(lcFile)
      LOCAL lii,loPDM,loSet
      FOR lii=1 TO m.This.iPDMs
          IF m.This.aPDMs(lii,1)==lcFile && If exists
             EXIT && Then exit
          ENDIF
      NEXT
      
      IF lii>m.This.iPDMs && If not exists
         * Then add to array and create PDM object
         STORE m.This.iPDMs+1 TO liIndex,This.iPDMs,This.Index && Increment counter
         DIME This.aPDMs(liIndex,2)
         STORE CREATEOBJECT("_pdm",m.This.Name,m.This.Name+".aPDMs("+LTRIM(STR(liIndex,11))+",2)",m.This.Collate) TO m.This.aPDMs(liIndex,2),m.loPDM
         STORE lcFile TO m.This.aPDMs(liIndex,1),loPDM._Name
         This.PlugIns.SetPDMRef(loPDM.PDM)
         =m.loPDM.SetDefSets()
         loPDM.Plugins.AddPlugIn(40000,.NULL.,.F.) && Auto Add Syntax Coloring plugin
         loSet=loPDM.Plugins.GetSetting(40000)
         IF NOT ISNULL(loSet)
            loSet.SyntaxColoring=1
         ENDIF   
      ELSE
         loPDM=.NULL.
      ENDIF
      RETURN m.loPDM
   ENDPROC

   PROCEDURE SetActivePDM(loPDM) && Add PDM file to list
      poPDM=loPDM
      This.Index=This.GetPDMIndex(loPDM._Name)
      This.PlugIns.SetPDMRef(loPDM.PDM)
   ENDPROC


   PROCEDURE GetPDMIndex(lcName) && Add PDM file to list
      * lcFile  - PDM file
      *@liIndex - Return index of array
      lcName=UPPER(lcName)
      LOCAL lii
      FOR lii=1 TO m.This.iPDMs
          IF UPPER(m.This.aPDMs(lii,2)._Name)==lcName && If exists
             EXIT && Then exit
          ENDIF
      NEXT
      RETURN IIF(m.lii<=m.This.iPDMs,m.lii,0)
   ENDPROC


   PROCEDURE ChangePDMName(lcOFile,lcNFile) && Change PDM file name in list
      * lcOFile  - PDM file - Old File
      * lcNFile  - PDM file - new file
      lcOFile=UPPER(lcOFile)
      LOCAL lii,loPDM
      FOR lii=1 TO m.This.iPDMs
          IF m.This.aPDMs(lii,1)==lcOFile && If exists
             m.This.aPDMs(lii,1)=UPPER(lcNFile)
             EXIT && Then exit
          ENDIF
      NEXT
      RETURN .T.
   ENDPROC

   PROCEDURE RemovePDM(lcFile) && Remove PDM file from list
      * lcFile  - PDM file
      lcFile=UPPER(lcFile)
      LOCAL lii,loPDM,liy,lcOld
      FOR lii=1 TO m.This.iPDMs
          IF m.This.aPDMs(lii,1)==lcFile && If exists
             m.This.iPDMs=m.This.iPDMs-1
             =ADEL(This.aPDMs,m.lii)
             IF m.This.iPDMs>0
                DIME This.aPDMs(m.lii,2)
                FOR liy=lii TO m.This.iPDMs
                    lcOld=m.This.aPDMs(lii,2).PDM
                    m.This.aPDMs(lii,2).PDM=m.This.Name+".aPDMs("+LTRIM(STR(m.liy,11))+",2)"
                    m.This.aPDMs(lii,2).SetPDMRef(m.This.aPDMs(lii,2).PDM)
                    IF !ISNULL(m.This.oGUI) AND PEMSTATUS(m.This.oGUI,"SynchronisePDMRef",5)
                       m.This.oGUI.SynchronisePDMRef(lcOld,m.This.aPDMs(lii,2).PDM)
                    ENDIF
                NEXT
             ENDIF
             EXIT && Then exit
          ENDIF
      NEXT
      RETURN .T.
   ENDPROC

   PROCEDURE AddReg(lcFile) && Add PDM file to reg list
      * lcFile  - PDM file
      lcFile=UPPER(lcFile)
      LOCAL lii,llRet
      FOR lii=1 TO m.This.iReg
          IF m.This.aReg(lii,1)==lcFile && If exists
             EXIT && Then exit
          ENDIF
      NEXT
      
      IF lii>m.This.iReg && If not exists
         * Then add to array 
         STORE m.This.iReg+1 TO This.iReg && Increment counter
         DIME This.aReg(m.This.iReg,1)
         This.aReg(This.iReg,1)=lcFile
         RETURN .T.
      ELSE
         RETURN .F.
      ENDIF
   ENDPROC


   PROCEDURE AddPDMs(lcFileList) && Add PDM files to list
      * lcFileList  - PDM file list
      lcFileList=UPPER(lcFileList)
      LOCAL lii,loPDM,lcFile,liy,liz,liCount
      lcFileList=lcFileList+IIF(RIGHT(lcFileList,1)=',','',',')
      liCount=OCCURS(',',lcFileList) && Count of ,

      liy=1
      FOR lii=1 TO liCount
          liz=AT(',',lcFileList,lii)
          lcFile=ALLT(SUBST(lcFileList,liy,liz-liy))
          IF !EMPTY(lcFile)
             loPDM=m.This.AddPDM(lcFile)
             =IIF(!ISNULL(m.loPDM),m.loPDM.Open(lcFile),.T.) && Open PDM File (read setings)
          ENDIF
          liy=liz+1
      NEXT
   ENDPROC

   PROCEDURE WriteMSG(lcMessage) && Pepole hlen do GUI
      RETURN IIF(!EMPTY(m.This.iWWD) AND m.This.GUI,EVAL(m.This.iWWD+"(lcMessage)"),.T.)
   ENDPROC

   PROCEDURE WriteDMSG(lcMessage) && Pepole detailn hlen do GUI
      RETURN IIF(!EMPTY(m.This.iDWWD) AND m.This.GUI,EVAL(m.This.iDWWD+"(lcMessage)"),.T.)
   ENDPROC


**STOP XX
   PROCEDURE AddClassInfo(lcFILE, lcCLASS, lcPARENTCLASS, lcPARENTLIB, lcRESERVED7) && Add class info to global list
      * lcFILE        - Zdrojov soubor
      * lcCLASS       - tda
      * lcPARENTCLASS - Nadazen tda
      * lcPARENTLIB   - Soubor nadazen tdy
      * lcRESERVED7   - Popis tdy
      LOCAL liXX000,liSele
      lcFILE=UPPER(lcFILE)
      lcCLASS=UPPER(lcCLASS)
      lcPARENTCLASS=UPPER(lcPARENTCLASS)
      lcPARENTLIB=UPPER(lcPARENTLIB)
      liSele=SELECT()
      SELECT (m.This.AClasses)
      LOCATE FOR FILE==lcFILE AND CLASS==lcCLASS
      IF NOT FOUND()
         GO BOTTOM
         liXX000=XX000+1
         INSERT INTO (m.This.AClasses) (XX000 ,XX010 ,FILE , CLASS , PARENTCLASS , PARENTLIB , MEMBERDATA , RESERVED7 );
            VALUES (liXX000, -2000000001, lcFILE, lcCLASS, lcPARENTCLASS, lcPARENTLIB, "", lcRESERVED7)
      ENDIF
      SELECT (liSele)
      RETURN  liXX000
   ENDPROC

   PROCEDURE UpdateClassInfo_MD(liXX000,lcMEMBERDATA) && update meberdata for class info
      LOCAL liSele,lii
      liSele=SELECT()
      SELECT (m.This.AClasses)
      IF SEEK(liXX000)
         lii=AT("<VFPData>",lcMEMBERDATA)
         REPLACE MEMBERDATA WITH IIF(lii=0,"",SUBSTR(lcMEMBERDATA,lii))
      ENDIF
      SELECT (liSele)
   ENDPROC

   PROCEDURE AddClassPEMInfo(liXX000, lcPEM, lcRESERVED7) && Add class PEM info to global list
      * liXX000  - Id tdy
      * lcCLASS  - PEM
      * lcPEM    - Popis PEM
      LOCAL liSele
      lcPEM=UPPER(lcPEM)
      liSele=SELECT()
      SELECT (m.This.AClassesPEM)
      SET COLLATE TO "MACHINE" && Nastav tdn MACHINE
      IF NOT SEEK(BINTOC(liXX000)+BINTOC(VAL(SYS(2007,lcPEM))))
         INSERT INTO (m.This.AClassesPEM) (XX000 ,PEM , DISPLAYPEM, RESERVED7, PEM07 );
            VALUES (liXX000, lcPEM, "", lcRESERVED7, VAL(SYS(2007,lcPEM)))
      ENDIF
      SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn
      SELECT (liSele)
   ENDPROC


   PROCEDURE FixClassInfo() && fix global class info (PEM) list
      LOCAL liRecno,liXX010,liXX000,lii,liCount,lcAlias,liS,liE,lcRow,lcPEM07,lcDISPLAYPEM,liRecnoX,llFoundICH,liPEM07
      lcAlias=SYS(2015)
      CREATE CURSOR (lcAlias) (XX000 I, PEM M, DISPLAYPEM M, PEM07 C(10), OVERRIDE I)

      SELECT (This.AClasses)
      SCAN FOR LEN(MEMBERDATA)>0
           liXX000=XX000
           liCount=OCCURS("/>",MEMBERDATA)
           FOR lii=1 TO liCount
               liS=AT("<memberdata",MEMBERDATA,lii)
               liE=AT("/>",MEMBERDATA,lii)
               lcRow=SUBSTR(MEMBERDATA,liS,liE-liS)
               IF ATC("display=",lcRow)>0
                  lcName=UPPER(PEM_GetXMLProperty(@lcRow,"name"))
                  INSERT INTO (lcAlias) ;
                      (XX000, PEM , DISPLAYPEM, PEM07 , OVERRIDE ) VALUES ;
                      (liXX000,lcName,PEM_GetXMLProperty(@lcRow,"display"), SYS(2007,lcName), IIF(PEM_GetXMLProperty(@lcRow,"override")=="True",1,0))
               ENDIF
           NEXT    
      ENDSCAN

      SELECT  (lcAlias)
      INDEX ON STR(XX000,11)+PEM07 TAG I01

      * set parent class ID AND MEMBERDATA 
      SELECT (This.AClasses)
      SCAN FOR LEN(PARENTCLASS)+LEN(PARENTLIB)>0
           liRecno=RECNO()
           lcPARENTCLASS=PARENTCLASS
           lcPARENTLIB=PARENTLIB
           LOCATE FOR FILE==lcPARENTLIB AND CLASS==lcPARENTCLASS
           liXX010=XX000
           GO (liRecno)
           IF FOUND()
              REPLACE XX010 WITH liXX010
           ENDIF
      ENDSCAN      

      * set class info PEM by MEMBERDATA class
      SET COLLATE TO "MACHINE" && Nastav tdn MACHINE
      SELECT (This.AClasses)
      SCAN ALL
           liXX000=XX000
           liXX010=XX010
           liRecno=RECNO()
           SELECT (This.AClassesPEM)
           =SEEK(BINTOC(liXX000))
           SCAN WHILE XX000=liXX000 FOR EMPTY(DISPLAYPEM)
           
                liRecnoX=RECNO()
                lcPEM07=PADR(SYS(2007,PEM),10)
                liPEM07=VAL(SYS(2007,UPPER(PEM)))

                * check if PEM exists in class hierarchy
                * if yes drop it
                llFoundICH=.F.
                DO WHILE NOT llFoundICH 
                   llFoundICH=SEEK(BINTOC(liXX010)+BINTOC(liPEM07),This.AClassesPEM)
                   IF llFoundICH OR NOT SEEK(liXX010,This.AClasses) OR EVALUATE(This.AClasses+".XX000")=-2000000002
                      EXIT
                   ENDIF   
                   liXX010=EVALUATE(This.AClasses+".XX010")
                ENDDO
                GO (liRecnoX)
                IF NOT llFoundICH
                   lcDISPLAYPEM=IIF(SEEK(STR(liXX000,11)+lcPEM07,lcAlias),EVALUATE(lcAlias+".DISPLAYPEM"),"")
                   REPLACE DISPLAYPEM WITH lcDISPLAYPEM
                ELSE
                   DELETE NEXT 1
                ENDIF   
           ENDSCAN

           SELECT (This.AClasses)
           GO (liRecno)
      ENDSCAN
      SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn

      
      USE IN (lcAlias)
   ENDPROC


   PROCEDURE GetClassPEMInfo(lcFILE, lcCLASS, lcPEM, loRam)
      LOCAL liXX000,liSele,liPEM07,llSeek
      lcFILE=UPPER(lcFILE)
      lcCLASS=UPPER(lcCLASS)
      liPEM07=VAL(SYS(2007,UPPER(lcPEM)))
      liSele=SELECT()
      loRam=.NULL.
      SET COLLATE TO "MACHINE" && Nastav tdn MACHINE
      SELECT (m.This.AClasses)
      LOCATE FOR FILE==lcFILE AND CLASS==lcCLASS
      IF NOT FOUND()
         =SEEK(-2000000001)
      ENDIF
      IF FOUND()
         liXX000=XX000
         llSeek=.F.
         DO WHILE NOT llSeek
            SELECT (m.This.AClassesPEM)
            llSeek=SEEK(BINTOC(liXX000)+BINTOC(liPEM07))
            IF llSeek
               IF !EMPTY(DISPLAYPEM)
                  SCATTER NAME loRam MEMO
                  EXIT
               ELSE
                  llSeek=.F.
               ENDIF   
            ENDIF
            SELECT (m.This.AClasses)
            liXX000=XX010
            IF NOT SEEK(liXX000)
               EXIT
            ENDIF   
         ENDDO   
      ENDIF
      SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn
      SELECT (liSele)
      RETURN loRam
   ENDPROC


   PROCEDURE AutoFillClassPEMInfo()
      LOCAL liCount,lii,liSele,liPEM07,lcRow,lcName,lcAlias
      LOCAL ARRAY laString(1) 
      liSele=SELECT()
      SET COLLATE TO "MACHINE" && Nastav tdn MACHINE
      liCount=This.ReadLocalizedStringEx(@laString,100000,129999)
      FOR lii=1 TO liCount STEP 2
          liPEM07=VAL(SYS(2007,UPPER(laString(lii,2))))
          IF NOT SEEK(BINTOC(-2000000001)+BINTOC(liPEM07))
             INSERT INTO (m.This.AClassesPEM) (XX000, PEM, DISPLAYPEM, RESERVED7, PEM07) VALUES;
                  (-2000000001,UPPER(laString(lii,2)),laString(lii,2),laString(lii+1,2),liPEM07)
          ELSE
             REPLACE RESERVED7 WITH laString(lii+1,2)
          ENDIF        
      NEXT
      
      SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn
      SELECT (liSele)
   ENDPROC


   PROCEDURE AddAnchor && Add anchor class from VCX/PRG
      * lcClassLoc - Directory and name library
      * lcClass    - Class name
      * lcMethod   - Method/procedure name
      * lcHTML     - Directory and name HTML file
      * lcAnchor   - Anchor of class in HTML file
      * liXX007    - File group - file, class, method, property
      LPARAMETERS m.lcClassLoc, m.lcClass, m.lcMethod, m.lcHTML, m.lcAnchor, m.liXX007, m.lcRESERVED7
      
      LOCAL m.lcXX006, m.llPFLAG
      m.lcHTML=LOWER(ExtractPathFromFile(m.lcHTML))+LOWER(ExtractFileFromFile(m.lcHTML))
      m.lcXX006=IIF(LEN(m.lcMethod)>0, m.lcMethod,IIF(LEN(m.lcClass)>0, m.lcClass, LOWER(ExtractFileFromFile(m.lcClassloc))))

*!*	      llPFLAG=IIF(liXX007=_PDM_FG_Property,;
*!*	                  IIF(poPDM.CreateAnchorsForAllProperties=2,This.CheckPropertyAnchor(@lcClassLoc,@lcClass,@lcMethod),;
*!*	                  IIF(poPDM.CreateAnchorsForAllProperties=1,.T.,.F.)),.T.)

      m.llPFLAG=IIF(m.liXX007=_PDM_FG_Property, poPDM.CreateAnchorsForAllProperties=1, .T.)
           
      INSERT INTO (m.This.Anchors) (CLASSLOC, CLASS, METHOD, BFILE, FILE, ANCHOR, XX007, XX006, PFLAG, XXGUID, XXI02, RESERVED7) ;
             VALUES  ;
             (m.lcClassLoc, m.lcClass, m.lcMethod, "", m.lcHTML, m.lcAnchor, m.liXX007,;
              IIF(RAT("!", m.lcXX006)>0,SUBST(m.lcXX006, RAT("!", m.lcXX006)+1), m.lcXX006),;
              m.llPFLAG,;
              SYS(2015)+"-"+SYS(2007, m.lcClassLoc+m.lcClass+m.lcMethod),;
              PADL(SYS(2007, UPPER(m.lcClassLoc)), 6)+PADL(SYS(2007 ,UPPER(m.lcClass)), 6)+PADL(SYS(2007, UPPER(m.lcMethod)), 6), m.lcRESERVED7)
              
   ENDPROC


   PROCEDURE CheckPropertyAnchor(lcClassLoc,lcClass,lcMethod) && Check property anchor
      * Check if property is allowed in DIAP plugin
      LOCAL loPIPar,lii,llPFLAG
      loPIPar=m.poPDM.oPIPar
      loPIPar.Reset()
      loPIPar.File=m.lcClassLoc
      loPIPar.cParent=m.lcClass
      loPIPar.cPEM=m.lcMethod
      loPIPar.Type="DIAP"
      loPIPar.FileGroup=_PDM_FG_Property

      FOR m.lii=1 TO m.poPDM.iDIAP
          llPFLAG=m.poPDM.aDIAP(m.lii,1).CheckPropertyFlag(@m.loPIPar,m.poPDM.aDIAP(m.lii,2))
      NEXT
      RETURN llPFLAG
   ENDPROC


   PROCEDURE _AddFile(lcFile,lcClass,lcPEM) && Add file to internaly list
      * lcFile  - Source File
      * lcClass - Class name
      * lcPEM   - Property, Method, Event
      LOCAL liXX000
      liXX000=m.This._GetFile(@m.lcFile,@m.lcClass,@m.lcPEM)
      IF m.liXX000=-2000000001
         liXX000=RECC(m.This.AFiles)+1
         INSERT INTO (m.This.AFiles) (XX000,FILE ,CLASS, PEM) ;
                VALUES  ;
                (liXX000,m.lcFile,m.lcClass, m.lcPEM)
      ENDIF
      RETURN liXX000
   ENDPROC

   PROCEDURE _GetFile(lcFile,lcClass,lcPEM) && Get file from internaly list
      * lcFile  - Source File
      * lcClass - Class name
      * lcPEM   - Property, Method, Event
      LOCAL liSele,liXX000
      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.AFiles)
*!*	*!*	      DO CASE
*!*	*!*	         CASE LEN(m.lcClass)> OR LEN(m.lcPEM)>
              LOCATE FOR UPPER(FILE)==UPPER(m.lcFile) AND UPPER(CLASS)==UPPER(m.lcClass) AND UPPER(PEM)==UPPER(m.lcPEM)

      liXX000=IIF(FOUND(),XX000,-2000000001)
      SELE (m.liSele)
      RETURN m.liXX000
   ENDPROC

   PROCEDURE _GetFileByID(liXX000,lcFile,lcClass,lcPEM) && Get file by ID
      * liXX000 - File's ID

      LOCAL llFind,liSele
      llFind=SEEK(STR(liXX000,11),m.This.AFiles)
      IF llFind
         liSele=SELE() && Zapamatuj si oblast
         SELE (m.This.AFiles)
         lcFile=FILE
         lcClass=CLASS
         lcPEM=PEM
         SELE (m.liSele)
      ENDIF
      RETURN m.llFind
   ENDPROC

   PROCEDURE AddCAnchor(lcFile,lcFile2,liXX020) && Add cross anchor
      * lcFile - Source File
      * lcFile2 - Destination File
      * liXX020 - Type of cross anchor

      LOCAL lcClass,lcPEM,li1,li2,liXX000,liXX000D
      STORE "" TO lcClass,lcPEM
      li1=ATC(CHR(0),m.lcFile,1)
      IF li1>0
         li2=ATC(CHR(0),m.lcFile,2)
         lcClass=SUBST(m.lcFile,m.li1+1,m.li2-m.li1-1)
         lcPEM=SUBST(m.lcFile,m.li2+1)
         lcFile=LEFT(m.lcFile,m.li1-1)
      ENDIF

      liXX000=This._AddFile(m.lcFile,m.lcClass,m.lcPEM)

      STORE "" TO lcClass,lcPEM
      li1=ATC(CHR(0),m.lcFile2,1)
      IF li1>0
         li2=ATC(CHR(0),m.lcFile2,2)
         lcClass=SUBST(m.lcFile2,m.li1+1,m.li2-m.li1-1)
         lcPEM=SUBST(m.lcFile2,m.li2+1)
         lcFile=LEFT(m.lcFile2,m.li1-1)
      ELSE
         lcFile=m.lcFile2
      ENDIF
      liXX000D=This._AddFile(m.lcFile,m.lcClass,m.lcPEM)

      IF !SEEK(STR(m.liXX000,11)+STR(m.liXX020,1)+STR(m.liXX000D,11),m.This.CAnchors)
         INSERT INTO (m.This.CAnchors) (XX000,XX000D,XX020) ;
                VALUES  ;
                (m.liXX000,m.liXX000D,m.liXX020)
      ENDIF
   ENDPROC

   PROCEDURE GetCAnchor(lcFileX,laFiles,lcRelativePath,liXX020) && Get cross anchors
      * lcFile         - Source File
      *@laFiles        - Output Array of cross files
      * lcRelativePath - Relative Path to Root output directory
      * liXX020        - Type of cross anchor

      LOCAL liSele,lcRet,liCount,lii,li1,li2,lcXX000,m.lcClass,m.lcPEM,liXX007,lcFile
      LOCAL ARRAY laFiles(1)

      lcFileX=UPPER(lcFileX)
      liCount=0

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.CAnchors) && Pak jej uzavi

      STORE "" TO m.lcClass,m.lcPEM 
      li1=ATC(CHR(0),m.lcFileX,1)
      IF li1>0
         li2=ATC(CHR(0),m.lcFileX,2)
         lcClass=SUBST(m.lcFileX,m.li1+1,m.li2-m.li1-1)
         lcPEM=SUBST(m.lcFileX,m.li2+1)
         lcFile=LEFT(m.lcFileX,m.li1-1)
      ELSE
         lcFile=m.lcFileX
      ENDIF

      lcXX000=STR(This._GetFile(m.lcFile,m.lcClass,m.lcPEM),11)+STR(m.liXX020,1)
      =SEEK(lcXX000)
      IF FOUND()
         * Read cross files and Convert cross files to anchors
         COUNT TO liCount WHILE STR(XX000,11)+STR(XX020,1)=lcXX000
         DIME laFiles(m.liCount,3)
         lii=0
         =SEEK(lcXX000)
         SCAN WHILE STR(XX000,11)+STR(XX020,1)=lcXX000
              lii=m.lii+1
              IF This._GetFileByID(EVAL(m.This.CAnchors+".XX000D"),@m.lcFile,@m.lcClass,@m.lcPEM)
                 DO CASE 
                    CASE LEN(m.lcClass)=0 AND LEN(m.lcPEM)=0
                         laFiles(m.lii,1)=m.This.GetAnchor(m.lcFile,m.lcRelativePath)
                         laFiles(m.lii,3)=_PDM_FG_Any
                         laFiles(m.lii,2)=m.lcFile

                    CASE LEN(m.lcClass)>0 AND LEN(m.lcPEM)=0
                         laFiles(m.lii,1)=m.This.GetClassAnchor(lcFile,lcClass,lcRelativePath)
                         laFiles(m.lii,3)=_PDM_FG_Class
                         laFiles(m.lii,2)=m.lcFile+CHR(0)+m.lcClass+CHR(0)

                    OTHERWISE
                         laFiles(m.lii,1)=m.This.GetMPAnchor(m.lcFile,m.lcClass,m.lcPEM,m.lcRelativePath,@m.liXX007)
                         laFiles(m.lii,3)=m.liXX007
                         laFiles(m.lii,2)=m.lcFile+CHR(0)+m.lcClass+CHR(0)+m.lcPEM

                 ENDCASE
              ENDIF
         ENDSCAN
      ENDIF

      SELE (liSele) && Sko na pvodn oblast
      RETURN liCount
   ENDPROC


   PROCEDURE GetClassAnchor(lcFile,lcClass,lcRelativePath,lcGUID) && Return anchor for class from VCX/PRG
      * lcFile         - Directory and name VCX library
      * lcClass        - Class name
      * lcRelativePath - Relative Path to Root output directory
      *@lcGUID         - Universal GUID
      LOCAL liSele,lcRet
      lcFile=UPPER(lcFile)
      lcClass=UPPER(lcClass)

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors)
      SET ORDER TO "I02"
      SET KEY TO (PADL(SYS(2007,UPPER(lcFile)),6)+PADL(SYS(2007,UPPER(lcClass)),6))
      LOCATE FOR UPPER(CLASSLOC)==lcFile AND UPPER(CLASS)==lcClass AND LEN(METHOD)=0
      * Pokud to nael
      lcRet=IIF(FOUND(),STRTRAN(IIF(BFILE="\\" OR SUBS(BFILE,2,2)=":\","",lcRelativePath)+BFILE+FILE+IIF(LEN(lcClass)>0,"#"+ANCHOR,''),"\","/"),'')
      lcGUID=ALLTRIM(XXGUID)
      SET KEY TO
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN lcRet && Vra pznak, zda vtu nael
   ENDPROC

   PROCEDURE GetAnchor(lcFile,lcRelativePath) && Return Anchor for file
      * lcFile         - Directory and name file
      * lcRelativePath - Relative Path to Root output directory
      LOCAL liSele,lcRet
      lcFile=UPPER(lcFile)

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors)
      SET ORDER TO "I02"
      SET KEY TO (PADL(SYS(2007,UPPER(lcFile)),6))
      LOCATE FOR UPPER(CLASSLOC)==lcFile AND LEN(CLASS)=0 AND LEN(METHOD)=0
      * Pokud to nael
      lcRet=IIF(FOUND(),STRTRAN(IIF(BFILE="\\" OR SUBS(BFILE,2,2)=":\","",lcRelativePath)+BFILE+FILE+IIF(ANCHOR=='','',"#"+ANCHOR),"\","/"),'')
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN lcRet && Vra kotvu
   ENDPROC

   PROCEDURE GetAnchors(paAnchors,lcFile,lcRelativePath) && Return Anchors for file
      *@paAnchors      - Array of Classes anchors
      * lcFile         - [Directory] and name file
      * lcRelativePath - Relative Path to Root output directory
      LOCAL liSele,lcRet,llSF
      lcFile=UPPER(lcFile)

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors)
      SET ORDER TO "I02"
      SET KEY TO (PADL(SYS(2007,UPPER(lcFile)),6))
      COUNT TO liCount FOR LEN(CLASS)=0 AND LEN(METHOD)=0 AND UPPER(CLASSLOC)==lcFile
      IF liCount=0
         SET KEY TO
         COUNT TO liCount FOR LEN(CLASS)=0 AND LEN(METHOD)=0 AND UPPER(ExtractFileFromFile(CLASSLOC))==lcFile
         llSF=.T.
      ENDIF
      
      IF liCount>0
         DIME paAnchors(liCount,4)
         IF llSF
            LOCATE FOR LEN(CLASS)=0 AND LEN(METHOD)=0 AND UPPER(ExtractFileFromFile(CLASSLOC))==lcFile
         ELSE
            LOCATE FOR LEN(CLASS)=0 AND LEN(METHOD)=0 AND UPPER(CLASSLOC)==lcFile
         ENDIF
         FOR lii=1 TO liCount
             paAnchors(lii,1)=STRTRAN(IIF(BFILE="\\" OR SUBS(BFILE,2,2)=":\","",lcRelativePath)+BFILE+FILE+IIF(ANCHOR=='','',"#"+ANCHOR),"\","/")
             STORE "" TO paAnchors(lii,2),paAnchors(lii,3)
             paAnchors(lii,4)=XX007
             CONTINUE
         NEXT
      ENDIF
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN liCount && Vra poet
   ENDPROC


   PROCEDURE GetAnchorObj(lcFile,lcClass,lcMethod) && Return anchor object method class or procedure
      * lcFile         - Directory and name VCX library/PRG file
      * lcClass        - Class name
      * lcMethod       - Method or procedure name or property
      LOCAL liSele,lcRet,llFound,loRam
      lcFile=UPPER(lcFile)
      lcClass=UPPER(lcClass)
      lcMethod=UPPER(lcMethod)
      loRam=.NULL. 
      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors) 
      SET ORDER TO "I02"
      SET KEY TO (PADL(SYS(2007,UPPER(lcFile)),6)+PADL(SYS(2007,UPPER(lcClass)),6)+PADL(SYS(2007,UPPER(lcMethod)),6))
      LOCATE FOR UPPER(CLASSLOC)==lcFile AND UPPER(CLASS)==lcClass AND UPPER(METHOD)==lcMethod AND PFLAG
      * Pokud to nael
      IF FOUND()
         SCATTER NAME loRam MEMO
      ENDIF   
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN loRam && Vra Ram objekt
   ENDPROC

   PROCEDURE GetMPAnchor(lcFile,lcClass,lcMethod,lcRelativePath,liXX007) && Return anchor for method class or procedure
      * lcFile         - Directory and name VCX library/PRG file
      * lcClass        - Class name
      * lcMethod       - Method or procedure name
      * lcRelativePath - Relative Path to Root output directory
      *@liXX007        - Type of Anchor
      LOCAL liSele,lcRet,llFound
      lcFile=UPPER(lcFile)
      lcClass=UPPER(lcClass)
      lcMethod=UPPER(lcMethod)

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors) 
      SET ORDER TO "I02"
      SET KEY TO (PADL(SYS(2007,UPPER(lcFile)),6)+PADL(SYS(2007,UPPER(lcClass)),6)+PADL(SYS(2007,UPPER(lcMethod)),6))
      LOCATE FOR UPPER(CLASSLOC)==lcFile AND UPPER(CLASS)==lcClass AND UPPER(METHOD)==lcMethod AND PFLAG
      * Pokud to nael
      lcRet=IIF(FOUND(),STRTRAN(IIF(BFILE="\\" OR SUBS(BFILE,2,2)=":\","",lcRelativePath)+BFILE+FILE+IIF(LEN(ANCHOR)>0,"#"+ANCHOR,""),"\","/"),'')
      liXX007=XX007
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN lcRet && Vra pznak, zda vtu nael
   ENDPROC

   PROCEDURE GetClassAnchors(paAnchors,lcClass,lcRelativePath) && Return anchor for class from VCX/PRG
      *@paAnchors      - Array of Classes anchors
      * lcClass        - Class name
      * lcRelativePath - Relative Path to Root output directory
      LOCAL liSele,lcRet,liCount,lii
      lcClass=UPPER(lcClass)

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors) && Pak jej uzavi
      SET ORDER TO "I03"
      SET KEY TO (PADL(SYS(2007,UPPER(lcClass)),6))

      COUNT TO liCount FOR UPPER(CLASS)==lcClass AND LEN(METHOD)=0
      
      IF liCount>0
         DIME paAnchors(liCount,4)
         LOCATE FOR UPPER(CLASS)==lcClass AND LEN(METHOD)=0
         FOR lii=1 TO liCount
             paAnchors(lii,1)=STRTRAN(IIF(BFILE="\\" OR SUBS(BFILE,2,2)=":\","",lcRelativePath)+BFILE+FILE+IIF(LEN(lcClass)>0,"#"+ANCHOR,''),"\","/")
             paAnchors(lii,2)=CLASSLOC
             paAnchors(lii,3)=CLASS
             paAnchors(lii,4)=XX007
             CONTINUE
         NEXT
      ENDIF
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN liCount && Vra pznak, zda vtu nael
   ENDPROC


   PROCEDURE GetMPAnchors(paAnchors,lcClass,lcMethod,lcRelativePath) && Return anchor for method class or procedure
      *@paAnchors      - Array of Classes anchors
      * lcClass        - Class name
      * lcMethod       - Method or procedure name
      * lcRelativePath - Relative Path to Root output directory
      LOCAL liSele,lcRet,liCount,lii
      lcClass=UPPER(lcClass)
      lcMethod=UPPER(lcMethod)

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors)

      IF LEN(lcClass)=0
         SET ORDER TO "I04"
         SET KEY TO (PADL(SYS(2007,UPPER(lcMethod)),6))
         COUNT TO liCount FOR UPPER(METHOD)==lcMethod AND PFLAG
      ELSE
         SET ORDER TO "I03"
         SET KEY TO (PADL(SYS(2007,UPPER(lcClass)),6))
         COUNT TO liCount FOR UPPER(CLASS)==lcClass AND UPPER(METHOD)==lcMethod AND PFLAG
      ENDIF

      IF liCount>0
         DIME paAnchors(liCount,4)
         LOCATE FOR IIF(LEN(lcClass)=0,.T.,UPPER(CLASS)==lcClass) AND UPPER(METHOD)==lcMethod AND PFLAG
         FOR lii=1 TO liCount
             paAnchors(lii,1)=STRTRAN(IIF(BFILE="\\" OR SUBS(BFILE,2,2)=":\","",lcRelativePath)+BFILE+FILE++IIF(LEN(lcClass)>0,"#"+ANCHOR,''),"\","/")
             paAnchors(lii,2)=CLASSLOC
             paAnchors(lii,3)=CLASS
             paAnchors(lii,4)=XX007
             CONTINUE
         NEXT
      ENDIF
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN liCount && Vra pznak, zda vtu nael
   ENDPROC

   PROCEDURE IsFileHasAnchor(lcFile) && Return if file has anchor
      * lcFile - Directory and name file
      LOCAL liSele,llRet
      lcFile=UPPER(lcFile)

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors) && Pak jej uzavi
      SET ORDER TO "I02"
      SET KEY TO (PADL(SYS(2007,UPPER(lcFile)),6))
      LOCATE FOR UPPER(CLASSLOC)==lcFile
      * Pokud to nael
      llRet=FOUND()
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN llRet && Vra pznak, zda vtu nael
   ENDPROC

   PROCEDURE SetAnchorsDefault() && 
      LOCAL liSele
      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors)
      REPL BFILE WITH "" ALL
      SELE (m.This.AnchorsCSS)
      REPL BFILE WITH "" ALL
      SELE (liSele) && Sko na pvodn oblast
   ENDPROC

   PROCEDURE SetAnchors(lcPath,louList) &&
      * lcPath  - Directory and name file
      * louList - Universal file list
      LOCAL liSele,lii
      liSele=SELE() && Zapamatuj si oblast

      SELE (m.This.Anchors) && Anchors - files, classes, PEM
      SET ORDER TO "I02"
      FOR lii=1 TO louList.Count
          SET KEY TO (PADL(SYS(2007,UPPER(louList.aList(lii))),6))
          REPL BFILE WITH lcPath
      NEXT
      SET ORDER TO "I01"

      SELE (m.This.AnchorsCSS) && CSS anchors
      FOR lii=1 TO louList.Count
          REPL BFILE WITH lcPath FOR CLASSLOC==louList.aList(lii)
      NEXT
      SELE (liSele) && Sko na pvodn oblast
   ENDPROC


   PROCEDURE EnablePAnchor(lcFile,lcClass,lcPEM) && Enable property anchor
      * lcFile  - Directory and name VCX library/PRG file
      * lcClass - Class name
      * lcProp  - Property name

      LOCAL liSele
      lcFile=UPPER(lcFile)
      lcClass=UPPER(lcClass)
      lcPEM=UPPER(lcPEM)

      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors) && Pak jej uzavi
      SET ORDER TO "I02"
      SET KEY TO (PADL(SYS(2007,UPPER(lcFile)),6)+PADL(SYS(2007,UPPER(lcClass)),6)+PADL(SYS(2007,UPPER(lcPEM)),6))
      LOCATE FOR UPPER(CLASSLOC)==lcFile AND UPPER(CLASS)==lcClass AND UPPER(METHOD)==lcPEM 
      IF FOUND()
         REPL PFLAG WITH .T.
      ENDIF
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN .T. && Vra pznak, zda vtu nael
   ENDPROC

   PROCEDURE EnablePAnchors(laProperties) && Enable property anchor for more properties
      * laProperties - Array for property anchors
      * laProperties[x,1] - Directory and name VCX library/PRG file
      * laProperties[x,2] - Class name
      * laProperties[x,3] - Property name
      EXTERNAL ARRAY LAPROPERTIES
      LOCAL liSele,lii
      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.Anchors) && Pak jej uzavi
      SET ORDER TO "I02"

      FOR lii=1 TO ALEN(laProperties,1)
          lcFile=UPPER(laProperties(lii,1))
          lcClass=UPPER(laProperties(lii,2))
          lcPEM=UPPER(laProperties(lii,3))

          SET KEY TO (PADL(SYS(2007,UPPER(lcFile)),6)+PADL(SYS(2007,UPPER(lcClass)),6)+PADL(SYS(2007,UPPER(lcPEM)),6))
          LOCATE FOR UPPER(CLASSLOC)==lcFile AND UPPER(CLASS)==lcClass AND UPPER(METHOD)==lcPEM 
          IF FOUND()
             REPL PFLAG WITH .T.
          ENDIF
      NEXT 
      SET ORDER TO "I01"
      SELE (liSele) && Sko na pvodn oblast
      RETURN .T. && Vra pznak, zda vtu nael
   ENDPROC


   PROCEDURE AddCSSAnchor(lcClassLoc,lcClass,lcPClassLoc,lcPClass,lcCSS) && Add CSS anchor class
      * lcClassLoc  - Directory and name library
      * lcClass     - Class name
      * lcPClassLoc - Directory and name library parent class
      * lcPClass    - Parent Class name
      * lcCSS       - Directory and name CSS file
      LOCAL lcHTML
      lcHTML=LOWER(ExtractPathFromFile(lcHTML))+ExtractFileFromFile(lcHTML)
      INSERT INTO (m.This.AnchorsCSS) (CLASSLOC,CLASS,FILE,PCLASSLOC,PCLASS,XX000) ;
             VALUES  ;
             (UPPER(lcClassLoc),UPPER(lcClass),UPPER(lcPClassLoc),UPPER(lcPClass),lcCSS,.NULL.)
   ENDPROC

   PROCEDURE GetCSSAnchor(lcClassLoc,lcClass,lcClasses,lcCSSes,lcRelativePath) && Return  CSS' anchor class
      * lcClassLoc  - Directory and name library
      * lcClass     - Class name
      *@lcClasses   - List of CSS classes
      *@lcCSSes     - List of CSS files
      * lcRelativePath - Relative Path to Root output directory

      LOCAL liSele,liXX000,liRecno
      liSele=SELE() && Zapamatuj si oblast
      SELE (m.This.AnchorsCSS)
      STORE "" TO lcCSSes,lcClasses

      LOCATE FOR CLASSLOC==UPPER(lcClassLoc) AND CLASS==UPPER(lcClass)
      IF FOUND()
         lcCSSes=STRTRAN(IIF(BFILE="\\" OR SUBS(BFILE,2,2)=":\","",lcRelativePath)+BFILE+FILE,"\","/")+CRLF
         lcClasses=STRTRAN("cls."+LOWER(CLASS)+" ",".","_")
         
         lcClassLoc=UPPER(PCLASSLOC)
         lcClass=UPPER(PCLASS)
         liXX000=XX000
      ENDIF
      
      DO WHILE LEN(lcClassloc)>0
         IF ISNULL(liXX000)
            liRecno=RECNO()
            LOCATE FOR CLASSLOC==lcClassLoc AND CLASS==lcClass
            IF !FOUND()
               EXIT
            ENDIF
            liXX000=RECNO()
            GO (liRecno)
            REPL XX000 WITH liRecno
            GO (liXX000)
         ELSE
            GO (liXX000)
            liXX000=XX000
         ENDIF

         lcCSSes=lcCSSes+STRTRAN(IIF(BFILE="\\" OR SUBS(BFILE,2,2)=":\","",lcRelativePath)+BFILE+FILE,"\","/")+CRLF
         lcClasses=lcClasses+STRTRAN("cls."+LOWER(CLASS)+" ",".","_")
         
         lcClassLoc=UPPER(PCLASSLOC)
         lcClass=UPPER(PCLASS)
      ENDDO

      SELE (liSele) && Sko na pvodn oblast
   ENDPROC


   PROCEDURE FixedPrompt(lcPrompt) && Fix prompt pad/popup/bar or caption
      * lcPrompt - prompt pad/popup/bar
      LOCAL lii
      lii=AT("\<",lcPrompt)
      RETURN IIF(lii=0,StrTranHTMLString(lcPrompt),;
             LEFT(lcPrompt,lii-1)+'<span class="HotKey">'+SUBS(lcPrompt,lii+2,1)+'</span>'+SUBS(lcPrompt,lii+3))
   ENDPROC

   PROCEDURE AScan(lcText,laArray) && Najde text v matici
      * lcText  - Hledan text
      *@laArray - Matice pedan odkazem
      LOCAL lcExact,lii

      lcExact=SET("EXACT") && Pvodn nastaven SET EXACT
      SET EXACT ON && Nastav ON na pln porovnn
      lii=ASCAN(laArray,lcText) && Najdi text
      SET EXACT &lcExact.
      RETURN IIF(lii>0,ASUBS(laArray,lii,1),0)
   ENDPROC

   PROCEDURE GenerateFromPDM(lcPDM,lcSource,lcOutDir,liSeverally) && Generate HTML doc for project
      * lcPDM       - Path and name PDM file or files
      * lcSource    - Path and name PJX file or list of files
      * lcOutDir    - Out Dir HTML Doc
      * liSeverally - Pznak generovn HTML doc. pro kad soubor zvl᚝
      LOCAL loPDM,liRet,llFiles,lii,liCount,liy,liz,lcFile,lix
      loPDM=m.This.AddPDM("Native") && Add first PDM object
      =IIF(!EMPTY(lcPDM),m.loPDM.Open(lcPDM),.T.) && Open PDM file and read sets
      liRet=_PDM_OK
      IF EMPTY(lcSource) && Zdroj nen definovn

      ELSE
         * je definovn zdroj
         llFiles=OCCURS(',',lcSource)>0 OR !EMPTY(lcSource) AND !UPPER(ExtractExtensionFromFile(lcSource))=="PJX"
         IF llFiles && Nov zdroj je seznam soubor
            lcSource=ALLT(lcSource)
            lcSource=lcSource+IIF(RIGHT(lcSource,1)=',','',',')
            STORE OCCURS(',',lcSource) TO liCount && Count of item

            IF lcSource#","
               loPDM.SourceType=_PDM_ST_OMFiles
               * Nati seznam soubor ze seznamu

               liy=1
               lix=0
               FOR lii=1 TO liCount
                   liz=AT(',',lcSource,lii)
                   lcFile=ALLT(SUBST(lcSource,liy,liz-liy))
                   IF !EMPTY(lcFile)
                      lix=lix+1
                      DIME m.loPDM.OMFiles.aList(lix,2)
                      loPDM.OMFiles.aList(lix,2)=m.This.CheckFileName(lcFile)
                      loPDM.OMFiles.aList(lix,1)=UPPER(m.loPDM.OMFiles.aList(lix,1))
                   ENDIF
                  liy=liz+1
               NEXT
               loPDM.OMFiles.Count=lix
            ENDIF

            IF PCOUNT()=4 AND TYPE("liSeverally")="N"
               loPDM.Severally=IIF(liSeverally=0,0,1)
            ENDIF
         ELSE
            IF loPDM.SourceType=_PDM_ST_OMFiles && IF PDM as One or more files
               liRet=_PDM_IsOMFiles  && Then jump out
            ENDIF
            IF liRet=_PDM_OK AND !EMPTY(lcSource)
               loPDM.PJXFile=lcSource
            ENDIF
         ENDIF
      ENDIF

      IF liRet=_PDM_OK
         IF !EMPTY(lcOutDir)
            loPDM.OutDir=lcOutDir
         ENDIF
         liRet=m.This.WorkPJXs()
      ENDIF
      This.iPDMs=0
      This.aPDMs(1,1)=""
      This.aPDMs(1,2)=.NULL.
      RETURN liRet
   ENDPROC



   PROCEDURE GenerateFromPJX(lcPDM,lcProject,lcOutDir) && Generate HTML doc for project
      * lcPDM     - Path and name PDM file or files
      * lcProject - Path and name PJX file
      * lcOutDir  - Out Dir HTML Doc
      LOCAL loPDM,liRet
      loPDM=m.This.AddPDM("Native") && Add first PDM object
      =IIF(!EMPTY(lcPDM),m.loPDM.Open(lcPDM),.T.) && Open PDM file and read sets
      IF m.loPDM.SourceType=_PDM_ST_OMFiles && IF PDM as One or more files
         RETURN _PDM_IsOMFiles  && Then jump out
      ENDIF

      IF !EMPTY(lcProject)
         loPDM.PJXFile=lcProject
      ENDIF
      IF !EMPTY(lcOutDir)
         loPDM.OutDir=lcOutDir
      ENDIF
      liRet=m.This.WorkPJXs()
      This.iPDMs=0
      This.aPDMs(1,1)=""
      This.aPDMs(1,2)=.NULL.
      RETURN liRet
   ENDPROC

   PROCEDURE GenerateFromPDMs(lcPDMs) && Generate HTML doc for pdm files
      * lcPDMs - List of PDM files
      LOCAL liRet
      This.AddPDMs(lcPDMs)
      liRet=m.This.WorkPJXs()
      This.iPDMs=0
      DIME This.aPDMs(1,2)
      This.aPDMs(1,1)=""
      This.aPDMs(1,2)=.NULL.
      RETURN liRet
   ENDPROC

   PROCEDURE GenerateFromFiles(lcPDM,lcFiles,lcOutDir,liSeverally) && Generate HTML doc for one or more files
      * lcPDM       - Path and name PDM file or files
      * lcFiles     - List of files
      * lcOutDir    - Out Dir HTML Doc
      * liSeverally - Pznak generovn HTML doc. pro kad soubor zvl᚝
      LOCAL loPDM,lii,liCount,liy,liz,lcFile,lix,liRet

      loPDM=m.This.AddPDM("Native") && Add first PDM object
      =IIF(!EMPTY(lcPDM),m.loPDM.Open(lcPDM),.T.) && Open PDM file and read sets

      lcFiles=ALLT(lcFiles)
      lcFiles=lcFiles+IIF(RIGHT(lcFiles,1)=',','',',')
      STORE OCCURS(',',lcFiles) TO liCount && Count of item

      IF lcFiles#","
         loPDM.SourceType=_PDM_ST_OMFiles
         * Nati seznam soubor ze seznamu

         liy=1
         lix=0
         FOR lii=1 TO liCount
             liz=AT(',',lcFiles,lii)
             lcFile=ALLT(SUBST(lcFiles,liy,liz-liy))
             IF !EMPTY(lcFile)
                lix=lix+1
                DIME m.loPDM.OMFiles.aList(lix,2)
                loPDM.OMFiles.aList(lix,2)=m.This.CheckFileName(lcFile)
                loPDM.OMFiles.aList(lix,1)=UPPER(m.loPDM.OMFiles.aList(lix,1))
             ENDIF
             liy=liz+1
         NEXT
         loPDM.OMFiles.Count=liz
      ENDIF
      IF !EMPTY(lcOutDir)
         loPDM.OutDir=lcOutDir
      ENDIF
      IF PCOUNT()=4 AND TYPE("liSeverally")="N"
         loPDM.Severally=IIF(liSeverally=0,0,1)
      ENDIF

      liRet=m.This.WorkPJXs()

      This.iPDMs=0
      This.aPDMs(1,1)=""
      This.aPDMs(1,2)=.NULL.

      RETURN liRet
   ENDPROC

   PROCEDURE CheckFileName(lcFile) && Oprav pponu souboru
      * lcFile - 
      LOCAL lcExt
      lcExt=ExtractExtensionFromFile(lcFile)

      RETURN IIF(lcExt="FXP",ChangeExtensionFromFile(lcFile,"PRG"),;
             IIF(lcExt="SPX",ChangeExtensionFromFile(lcFile,"SPR"),;
             IIF(lcExt="MPX",ChangeExtensionFromFile(lcFile,"MPR"),;
             IIF(lcExt="SCT",ChangeExtensionFromFile(lcFile,"SCX"),;
             IIF(lcExt="VCT",ChangeExtensionFromFile(lcFile,"VCX"),;
             IIF(lcExt="CDX",ChangeExtensionFromFile(lcFile,"DBF"),;
             IIF(lcExt="FPT",ChangeExtensionFromFile(lcFile,"DBF"),;
             IIF(lcExt="MNT",ChangeExtensionFromFile(lcFile,"MNX"),;
             IIF(lcExt="FRT",ChangeExtensionFromFile(lcFile,"FRX"),;
             IIF(lcExt="LBT",ChangeExtensionFromFile(lcFile,"LBX"),;
             IIF(lcExt="DCT",ChangeExtensionFromFile(lcFile,"DBC"),;
             IIF(lcExt="DCX",ChangeExtensionFromFile(lcFile,"DBC"),;
             IIF(lcExt="QPX",ChangeExtensionFromFile(lcFile,"QPR"),lcFile)))))))))))))

   ENDPROC
   
   PROCEDURE ParseFile(lcFile) && Vyseparuje nzev souboru zsti dky pkazovho kdu
      LOCAL lii,lcFileX

      * hledej (
      *  if ne, asi makro 
      *    hledej makro
      *      if ne, nzev soboru
      *      else, 
      *        hledej teku, za tekou nzev souboru

      *  if ano, nepmy vraz
      *    hledej ",',[
      *      if ne, then unknown
      *      else soubor

      * if found
      *  odfilruj sloky

      IF LEFT(m.lcFile,1)="(" && nepm vraz
         *(lcPath+"CryptPak.vcx")
         * Najd prvn ")" a mezi nima je soubor
         lii=AT(m.lcFile,")")
         lcFileX=SUBST(m.lcFile,2,lii-2) && Zbaveno zvorek

         * a te z toho vymla nzev souboru
         * patrn tam bude znamnko + 
         *lcPath+"CryptPak.vcx"

         lcFileX="" && V tto chvli nelze nzev souboru vypreparovat
      ELSE
         * test na makro
         lii=AT("&",m.lcFile)
         IF lii>0 && Je tam makro, najdi teku a ve za n je nzev souboru
            lii=AT(".",m.lcFile)
            m.lcFileX=IIF(lii=0 OR lii=LEN(m.lcFile),"",SUBST(m.lcFile,lii+1))
         ELSE
            m.lcFileX=m.lcFile
         ENDIF
      ENDIF

      * odstra sloku(y)
      lii=RAT("/",m.lcFileX)
      RETURN IIF(lii>0,SUBS(lcFileX,lii+1),m.lcFileX)
   ENDPROC


   PROCEDURE SizeToS(liSize) && Pevede velikost souboru na text
      RETURN IIF(liSize<1024,LTRIM(STR(liSize,4))+"&nbsp;B",;
             IIF(BETWEEN(liSize,1024,1024^2-1),LTRIM(STR(liSize/1024,10,4))+"&nbsp;KB",;
             IIF(BETWEEN(liSize,1024^2,1024^3-1),LTRIM(STR(liSize/(1024^2),10,4))+"&nbsp;MB",;
             IIF(BETWEEN(liSize,1024^3,1024^4-1),LTRIM(STR(liSize/(1024^3),10,4))+"&nbsp;GB",;
             IIF(BETWEEN(liSize,1024^4,1024^5-1),LTRIM(STR(liSize/(1024^4),10,4))+"&nbsp;TB",;
             IIF(BETWEEN(liSize,1024^5,1024^6-1),LTRIM(STR(liSize/(1024^5),10,4))+"&nbsp;KTB",;
                LTRIM(STR(liSize,20))+"&nbsp;B"))))))
   ENDPROC


   PROCEDURE Mkd(lcPath) && Create folder if not exist
      * lcPath -  cesta
      LOCAL lcPom,lcDriveRoot,lii,lcErr,liErr,luCatch
      lcPath=ALLT("&lcPath") && preventivn odstra makra

      IF DIRECTORY(m.lcPath) && pokud dan cesta existuje
         RETURN 1 && pak se vra 
      ENDIF

      * patrn nejde o UNC nebo DOS cestu s diskem
      IF !(LEFT(m.lcPath,2)="\\" OR SUBS(m.lcPath,2,1)=":")
         lcPom=ALLTRIM(SET("PATH")) && vra nastaven PATH a oe mezery
         IF LEFT(m.lcPath,1)="\" && jde o cestu z rootu, pak musm pidat jen disk (server+sdlen disk)
            IF LEFT(m.lcPom,2)="\\" && jde o UNC cestu
               lii=AT("\",m.lcPom,4) && najdi 4. oddlova
               IF lii>0 && pokud tam je
                  lcPom=LEFT(m.lcPom,m.lii-1) && pak nati cestu bez oddlovae
               ENDIF
             ELSE
               * jinak jde o DOS cestu
               lcPom=LEFT(m.lcPom,2)
             ENDIF
         ELSE
            IF RIGHT(m.lcPom,1)#"\" && pokud na konci nen oddlova
               lcPom=m.lcPom+"\" && pak ho tam pidej
            ENDIF
         ENDIF
         lcPath=m.lcPom+m.lcPath && seti novou cestu
      ENDIF

      IF LEFT(m.lcPath,2)#"\\" && pokud to je DOS cesta
         lcDriveRoot=LEFT(m.lcPath,2)+"\" && vem si disk
         IF INLIST(GetDriveType(m.lcDriveRoot+CHR(0)),0,5) && Disk neexistuje, nebo je to CD-ROM
            RETURN 4  && vra se
         ENDIF
      ENDIF

      luCatch=m.This.SetCatch(.T.)
      MD (m.lcPath) && zalo cestu
      =m.This.SetCatch(luCatch)

      * pokud nen chyba, pak vra 0
      * pstup zamtnut
      * invalid path or name
      RETURN IIF(m.This.nErr=0,0,;
             IIF(m.This.nErr=1705,2,;
             IIF(m.This.nErr=202,3,3)))  && vra pznak chyb
   ENDPROC

   PROCEDURE GetXX007ToAlt(liXX007,lcText) && Return tooltip for type of anchor
     RETURN IIF(m.liXX007=_PDM_FG_Any,STRTRAN(m.This.aStrings(PDM_05049),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_VCX,STRTRAN(m.This.aStrings(PDM_05113),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_SCX,STRTRAN(m.This.aStrings(PDM_05160),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_DBC,STRTRAN(m.This.aStrings(PDM_05161),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_DBF,STRTRAN(m.This.aStrings(PDM_05167),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_QPR,STRTRAN(m.This.aStrings(PDM_05157),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_View,STRTRAN(m.This.aStrings(PDM_05168),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_PRG,STRTRAN(m.This.aStrings(PDM_05162),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_MNX,STRTRAN(m.This.aStrings(PDM_05163),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_FRX,STRTRAN(m.This.aStrings(PDM_05164),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_LBX,STRTRAN(m.This.aStrings(PDM_05165),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_IMG,STRTRAN(m.This.aStrings(PDM_05239),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_Class,STRTRAN(m.This.aStrings(PDM_02799),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_Method,STRTRAN(m.This.aStrings(PDM_04726),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_Property,STRTRAN(m.This.aStrings(PDM_04653),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_HPP,STRTRAN(m.This.aStrings(PDM_05166),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_Conn,STRTRAN(m.This.aStrings(PDM_05169),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_Proced,STRTRAN(m.This.aStrings(PDM_05158),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_Object,STRTRAN(m.This.aStrings(PDM_02800),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_SP,STRTRAN(m.This.aStrings(PDM_05158),"%name%",m.lcText),;
             IIF(m.liXX007=_PDM_FG_FLL,STRTRAN(m.This.aStrings(PDM_05257),"%name%",m.lcText),"")))))))))))))))))))))

   ENDPROC


   PROCEDURE GenerateBackReferenceHTML(m.lcFile,m.lcClass,m.lcPEM,lcDir) && Generate Back Reference HTML
      LOCAL lii,liCount,lcHTML,li1,li2,lcPom
      LOCAL ARRAY laSO(1)
      liCount=m.This.GetCAnchor(m.lcFile+CHR(0)+m.lcClass+CHR(0)+m.lcPEM,@laSO,lcDir,_PDM_CA_BackReference)
      lcHTML=""
      FOR lii=1 TO m.liCount
          li1=ATC(CHR(0),laSO(m.lii,2),1)
          li2=ATC(CHR(0),laSO(m.lii,2),2)
          lcPom=SUBST(laSO(m.lii,2),li1+1,li2-li1-1)
          lcPom=lcPom+IIF(EMPTY(lcPom),"",".")+SUBST(laSO(m.lii,2),li2+1)+IIF(INLIST(laSO(m.lii,3),_PDM_FG_Method,_PDM_FG_Proced),"()","")

          lcHTML=m.lcHTML+;
                 [<a href="]+laSO(m.lii,1)+[" target="_top" title="]+m.This.GetXX007ToAlt(laSO(m.lii,3),lcPom)+[">]+m.lcPom+[</a>]+IIF(m.lii<m.liCount,[ | ],"")+m.poPDM.aSpace(21)
 
      NEXT
      RETURN IIF(m.liCount=0,"",;
                 '<div class="diaxp_backrefer">'+;
                 [<span>]+m.This.aStrings(PDM_01304)+[</span>]+m.lcHTML+[</div>]+m.poPDM.aSpace(21))
  ENDPROC

ENDDEFINE


******************************************
** Definice tdy _PDM
DEFINE CLASS _pdm AS _pdm_Session
   Name="_pdm"

   FileVersion="0.0.0" && File version

   _Name="" && Inner Name

   PDM_File="" && Umstn a nzev PDM souboru
   PDM_Alias="" && Alias vytvoenho kurzoru
   Collate=""
   hPrintList=0 && Handle open file for save file name for later print
   PJX_Opened=.F. && Flag is open PJX file
   Simple=.F. && Flag simple PDM project (without friendly projects)
   FL="" && Alias File list for later processing
   ClearOutDir=0 && Flag if before generation HTML doc is clear output direcotory (files,folders)

   ErrStopCount=-1 && Poet nalezench chyb pi kterm se zastav generovn HTML strnek
   NP_ExcludeFiles=0 && Pznak, zda se myj EXCLUDE soubory vynechat pi zpracovn
   GL_NonGenPage=0 && Pznak, zda se maj generovat i odkazy na negenerovan strnky
   ExpandAllPM=_EPM_User && Pznak, zda se m vygenerovat obsah procedur a metod rozbalen
   Incremental = 0 && Flag incremental generation HTML doc


   SyntaxColoring=1 && Pznak SyntaxColoring
   SCIndent=0 && Show indent on row
   SCCounter=0 && Show row's number

   HTMLS = "" && Folder and name of DBF with HTML strings.
              * If Empty, then PDM use tables's HTML strings from folder lang/[lng]
              * If not define disk or server, then folder is relative to PDM root folder

   IncludeSC=_ESC_Include && 
   IncludeSC_S="" && 

   IncludeDD=_EDD_Include && 
   IncludeDD_S="" && 
   DD_START="" && 
   DD_STOP="" && 
   OnlyComment=_DD_OC_Yes

   AutoPrint=_AP_No && Pznak, zda se maj soubory automaticky tisknout

   * Experimental
   Array_AddAsProperty=0
   Array_RemoveCells=0
   CreateAnchorsForAllProperties=0
   ECPMDblclick=1
   TabSize=4
   ShowQuickFileList=1

*******************************************************
   PJXFile="" && Umstn a nzev PJX souboru
   PJXPath="" && Umstn PJX souboru
   OutDir="" && Vstupn adres
   ProjectName="" && Nzev projektu
   FirstPage="" && The first generate HTML Page

   ARepos="" && Alias kurzoru pro repozit
   AICL="" && Alias kurzoru soubor detekujc zmny
   AStats="" && Alias kurzoru pro statistiku

   DefaultFolder="" && Default folder for FULLPATH()
   FoxCodeTable="" && FoxCode Table for memberdata

   PJX=.NULL. && Objekt pro vygenerovn projektu
   DBC=.NULL. && Objekt pro vygenerovn dat
   VCX=.NULL. && Objekt pro vygenerovn Td
   SCX=.NULL. && Objekt pro vygenerovn Formul
   PRG=.NULL. && Objekt pro vygenerovn program
   MNX=.NULL. && Objekt pro vygenerovn Menu
   FRX=.NULL. && Objekt pro vygenerovn Report
   LBX=.NULL. && Objekt pro vygenerovn Label
   XXX=.NULL. && Objekt pro vygenerovn Ostatnch soubor
   FrP=.NULL. && Odkaz na objekt friendly PDM project
   Cus=.NULL. && Odkaz na objekt Custom links
   PO=.NULL. && Odkaz na objekt Project Overview
   GCT=.NULL. && Object reference to Global Classes Tree
   STA=.NULL. && Object reference to Statistics

   oAPRG=.NULL. && Odkaz na objekt pro analzu zdrojovho kdu

   * One or more files
   SourceType=_PDM_ST_Project && Project or one/more files
   OMFiles=.NULL.    && Odkaz na objekt One/More Files
   Severally=0 && Pznak, zda se m dokumentace generovat pro kad soubor zvl᚝
   SRecno=0 && slo vty pro md OMFiles a Severally


   PlugIns=.NULL.
   Comments=.NULL.
   S_C=.NULL.    && Odkaz na objekt Setup/Cleanup
   ***********************************************



   One=.F. && Flag if will be generate HTML for one file

   oProcessing="" && Name of object, which generating HTML doc

   SNW="" && 
   RE="" && 
   RME="" && 
   StartS="" && 
   StopS="" && 

   iDIAMP=0 && DIAMP plug-ins
   DIME aDIAMP(1)

   iDIAP=0 && DIAP plug-ins
   DIME aDIAP(1)

   iEFRX=0 && EFRX plug-ins
   DIME aEFRX(1)

   iDIAC=0 && DIAC plug-ins
   DIME aDIAC(1)

   iDIAF=0 && DIAF plug-ins
   DIME aDIAF(1)

   iAC=0 && AC plug-ins
   DIME aAC(1)

   iPJXEX=0 && PJXEX plug-ins
   DIME aPJXEX(1)

   iDCOP=0 && DCOP plug-ins
   DIME aDCOP(1)

   iBC=0 && BC plug-ins
   DIME aBC(1)

   iCONV=0 && CONV plug-ins
   DIME aCONV(1)

   iCF=0 && Syntax coloring plug-ins
   DIME aCF(1)

   iVF=0 && Value formating plug-ins
   DIME aVF(1)

   ChangedPJX=.F. && Change's flag

   AGObj="" && Alias for global tree view class
   iGObj=0 && Counter of files in lobal tree view class

   oPIPar=.NULL.  && Object reference to PI parameters



   Margin_Left=0.25 && Left margin
   Margin_Top=0.0 && Top margin
   Margin_Right=0.25 && Right margin
   Margin_Bottom=0.0 && Bottom margin

   DIME aSpace(21) && Array of spaces
   FormatSpace=_Format_Yes && Formtovat pomoc mezer
   FormatCRLF=_Format_Yes && Formtovat pomoc CRLF
   APISearcher=""


   DIME aDefExt(13,2)
   aDefExt(1,1)="d"
   aDefExt(1,2)="DBC,"
   aDefExt(2,1)="D"
   aDefExt(2,2)="DBF,"
   aDefExt(3,1)="Q"
   aDefExt(3,2)="QPR,"
   aDefExt(4,1)="V"
   aDefExt(4,2)="VCX,"
   aDefExt(5,1)="K"
   aDefExt(5,2)="SCX,"
   aDefExt(6,1)="P"
   aDefExt(6,2)="PRG,MPR,"
   aDefExt(7,1)="L"
   aDefExt(7,2)="FLL,"
   aDefExt(8,1)="Z"
   aDefExt(8,2)="APP,EXE,"
   aDefExt(9,1)="M"
   aDefExt(9,2)="MNX,"
   aDefExt(10,1)="R"
   aDefExt(10,2)="FRX,"
   aDefExt(11,1)="B"
   aDefExt(11,2)="LBX,"
   aDefExt(12,1)="T"
   aDefExt(12,2)="TXT,HPP,H,"
   aDefExt(13,1)="x"
   aDefExt(13,2)="BMP,GIF,JPG,MSK,ICO,CUR,ANI,PNG,DIB,EMF,EXIF,GFA,JPEG,JPE,JFIF,TIF,TIFF,WMF,"

   ListDefExt="" && List all known file types



   iAR=0        && Count of Autoremove settings
   DIME aAR(1)  && Array of items which PDM remove from pdm file
   
   PROCEDURE Init(lcPDMs,lcPDM,lcCollate) && Inicializace tdy
      * lcPDMs  - Nzev PUBLIC reference PDMs objektu
      * lcPDM   - Nzev PUBLIC reference tohoto objektu
      * lcCollate - Tdn
      =DODEFAULT(lcCollate) && Voln pvodn metody

      This.PJX=CREATEOBJECT("_pdm_PJX") && Object for generate HTML pages of project
      This.DBC=CREATEOBJECT("_pdm_DBC",lcCollate) && Object for generate HTML pages of data
      This.VCX=CREATEOBJECT("_pdm_VCX") && Object for generate HTML pages of VCX classes
      This.SCX=CREATEOBJECT("_pdm_SCX") && Object for generate HTML pages of forms
      This.PRG=CREATEOBJECT("_pdm_PRG") && Object for generate HTML pages of programs
      This.MNX=CREATEOBJECT("_pdm_MNX") && Object for generate HTML pages of Menu
      This.FRX=CREATEOBJECT("_pdm_FRX") && Object for generate HTML pages of reports

      This.LBX=CREATEOBJECT("_pdm_LBX") && Object for generate HTML pages of labels
      This.XXX=CREATEOBJECT("_pdm_XXX") && Object for generate HTML pages of query

      This.FrP=CREATEOBJECT("_FriendlyPDMproject")

      This.GCT=CREATEOBJECT("_GlobalClassesTree")
      This.STA=CREATEOBJECT("_Statistics")

      This.OMFiles=CREATEOBJECT("_FileList")
      This.OMFiles.Name="OMFiles"

      This.S_C=CREATEOBJECT("_SetupCleanup")
      This.S_C.Name="S_C"

      This.CuS=CREATEOBJECT("_pdm_CuS")
      This.CuS.Name="CuS"

      This.PO=CREATEOBJECT("_ProjectOverview")
      This.PO.Name="PO"

      This.PlugIns=CREATEOBJECT("_pdm_PlugIns")
      This.Comments=CREATEOBJECT("_Comments")

      STORE lcPDMs TO m.This.PJX.PDMs,m.This.DBC.PDMs,m.This.VCX.PDMs,;
                      m.This.SCX.PDMs,m.This.PRG.PDMs,m.This.MNX.PDMs,m.This.FRX.PDMs,;
                      m.This.LBX.PDMs,m.This.XXX.PDMs,m.This.FrP.PDMs,;
                      m.This.S_C.PDMs,m.This.PDMs,m.This.PlugIns.PDMs,m.This.Comments.PDMs,;
                      m.This.CuS.PDMs,This.PO.PDMs,This.DBC.oAPRG.PDMs,;
                      This.GCT.PDMs,This.STA.PDMs

      m.This.SetPDMRef(lcPDM)

      This.Collate=lcCollate
      This.ARepos=SYS(2015) && Alias for temporaly cursor
   ENDPROC


   PROCEDURE GetChildObjectForGroup(lcGroup) && Return child object for group
      * lcGroup - group
      LOCAL liy,liz
      LOCAL ARRAY laChilds(8)
      laChilds(1)=This.DBC
      laChilds(2)=This.VCX
      laChilds(3)=This.SCX
      laChilds(4)=This.PRG
      laChilds(5)=This.MNX
      laChilds(6)=This.FRX
      laChilds(7)=This.LBX
      laChilds(8)=This.XXX

      * podle skupiny souboru najdi objekt kam pat
      FOR liy=1 TO ALEN(laChilds)
          FOR liz=1 TO ALEN(laChilds(m.liy).aTF)
              IF laChilds(m.liy).aTF(m.liz)==m.lcGroup
                 EXIT
              ENDIF
          NEXT
          IF liz<=ALEN(laChilds(m.liy).aTF)
             RETURN laChilds(m.liy)
          ENDIF
      NEXT
      RETURN .NULL.
   ENDPROC

   PROCEDURE GetBasePathForFile(lcGroup,lcFile) && Return child object for group
      * lcGroup - group
      * lcFile - file

      LOCAL loChild
      loChild=This.GetChildObjectForGroup(m.lcGroup)
      IF !ISNULL(m.loChild)
         lcFile=m.loChild.GetBasePathForFile(lcGroup,lcFile)
      ENDIF
      RETURN lcFile      
   ENDPROC


   PROCEDURE SetPDMRef(lcPDM) && Set PDM Reference to child objects
      * lcPDM - PUBLIC reference to PDM object
      STORE lcPDM TO This.PJX.PDM,This.DBC.PDM,This.VCX.PDM,;
                     This.SCX.PDM,This.PRG.PDM,This.MNX.PDM,This.FRX.PDM,;
                     This.LBX.PDM,This.XXX.PDM,This.FrP.PDM,This.PDM,This.PlugIns.PDM,;
                     This.CuS.PDM,This.PO.PDM,This.DBC.oAPRG.PDM,;
                     This.GCT.PDM,This.STA.PDM
   ENDPROC


   PROCEDURE GetFirstxhtml(lcFolder) && Return the first xhtml file
      LOCAL lii,lcFF
      LOCAL ARRAY laPom(9)
      IF EMPTY(lcFolder)
         lcFolder=AddBackSlashInPath(This.OutDir)
      ENDIF
      lcFF=This.FirstPage

      * test if exist the main Index.htm page
      IF FILE(lcFolder+"Index.htm")
         lcFF="Index.htm"
      ELSE
         * Pokud nen uloena hlavn strnka, nebo neexistuje,
         * pak musm najt prvn, kter existuje.
         * Pokud dnou nenajdu, pak zavu
         IF EMPTY(lcFF) OR !FILE(lcFolder+lcFF)
            laPom(1)="PJX"
            laPom(2)="DBC"
            laPom(3)="VCX"
            laPom(4)="SCX"
            laPom(5)="PRG"
            laPom(6)="MNX"
            laPom(7)="FRX"
            laPom(8)="LBX"
            laPom(9)="XXX"

            FOR lii=1 TO ALEN(laPom)
                IF FILE(lcFolder+EVAL("poPDM."+laPom(lii)+".HTMLMain"))
                   EXIT
                ENDIF
            NEXT
            lcFF=IIF(BETWEEN(lii,1,ALEN(laPom)),EVAL("poPDM."+laPom(lii)+".HTMLMain"),"")
         ENDIF
      ENDIF
      RETURN lcFolder+lcFF
   ENDPROC

   PROCEDURE OpenPJX() && Open VFP project 
      LOCAL liErr,lcAlias,lcMessage,loPDMs,lii,lcExt,lcFile,loOMFiles,lcPJX,lcType,lcADUPL,lcXX000
      LOCAL ARRAY laFields(1),laExt(1),laFile(1)
      loPDMs=EVAL(m.This.PDMs)

      liErr=_PDM_OK
      This.PDM_Alias=SYS(2015)
      lcAlias=SYS(2015)
      lcPJX=m.This.PJXFile

      IF m.This.SourceType=_PDM_ST_Project
         * Test, zda dan PJX soubor existuje
         IF !FILE(lcPJX)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgPJXNE),"%File%",lcPJX)
            liErr=_PDM_PJXNE
         ENDIF
       
         IF liErr=_PDM_OK
            * Ulo si pedan parametry
            This.PJXPath=ExtractPathFromFile(lcPJX) && Zapamatuj si jen cestu
            This.ProjectName=ExtractShortFileFromFile(lcPJX) && Zapamatuj si jen nzev

            * Oteven projektu jako tabulky a pravy pomoc SQL - SELECT
            IF m.loPDMs.OpenTable(m.This.DataSessionID,lcPJX,lcAlias," AGAIN SHARE NOUPDATE")>0
               lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgPJXNO),"%File%",lcPJX)
               liErr=_PDM_PJXNO
            ELSE
               SELE (lcAlias)
               IF TYPE("KEY")="U"
                  SELECT *,10000000000000000 AS size FROM (lcAlias) WHERE NOT DELETED() INTO TABLE (GetTempPathEx()+m.This.PDM_Alias) && Udlej jej kopii
               ELSE
                  SELECT *,10000000000000000 AS size FROM (lcAlias) WHERE NOT DELETED() INTO TABLE (GetTempPathEx()+m.This.PDM_Alias) && Udlej jej kopii
               ENDIF
               USE IN (lcAlias) && Uzavi PJX soubor
            ENDIF
         ENDIF
      ELSE
         * jede to ze sznamu soubor
         USE blank.pjx ALIAS (lcAlias) && Open blank project
         =AFIELDS(laFields)

         CREATE CURSOR (m.This.PDM_Alias) FROM ARRAY laFields && Create temporal project
         This.PJXPath="" && Zapamatuj si jen cestu
         This.ProjectName="" && Zapamatuj si jen nzev
         IF USED(lcAlias)  && Close blank projecz
            USE IN (lcAlias)
         ENDIF
         
         * Napl fiktivn projekt
         loOMFiles=m.This.OMFiles
         FOR lii=1 TO loOMFiles.Count
             lcExt=ExtractExtensionFromFile(loOMFiles.aList(lii,1))
             lcType=IIF(lcExt="DBC","d",;
                    IIF(lcExt="DBF","D",;
                    IIF(lcExt="QPR","Q",;
                    IIF(lcExt="VCX","V",;
                    IIF(lcExt="SCX","K",;
                    IIF(lcExt="PRG" OR lcExt="MPR","P",;
                    IIF(lcExt="FLL","L",;
                    IIF(lcExt="APP" OR lcExt="EXE","Z",;
                    IIF(lcExt="MNX","M",;
                    IIF(lcExt="FRX","R",;
                    IIF(lcExt="LBX","B",;
                    IIF(INLIST(lcExt,"TXT","H","HPP"),"T",;
                    IIF(INLIST(lcExt,"BMP","GIF","JPG","MSK","ICO","CUR","ANI",;
                                     "PNG","DIB","EMF","EXIF","GFA","JPEG","JPE",;
                                     "JFIF","TIF","TIFF","WMF"),"x"," ")))))))))))))
             
             IF lcType#" "
                INSERT INTO (This.PDM_Alias) (NAME,TYPE,EXCLUDE,KEY,CPID) ;
                       VALUES ;
                       (loOMFiles.aList(lii,2)+CHR(0),lcType,.F.,ExtractShortFileFromFile(loOMFiles.aList(lii,1)),IIF(lcType="x",0,CPCURRENT()))
             ENDIF
             
         NEXT

         This.GetFlagOfFileType(@laExt)
         This.PJX.Generate=0
         This.DBC.Generate=laExt(_PDMSG_DBC)
         This.SCX.Generate=laExt(_PDMSG_SCX)
         This.FRX.Generate=laExt(_PDMSG_FRX)
         This.PRG.Generate=laExt(_PDMSG_PRG)
         This.VCX.Generate=laExt(_PDMSG_VCX)
         This.LBX.Generate=laExt(_PDMSG_LBX)
         This.XXX.Generate=laExt(_PDMSG_XXX)
         This.MNX.Generate=laExt(_PDMSG_MNX)

         STORE 1 TO This.DBC.GEN_Tables, This.DBC.GEN_Queries, This.PRG.GEN_PRG, This.PRG.GEN_FLL,;
                    This.PRG.GEN_APP, This.XXX.GEN_IMG, This.XXX.GEN_TXT, This.XXX.GEN_HPP
         STORE 0 TO This.NP_ExcludeFiles,This.GL_NonGenPage
      ENDIF

      IF liErr=_PDM_OK
         This.One=IIF(m.This.SourceType=_PDM_ST_OMFiles AND m.This.Severally=1,.T.,RECC(m.This.PDM_Alias)=1) AND m.This.FrP.Count=0
         This.OutDir=AddBackSlashInPath(m.This.OutDir) && Pidej backslash pokud nen

         IF m.This.One
            m.This.CuS.Generate=0
         ENDIF
         This.PO.Generate=IIF(m.This.One,0,1)

         * nati velikosti souboru
         SELE (m.This.PDM_Alias)
         m.This.PJX.Version="3.0"

         IF TYPE("GUID")="U"
            * najdi duplicitn soubor
            * tam kde je stejn nzev a rozdln cesta, tak vygeneruj SYS(2007,Path+fileName)
            ALTER TABLE (m.This.PDM_Alias) ADD COLUMN GUID M

            lcADUPL=SYS(2015)
            SELECT SYS(2007,UPPER(ExtractFileFromFile(NullTermined(NAME)))) AS XX000 FROM (m.This.PDM_Alias) GROUP BY 1 HAVING COUNT(1)>1 INTO CURSOR (m.lcADUPL)

            SELECT (m.lcADUPL)
            SCAN ALL
                 lcXX000=XX000
                 SELE (m.This.PDM_Alias)
                 SET FILTER TO SYS(2007,UPPER(ExtractFileFromFile(NullTermined(NAME))))=m.lcXX000
                 GO TOP
                 SKIP 1
                 REPLACE GUID WITH SYS(2007,UPPER(ExtractPathFromFile(NAME)))+"_"+ExtractFileFromFile(NullTermined(NAME)) REST
                 SET FILTER TO
                 SELECT (m.lcADUPL)
            ENDSCAN
            USE IN (m.lcADUPL)
         
            SELE (m.This.PDM_Alias)
            REPLACE GUID WITH ExtractFileFromFile(NullTermined(NAME)) FOR LEN(GUID)=0
            
*            ALTER TABLE (m.This.PDM_Alias) ADD COLUMN GUID C(38)
*            REPLACE GUID WITH CreateGUID() ALL
         ENDIF

         IF TYPE("KEY")="U"
            m.This.PJX.Version="2.6"
            ALTER TABLE (m.This.PDM_Alias) ADD COLUMN KEY M
            REPLACE KEY WITH UPPER(ExtractShortFileFromFile(NullTermined(NAME))) ALL
         ENDIF

         IF TYPE("RESERVED2")="U"
            ALTER TABLE (m.This.PDM_Alias) ADD COLUMN RESERVED2 M
         ENDIF

         IF TYPE("COMMENTS")="U"
            ALTER TABLE (m.This.PDM_Alias) ADD COLUMN COMMENTS M
         ENDIF

         IF TYPE("CPID")="U"
            ALTER TABLE (m.This.PDM_Alias) ADD COLUMN CPID N(1)
         ENDIF

         SCAN FOR TYPE#"H"
              lcFile=FULLPATH(NullTermined(Name),m.This.PJXPath)
              lcExt=ExtractExtensionFromFile(lcFile)

              IF ADIR(laFile,lcFile)>0
                 lii=laFile(1,2)
                 IF INLIST(lcExt,"SCX","VCX","MNX","FRX","LBX","DBF","DBC")
                    lcFile=IIF(lcExt="SCX",ChangeExtensionFromFile(lcFile,"SCT"),;
                           IIF(lcExt="VCX",ChangeExtensionFromFile(lcFile,"VCT"),;
                           IIF(lcExt="MNX",ChangeExtensionFromFile(lcFile,"MNT"),;
                           IIF(lcExt="FRX",ChangeExtensionFromFile(lcFile,"FRT"),;
                           IIF(lcExt="LBX",ChangeExtensionFromFile(lcFile,"LBR"),;
                           IIF(lcExt="DBF",ChangeExtensionFromFile(lcFile,"FPT"),;
                           IIF(lcExt="DBC",ChangeExtensionFromFile(lcFile,"DCT"),"")))))))

                    =ADIR(laFile,lcFile)
                    lii=lii+laFile(1,2)

                    IF lcExt="DBF" AND ADIR(laFile,ChangeExtensionFromFile(lcFile,"CDX"))>0
                       lii=lii+laFile(1,2)
                    ENDIF
                    IF lcExt="DBC" AND ADIR(laFile,ChangeExtensionFromFile(lcFile,"DCX"))>0
                       lii=lii+laFile(1,2)
                    ENDIF
                 ENDIF
              ELSE
                 lii=-1
              ENDIF
              REPL size WITH lii
         ENDSCAN
      ELSE
         =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
      ENDIF
      This.PJX_Opened=liErr=_PDM_OK
      This.oAPRG=CREATEOBJECT("_PDM_AnalyseSC",m.This.PDMs,m.This.PJX.PDM)
      This.oAPRG.CreateCursors()

      This.DBC.oAPRG.CreateCursors()
      STORE CREATEOBJECT("_pdm_PlugIn_Par") TO This.oPIPar


      This.AStats=SYS(2015) && Alias
      * Create temporaly cursor for statistics
      CREATE CURSOR (m.This.AStats) (XX000 I, XX000F I, KEY C(80), XX507 I, XX510 M, XX600 M, XX601 I NULL, XX602 M NULL)
      SELECT (m.This.AStats)
      INDEX ON XX000F TAG "I03"
      INDEX ON STR(XX507, 11)+KEY TAG "I02" FOR XX507>0
      INDEX ON KEY TAG "I01"

      RETURN liErr
   ENDPROC


   PROCEDURE ClosePJX() && Close PJX File
      IF USED(m.This.PDM_Alias)
         USE IN (m.This.PDM_Alias)
         DELE FILE (GetTempPathEx()+m.This.PDM_Alias+".*") && Delete temp files
      ENDIF
      IF USED(m.This.AStats)
         USE IN (m.This.AStats)
      ENDIF
      =EVAL(m.This.PDMs+".CloseAlias(m.This.DataSessionID)")
      =EVAL(m.This.PDMs+".CloseAlias(m.This.DBC.DataSessionID)")
      This.PJX_Opened=.F.
      This.oAPRG.CloseCursors()
      This.oAPRG=.NULL.
      This.DBC.oAPRG.CloseCursors()
   ENDPROC

   PROCEDURE PrintHTMLs(lcPath,lcFile) && Now print HTML files by PDMprn.log
      * lcPath - Output directory
      * lcFile - Name of file list (PDMprn.log)
      LOCAL loo,liErr,loPDMs,llExists
      loPDMs=EVAL(m.This.PDMs)
      llExists=!ISNULL(m.loPDMs.PHTML)
      loo=IIF(!llExists,CREATEOBJECT("_PrintHTML"),m.loPDMs.PHTML)
      =IIF(!llExists,loo.CreateIE(m.This),.T.)
      loPDMs.WriteMSG(m.loPDMs.GetString(_PDM_PrintHTML_PB))
      liErr=loo.PrintHTMLs(lcPath,lcFile,SYS(1272,m.loPDMs)+".aPDMs("+LTRIM(STR(m.loPDMs.Index,11))+",2)"+".PrintHTMLs_CB")
      loPDMs.WriteMSG(IIF(liErr#_PDM_OK,"",m.loPDMs.GetString(_PDM_PrintHTML_PE)))
      =IIF(!llExists,loo.RemoveIE(),.T.)
      RETURN liErr
   ENDPROC

   PROCEDURE PrintHTMLs_CB(lcFile) && Callback method for printing HTML file
      * lcFile - File name
      LOCAL loPDMs
      loPDMs=EVAL(m.This.PDMs)
      loPDMs.WriteMSG(STRTRAN(m.loPDMs.GetString(_PDM_msgFilePRN),"%File%",lcFile))
   ENDPROC

   PROCEDURE AddFile && Add file to
      LPARAMETERS  m.luI1, m.liI2, m.liI3, m.liI4, m.lcFile, m.liOrientation, m.llFS, m.lcFrName, m.liFlags
      * liI1-liI4     - Sort index of file 
      * lcFile        - Directory and HTML file name
      * liOrientation - Paper Orientation
      * llFS          - Frameset flag
      * lcFrName      - Friendly Name/Caption
      * liFlags       - Rzn pklady

      IF TYPE("m.luI1")="N"
         INSERT INTO (m.This.FL) (XX000, XX001, XX002, XX003, XX510, XX505, XX506, XX507) ;
           VALUES ;
           (m.luI1, m.liI2, m.liI3, m.liI4,STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
      ELSE
         DO CASE
            CASE m.luI1.nLevel=3
                 INSERT INTO (m.This.FL) (XX000, XX001, XX002, XX510, XX505, XX506, XX507) VALUES;
                             (m.luI1.I1, m.luI1.I2, m.luI1.I3, ;
                              STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
            CASE m.luI1.nLevel=4
                 INSERT INTO (m.This.FL) (XX000, XX001, XX002, XX003, XX510, XX505, XX506, XX507) VALUES;
                             (m.luI1.I1, m.luI1.I2, m.luI1.I3, m.luI1.I4, ;
                             STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
            CASE m.luI1.nLevel=5
                 INSERT INTO (m.This.FL) (XX000, XX001, XX002, XX003, XX004, XX510, XX505, XX506, XX507) VALUES;
                             (m.luI1.I1, m.luI1.I2, m.luI1.I3, m.luI1.I4, m.luI1.I5, ;
                             STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
            CASE m.luI1.nLevel=6
                 INSERT INTO (m.This.FL) (XX000, XX001, XX002, XX003, XX004, XX005, XX510, XX505, XX506, XX507) VALUES;
                             (m.luI1.I1, m.luI1.I2, m.luI1.I3, m.luI1.I4, m.luI1.I5, m.luI1.I6, ;
                             STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
            CASE m.luI1.nLevel=7
                 INSERT INTO (m.This.FL) (XX000, XX001, XX002, XX003, XX004, XX005, XX006, XX510, XX505, XX506, XX507) VALUES;
                             (m.luI1.I1, m.luI1.I2, m.luI1.I3, m.luI1.I4, m.luI1.I5, m.luI1.I6, m.luI1.I7, ;
                             STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
            CASE m.luI1.nLevel=8
                 INSERT INTO (m.This.FL) (XX000, XX001, XX002, XX003, XX004, XX005, XX006, XX007, XX510, XX505, XX506, XX507) VALUES;
                             (m.luI1.I1, m.luI1.I2, m.luI1.I3, m.luI1.I4, m.luI1.I5, m.luI1.I6, m.luI1.I7, m.luI1.I8, ;
                             STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
            CASE m.luI1.nLevel=9
                 INSERT INTO (m.This.FL) (XX000, XX001, XX002, XX003, XX004, XX005, XX006, XX007, XX008, XX510, XX505, XX506, XX507) VALUES;
                             (m.luI1.I1, m.luI1.I2, m.luI1.I3, m.luI1.I4, m.luI1.I5, m.luI1.I6, m.luI1.I7, m.luI1.I8, m.luI1.I9, ;
                             STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
            CASE m.luI1.nLevel=10
                 INSERT INTO (m.This.FL) (XX000 ,XX001, XX002, XX003, XX004, XX005, XX006, XX007, XX008, XX009, XX510, XX505, XX506, XX507) VALUES;
                             (m.luI1.I1, m.luI1.I2, m.luI1.I3, m.luI1.I4, m.luI1.I5, m.luI1.I6, m.luI1.I7, m.luI1.I8, m.luI1.I9, m.luI1.I10, ;
                             STRTRAN(m.lcFile, "\", "/")+IIF(EMPTY(m.liOrientation), "", ","+STR(m.liOrientation, 1)), m.llFS, IIF(TYPE("m.lcFrName")#"C", "", m.lcFrName), IIF(TYPE("m.liFlags")#"N", 0, m.liFlags))
         ENDCASE
      ENDIF

      * XX000 = XX000
      * XX001 = XX001
      * XX002 = XX002
      * XX003 = XX003
      * XX010 = XX510
      * XX005 = XX505
      * XX006 = XX506
      * XX007 = XX507
   ENDPROC

   PROCEDURE GetListOfObject(lcType,laObjects) && Vrt seznam objekt dle typu
      * lcType    - Typ objektu
      *@laObjects - Matice, do kter se napln seznam objekt
      SET COLLATE TO "MACHINE" && Nastav tdn MACHINE
      IF EMPTY(lcType)
         SELECT RECNO() FROM (m.This.PDM_Alias) INTO ARRAY laObjects
      ELSE
         IF m.This.SourceType=_PDM_ST_OMFiles AND m.This.Severally=1
            SELECT Key, RECNO(),.F.,"","" FROM (m.This.PDM_Alias) WHERE Type == lcType AND RECNO()=m.This.SRecno INTO ARRAY laObjects
         ELSE
            SELECT Key, RECNO(),.F.,"","" FROM (m.This.PDM_Alias) WHERE Type == lcType INTO ARRAY laObjects
         ENDIF
      ENDIF
      SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn
      RETURN _TALLY && Vra poet objekt
   ENDPROC

   PROCEDURE GetPropertiesOfObject(liID,loRam) && Vrt seznam vlastnost objektu
      * liID    - ID objektu (RECNO())
      *@loRam   - Ram objekt s vlastnostmi 
      SELE (m.This.PDM_Alias) && Sko na tabulku projektu
      IF liID>0 AND liID<=RECC()
         GO (liID) && Sko na konktrtn objekt
         SCATT MEMO NAME loRam && Nati Ram objekt
         RETURN .T. && Vra, e objekt naetl
      ENDIF
      RETURN .F. && Vra, e objekt nebyl naten
   ENDPROC


   PROCEDURE WorkPJX() && Run process VFP project
      LOCAL liErr,lcMessage,loRam,lcOut,loPDMs,lcOut,lii,lcTag,luCatch,loPIPar,lcPom,llDNRR,lcWL,liSC,loSet,;
            liPEM07,lcRow,lcAlias,lcName,liSID
      LOCAL ARRAY laPI(1)

      IF !m.This.PJX_Opened && If not open PJX file
         RETURN _PDM_FileNO && Then return
      ENDIF

      lcOut=m.This.OutDir && Output directory
      loPDMs=EVAL(m.This.PDMs)

      SET COLLATE TO "MACHINE" && Nastav tdn MACHINE
      lcAlias=SYS(2015)
      liSID=m.This.DataSessionID
      IF NOT EMPTY(This.FoxCodeTable) AND m.loPDMs.OpenTable(liSID,This.FoxCodeTable,m.lcAlias,"SHARE NOUPDATE")=_PDM_OK && Oteve tabulku
         SELECT (lcAlias)
         SET FILTER TO TYPE="E"
         SCAN ALL 
              lcRow=TIP
              liPEM07=VAL(SYS(2007,UPPER(ABBREV)))
              lcName=ABBREV
              SET DATASESSION TO (m.poPDMs.DataSessionID)
              SELECT (poPDMs.AClassesPEM)
              IF NOT SEEK(BINTOC(-2000000001)+BINTOC(liPEM07))
                 INSERT INTO (poPDMs.AClassesPEM) (XX000, PEM , DISPLAYPEM, PEM07 ) VALUES (-2000000001,lcName,PEM_GetXMLProperty(@lcRow,"display"), liPEM07)
              ENDIF   
              SET DATASESSION TO (liSID)
              SELECT (lcAlias)
         ENDSCAN
      ENDIF   
      m.loPDMs.OpenTable(-1,lcAlias)
      SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn

      liErr=_PDM_OK
      lcWL=""
      This.FL=SYS(2015) && Alias
      This.AICL=SYS(2015) && Alias
      This.AGObj=SYS(2015) && Alias

      * Create temporaly cursor for repository 
      CREATE CURSOR (m.This.ARepos) (XX200 M, XX205 M, XX204 N(17))

      * Test, zda vstupn cesta existuje
      IF liErr=_PDM_OK AND !INLIST(m.loPDMs.MKD(lcOut),0,1)
         IF m.loPDMs.GUI
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgOutPathNC),"%Dir%",lcOut)
         ENDIF
         liErr=_PDM_OutPathNC
      ENDIF

      IF liErr=_PDM_OK
         llDNRR=.T.
         * If Clear Output Directory
         IF m.This.ClearOutDir=1 AND m.This.Incremental=0
            llDNRR=.F.
            IF !RemoveDirectoryAll(lcOut,.T.)
               lcWL=STRTRAN(m.loPDMs.GetString(_PDM_msgClearDirFailed),"%Dir%",lcOut)
            ENDIF
         ENDIF

         * Test, zda existuje cesta pro reposit
         IF !INLIST(m.loPDMs.MKD(lcOut+"repository"),0,1)
            IF m.loPDMs.GUI
               lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+"repository")
            ENDIF
            liErr=_PDM_RepositoryNC
         ELSE
            IF m.This.Incremental=0 AND llDNRR AND !RemoveDirectoryAll(lcOut+"repository\",.F.)
               lcWL=lcWL+CRLF+STRTRAN(m.loPDMs.GetString(_PDM_msgClearDirFailed),"%Dir%",lcOut+"repository")
            ENDIF
         ENDIF
      ENDIF

      IF liErr=_PDM_OK
         IF !INLIST(m.loPDMs.MKD(lcOut+"css"),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+"css")
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            m.loPDMs.WriteToLogFile(@m.lcMessage)
            liErr=_PDM_NCDir
         ENDIF
      ENDIF

      IF liErr=_PDM_OK
         IF !INLIST(m.loPDMs.MKD(lcOut+"js"),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+"js")
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            m.loPDMs.WriteToLogFile(@m.lcMessage)
            liErr=_PDM_NCDir
         ENDIF
      ENDIF

      IF liErr=_PDM_OK
         IF !INLIST(m.loPDMs.MKD(lcOut+"imgs"),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+"imgs")
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            m.loPDMs.WriteToLogFile(@m.lcMessage)
            liErr=_PDM_NCDir
         ENDIF
      ENDIF


      * Preparing LOG files
      loPDMs.LOGErr=lcOut+"PDMErr.log" && Directory and name LOG error file
      loPDMs.LOGFile=lcOut+"PDM.log" &&  Directory and name LOG file

      IF liErr=_PDM_OK
         loPDMs.hLOGErr=poPDMs.FCreate(m.loPDMs.LOGErr) && Handle otevenho LOG error file
         IF m.loPDMs.hLOGErr<=0 && Nepodailo se to
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCLogErr),"%File%",m.loPDMs.LOGErr)
            liErr=_PDM_NCLogErr
         ENDIF
      ENDIF

      IF liErr=_PDM_OK
         loPDMs.hLOGFile=m.loPDMs.FCreate(m.loPDMs.LOGFile) && Handle otevenho LOG file
         IF m.loPDMs.hLOGErr<=0 && Nepodailo se to
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCLogFile),"%File%",m.loPDMs.LOGFile)
            liErr=_PDM_NCLogFile
         ENDIF
      ENDIF

      luCatch=m.loPDMs.SetCatch(.F.)

      IF liErr=_PDM_OK
         IF !CopyDirectory(m.loPDMs.MainPath+"res\pool\css",lcOut+"css",.F.,.T.) && Pekopruj zkladn potebn soubory
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFolderFailed),"%name%",m.loPDMs.MainPath+"res\pool\css")
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF

         IF !CopyDirectory(m.loPDMs.MainPath+"res\pool\js\",lcOut+"js",.F.,.T.) && Pekopruj zkladn potebn soubory
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFolderFailed),"%name%",m.loPDMs.MainPath+"res\pool\js")
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF

         IF !CopyDirectory(m.loPDMs.MainPath+"res\pool\imgs\",lcOut+"imgs",.F.,.T.) && Pekopruj zkladn potebn soubory
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFolderFailed),"%name%",m.loPDMs.MainPath+"res\pool\imgs")
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF


         * Copy localized resource, if not found, copy resource for English language 
         IF !m.loPDMs.HTMLCLang=="en" AND DIRECTORY(m.loPDMs.MainPath+"res\pool\lang\"+m.loPDMs.HTMLCLang)
            IF !CopyDirectory(m.loPDMs.MainPath+"res\pool\lang\"+m.loPDMs.HTMLCLang,lcOut+"imgs",.F.,.T.) && Pekopruj zkladn potebn soubory
               lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFolderFailed),"%name%",m.loPDMs.MainPath+"res\pool\lang\"+m.loPDMs.HTMLCLang)
               loPDMs.WriteToLogFile(@m.lcPom)
            ENDIF
         ELSE
            IF !CopyDirectory(m.loPDMs.MainPath+"res\pool\lang\en",lcOut+"imgs",.F.,.T.) && Pekopruj zkladn potebn soubory
               lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFolderFailed),"%name%",m.loPDMs.MainPath+"res\pool\lang\en")
               loPDMs.WriteToLogFile(@m.lcPom)
            ENDIF
         ENDIF


         =This.InitResources() AND This.PJX.InitResources() AND ;
          This.DBC.InitResources() AND This.VCX.InitResources() AND ;
          This.SCX.InitResources() AND This.PRG.InitResources() AND ;
          This.MNX.InitResources() AND This.FRX.InitResources() AND ;
          This.LBX.InitResources() AND This.XXX.InitResources() AND ;
          This.FrP.InitResources() AND This.CuS.InitResources() AND ;
          This.GCT.InitResources() AND This.STA.InitResources()

         * Pokud nen SC, pak odstra plugin

         IF This.SyntaxColoring=0
            loSet=This.Plugins.GetSetting(40000) 
            This.Plugins.RemovePlugIn(40000)
         ENDIF

         * Open sources for plug-ines
         IF !m.This.PI_Initialize()
            IF m.loPDMs.GUI
               lcMessage=m.loPDMs.GetString(_PDM_msgOSFailed)
            ENDIF
            liErr=_PDM_OSFailed
         ENDIF

         IF This.SyntaxColoring=0
            This.Plugins.AddPlugIn(40000,loSet,.F.)
         ENDIF
      ENDIF

      liSC=This.SyntaxColoring
      This.SyntaxColoring=IIF(m.This.iCF>0 AND This.SyntaxColoring=1,1,0)

      IF liErr=_PDM_OK AND !EMPTY(STRTRAN(m.This.S_C.Setup,CHR(13)+CHR(10),""))
         * Setup
         liErr=m.This.S_C.Execute(m.This.S_C.Setup,0,@m.lcMessage)
      ENDIF      

      IF liErr#_PDM_OK AND m.loPDMs.GUI
         =MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain))
      ENDIF
      
      IF liErr=_PDM_OK

         IF LEN(lcWL)>0
            loPDMs.WriteToLogFile(@m.lcWL)
            lcWL=""
         ENDIF


         IF m.This.SyntaxColoring=0 && None
            loPDMs.SC_Code=[<pre class="PDMCODE" ] && Poten tag pro zdrojov kd
            loPDMs.SC_Code_Close=[</pre>] && Ukonujc tag pro zdrojov kd
            loPDMs.SC_Expr=[<div class="PDMEXPR" ] && Poten tag pro vraz
            loPDMs.SC_Expr_Close=[</div>] && Ukonujc tag pro vraz
            loPDMs.SC_Expr_1=[<div class="PDMEXPR" style="display: inline;" ] && Poten tag pro vraz
            loPDMs.SC_Expr_1_Close=[</div>] && Ukonujc tag pro vraz
            loPDMs.SC_Expr_2=[<span class="PDMEXPR" ] && Poten tag pro vraz
            loPDMs.SC_Expr_2_Close=[</span>] && Ukonujc tag pro vraz
         ENDIF


         loPDMs.SetAnchorsDefault() && Set default Directory HTML files
         FOR lii=1 TO m.This.FrP.Count
             * Set relative Directory to HTML files by PDM project
             =IIF(!ISNULL(m.This.FrP.aList(lii,4)),m.loPDMs.SetAnchors(m.This.FrP.aList(lii,3),m.This.FrP.aList(lii,4)),.T.)
         NEXT

         STORE 0 TO This.PJX.nLI2,This.DBC.nLI2,;
                    This.SCX.nLI2,This.FRX.nLI2,;
                    This.VCX.nLI2,This.PRG.nLI2,;
                    This.LBX.nLI2,This.XXX.nLI2,;
                    This.MNX.nLI2,This.FrP.nLI2,;
                    This.Cus.nLI2

         * Create temporaly cursor for file list
         CREATE CURSOR (m.This.FL) (XX000 I,XX001 I,XX002 I,XX003 I,XX004 I,XX005 I,XX006 I,XX007 I,XX008 I,XX009 I,XX510 M, XX505 I, XX506 M, XX507 I)

         * Create temporaly cursor for ICL
         CREATE CURSOR (m.This.AICL) (XX300 C(254),XX301 I,XX302 C(16))
         =m.This.Read_ICL(m.This.PDM_File) && Nati seznam soubor pro porovnn zmn

         * Create temporaly cursor for Global Classes Tree (and objects)
         CREATE CURSOR (m.This.AGObj) (RESERVED4 M, OBJNAME M, RESERVED7 M, XX002 I, CLASS M, CLASSLOC M, CLASSLOCX M, BASECLASS M, XX001 I, XX000 I)
         This.iGObj=0

* XX000 I,  - recordid
* XX000F I,  - fileid
* KEY C(80) - Key parent
* XX507 I - Type
* XX510 M - file/class/object/etc. name
* XX600 M - stats name
* XX601 I - stats value

         
         IF This.FormatSpace=_Format_Yes
            FOR lii=1 TO 20 STEP 4
                This.aSpace(lii)=SPACE(lii)
                This.aSpace(lii+1)=This.aSpace(lii)+" "
                This.aSpace(lii+2)=This.aSpace(lii)+"  "
                This.aSpace(lii+3)=This.aSpace(lii)+"   "
            NEXT
         ELSE
            STORE "" TO This.aSpace
         ENDIF

         IF This.FormatCRLF=_Format_Yes
            This.aSpace(21)=CRLF
         ELSE
            This.aSpace(21)=""
         ENDIF

         loPIPar=This.oPIPar

         IF m.This.iBC>0
            m.loPDMs.WriteMSG(m.loPDMs.GetString(_PDM_msgBCPIRun))
            loPIPar.Reset()
            loPIPar.Type="BC"
            FOR lii=1 TO m.This.iBC
                =m.This.aBC(lii,1).Run(@m.loPIPar,m.This.aBC(lii,2))
            NEXT
            RELE laPI
         ENDIF
         
         PUBLIC ARRAY paComments(1)
         =m.This.Comments.PrepareArray(@paComments)

         This.GenerateHTML() && Spus generovn HTML soubor
         m.loPDMs.WriteDMSG("")
         RELE paComments

         This.SyntaxColoring=liSC

         IF !m.loPDMs.Canceled
            m.loPDMs.WriteMSG(m.loPDMs.GetString(_PDM_msgGenPList))
            * Save special settings
            =IIF(!EMPTY(m.This.PDM_File) AND !(m.This.SourceType=_PDM_ST_OMFiles AND m.This.Severally=1),m.This.SaveSpecial(),.T.)

            * Create File list for Print
            This.hPrintList=poPDMs.FCreate(lcOut+"PDMprn.log") && Handle opened file
            IF This.hPrintList<=0 AND m.loPDMs.GUI && Nepodailo se to
               =MESSAGEBOX(STRTRAN(m.loPDMs.GetString(_PDM_msgNCLogErr),"%File%",lcOut+"PDMprn.log"),16,m.loPDMs.GetString(_PDM_msgMain))
            ELSE
               SELE (m.This.FL)
               INDEX ON STR(XX000,6)+STR(XX001,6)+STR(XX002,6)+STR(XX003,6)+STR(XX004,6)+;
                        STR(XX005,6)+STR(XX006,6)+STR(XX007,6)+STR(XX008,6)+STR(XX009,6) TAG I01

               SCAN FOR !BITTEST(XX505,0) AND !EMPTY(XX510) && All files, exception frames
                    =FPUTS(m.This.hPrintList,XX510)
               ENDSCAN
               =m.loPDMs.FClose(m.This.hPrintList) && Close print list PDM file
            ENDIF

            IF m.This.iCONV>0
               m.loPDMs.WriteMSG(m.loPDMs.GetString(_PDM_msgCONVPIRun))
               loPIPar.Reset()
               loPIPar.Type="CONV"
               FOR lii=1 TO m.This.iCONV
                   =m.This.aCONV(lii,1).Run(@m.loPIPar,m.This.aCONV(lii,2))
               NEXT
            ENDIF

            IF m.This.iAC>0
               m.loPDMs.WriteMSG(m.loPDMs.GetString(_PDM_msgACPIRun))
               *REPL XX006 WITH LEFT(SUBST(XX010,RAT("/",XX010,2)+1),AT("/",SUBST(XX010,RAT("/",XX010,2)+1))-1) FOR LEN(XX006)=0
               loPIPar.Reset()
               loPIPar.Type="AC"
               FOR lii=1 TO m.This.iAC
                   =m.This.aAC(lii,1).Run(@m.loPIPar,m.This.aAC(lii,2))
               NEXT
            ENDIF

            * Print HTML files
            =IIF(m.This.AutoPrint=1,m.This.PrintHTMLs(lcOut,lcOut+"PDMprn.log"),.T.)
         ENDIF

         STORE .NULL. TO This.oPIPar,loPIPar
      ENDIF
      m.loPDMs.WriteMSG("")

      This.PI_Release()

      * Cleanup
      IF !EMPTY(STRTRAN(m.This.S_C.Cleanup,CHR(13)+CHR(10),""))
         =m.This.S_C.Execute(m.This.S_C.Cleanup,1,"")
      ENDIF

      IF USED(m.This.FL) && Close alias File list
         USE IN (m.This.FL)
      ENDIF

      IF USED(m.This.ARepos) && Close alias repository
         USE IN (m.This.ARepos)
      ENDIF

      IF USED(m.This.AICL) && Close alias ICL
         USE IN (m.This.AICL)
      ENDIF

      IF USED(m.This.AGObj)
         USE IN (m.This.AGObj)
      ENDIF

      
      IF m.loPDMs.hLOGFile>0
         =m.loPDMs.FClose(m.loPDMs.hLOGFile) && Close LOG File
         loPDMs.hLOGFile=0
      ENDIF

      IF m.loPDMs.hLOGErr>0
         =m.loPDMs.FClose(m.loPDMs.hLOGErr) && Close Error LOG file
         loPDMs.hLOGErr=0
      ENDIF

      m.loPDMs.SetCatch(luCatch)
      RETURN liErr
   ENDPROC


   PROCEDURE GenerateHTML() && Generovn HTML strnek
      LOCAL lcFile,llLine,lii,lcFirst,liHKEY,lcData,lcFC,lcBC,liStyle,liCount,loPDMs,lcOut,;
            lcMessage,llOne,lcCSS,lcJS,lcIPath,lcString,lihFile,lcPom
      LOCAL ARRAY laSC(7,2),laTitles(3)

      loPDMs=EVAL(m.This.PDMs)
      lcOut=m.This.OutDir
      llOne=m.This.One

      This.GetGLCSS_JS(m.This.OutDir,.NULL.,@m.lcCSS,@m.lcJS)
      lcIPath=IIF(!m.loPDMs.HTMLCLang=="en" AND DIRECTORY(m.loPDMs.MainPath+"res\lang\"+m.loPDMs.HTMLCLang),;
              m.loPDMs.MainPath+"res\lang\"+m.loPDMs.HTMLCLang,m.loPDMs.MainPath+"res\lang\en")+"\"

      laTitles(2)=m.loPDMs.aStrings(PDM_05102)

      This.SNW=m.loPDMs.AddRowScript("SetNoWrap")
      This.RE=m.loPDMs.AddScript("ResetElement")
      This.RME=m.loPDMs.AddScript("ResetMainElement")
      This.StartS=m.loPDMs.StartScript()
      This.StopS=m.loPDMs.StopScript()


      lcString=IIF(llOne,"",m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_05102))+m.loPDMs.GetStyles()+lcCSS+m.loPDMs.AddExternalScript(m.loPDMs.ExternJS)+lcJS+;
               '</head><body class="mainmenu">'+m.This.aSpace(21)+;
               '<div class="mainmenuLeft">'+m.This.aSpace(21)+;
               This.aSpace(1)+'<div class="mainmenu"><img class="mm_hf" src="imgs/header.gif" alt="" /></div>'+m.This.aSpace(21))

     IF m.This.PO.Generate=1 AND LEN(ALLT(m.This.PO.Link))>0
         This.oProcessing="PO"
         This.PO.GenerateHTML()
         This.oProcessing=""

         lcFirst=IIF(llOne,m.This.PO.HTMLOMMain,m.This.PO.HTMLMain)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05136)
            laTitles(3)=m.loPDMs.aStrings(PDM_05138)
            loPDMs.OutPage("projectoverview",lcOut+m.This.PO.HTMLMain,m.This.PO.HTMLDetail,@laTitles,"Blank_QL.htm",This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.PO.Generate=1 AND LEN(ALLT(m.This.PO.Link))>0 OR m.This.PO.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.PO.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/projover.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00232)+'" title="'+m.loPDMs.aStrings(PDM_00232)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.

         IF CopyFile((lcIPath+"projover.gif"+CHR(0)),(lcOut+"imgs/projover.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"projover.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF

      IF m.This.PJX.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.PJX.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.PJX.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            m.loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF

         This.oProcessing="PJX"
         IF !llOne
            m.This.AddFile(m.This.PJX.nLI1,0,0,0,m.This.PJX.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00166),_PDM_FG_Any)
         ENDIF
         m.This.PJX.GenerateHTML()
         This.oProcessing=""
         IF !llOne
            laTitles(1)=STRTRAN(m.loPDMs.aStrings(PDM_05103),"%name%",m.This.ProjectName)
            laTitles(3)=STRTRAN(m.loPDMs.aStrings(PDM_05105),"%name%",m.This.ProjectName)
            loPDMs.OutPage("project",lcOut+m.This.PJX.HTMLMain,m.This.PJX.OutDir+"/"+m.This.PJX.HTMLDetail,@laTitles,"Blank_QL.htm",This.ShowQuickFileList)
         ENDIF
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.PJX.HTMLOMMain,m.This.PJX.HTMLMain),lcFirst)
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF m.This.PJX.Generate=1 OR m.This.PJX.Generate=0 AND m.This.GL_NonGenPage=1
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.PJX.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/project.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00166)+'" title="'+m.loPDMs.aStrings(PDM_00166)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.

         IF CopyFile((lcIPath+"project.gif"+CHR(0)),(lcOut+"imgs/project.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"project.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF

      * !!! Don't Move - first !!!
      IF This.VCX.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.VCX.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.VCX.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF

         This.oProcessing="VCX"
         IF !llOne
            m.This.AddFile(m.This.VCX.nLI1,0,0,0,m.This.VCX.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00174),_PDM_FG_Any)
         ENDIF
         m.This.VCX.GenerateHTML()
         This.oProcessing=""
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.VCX.HTMLOMMain,m.This.VCX.HTMLMain),lcFirst)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05112)
            laTitles(3)=m.loPDMs.aStrings(PDM_05114)
            loPDMs.OutPage("class",lcOut+m.This.VCX.HTMLMain,m.This.VCX.OutDir+"/"+m.This.VCX.HTMLDetail,@laTitles,m.This.VCX.OutDir+"/"+m.This.VCX.HTMLList,This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.VCX.Generate=1 OR m.This.VCX.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+m.This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.VCX.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/classes.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00174)+'" title="'+m.loPDMs.aStrings(PDM_00174)+'" /></a></div>'+m.This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"classes.gif"+CHR(0)),(lcOut+"imgs/classes.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"classes.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF
      * !!! Don't Move - first !!!

      * !!! Don't Move - second !!!
      IF This.SCX.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.SCX.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.SCX.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF
         This.oProcessing="SCX"
         IF !llOne
            m.This.AddFile(m.This.SCX.nLI1,0,0,0,m.This.SCX.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00182),_PDM_FG_Any)
         ENDIF
         m.This.SCX.GenerateHTML()
         This.oProcessing=""
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.SCX.HTMLOMMain,m.This.SCX.HTMLMain),lcFirst)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05106)
            laTitles(3)=m.loPDMs.aStrings(PDM_05108)
            loPDMs.OutPage("form",lcOut+m.This.SCX.HTMLMain,m.This.SCX.OutDir+"/"+m.This.SCX.HTMLDetail,@laTitles,m.This.SCX.OutDir+"/"+m.This.SCX.HTMLList,This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.SCX.Generate=1 OR m.This.SCX.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.SCX.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/forms.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00182)+'" title="'+m.loPDMs.aStrings(PDM_00182)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"forms.gif"+CHR(0)),(lcOut+"imgs/forms.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"forms.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF
      * !!! Don't Move - second !!!

      * !!! Don't Move - third !!!
      IF m.This.DBC.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.DBC.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.DBC.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF
         This.oProcessing="DBC"
         IF !llOne
            m.This.AddFile(m.This.DBC.nLI1,0,0,0,m.This.DBC.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00189),_PDM_FG_Any)
         ENDIF
         This.DBC.GenerateHTML()
         This.oProcessing=""
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.DBC.HTMLOMMain,m.This.DBC.HTMLMain),lcFirst)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05109)
            laTitles(3)=m.loPDMs.aStrings(PDM_05111)
            loPDMs.OutPage("data",lcOut+m.This.DBC.HTMLMain,m.This.DBC.OutDir+"/"+m.This.DBC.HTMLDetail,@laTitles,m.This.DBC.OutDir+"/"+m.This.DBC.HTMLList,This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.DBC.Generate=1 OR m.This.DBC.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+m.This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.DBC.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/data.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00189)+'" title="'+m.loPDMs.aStrings(PDM_00189)+'" /></a></div>'+m.This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"data.gif"+CHR(0)),(lcOut+"imgs/data.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"data.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF
      * !!! Don't Move - third !!!

      IF This.PRG.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.PRG.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.PRG.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF
         This.oProcessing="PRG"
         IF !llOne
            m.This.AddFile(m.This.PRG.nLI1,0,0,0,m.This.PRG.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00197),_PDM_FG_Any)
         ENDIF
         This.PRG.GenerateHTML()
         This.oProcessing=""
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05115)
            laTitles(3)=m.loPDMs.aStrings(PDM_05117)
            loPDMs.OutPage("code",lcOut+m.This.PRG.HTMLMain,m.This.PRG.OutDir+"/"+m.This.PRG.HTMLDetail,@laTitles,m.This.PRG.OutDir+"/"+m.This.PRG.HTMLList,This.ShowQuickFileList)
         ENDIF
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.PRG.HTMLOMMain,m.This.PRG.HTMLMain),lcFirst)
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.PRG.Generate=1 OR m.This.PRG.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.PRG.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/code.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00197)+'" title="'+m.loPDMs.aStrings(PDM_00197)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"code.gif"+CHR(0)),(lcOut+"imgs/code.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"code.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF

      IF m.This.MNX.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.MNX.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.MNX.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF
         This.oProcessing="MNX"
         IF !llOne
            m.This.AddFile(m.This.MNX.nLI1,0,0,0,m.This.MNX.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00204),_PDM_FG_Any)
         ENDIF
         This.MNX.GenerateHTML()
         This.oProcessing=""
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.MNX.HTMLOMMain,m.This.MNX.HTMLMain),lcFirst)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05121)
            laTitles(3)=m.loPDMs.aStrings(PDM_05123)
            m.loPDMs.OutPage("menus",lcOut+m.This.MNX.HTMLMain,m.This.MNX.OutDir+"/"+m.This.MNX.HTMLDetail,@laTitles,m.This.MNX.OutDir+"/"+m.This.MNX.HTMLList,This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.MNX.Generate=1 OR m.This.MNX.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.MNX.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/menus.gif" alt="'+;
                  loPDMs.aStrings(PDM_00204)+'" title="'+m.loPDMs.aStrings(PDM_00204)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"menus.gif"+CHR(0)),(lcOut+"imgs/menus.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"menus.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF

      IF m.This.FRX.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.FRX.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.FRX.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF
         This.oProcessing="FRX"
         IF !llOne
            m.This.AddFile(m.This.FRX.nLI1,0,0,0,m.This.FRX.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00212),_PDM_FG_Any)
         ENDIF
         This.FRX.GenerateHTML()
         This.oProcessing=""
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.FRX.HTMLOMMain,m.This.FRX.HTMLMain),lcFirst)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05118)
            laTitles(3)=m.loPDMs.aStrings(PDM_05120)
            m.loPDMs.OutPage("reports",lcOut+m.This.FRX.HTMLMain,m.This.FRX.OutDir+"/"+m.This.FRX.HTMLDetail,@laTitles,m.This.FRX.OutDir+"/"+m.This.FRX.HTMLList,This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.FRX.Generate=1 OR m.This.FRX.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.FRX.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/reports.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00212)+'" title="'+m.loPDMs.aStrings(PDM_00212)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"reports.gif"+CHR(0)),(lcOut+"imgs/reports.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"reports.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF

      IF m.This.LBX.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.LBX.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.LBX.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF
         This.oProcessing="LBX"
         IF !llOne
            m.This.AddFile(m.This.LBX.nLI1,0,0,0,m.This.LBX.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00220),_PDM_FG_Any)
         ENDIF
         This.LBX.GenerateHTML()
         This.oProcessing=""
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.LBX.HTMLOMMain,m.This.LBX.HTMLMain),lcFirst)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05124)
            laTitles(3)=m.loPDMs.aStrings(PDM_05126)
            m.loPDMs.OutPage("labels",lcOut+m.This.LBX.HTMLMain,m.This.LBX.OutDir+"/"+m.This.LBX.HTMLDetail,@laTitles,m.This.LBX.OutDir+"/"+m.This.LBX.HTMLList,This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.LBX.Generate=1 OR m.This.LBX.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.LBX.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/labels.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00220)+'" title="'+m.loPDMs.aStrings(PDM_00220)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"labels.gif"+CHR(0)),(lcOut+"imgs/labels.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"labels.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF

      IF m.This.XXX.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.XXX.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.XXX.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF
         This.oProcessing="XXX"
         IF !llOne
            m.This.AddFile(m.This.XXX.nLI1,0,0,0,m.This.XXX.HTMLMain,0,_PDM_EF_Frame,m.loPDMs.aStrings(PDM_00228),_PDM_FG_Any)
         ENDIF
         This.XXX.GenerateHTML()
         This.oProcessing=""
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.XXX.HTMLOMMain,m.This.XXX.HTMLMain),lcFirst)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05127)
            laTitles(3)=m.loPDMs.aStrings(PDM_05129)
            loPDMs.OutPage("other",lcOut+m.This.XXX.HTMLMain,m.This.XXX.OutDir+"/"+m.This.XXX.HTMLDetail,@laTitles,m.This.XXX.OutDir+"/"+m.This.XXX.HTMLList,This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.XXX.Generate=1 OR m.This.XXX.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.XXX.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/other.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00228)+'" title="'+m.loPDMs.aStrings(PDM_00228)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"other.gif"+CHR(0)),(lcOut+"imgs/other.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"other.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF


      IF m.This.CuS.Generate=1
         IF !INLIST(m.loPDMs.MKD(lcOut+m.This.Cus.OutDir),0,1)
            lcMessage=STRTRAN(m.loPDMs.GetString(_PDM_msgNCDir),"%Dir%",lcOut+m.This.CuS.OutDir)
            =IIF(m.loPDMs.GUI,MESSAGEBOX(lcMessage,16,m.loPDMs.GetString(_PDM_msgMain)),.T.)
            loPDMs.WriteToLogFile(@m.lcMessage)
            RETURN .F.
         ENDIF
         This.oProcessing="CuS"
         This.CuS.GenerateHTML()
         This.oProcessing=""
         lcFirst=IIF(EMPTY(lcFirst),IIF(llOne,m.This.CuS.HTMLOMMain,m.This.CuS.HTMLMain),lcFirst)
         IF !llOne
            laTitles(1)=m.loPDMs.aStrings(PDM_05133)
            laTitles(3)=m.loPDMs.aStrings(PDM_05135)
            m.loPDMs.OutPage("customlinks",lcOut+m.This.CuS.HTMLMain,m.This.CuS.OutDir+"/"+m.This.CuS.HTMLDetail,@laTitles,"Blank_QL.htm",This.ShowQuickFileList)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF
      IF (m.This.CuS.Generate=1 OR m.This.CuS.Generate=0 AND m.This.GL_NonGenPage=1) AND !llOne
         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.CuS.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/custom.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00230)+'" title="'+m.loPDMs.aStrings(PDM_00230)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"custom.gif"+CHR(0)),(lcOut+"imgs/custom.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"custom.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
      ENDIF

      IF m.This.FrP.Count>0
         lcFirst=IIF(EMPTY(lcFirst),m.This.FrP.HTMLMain,lcFirst)
         This.oProcessing="FrP"
         m.This.FrP.GenerateHTML()
         This.oProcessing=""
         laTitles(1)=m.loPDMs.aStrings(PDM_05130)
         laTitles(3)=m.loPDMs.aStrings(PDM_05132)
         loPDMs.OutPage("frp",lcOut+m.This.FrP.HTMLMain,m.This.FrP.HTMLDetail,@laTitles,"Blank_QL.htm",This.ShowQuickFileList)

         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.FrP.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/frp.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00234)+'" title="'+m.loPDMs.aStrings(PDM_00234)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"frp.gif"+CHR(0)),(lcOut+"imgs/frp.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"frp.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF

      * Global classes tree
      IF m.This.GCT.Generate=1 AND m.This.iGOBJ>0
         m.This.GCT.GenerateHTML()
         =m.loPDMs.WriteDMSG("")
      ENDIF

      * Statistics
      IF m.This.STA.Generate=1 AND !llOne
         lcFirst=IIF(EMPTY(lcFirst),m.This.STA.HTMLMain,lcFirst)
         This.oProcessing="STA"
         m.This.STA.GenerateHTML()
         This.oProcessing=""

         laTitles(1)=m.loPDMs.aStrings(PDM_05130)
         laTitles(3)=m.loPDMs.aStrings(PDM_05132)
         loPDMs.OutPage("sta",lcOut+m.This.STA.HTMLMain,m.This.STA.HTMLDetail,@laTitles,"Blank_QL.htm",This.ShowQuickFileList)

         lcString=lcString+;
                  IIF(llLine,This.aSpace(2)+'<div class="mainmenu"><img class="mm_line" src="imgs/line.gif" alt="" /></div>'+This.aSpace(21),'')+;
                  This.aSpace(2)+'<div class="mainmenu"><a href="'+m.This.STA.HTMLMain+'" target="_top" onfocus="LostFocus()"><img class="mm_body" src="imgs/statistics.gif" alt="'+;
                  m.loPDMs.aStrings(PDM_00235)+'" title="'+m.loPDMs.aStrings(PDM_00235)+'" /></a></div>'+This.aSpace(21)
         llLine=.T.
         IF CopyFile((lcIPath+"statistics.gif"+CHR(0)),(lcOut+"imgs/statistics.gif"+CHR(0)),0)=0 && Copy picture
            lcPom=STRTRAN(m.loPDMs.GetString(_PDM_msgCopyFileFailed),"%name%",(lcIPath+"statistics.gif"))
            loPDMs.WriteToLogFile(@m.lcPom)
         ENDIF
         =m.loPDMs.WriteDMSG("")
      ENDIF

      lcString=IIF(llOne,"",lcString+;
               ' <div class="mainmenu"><img class="mm_hf" src="imgs/footer.gif" alt="" /></div>'+This.aSpace(21))


      * Pidej img pro nhled obrzk
      lcString=IIF(llOne,"",lcString+;
               This.aSpace(1)+'<img id="IMG_QUICKVIEW" class="imgQuickView" src=""  alt="" title="" />'+This.aSpace(21)+;
               '</div>'+This.aSpace(21))

      lcString=IIF(llOne,"",lcString+;
               '<div class="mainmenuRight"'+IIF(This.ShowQuickFileList=0,' style="visibility:hidden;"','')+'>'+m.This.aSpace(21)+;
               This.aSpace(1)+"<iframe id='IFRAME_LIST' class='iframe_QL' frameborder='0px'  src='Blank_QL.htm' ></iframe>"+This.aSpace(21)+;
               '</div>'+This.aSpace(21))

      lcString=IIF(llOne,"",lcString+;
               This.StartS+m.loPDMs.AddRowScript("IFRAME_LIST")+This.StopS+This.aSpace(21))

      lcString=IIF(llOne,"",lcString+;
               '</body>'+m.This.aSpace(21)+'</html>')

      * Vytvo MainMenu
      IF !llOne
         lcFile=lcOut+"MainMenu.htm"
         lihFile=m.loPDMs.FCreate(lcFile)
         IF lihFile>0
            =FWRITE(lihFile,lcString)
            =m.loPDMs.FClose(lihFile)
         ELSE
            m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcFile))
         ENDIF
      ENDIF


      * Vytvo extern soubor JavaScript
      lcFile=lcOut+m.loPDMs.ExternJS
      lihFile=m.loPDMs.FCreate(lcFile)
      IF lihFile>0
         lcString=m.loPDMs.AddScript("go_class_m")+;
                  m.loPDMs.AddScript("go_class")+;
                  m.loPDMs.AddScript("go_proc")+;
                  m.loPDMs.AddScript("LostFocus")+;
                  m.loPDMs.AddScript("ExpandSC")+;
                  m.loPDMs.AddScript("LoadForm")+;
                  m.loPDMs.AddScript("ExpandVal")+;
                  m.loPDMs.AddScript("HighLite")+;
                  m.loPDMs.AddScript("HighLiteII")+;
                  m.loPDMs.AddScript("ExpandTab")+;
                  m.loPDMs.AddScript("ExpandAllObjects")+;
                  m.loPDMs.AddScript("GetBrowser")+;
                  m.loPDMs.AddScript("MouseMove")+;
                  m.loPDMs.AddScript("onExpandTab")+;
                  m.loPDMs.AddScript("Go_Band")+;
                  m.loPDMs.AddScript("Go_Object")+;
                  m.loPDMs.AddScript("QuickViewIMG")+;
                  m.loPDMs.AddScript("GetRoot")+;
                  m.loPDMs.AddScript("ExpandTreeRow")+;
                  m.loPDMs.AddScript("onExpandTreeRow")+;
                  m.loPDMs.AddScript("ExpandAllDIV")+;
                  m.loPDMs.AddScript("HighLiteOver")+;
                  m.loPDMs.AddScript("HighLiteOut")+;
                  m.loPDMs.AddScript("LNK_Functions")+;
                  m.loPDMs.AddScript("GetAbsoluteLeft")
                  
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcFile))
      ENDIF


      * Vytvo Blank_QL.htm
      lcFile=lcOut+"Blank_QL.htm"
      lihFile=m.loPDMs.FCreate(lcFile)
      IF lihFile>0
         lcString=m.loPDMs.GetHeader(m.loPDMs.aStrings(PDM_05102))+m.loPDMs.GetStyles()+lcCSS+m.loPDMs.AddExternalScript(m.loPDMs.ExternJS)+lcJS+;
                  '</head><body class="quickfilelist">'+m.This.aSpace(21)+;
                  This.aSpace(1)+m.loPDMs.aStrings(PDM_00480)+m.This.aSpace(21)+;
                  '</body>'+m.This.aSpace(21)+'</html>'
                  
         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcFile))
      ENDIF


      * Create the main Index.htm page
      lcFile=lcOut+"Index.htm"
      lihFile=m.loPDMs.FCreate(lcFile)
      IF lihFile>0
         lcString=m.loPDMs.GetHeader('')+;
                  [<meta http-equiv="Refresh" content="1; URL=]+STRTRAN(lcFirst,"\","/")+[">]+m.This.aSpace(21)+;
                  '</head><body>'+m.This.aSpace(21)+;
                  '</body>'+m.This.aSpace(21)+'</html>'+m.This.aSpace(21)

         =FWRITE(lihFile,lcString)
         =m.loPDMs.FClose(lihFile)
      ELSE
         m.loPDMs.WriteToLogFile(STRTRAN(m.loPDMs.GetString(_PDM_msgFileNC),"%File%",lcFile))
      ENDIF
      
      m.This.FirstPage=lcFirst && Zapi si prvn strnku, kter se vygenerovala
   ENDPROC


   PROCEDURE SetDefSets() && Nastav vchoz hodnoty
      LOCAL loPDMs,lcData,liCount,liz,lii,liy,lim,lcAPPData
      LOCAL ARRAY laPom(1)

      loPDMs=EVAL(This.PDMs)

      This.ErrStopCount=-1
      This.SyntaxColoring=1 && Pznak SyntaxColoring
      STORE 0 TO This.NP_ExcludeFiles,This.GL_NonGenPage,This.ClearOutDir,This.Incremental,This.Severally,;
                 This.SCIndent,This.SCCounter,This.Array_AddAsProperty,This.Array_RemoveCells,;
                 This.CreateAnchorsForAllProperties

      STORE 1 TO This.ECPMDblclick, This.ShowQuickFileList

      STORE _EPM_User TO This.ExpandAllPM
      STORE _AP_No TO This.AutoPrint

      This.FirstPage=""
      This.IncludeSC=_ESC_Include
      This.IncludeSC_S=""

      This.GLCSS=""
      This.GLJS=""
      This.DefaultFolder=""
      This.FoxCodeTable=""

      STORE _Format_Yes TO This.FormatSpace,This.FormatCRLF

      This.IncludeDD=_EDD_Include
      STORE "" TO m.This.IncludeDD_S, This.DD_START, This.DD_STOP
      This.OnlyComment=_DD_OC_Yes

      This.SourceType=_PDM_ST_Project

      STORE 0.25 TO This.Margin_Left,This.Margin_Right
      STORE 0.0  TO This.Margin_Top,This.Margin_Bottom

      lcAPPData=loPDMs.APPData

      * Nati seznam znmch typ soubor
      lcData=GetINISection("DEFEXT",32000,m.lcAPPData+"pdm.ini") && Cel sekce
      m.liCount=0
      IF !EMPTY(m.lcData) && Pokud to nen przdn
         lcData=STRTRAN(m.lcData,CHR(0),CHR(13)+CHR(10))
         m.liCount=ALINES(laPom,m.lcData) && Nati dky
      ENDIF
      IF m.liCount>0
         DIME m.This.aDefExt(m.liCount,2)
         liz=0
         FOR lii=1 TO m.liCount
             liy=AT(":",laPom(m.lii))
             IF m.liy>0
                liz=m.liz+1
                lim=AT("=",laPom(m.lii))
                m.This.aDefExt(m.lii,1)=SUBST(laPom(m.lii),m.lim+1,m.liy-m.lim-1)
                m.This.aDefExt(m.lii,2)=SUBST(laPom(m.lii),m.liy+1)
             ENDIF
         NEXT
         IF m.liz>0
            DIME m.This.aDefExt(m.liz,2)
         ENDIF
      ENDIF
      =This.SetListDefExt()


      This.APISearcher=[http://www.news2news.com/vfp/?search=%name%&x=7&y=5]
*      This.APISearcher=[http://www.google.com/search?q=API+%2B%name%+%2B%File%]
*      This.APISearcher=[http://www.altavista.com/web/results?q=API+%2B%name%+%2B%File%&kgs=0&kls=0]
*      This.APISearcher=[http://www.alltheweb.com/search?cat=web&cs=utf8&q=API+%2B%name%+%2B%File%&_sb_lang=pref]

      =This.PJX.SetDefSets() AND This.DBC.SetDefSets() AND ;
       This.SCX.SetDefSets() AND This.FRX.SetDefSets() AND ;
       This.VCX.SetDefSets() AND This.PRG.SetDefSets() AND ;
       This.LBX.SetDefSets() AND This.XXX.SetDefSets() AND ;
       This.MNX.SetDefSets() AND This.FrP.SetDefSets() AND ;
       This.OMFiles.SetDefSets() AND This.S_C.SetDefSets() AND ;
       This.PlugIns.SetDefSets() AND This.Comments.SetDefSets() AND;
       This.CuS.SetDefSets() AND This.PO.SetDefSets() AND;
       This.GCT.SetDefSets() AND This.STA.SetDefSets()
   ENDPROC


   PROCEDURE AddItemToAR(lcGroup,lcItem) && Add item to auto remove items from INI
      LOCAL lii
      STORE This.iAR+1 TO  This.iAR,lii
      DIME This.aAR(m.lii,2)
      This.aAR(m.lii,1)=lcGroup
      This.aAR(m.lii,2)=lcItem
   ENDPROC


   PROCEDURE ClearAR() && Clear autoremove array
      This.iAR=0
      DIME This.aAR(1)
      This.aAR(1)=.NULL.
   ENDPROC

   PROCEDURE Open(lcFile) && Oteve PDM projekt
      * lcFile - PDM project
      LOCAL lcData,lii,liy,liz,liCount,liz,loPDMs,loSet
      LOCAL ARRAY laPom(1)
      loPDMs=EVAL(This.PDMs)
      
      STORE lcFile TO This.PDM_File,This._Name
      This.FileVersion=GetINIString("GENERAL","Version",This.FileVersion,254,@m.lcFile)

      This.ErrStopCount=GetINIInt("GENERAL","ErrStopCount",This.ErrStopCount,@m.lcFile)
      This.PJXFile=GetINIString("GENERAL","PJXFile",This.PJXFile,254,@m.lcFile)
      This.OutDir=GetINIString("GENERAL","OutDir",This.OutDir,254,@m.lcFile)
      This.FirstPage=GetINIString("GENERAL","FirstPage",This.FirstPage,254,@m.lcFile)
      This.NP_ExcludeFiles=GetINIInt("GENERAL","NP_ExcludeFiles",This.NP_ExcludeFiles,@m.lcFile)
      This.GL_NonGenPage=GetINIInt("GENERAL","GL_NonGenPage",This.GL_NonGenPage,@m.lcFile)
      This.ExpandAllPM=GetINIInt("GENERAL","ExpandAllPM",This.ExpandAllPM,@m.lcFile)
      This.AutoPrint=GetINIInt("GENERAL","AutoPrint",This.AutoPrint,@m.lcFile)
      This.IncludeSC=GetINIInt("GENERAL","IncludeSC",This.IncludeSC,@m.lcFile)
      This.IncludeSC_S=GetINIString("GENERAL","IncludeSC_S",This.IncludeSC_S,30,@m.lcFile)
      This.IncludeDD=GetINIInt("GENERAL","IncludeDD",This.IncludeDD,@m.lcFile)
      This.IncludeDD_S=GetINIString("GENERAL","IncludeDD_S",This.IncludeDD_S,30,@m.lcFile)
      This.DD_START=GetINIString("GENERAL","DD_START",This.DD_START,30,@m.lcFile)
      This.DD_STOP=GetINIString("GENERAL","DD_STOP",This.DD_STOP,30,@m.lcFile)
      This.OnlyComment=GetINIInt("GENERAL","OnlyComment",This.OnlyComment,@m.lcFile)
      This.ClearOutDir=GetINIInt("GENERAL","ClearOutDir",This.ClearOutDir,@m.lcFile)
      This.Incremental=GetINIInt("GENERAL","Incremental",This.Incremental,@m.lcFile)
      This.SourceType=GetINIInt("GENERAL","SourceType",This.SourceType,@m.lcFile)
      This.Severally=GetINIInt("GENERAL","Severally",This.Severally,@m.lcFile)

      This.SyntaxColoring=GetINIInt("GENERAL","SyntaxColoring",This.SyntaxColoring,@m.lcFile)
      This.SCIndent=GetINIInt("GENERAL","SCIndent",This.SCIndent,@m.lcFile)
      This.SCCounter=GetINIInt("GENERAL","SCCounter",This.SCCounter,@m.lcFile)

      This.GLCSS=GetINIString("GENERAL","GLCSS",This.GLCSS,32000,@m.lcFile)
      This.GLJS=GetINIString("GENERAL","GLJS",This.GLJS,32000,@m.lcFile)
      This.HTMLS=ALLT(GetINIString("GENERAL","HTMLS",ALLT(This.HTMLS),254,@m.lcFile))

      This.Margin_Left=VAL(GetINIString("GENERAL","Margin_Left",STR(This.Margin_Left,6,4),6,@m.lcFile))
      This.Margin_Right=VAL(GetINIString("GENERAL","Margin_Right",STR(This.Margin_Right,6,4),6,@m.lcFile))
      This.Margin_Top=VAL(GetINIString("GENERAL","Margin_Top",STR(This.Margin_Top,6,4),6,@m.lcFile))
      This.Margin_Bottom=VAL(GetINIString("GENERAL","Margin_Bottom",STR(This.Margin_Bottom,6,4),6,@m.lcFile))

      This.FormatSpace=GetINIInt("GENERAL","FormatSpace",This.FormatSpace,@m.lcFile)
      This.FormatCRLF=GetINIInt("GENERAL","FormatCRLF",This.FormatCRLF,@m.lcFile)

      This.APISearcher=ALLT(GetINIString("GENERAL","APISearcher",ALLT(This.APISearcher),254,@m.lcFile))
      This.DefaultFolder=GetINIString("GENERAL","DefaultFolder",This.DefaultFolder,254,@m.lcFile)
      This.FoxCodeTable=GetINIString("GENERAL","FoxCodeTable",This.FoxCodeTable,254,@m.lcFile)

      This.Array_AddAsProperty=GetINIInt("GENERAL","Array_AddAsProperty",This.Array_AddAsProperty,@m.lcFile)
      This.Array_RemoveCells=GetINIInt("GENERAL","Array_RemoveCells",This.Array_RemoveCells,@m.lcFile)
      This.ShowQuickFileList=GetINIInt("GENERAL","ShowQuickFileList",This.ShowQuickFileList,@m.lcFile)

      This.CreateAnchorsForAllProperties=GetINIInt("GENERAL","CreateAnchorsForAllProperties",This.CreateAnchorsForAllProperties,@m.lcFile)
      This.ECPMDblclick=GetINIInt("GENERAL","ECPMDblclick",This.ECPMDblclick,@m.lcFile)

      This.TabSize=GetINIInt("GENERAL","TabSize",This.TabSize,@m.lcFile)

      * Nati seznam znmch typ soubor
      lcData=GetINISection("DEFEXT",32000,@m.lcFile) && Cel sekce
      m.liCount=0
      IF !EMPTY(m.lcData) && Pokud to nen przdn
         lcData=STRTRAN(m.lcData,CHR(0),CHR(13)+CHR(10))
         m.liCount=ALINES(laPom,m.lcData) && Nati dky
      ENDIF
      IF m.liCount>0
         DIME m.This.aDefExt(m.liCount,2)
         liz=0
         FOR lii=1 TO m.liCount
             liy=AT(":",laPom(m.lii))
             IF m.liy>0
                liz=m.liz+1
                m.This.aDefExt(m.lii,1)=SUBST(laPom(m.lii),2,m.liy-2)
                m.This.aDefExt(m.lii,2)=SUBST(laPom(m.lii),m.liy+1)
             ENDIF
         NEXT
         IF m.liz>0
            DIME m.This.aDefExt(m.liz,2)
         ENDIF
      ENDIF
      =This.SetListDefExt()


      =This.PJX.Open(@m.lcFile)
      =This.DBC.Open(@m.lcFile)
      =This.SCX.Open(@m.lcFile)
      =This.FRX.Open(@m.lcFile)
      =This.VCX.Open(@m.lcFile)
      =This.PRG.Open(@m.lcFile)
      =This.LBX.Open(@m.lcFile)
      =This.XXX.Open(@m.lcFile)
      =This.MNX.Open(@m.lcFile)
      =This.FrP.Open(@m.lcFile,"GENERAL")
      =This.OMFiles.Open(@m.lcFile,"GENERAL")
      =This.S_C.Open(@m.lcFile,"GENERAL")
      =This.PlugIns.Open(@m.lcFile,"GENERAL")
      =This.Comments.Open(@m.lcFile,"GENERAL")
      =This.CuS.Open(@m.lcFile)
      =This.PO.Open(@m.lcFile,"GENERAL")
      =This.GCT.Open(@m.lcFile)
      =This.STA.Open(@m.lcFile)

      * Nyn zkontroluj zda naten verze odpovd t posledn znm
      IF !loPDMs.FileVersion==This.FileVersion
         IF VAL(CHRTRAN(This.FileVersion,".",""))=0
            * zave plug-in pro SC 
            * a nastav mu tyto vlastnosti
            IF This.SyntaxColoring>0
               This.Plugins.AddPlugIn(40000,.NULL.,.F.)
               loSet=This.Plugins.GetSetting(40000) 
               loSet.SyntaxColoring=This.SyntaxColoring
               loSet.SCFile=GetINIString("GENERAL","SCFile",loSet.SCFile,254,@m.lcFile)
               This.SyntaxColoring=1
            ENDIF
            This.AddItemToAR("GENERAL","SCFile")
         ENDIF

         * pidej plugin value formating pro verze mlad ne 0.0.2
         * STOP B
         IF VAL(CHRTRAN(This.FileVersion,".",""))<=1
            loPI=This.Plugins.AddPlugIn(50000,.NULL.,.F.)
            IF NOT ISNULL(loPI)
               loSet=This.Plugins.GetSetting(50000)
               loPI.CreateDefaultSettings(loSet)
            ENDIF   
            This.ClearOutDir=1
         ENDIF
  
         This.FileVersion=loPDMs.FileVersion
      ENDIF

      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Save() && Save PDM file
      LOCAL lcFile,m.loPDMs,lcPom,lii,lcData,lcCSS,lcJS

      STORE This.PDM_File TO lcFile,This._Name
      IF EMPTY(lcFile)
         RETURN
      ENDIF
      loPDMs=EVAL(This.PDMs)

      * Remove old settings from INI file - first
      FOR lii=1 TO This.iAR
          =IIF(ISNULL(This.aAR(m.lii,2)),;
               WriteINISection(This.aAR(m.lii,1),.NULL.,@lcFile),;
               WriteINIString(This.aAR(m.lii,1),This.aAR(m.lii,2),.NULL.,@lcFile))
      NEXT
      This.ClearAR() 

      =WriteINIString("GENERAL","Version",This.FileVersion,@m.lcFile)

      =WriteINIString("GENERAL","ErrStopCount",LTRIM(STR(This.ErrStopCount,11)),@m.lcFile)
      =WriteINIString("GENERAL","SyntaxColoring",STR(This.SyntaxColoring,1),@m.lcFile)
      =WriteINIString("GENERAL","SCIndent",STR(This.SCIndent,1),@m.lcFile)
      =WriteINIString("GENERAL","SCCounter",STR(This.SCCounter,1),@m.lcFile)
      =WriteINIString("GENERAL","NP_ExcludeFiles",STR(This.NP_ExcludeFiles,1),@m.lcFile)
      =WriteINIString("GENERAL","GL_NonGenPage",STR(This.GL_NonGenPage,1),@m.lcFile)
      =WriteINIString("GENERAL","ExpandAllPM",STR(This.ExpandAllPM,1),@m.lcFile)
      =WriteINIString("GENERAL","AutoPrint",STR(This.AutoPrint,1),@m.lcFile)
      =WriteINIString("GENERAL","ClearOutDir",STR(This.ClearOutDir,1),@m.lcFile)
      =WriteINIString("GENERAL","Incremental",STR(This.Incremental,1),@m.lcFile)

      =WriteINIString("GENERAL","PJXFile",This.PJXFile,@m.lcFile)
      =WriteINIString("GENERAL","OutDir",This.OutDir,@m.lcFile)

      =WriteINIString("GENERAL","IncludeSC",STR(This.IncludeSC,1),@m.lcFile)
      =WriteINIString("GENERAL","IncludeSC_S",This.IncludeSC_S,@m.lcFile)
      =WriteINIString("GENERAL","IncludeDD",STR(This.IncludeDD,1),@m.lcFile)
      =WriteINIString("GENERAL","IncludeDD_S",This.IncludeDD_S,@m.lcFile)
      =WriteINIString("GENERAL","DD_START",This.DD_START,@m.lcFile)
      =WriteINIString("GENERAL","DD_STOP",This.DD_STOP,@m.lcFile)
      =WriteINIString("GENERAL","OnlyComment",STR(This.OnlyComment,1),@m.lcFile)

      =WriteINIString("GENERAL","SourceType",STR(This.SourceType,1),@m.lcFile)
      =WriteINIString("GENERAL","Severally",STR(This.Severally,1),@m.lcFile)

      lcCSS=This.GLCSS
      lcJS=This.GLJS
      =This.FormalyzeGLCSS_JS(ExtractPathFromFile(m.lcFile),@lcCSS,@lcJS)
      =WriteINIString("GENERAL","GLCSS",m.lcCSS,@m.lcFile)
      =WriteINIString("GENERAL","GLJS",m.lcJS,@m.lcFile)

      =WriteINIString("GENERAL","Margin_Left",STR(This.Margin_Left,6,4),@m.lcFile)
      =WriteINIString("GENERAL","Margin_Right",STR(This.Margin_Right,6,4),@m.lcFile)
      =WriteINIString("GENERAL","Margin_Top",STR(This.Margin_Top,6,4),@m.lcFile)
      =WriteINIString("GENERAL","Margin_Bottom",STR(This.Margin_Bottom,6,4),@m.lcFile)

      lcPom=IIF(AT("\\",This.HTMLS)>0 OR AT(":",This.HTMLS)>0,This.PathRelativePathTo(m.loPDMs.MainPath,This.HTMLS),This.HTMLS)
      =WriteINIString("GENERAL","HTMLS",ALLT(lcPom),@m.lcFile)

      =WriteINIString("GENERAL","FormatSpace",STR(This.FormatSpace,1),@m.lcFile)
      =WriteINIString("GENERAL","FormatCRLF",STR(This.FormatCRLF,1),@m.lcFile)

      =WriteINIString("GENERAL","APISearcher",This.APISearcher,@m.lcFile)
      =WriteINIString("GENERAL","DefaultFolder",This.DefaultFolder,@m.lcFile)
      =WriteINIString("GENERAL","FoxCodeTable",This.FoxCodeTable,@m.lcFile)


      =WriteINIString("GENERAL","Array_AddAsProperty",STR(This.Array_AddAsProperty,1),@m.lcFile)
      =WriteINIString("GENERAL","Array_RemoveCells",STR(This.Array_RemoveCells,1),@m.lcFile)
      =WriteINIString("GENERAL","ShowQuickFileList",STR(This.ShowQuickFileList,1),@m.lcFile)
      
      =WriteINIString("GENERAL","CreateAnchorsForAllProperties",STR(This.CreateAnchorsForAllProperties,1),@m.lcFile)
      =WriteINIString("GENERAL","ECPMDblclick",STR(This.ECPMDblclick,1),@m.lcFile)
      =WriteINIString("GENERAL","TabSize",STR(This.TabSize,5),@m.lcFile)

      * Save default extension
      lcData="" && Vyisti buffer
      FOR lii=1 TO ALEN(m.This.aDefExt,1)
          lcData=m.lcData+"="+m.This.aDefExt(m.lii,1)+":"+m.This.aDefExt(m.lii,2)+CHR(0)
      NEXT
      =WriteINISection("DEFEXT",@m.lcData,@m.lcFile) && Zapi poet
      

      =This.Save_FirstPage(lcFile)

      =This.PJX.Save(@m.lcFile)
      =This.DBC.Save(@m.lcFile)
      =This.SCX.Save(@m.lcFile)
      =This.FRX.Save(@m.lcFile)
      =This.VCX.Save(@m.lcFile)
      =This.PRG.Save(@m.lcFile)
      =This.LBX.Save(@m.lcFile)
      =This.XXX.Save(@m.lcFile)
      =This.MNX.Save(@m.lcFile)
      =This.CuS.Save(@m.lcFile)
      =This.FrP.Save(@m.lcFile,"GENERAL")
      =This.OMFiles.Save(@m.lcFile,"GENERAL")
      =This.S_C.Save(@m.lcFile,"GENERAL")
      =This.PlugIns.Save(@m.lcFile,"GENERAL")
      =This.Comments.Save(@m.lcFile,"GENERAL")
      =This.PO.Save(@m.lcFile,"GENERAL")
      =This.GCT.Save(@m.lcFile)
      =This.STA.Save(@m.lcFile)

      * Remove old settings from INI file - second
      FOR lii=1 TO This.iAR
          =IIF(ISNULL(This.aAR(m.lii,2)),;
               WriteINISection(This.aAR(m.lii,1),.NULL.,@lcFile),;
               WriteINIString(This.aAR(m.lii,1),This.aAR(m.lii,2),.NULL.,@lcFile))
      NEXT
      This.ClearAR() 

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE SaveSpecial() && Save special settings PDM project after process VFP project
      LOCAL lcFile
      lcFile=m.This.PDM_File
      =This.Save_FirstPage(@m.lcFile)
      =This.Save_ICL(@m.lcFile)
   ENDPROC

   PROCEDURE Save_FirstPage(lcFile) && Ulo prvn HTML strnku
      * lcFile - PDM project 
      =WriteINIString("GENERAL","FirstPage",m.This.FirstPage,@m.lcFile)
   ENDPROC

   PROCEDURE Save_ICL(lcFile) && Ulo seznam soubor, jejich velikost a datum s asem
      * lcFile - PDM project 
      LOCAL lcAlias,loPDMs,luCatch
      IF EMPTY(lcFile) && If file not defined
         RETURN && tehn return
      ENDIF
      m.loPDMs=EVAL(m.This.PDMs)
      lcAlias=SELE() && Zapamatuj si alias
      SELE (m.This.AICL) && Sko na seznam soubor
      luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
      COPY TO (ChangeExtensionFromFile(lcFile,"pdmicl")) TYPE SDF
      =m.loPDMs.SetCatch(luCatch) && Vra zachycen chyby
      SELE (lcAlias) && Sko na pvodn oblast
   ENDPROC

   PROCEDURE Read_ICL(lcFile) && nate seznam soubor, jejich velikost a datum s asem
      * lcFile - PDM project 
      LOCAL lcAlias,loPDMs,luCatch
      lcFile=ChangeExtensionFromFile(lcFile,"pdmicl")
      IF FILE(lcFile) && If Exist
         loPDMs=EVAL(m.This.PDMs)
         lcAlias=SELE() && Zapamatuj si alias
         SELE (m.This.AICL) && Sko na seznam soubor
         luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         APPEND FROM (lcFile) TYPE SDF
         =m.loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         SELE (lcAlias) && Sko na pvodn oblast
      ENDIF
   ENDPROC

   PROCEDURE ICL_TestFile(lcFile) && Otestuje, zda soubor existuje v seznamu a jak m atributy
      * lcFile - File from VFP project
      LOCAL lcAlias,llChange,lcDT
      LOCAL ARRAY laFile(1)
      llChange=.T. && Nastav pznak zmny
      lcAlias=SELE() && Zapamatuj si alias
      SELE (m.This.AICL) && Sko na seznam soubor
      IF ADIR(laFile,lcFile)=0 && Nati informace o souboru
         RETURN .F.
      ENDIF
      lcFile=PADR(UPPER(lcFile),254)
      lcDT=DTOS(laFile(1,3))+laFile(1,4)
      
      LOCATE FOR XX300==lcFile
      IF FOUND()
         llChange=XX301#laFile(1,2) OR XX302#lcDT
         IF llChange
            REPL XX301 WITH laFile(1,2), XX302 WITH lcDT
         ENDIF
      ELSE
         INSERT INTO (m.This.AICL) (XX300,XX301,XX302) VALUES (lcFile,laFile(1,2),lcDT)
      ENDIF
      SELE (lcAlias) && Sko na pvodn oblast
      RETURN llChange && Return flag of change file
   ENDPROC

   PROCEDURE CreateAnchors() && Open friendly PDM file and create list of files's and classes's anchors
      PRIVATE loSPDM
      LOCAL lii,lcFile,loPDMs,liErr
      loPDMs=EVAL(m.This.PDMs)
      loSPDM=CREATEOBJECT("_pdm",m.This.PDMs,"loSPDM",m.loPDMs.Collate) && Create single PDM object

      FOR lii=1 TO m.This.FrP.Count
          lcFile=m.This.FrP.aList(lii,2) && PDM File
          This.FrP.aList(lii,4)=.NULL. && Reset reference to _UList
          loSPDM.Open(FULLPATH(lcFile,m.This.PDM_File)) && Open PDM file (read settings)

          liErr=loSPDM.OpenPJX() && Open PJX File
          IF liErr=_PDM_OK
             * Relative Directory from Outdir to outdir friendly project
             IF m.loPDMs.AddReg(lcFile)
                This.FrP.aList(lii,3)=LOWER(SYS(2014,loSPDM.OutDir,This.OutDir))
                This.FrP.aList(lii,4)=CREATEOBJECT("_uList")
                This.FrP.aList(lii,5)=IIF(EMPTY(loSPDM.FirstPage),loSPDM.PJX.HTMLMain,loSPDM.FirstPage)
                loSPDM.CreateAnchorsD(m.This.FrP.aList(lii,4))
             ENDIF
          ENDIF
          loSPDM.ClosePJX() && Open PJX File
          loSPDM.SetDefSets() && Reset all Settings
      NEXT

      * A nyn to sam pro tento PDM projekt
      IF m.loPDMs.AddReg(m.This.PDM_File)
         =This.CreateAnchorsD(CREATEOBJECT("_uList"))
      ENDIF
      
      RELE loSPDM
   ENDPROC

   PROCEDURE CreateAnchorsD(louList)
      * louList - Universal object for list

      LOCAL m.lcAlias, m.lcPath, m.lii, m.lcFile, m.lcAnchor, m.liNPEF,;
            m.liCount, m.loRam, m.lcPom, m.loASC, m.loPDMs, m.lcPath, m.loXXX, m.luCatch, m.lcExt, m.loFL, m.lcSC, m.lcMSGF,;
            m.loFPL, m.liPEM07, m.lcRow, m.lcName, m.liSID

      This.PI_Initialize(.T.)
      LOCAL ARRAY laXXXs(1)
      loPDMs=EVAL(m.This.PDMs)
      This.ChangedPJX=.F.
      lcMSGF=m.loPDMs.GetString(_PDM_msgPrepareF)
      
      lcPath=m.This.PJXPath
      liNPEF=m.This.NP_ExcludeFiles

      PUBLIC ARRAY paComments(1)
      =This.Comments.PrepareArray(@paComments)

      loASC=m.This.oAPRG


      ******************************************************
      * Basic quick analysing
      ******************************************************
      * Data Page
      IF m.This.DBC.Generate=1 &&  AND !This.Simple
         loFPL=m.This.DBC.FPL
         loXXX=m.This.DBC
         * Create anchors DBC containers
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam DBC konteiner
         
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_DBC,"")
                   louList.Add(lcFile)
                   =This.AddFileToStats(m.loXXX, _PDM_FG_DBC, m.loRam.size)
                   loXXX.QuickAnalyse_DBC(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
         =m.loPDMs.WriteDMSG("")

         * Create anchors free tables
         liCount=IIF(loXXX.GEN_Tables=1,m.This.GetListOfObject(loXXX.aTF(2),@laXXXs),0) && Vrt seznam volnch DBF tabulek
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\FreeTables\"+loXXX.FileName+".htm","",_PDM_FG_DBF,"")
                   louList.Add(lcFile)
                   =This.AddFileToStats(m.loXXX, _PDM_FG_DBF, m.loRam.size)
                   loXXX.QuickAnalyse_FDBF(m.lcFile ,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
         =m.loPDMs.WriteDMSG("")
         
         * Create anchors Queries
         liCount=IIF(loXXX.GEN_Queries=1,m.This.GetListOfObject(loXXX.aTF(3),@laXXXs),0) && Vrt seznam dotaz
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\Queries\"+loXXX.FileName+".htm","",_PDM_FG_QPR,"")
                   louList.Add(lcFile)
                   =This.AddFileToStats(m.loXXX, _PDM_FG_QPR, m.loRam.size)
                   loXXX.QuickAnalyse_QPR(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * VCX libraries Page
      IF m.This.VCX.Generate=1
         loXXX=m.This.VCX

         * Create anchors VCX libraries
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam VCX knihoven
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_VCX,"")
                   louList.Add(lcFile)
                   =This.AddFileToStats(m.loXXX, _PDM_FG_VCX, m.loRam.size)
                   loXXX.QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Forms Page
      IF m.This.SCX.Generate=1
         loFPL=m.This.SCX.FPL
         loXXX=m.This.SCX
         * Create anchors forms
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam formul
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_SCX,"")
                   louList.Add(lcFile)
                   =This.AddFileToStats(m.loXXX, _PDM_FG_SCX, m.loRam.size)
                   loXXX.QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Programs Page
      IF m.This.PRG.Generate=1
         * Create anchors programs
         loXXX=m.This.PRG
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam program

         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))

                IF !(loRam.Exclude AND liNPEF=1) AND;
                     (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom)) AND;
                      !m.loPDMs.IsFileHasAnchor(lcPom)

                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_PRG,"")
                   louList.Add(lcFile)
                   * Analyze PRG file
                   =This.AddFileToStats(m.loXXX, _PDM_FG_PRG, m.loRam.size)
                   loXXX.QuickAnalyse(lcFile,AppendShortFileFromFile("Main.htm","_d"))
                ENDIF
             ENDIF
         ENDFOR

         liCount=m.This.GetListOfObject(loXXX.aTF(2),@laXXXs) && Vrt seznam FLL knihoven
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))

                IF !(loRam.Exclude AND liNPEF=1) AND;
                     (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom)) AND;
                      !m.loPDMs.IsFileHasAnchor(lcPom)

                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_FLL,"")
                   louList.Add(lcFile)
                   * Analyze FLL file
                   =This.AddFileToStats(m.loXXX, _PDM_FG_FLL, m.loRam.size)
                   loXXX.QuickAnalyseFLL(lcFile,AppendShortFileFromFile("Main.htm","_d"))
                ENDIF
             ENDIF
         ENDFOR

      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Reports Page
      IF m.This.FRX.Generate=1
         loFPL=m.This.FRX.FPL
         loXXX=m.This.FRX
         * Create anchors reports
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam report
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_FRX,"")
                   louList.Add(lcFile)
                   =This.AddFileToStats(m.loXXX, _PDM_FG_FRX, m.loRam.size)
                   loXXX.QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Labels Page
      IF m.This.LBX.Generate=1
         loFPL=m.This.LBX.FPL
         loXXX=m.This.LBX
         * Create anchors labels
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam label
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objekt
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_LBX,"")
                   louList.Add(lcFile)
                   =This.AddFileToStats(m.loXXX, _PDM_FG_LBX, m.loRam.size)
                   loXXX.QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")
            
      * Menus Page
      IF m.This.MNX.Generate=1
         loFPL=m.This.MNX.FPL
         loXXX=m.This.MNX
         * Create anchors menus
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam menu
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objekt
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_MNX,"")
                   louList.Add(lcFile)
                   =This.AddFileToStats(m.loXXX, _PDM_FG_MNX, m.loRam.size)
                   loXXX.QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Other Page
      IF m.This.XXX.Generate=1
         * Create anchors h files
         loXXX=m.This.XXX
         liCount=m.This.GetListOfObject("T",@laXXXs) && Vrt seznam textovch soubor

         * Nyn prove pouze analzu H souboru
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                lcExt=UPPER(ExtractExtensionFromFile(lcPom))

                IF (lcExt="H" OR lcExt="HPP") AND !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.This.XXX.Generate=1

                   * Analyze H file
                   lcSC=""
                   luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
                   lcSC=FILETOSTR(lcFile)
                   m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby
                   IF !EMPTY(lcSC)
                      loASC.Reset()
                      loASC.iSource=_ASC_PRG
                      loASC.HTMLName=AppendShortFileFromFile("Main.htm","_d")
                      loASC.QuickAnalyse(loXXX,@lcSC)
                   ENDIF
                   loXXX.QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
         =m.loPDMs.WriteDMSG("")

         liCount=m.This.GetListOfObject("T",@laXXXs) && Vrt seznam textovch soubor
         * Nyn vytvo odkazy na tyto soubory
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                lcExt=UPPER(ExtractExtensionFromFile(lcPom))

                STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                IF (lcExt="H" OR lcExt="HPP") AND !(loRam.Exclude AND liNPEF=1) AND FILE(lcFile) AND (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom)) AND !m.loPDMs.IsFileHasAnchor(lcPom)
*!*	                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.FileName=loRam.GUID
                   m.loPDMs.AddAnchor(lcFile,"","",loXXX.OutDir+"\"+loXXX.FileName+"\Main.htm","",_PDM_FG_HPP,"")
                   =This.AddFileToStats(m.loXXX, _PDM_FG_HPP, m.loRam.size)
                   louList.Add(lcFile)
                ENDIF
             ENDIF
         ENDFOR

         m.liCount=m.This.GetListOfObject("x", @m.laXXXs) && Vrt seznam obrazku
         * Nyn vytvo odkazy na tyto soubory
         FOR m.lii = 1 TO m.liCount
             IF m.This.GetPropertiesOfObject(m.laXXXs(m.lii,2), @m.loRam) && Vrt vlastnosti objektu
                m.lcPom=NullTermined(m.loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(m.lcMSGF, "%File%", m.lcPom))
                m.lcExt=UPPER(ExtractExtensionFromFile(m.lcPom))

                STORE FULLPATH(m.lcPom, m.lcPath) TO m.lcFile, m.loXXX.File
                IF !(loRam.Exclude AND m.liNPEF=1) AND FILE(m.lcFile) AND (m.This.SourceType=_PDM_ST_OMFiles OR m.loXXX.FPL.Type=1 OR m.loXXX.FPL.IsFileProcess(m.lcPom))
                   m.loXXX.FileName=m.loRam.GUID
                   =This.AddFileToStats(m.loXXX, _PDM_FG_IMG, m.loRam.size)
                   m.loXXX.QuickAnalyse_IMG(m.lcFile, "Main.htm")
                ENDIF
             ENDIF
         ENDFOR


         This.XXX.Generate=1
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Custom Links
      IF m.This.CuS.Generate=1
         loFL=m.This.CuS.FL
         * Create anchors menus
         FOR lii = 1 TO loFL.Count
             * Normalizuj zdroj
             STORE ALLT(loFL.aList(lii,2)) TO lcFile,loFL.aList(lii,2)
             loFL.aList(lii,1)=IIF(lcFile="\\" OR SUBS(lcFile,2,2)=":\","file://","")+lcFile

             IF loFL.aList(lii,3)=0 AND m.This.CuS.AlwaysCTR=0 OR ;
                loFL.aList(lii,3)=1 AND ;
                !(LEFT(loFL.aList(lii,1),7)=="file://" AND (SUBST(loFL.aList(lii,1),8,2)="\\" OR SUBS(loFL.aList(lii,1),9,2)=":\"))

                lcPom=""
                m.loPDMs.AddAnchor(loFL.aList(lii,2),"","",loFL.aList(lii,1),"",_PDM_FG_None,"")
             ENDIF
         ENDFOR
      ENDIF

      SET COLLATE TO "MACHINE" && Nastav tdn MACHINE
      lcAlias=SYS(2015)
      liSID=m.This.DataSessionID
      IF NOT EMPTY(This.FoxCodeTable) AND m.loPDMs.OpenTable(liSID,This.FoxCodeTable,m.lcAlias,"SHARE NOUPDATE")=_PDM_OK && Oteve tabulku
         SELECT (lcAlias)
         SET FILTER TO TYPE="E"
         SCAN ALL 
              lcRow=TIP
              lcName=UPPER(ALLTRIM(ABBREV))
              liPEM07=VAL(SYS(2007,lcName))
              SET DATASESSION TO (m.poPDMs.DataSessionID)
              SELECT (poPDMs.AClassesPEM)
              IF NOT SEEK(BINTOC(-2000000001)+BINTOC(liPEM07))
                 INSERT INTO (poPDMs.AClassesPEM) (XX000, PEM , DISPLAYPEM, PEM07 ) VALUES (-2000000001,lcName,PEM_GetXMLProperty(@lcRow,"display"), liPEM07)
              ENDIF   
              SET DATASESSION TO (liSID)
              SELECT (lcAlias)
         ENDSCAN
      ENDIF   
      m.loPDMs.OpenTable(liSID,lcAlias)
      SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn

      =m.loPDMs.WriteDMSG("")
      RELE paComments
      This.PI_Release()

      RETURN _PDM_OK
   ENDPROC


   PROCEDURE PI_QuickAnalysing() && Call Quick Analysing for all plugins
      PRIVATE loSPDM
      LOCAL lii,lcFile,loPDMs,liErr
      loPDMs=EVAL(m.This.PDMs)
      loSPDM=CREATEOBJECT("_pdm",m.This.PDMs,"loSPDM",m.loPDMs.Collate) && Create single PDM object

      FOR lii=1 TO m.This.FrP.Count
          lcFile=m.This.FrP.aList(lii,2) && PDM File
          loSPDM.Open(FULLPATH(lcFile,m.This.PDM_File)) && Open PDM file (read settings)

          liErr=loSPDM.OpenPJX() && Open PJX File
          IF liErr=_PDM_OK
             * Call plug-in for quick analysing
             =loSPDM.PI_QuickAnalysingD()
          ENDIF
          loSPDM.ClosePJX() && Open PJX File
          loSPDM.SetDefSets() && Reset all Settings
      NEXT

      * Call plug-in for quick analysing
      =This.PI_QuickAnalysingD()
      RELE loSPDM
   ENDPROC


   PROCEDURE PI_QuickAnalysingD() && Call Quick Analysing for all plugins
      LOCAL liCount,loPIPar,loPDMs,lii,liy,lcType,loPIs,liCount2,loPI,;
            lcPath,lcFile,liNPEF,loRam,lcPom,lcPath,loXXX,luCatch,lcExt,loFPL
      LOCAL ARRAY laPI(1),laRows(1),laXXXs(1)


      loPIPar=m.This.oPIPar
      loPDMs=EVAL(This.PDMs)
      loPIs=loPDMs.Plugins

*!*	          loPIPar.FileGroup=IIF(m.lcType=="DIAMP",_PDM_FG_Method,;
*!*	                            IIF(m.lcType=="DIAP",_PDM_FG_Property,;
*!*	                            IIF(m.lcType=="EFRXP",_PDM_FG_FRX,;
*!*	                            IIF(m.lcType=="DIAC",_PDM_FG_Class,;
*!*	                            IIF(m.lcType=="DIAF",_PDM_FG_Any,;
*!*	                            IIF(m.lcType=="AC",_PDM_FG_None,;
*!*	                            IIF(m.lcType=="PJXEX",_PDM_FG_None,;
*!*	                            IIF(m.lcType=="DCOP",_PDM_FG_Any,;
*!*	                            IIF(m.lcType=="CONV",_PDM_FG_None,;
*!*	                            IIF(m.lcType=="BC",_PDM_FG_None,_PDM_FG_None))))))))))

      * DCOP Quick Analysing
*!*	      STORE "DCOP" TO lcType,loPIPar.Type
*!*	      liCount=m.This.PlugIns.GetPlugInByType(m.lcType,@laPI)
*!*	      loPIPar.Reset()
*!*	          
*!*	      loPIPar.FileGroup=_PDM_FG_Any

*!*	      FOR m.liy=1 TO m.liCount
*!*	          =m.laPI(m.liy,1).QuickAnalyse(@m.loPIPar,m.laPI(m.liy,2))
*!*	      NEXT
*!*	      RELE laPI

      lcMSGF=m.loPDMs.GetString(_PDM_msgPrepareF)
      lcPath=m.This.PJXPath
      liNPEF=m.This.NP_ExcludeFiles

      ******************************************************
      * Plugin quick analysing
      ******************************************************
      This.PI_Initialize(.T.)
      * Data Page
      IF m.This.DBC.Generate=1 &&  AND !This.Simple
         loFPL=m.This.DBC.FPL
         loXXX=m.This.DBC
         * Create anchors DBC containers
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam DBC konteiner
         
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse_DBC(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
         =m.loPDMs.WriteDMSG("")

         * Create anchors free tables
         liCount=IIF(loXXX.GEN_Tables=1,m.This.GetListOfObject(loXXX.aTF(2),@laXXXs),0) && Vrt seznam volnch DBF tabulek
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse_DBF(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
         =m.loPDMs.WriteDMSG("")
         
         * Create anchors Queries
         liCount=IIF(loXXX.GEN_Queries=1,m.This.GetListOfObject(loXXX.aTF(3),@laXXXs),0) && Vrt seznam dotaz
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse_QPR(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * VCX libraries Page
      IF m.This.VCX.Generate=1
         loXXX=m.This.VCX

         * Create anchors VCX libraries
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam VCX knihoven
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Forms Page
      IF m.This.SCX.Generate=1
         loFPL=m.This.SCX.FPL
         loXXX=m.This.SCX
         * Create anchors forms
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam formul
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Programs Page
      IF m.This.PRG.Generate=1
         * Create anchors programs
         loXXX=m.This.PRG
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam program

         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))

                IF !(loRam.Exclude AND liNPEF=1) AND;
                     (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom))

                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse(lcFile,AppendShortFileFromFile("Main.htm","_d"))
                ENDIF
             ENDIF
         ENDFOR

         liCount=m.This.GetListOfObject(loXXX.aTF(2),@laXXXs) && Vrt seznam FLL knihoven
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))

                IF !(loRam.Exclude AND liNPEF=1) AND;
                     (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom))

                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   * Analyze FLL file
                   loXXX.PI_QuickAnalyseFLL(lcFile,AppendShortFileFromFile("Main.htm","_d"))
                ENDIF
             ENDIF
         ENDFOR

      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Reports Page
      IF m.This.FRX.Generate=1
         loFPL=m.This.FRX.FPL
         loXXX=m.This.FRX
         * Create anchors reports
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam report
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Labels Page
      IF m.This.LBX.Generate=1
         loFPL=m.This.LBX.FPL
         loXXX=m.This.LBX
         * Create anchors labels
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam label
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objekt
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")
            
      * Menus Page
      IF m.This.MNX.Generate=1
         loFPL=m.This.MNX.FPL
         loXXX=m.This.MNX
         * Create anchors menus
         liCount=m.This.GetListOfObject(loXXX.aTF(1),@laXXXs) && Vrt seznam menu
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objekt
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                IF !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loFPL.Type=1 OR loFPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   loXXX.PI_QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
      ENDIF
      =m.loPDMs.WriteDMSG("")

      * Other Page
      IF m.This.XXX.Generate=1
         * Create anchors h files
         loXXX=m.This.XXX
         liCount=m.This.GetListOfObject("T",@laXXXs) && Vrt seznam textovch soubor

         * Nyn prove pouze analzu H souboru
         FOR lii = 1 TO liCount
             IF m.This.GetPropertiesOfObject(laXXXs(lii,2),@m.loRam) && Vrt vlastnosti objektu
                lcPom=NullTermined(loRam.Name)
                m.loPDMs.WriteMSG(STRTRAN(lcMSGF,"%File%",lcPom))
                lcExt=UPPER(ExtractExtensionFromFile(lcPom))

                IF (lcExt="H" OR lcExt="HPP") AND !(loRam.Exclude AND liNPEF=1) AND (m.This.SourceType=_PDM_ST_OMFiles OR loXXX.FPL.Type=1 OR loXXX.FPL.IsFileProcess(lcPom))
                   STORE FULLPATH(lcPom,lcPath) TO lcFile,loXXX.File
                   loXXX.FileName=LOWER(ExtractFileFromFile(lcFile))
                   m.This.XXX.Generate=1
                   loXXX.PI_QuickAnalyse(lcFile,"Main.htm")
                ENDIF
             ENDIF
         ENDFOR
         =m.loPDMs.WriteDMSG("")
      ENDIF
      This.PI_Release()

      =m.loPDMs.WriteDMSG("")
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE PI_Initialize(llShort) && Initialize plugins
      LOCAL ARRAY laPI(1)
      IF !m.This.PlugIns.OpenSources(llShort)
         RETURN .F.
      ENDIF
      
      This.iDIAMP=m.This.PlugIns.GetPlugInByType("DIAMP",@laPI)
      IF m.This.iDIAMP>0
         DIME This.aDIAMP(m.This.iDIAMP,2)
         =ACOPY(laPI,m.This.aDIAMP)
      ENDIF

      This.iDIAP=m.This.PlugIns.GetPlugInByType("DIAP",@laPI)
      IF m.This.iDIAP>0
         DIME This.aDIAP(m.This.iDIAP,2)
         =ACOPY(laPI,m.This.aDIAP)
      ENDIF

      This.iEFRX=m.This.PlugIns.GetPlugInByType("EFRX",@laPI)
      IF m.This.iEFRX>0
         DIME This.aEFRX(m.This.iEFRX,2)
         =ACOPY(laPI,m.This.aEFRX)
      ENDIF

      This.iDIAC=m.This.PlugIns.GetPlugInByType("DIAC",@laPI)
      IF m.This.iDIAC>0
         DIME This.aDIAC(m.This.iDIAC,2)
         =ACOPY(laPI,m.This.aDIAC)
      ENDIF

      This.iDIAF=m.This.PlugIns.GetPlugInByType("DIAF",@laPI)
      IF This.iDIAF>0
         DIME m.This.aDIAF(m.This.iDIAF,2)
         =ACOPY(laPI,m.This.aDIAF)
      ENDIF

      This.iAC=m.This.PlugIns.GetPlugInByType("AC",@laPI)
      IF m.This.iAC>0
         DIME This.aAC(m.This.iAC,2)
         =ACOPY(laPI,m.This.aAC)
      ENDIF

      This.iPJXEX=m.This.PlugIns.GetPlugInByType("PJXEX",@laPI)
      IF m.This.iPJXEX>0
         DIME This.aPJXEX(m.This.iPJXEX,2)
         =ACOPY(laPI,m.This.aPJXEX)
      ENDIF

      This.iDCOP=m.This.PlugIns.GetPlugInByType("DCOP",@laPI)
      IF m.This.iDCOP>0
         DIME This.aDCOP(m.This.iDCOP,2)
         =ACOPY(laPI,m.This.aDCOP)
      ENDIF

      This.iCONV=m.This.PlugIns.GetPlugInByType("CONV",@laPI)
      IF m.This.iCONV>0
         DIME This.aCONV(m.This.iCONV,2)
         =ACOPY(laPI,m.This.aCONV)
      ENDIF

      This.iBC=m.This.PlugIns.GetPlugInByType("BC",@laPI)
      IF m.This.iBC>0
         DIME This.aBC(m.This.iBC,2)
         =ACOPY(laPI,m.This.aBC)
      ENDIF

      This.iCF=m.This.PlugIns.GetPlugInByType("CF",@laPI)
      IF m.This.iCF>0
         DIME This.aCF(m.This.iCF,2)
         =ACOPY(laPI,m.This.aCF)
      ENDIF

      This.iVF=m.This.PlugIns.GetPlugInByType("VF",@laPI)
      IF m.This.iVF>0
         DIME This.aVF(m.This.iVF,2)
         =ACOPY(laPI,m.This.aVF)
      ENDIF

      RELE laPI
   ENDPROC

   PROCEDURE PI_Release() && Release plugins

      DIME This.aBC(1)
      This.aBC(1)=.NULL.
      This.iBC=0

      DIME This.aDIAMP(1)
      This.aDIAMP(1)=.NULL.
      This.iDIAMP=0

      DIME This.aDIAP(1)
      This.aDIAP(1)=.NULL.
      This.iDIAP=0

      DIME This.aEFRX(1)
      This.aEFRX(1)=.NULL.
      This.iEFRX=0

      DIME This.aDIAC(1)
      This.aDIAC(1)=.NULL.
      This.iDIAC=0

      DIME This.aDIAF(1)
      This.aDIAF(1)=.NULL.
      This.iDIAF=0

      DIME This.aPJXEX(1)
      This.aPJXEX(1)=.NULL.
      This.iPJXEX=0

      DIME This.aDCOP(1)
      This.aDCOP(1)=.NULL.
      This.iDCOP=0

      DIME This.aCF(1)
      This.aCF(1)=.NULL.
      This.iCF=0

      DIME This.aAC(1)
      This.aAC(1)=.NULL.
      This.iAC=0

      DIME This.aVF(1)
      This.aVF(1)=.NULL.
      This.iVF=0

      =This.PlugIns.CloseSources()

   ENDPROC


   PROCEDURE AddFileToRepository(m.XX200,lcDest,m.XX205,m.XX205X) && Add File to repository shared files
      * m.XX200  - Source file
      * lcDest   - Output directory
      *@m.XX205  - Relative link to output directory (out)
      *@m.XX205X - Absolute link to output directory (out)

      LOCAL lcRepos,lcAlias,lcFile,m.XX204,llNew,lcRep,lcSou,luCatch,loPDMs,lcXX200,lcXX205
      LOCAL ARRAY laRep(1,2),laSou(1,2)
      m.XX204=-1
      m.XX200=LOWER(m.XX200)
      lcRepos=m.This.OutDir+"repository\"
      lcFile=ExtractFileFromFile(m.XX200)
      lcAlias=SELE()
      SELE (m.This.ARepos)
      LOCATE FOR XX200==m.XX200
      IF !FOUND() && Zdrojov soubor nen v repositi
         STORE lcRepos+lcFile TO m.XX205X,m.XX205
         IF FILE(m.XX205) && take se mus zkontrolovat, zda tam nen soubor shodnho jmna
            * Pozor, soubor shodnho jmna ji existuje
            * pak je musm zkontrolovat binrn, pokud jsou shodn, pouiju stvajc nzev
            * jinak musm vygenerovat dal nzev a provst koprovn
            LOCATE FOR XX205==m.XX205
            IF XX204=-1
               =ADIR(laRep,m.XX205) && Zjitn velikosti souboru v repositi, nen-li uloena
               m.XX204=m.laRep(1,2)
               REPL XX204 WITH laRep(1,2)
            ELSE
               m.XX204=XX204
            ENDIF

            IF ADIR(laSou,m.XX200)=0 && Zjitn velikosti souboru novho
               laSou(1,2)=-1
            ENDIF

            * Je-li velikost jin, pak se jedna o rzn soubory
            * jinak se mus provst binrn porovnn
            IF m.XX204#laSou(1,2)
               llNew=.T.
               m.XX204=laSou(1,2)
               STORE lcRepos+AppendShortFileFromFile(lcFile,"_"+LTRIM(STR(RECC(),11))) TO m.XX205,m.XX205X
            ELSE
               loPDMs=EVAL(This.PDMs)
               luCatch=m.loPDMs.SetCatch(.T.) && Nastav zachycen chyby
               lcRep=FILETOSTR(m.XX205)
               lcSou=FILETOSTR(m.XX200)
               m.loPDMs.SetCatch(luCatch) && Zru zachycen chyby

               llNew=m.loPDMs.nErr#0 OR !(lcRep==lcRep)
               IF llNew && pro nov soubor vygeneruj odvozen nzev
                  STORE lcRepos+AppendShortFileFromFile(lcFile,"_"+LTRIM(STR(RECC(),11))) TO m.XX205,m.XX205X
               ENDIF
            ENDIF
         ELSE
            llNew=.T. && Soubor v repositi nen
         ENDIF

         IF llNew && Pidv se nov soubor
            lcXX200=m.XX200+CHR(0)
            lcXX205=m.XX205+CHR(0)
            =CopyFile(@lcXX200,@lcXX205,0) && Pekopruj soubor do reposite
            * Pokud je BMP soubor a m u sebe masku, pak ji pekopruj taky
         
            IF RIGHT(m.XX200,4)==".bmp" AND FILE(ChangeExtensionFromFile(m.XX200,"msk"))
               lcXX200=ChangeExtensionFromFile(m.XX200,"msk")+CHR(0)
               lcXX205=ChangeExtensionFromFile(m.XX205,"msk")+CHR(0)
               =CopyFile(@lcXX200,@lcXX205,0) && Pekopruj soubor do reposite
            ENDIF
            INSERT INTO (m.This.ARepos) FROM MEMVAR && Zalo vtu do reposite
         ELSE
            STORE XX205 TO m.XX205,m.XX205X
         ENDIF
      ELSE
         STORE XX205 TO m.XX205,m.XX205X
      ENDIF
      * Vra relativn cestu k obrzku z clovho adrese
      * Nahra backslashe lomtkama
      m.XX205=LOWER(STRTRAN(SYS(2014,m.XX205,lcDest),"\","/"))
      SELE (lcAlias)
   ENDPROC

   PROCEDURE PathRelativePathTo(lcFrom,lcTo) && Return relative path between files
      * lcFrom - From file
      * lcTo   - To file
      RETURN LOWER(STRTRAN(SYS(2014,lcTo,lcFrom),"\","/"))
   ENDPROC


   PROCEDURE FullPath(lcFile,lcTo) && Return Full path for file
      * lcFile - Source File
      * lcTo   - To file/folder

      LOCAL lcDefa,lcFullPath
      lcFullPath=FULLPATH(m.lcFile,m.lcTo)
      IF !FILE(lcFullPath) AND !EMPTY(m.This.DefaultFolder)
         lcDefa=SET("DEFAULT")
         SET DEFAULT TO (m.This.DefaultFolder)
         lcFullPath=FULLPATH(m.lcFile,m.lcTo)
         IF !FILE(lcFullPath)
            lcFullPath=FULLPATH(ExtractFileFromFile(m.lcFile),m.lcTo)
            IF !FILE(lcFullPath)
               lcFullPath=AddBackSlashInPath(m.This.DefaultFolder)+m.lcFile
            ENDIF
         ENDIF
         SET DEFAULT TO (m.lcDefa)
      ENDIF

      RETURN m.lcFullPath
   ENDPROC

   PROCEDURE GetFlagOfFileType(laExt) && 
      *@laExt - (Out) 
      * laExt(1) - Data (dbf,bdc,qpr)
      * laExt(2) - Forms (scx)
      * laExt(3) - Reports (frx)
      * laExt(4) - Code (mpr,prg,fll,app,exe)
      * laExt(5) - Classes (vcx)
      * laExt(6) - Labels (lbx)
      * laExt(7) - Others (txt,ico,jpg,gif,bmp,h, etc...)
      * laExt(8) - Menus (mnx)

      LOCAL loOMFiles,lii,lcExt,liy,liz,loPDMs,lcPom,liSG
      DIME laExt(8)
      STORE 0 TO laExt
      loOMFiles=m.This.OMFiles
      loPDMs=EVAL(m.This.PDMs)
      FOR lii=1 TO m.loOMFiles.Count
          lcExt=ExtractExtensionFromFile(m.loOMFiles.aList(m.lii,1))
          * matice oPDM.aDefExt() obsahuje kd skupiny a seznam ppon
          * matice oPDMs.aSG() obsahuje id superskupiny a seznam kd skupin
          FOR liy=1 TO ALEN(m.This.aDefExt,1)
              IF ATC(m.lcExt,m.This.aDefExt(liy,2))>0
                 FOR liz=1 TO ALEN(m.loPDMs.aSG,1)
                     IF ATC(m.This.aDefExt(liy,1),m.loPDMs.aSG(liz,2))>0
                        laExt(m.loPDMs.aSG(liz,1))=IIF(laExt(m.loPDMs.aSG(liz,1))=0,1,laExt(m.loPDMs.aSG(liz,1)))
                        EXIT
                     ENDIF
                 NEXT
              ENDIF
          NEXT
      NEXT
   ENDPROC

   PROCEDURE GetRecount() && Return count of record
      RETURN RECC(m.This.PDM_Alias)
   ENDPROC


   PROCEDURE SetPDMToOMFile(lcOut,liRecno) && Nastav pznak dle souboru
      * lcOut   - Basic output directory
      * liRecno - ID of record
      LOCAL liy,liz,lcExt,loPDMs
      LOCAL ARRAY laExt(8)
      SELE (m.This.PDM_Alias)
      GO (liRecno) && Sko na vtu

      STORE 0 TO laExt
      lcExt=UPPER(ExtractExtensionFromFile(NullTermined(NAME)))
      loPDMs=EVAL(m.This.PDMs)

      FOR liy=1 TO ALEN(m.This.aDefExt,1)
          IF ATC(m.lcExt,m.This.aDefExt(liy,2))>0
             FOR liz=1 TO ALEN(m.loPDMs.aSG,1)
                 IF ATC(m.This.aDefExt(liy,1),m.loPDMs.aSG(liz,2))>0
                    laExt(m.loPDMs.aSG(liz,1))=IIF(laExt(m.loPDMs.aSG(liz,1))=0,1,laExt(m.loPDMs.aSG(liz,1)))
                    EXIT
                 ENDIF
             NEXT
          ENDIF
      NEXT
      
      This.SRecno=liRecno
      This.OutDir=lcOut+LOWER(ExtractFileFromFile(NullTermined(NAME)))+"\"
      This.FileName=LOWER(ExtractFileFromFile(NullTermined(NAME)))
      This.PJX.Generate=0
      This.DBC.Generate=laExt(_PDMSG_DBC)
      This.SCX.Generate=laExt(_PDMSG_SCX)
      This.FRX.Generate=laExt(_PDMSG_FRX)
      This.PRG.Generate=laExt(_PDMSG_PRG)
      This.VCX.Generate=laExt(_PDMSG_VCX)
      This.LBX.Generate=laExt(_PDMSG_LBX)
      This.XXX.Generate=laExt(_PDMSG_XXX)
      This.MNX.Generate=laExt(_PDMSG_MNX)
   ENDPROC

   PROCEDURE GetSCCSS(lcPath) && Return Script to SC CSS file
      LOCAL lcCSS,loPDMs
      liSC=This.SyntaxColoring

      IF This.SyntaxColoring=1
         This.GetPI_ENV("SC",@lcPath,@lcCSS,"")
      ELSE
         loPDMs=EVAL(m.This.PDMs)
         lcCSS=loPDMs.SCCSS
         lcCSS=m.loPDMs.AddExternalStyle(m.This.PathRelativePathTo(@m.lcPath,lcCSS))
      ENDIF
      RETURN lcCSS
   ENDPROC

   PROCEDURE FormalyzeGLCSS_JS(lcPath,lcCSS,lcJS)
      LOCAL lii,liCount
      LOCAL ARRAY laData(1)

      IF !EMPTY(lcCSS)
         liCount=ALINES(laData,STRTRAN(STRTRAN(m.lcCSS,",",CRLF),";",CRLF))
         lcCSS=""
         FOR lii=1 TO m.liCount
             lcCSS=lcCSS+IIF(AT("\\",laData(m.lii))>0 OR AT(":",laData(m.lii))>0,;
                   This.PathRelativePathTo(m.lcPath,laData(m.lii)),laData(m.lii))+","
         NEXT
      ENDIF

      IF !EMPTY(m.lcJS)
         liCount=ALINES(laData,STRTRAN(STRTRAN(m.lcJS,",",CRLF),";",CRLF))
         lcJS=""
         FOR lii=1 TO m.liCount
             lcJS=lcJS+IIF(AT("\\",laData(m.lii))>0 OR AT(":",laData(m.lii))>0,;
                  This.PathRelativePathTo(m.lcPath,laData(m.lii)),laData(m.lii))+","
         NEXT
      ENDIF
   ENDPROC

   PROCEDURE GetGLCSS_JS(lcPath,loObj,lcCSS,lcJS)
      * lcPath - Output Path
      * loObj  - Ref. to Object (PJX,DBC,...) 
      *@lcCSS  - Output link CCS file
      *@lcJS   - Output link JS file

      LOCAL lcOut,m.loPDMs,lii
      loPDMs=EVAL(m.This.PDMs)
      STORE "" TO lcCSS,lcJS

      IF !EMPTY(m.This.aGLCSS)
         FOR lii=1 TO ALEN(m.This.aGLCSS)
             lcCSS=m.lcCSS+m.loPDMs.AddExternalStyle(m.This.PathRelativePathTo(@m.lcPath,m.This.aGLCSS(m.lii)))
         NEXT
      ENDIF

      IF !EMPTY(m.This.aGLJS)
         FOR lii=1 TO ALEN(m.This.aGLJS)
             lcJS=m.lcJS+m.loPDMs.AddExternalStyle(m.This.PathRelativePathTo(@m.lcPath,m.This.aGLJS(m.lii)))
         NEXT
      ENDIF

      IF !ISNULL(loObj) AND !EMPTY(loObj.aGLCSS)
         FOR lii=1 TO ALEN(m.loObj.aGLCSS)
             lcCSS=m.lcCSS+m.loPDMs.AddExternalStyle(m.This.PathRelativePathTo(@m.lcPath,m.loObj.aGLCSS(m.lii)))
         NEXT
      ENDIF

      IF !ISNULL(loObj) AND !EMPTY(loObj.aGLCSS)
         FOR lii=1 TO ALEN(m.loObj.aGLJS)
             lcJS=m.lcJS+m.loPDMs.AddExternalStyle(m.This.PathRelativePathTo(@m.lcPath,m.loObj.aGLJS(m.lii)))
         NEXT
      ENDIF



*!*	      IF !EMPTY(m.This.gGLCSS)
*!*	         lcCSS=m.loPDMs.AddExternalStyle(m.This.PathRelativePathTo(@m.lcPath,m.This.gGLCSS))
*!*	      ENDIF

*!*	      IF !EMPTY(m.This.gGLJS)
*!*	         lcJS=m.loPDMs.AddExternalScript(m.This.PathRelativePathTo(@m.lcPath,m.This.gGLJS))
*!*	      ENDIF

*!*	      IF !ISNULL(loObj) AND !EMPTY(loObj.gGLCSS)
*!*	         lcCSS=lcCSS+m.loPDMs.AddExternalStyle(m.This.PathRelativePathTo(@m.lcPath,loObj.gGLCSS))
*!*	      ENDIF

*!*	      IF !ISNULL(loObj) AND !EMPTY(loObj.gGLJS)
*!*	         lcJS=lcJS+m.loPDMs.AddExternalScript(m.This.PathRelativePathTo(@m.lcPath,loObj.gGLJS))
*!*	      ENDIF

      lcCSS=STRTRAN(lcCSS,CRLF,m.This.aSpace(21))
      lcJS=STRTRAN(lcJS,CRLF,m.This.aSpace(21))
   ENDPROC



   PROCEDURE GetPI_ENV(lcPI,lcPath,lcCSS,lcJS) && Return External CSS, JS, Inner JS or another sources for xhtml from plug-in
      * lcPI   - Plug-in group
      * lcPath - Output Path
      *@lcCSS  - Output link CCS file
      *@lcJS   - Output link JS file
      LOCAL lcOut,loPDMs,lcPom,lii,liCount,liy
      LOCAL ARRAY laPI(1)
      loPDMs=EVAL(m.This.PDMs)
      STORE "" TO lcCSS,lcJS
      DO CASE
         CASE lcPI=="DIAMP"
              liCount=m.This.iDIAMP
              IF m.liCount>0
                 DIME laPI(m.liCount,ALEN(m.This.aDIAMP,2))
                 =ACOPY(m.This.aDIAMP,laPI)
              ENDIF

         CASE lcPI=="DIAP"
              liCount=m.This.iDIAP
              IF m.liCount>0
                 DIME laPI(m.liCount,ALEN(m.This.aDIAP,2))
                 =ACOPY(m.This.aDIAP,laPI)
              ENDIF

         CASE lcPI=="EFRX"
              liCount=m.This.iEFRX
              IF m.liCount>0
                 DIME laPI(m.liCount,ALEN(m.This.aEFRX,2))
                 =ACOPY(m.This.aEFRX,laPI)
              ENDIF

         CASE lcPI=="PJXEX"
              liCount=m.This.iPJXEX
              IF m.liCount>0
                 DIME laPI(m.liCount,ALEN(m.This.aPJXEX,2))
                 =ACOPY(m.This.aPJXEX,laPI)
              ENDIF

         CASE lcPI=="DIAF"
              liCount=m.This.iDIAF
              IF m.liCount>0
                 DIME laPI(m.liCount,ALEN(m.This.aDIAF,2))
                 =ACOPY(m.This.aDIAF,laPI)
              ENDIF

         CASE lcPI=="DIAC"
              liCount=m.This.iDIAC
              IF m.liCount>0
                 DIME laPI(m.liCount,ALEN(m.This.aDIAC,2))
                 =ACOPY(m.This.aDIAC,laPI)
              ENDIF

         CASE lcPI=="SC"
              liCount=m.This.iCF
              IF m.liCount>0
                 DIME laPI(m.liCount,ALEN(m.This.aCF,2))
                 =ACOPY(m.This.aCF,laPI)
              ENDIF
      ENDCASE

      FOR lii=1 TO m.liCount
          IF PEMSTATUS(laPI(m.lii,2),"aCSS",5) AND !EMPTY(laPI(m.lii,2).aCSS)
             FOR liy=1 TO ALEN(laPI(m.lii,2).aCSS)
                 lcCSS=m.lcCSS+m.loPDMs.AddExternalStyle(m.This.PathRelativePathTo(@m.lcPath,laPI(m.lii,2).aCSS(m.liy)))
             NEXT
          ENDIF
          IF PEMSTATUS(laPI(m.lii,2),"aJS",5) AND !EMPTY(laPI(m.lii,2).aJS)
             FOR liy=1 TO ALEN(laPI(m.lii,2).aJS)
                 lcJS=m.lcJS+m.loPDMs.AddExternalScript(m.This.PathRelativePathTo(@m.lcPath,laPI(m.lii,2).aJS(m.liy)))
             NEXT
          ENDIF

          IF PEMSTATUS(laPI(m.lii,1),"GetScript",5)
             lcPom=laPI(m.lii,1).GetScript()
             lcJS=m.lcJS+IIF(LEN(m.lcPom)=0,"",m.lcPom)
          ENDIF
      NEXT
      lcCSS=STRTRAN(m.lcCSS,CRLF,m.This.aSpace(21))
      lcJS=STRTRAN(m.lcJS,CRLF,m.This.aSpace(21))
   ENDPROC



   PROCEDURE AddFileToProject
      * m.Type - Output Path
      * lcFile  - Output link CCS file
      LPARAMETERS m.Type, m.lcFile
      
      LOCAL m.liSele, m.Name, m.lii, m.lcExt
      LOCAL ARRAY m.laFile(1)
      m.liSele=SELE()
      SET COLLATE TO "MACHINE" && Nastav tdn MACHINE
      SELE (m.This.PDM_Alias)

      m.Name=IIF(This.SourceType=1, SYS(2014, m.lcFile, ExtractPathFromFile(m.This.PJXFile)), m.lcFile)+CHR(0)
      LOCATE FOR UPPER(NAME)==UPPER(m.Name)
      IF !FOUND()
         m.lcExt=ExtractExtensionFromFile(m.lcFile)
         IF ADIR(m.laFile, IIF(LEFT(m.Name, 2)="\\" OR SUBSTR(m.Name, 2, 1)=":", CHRTRAN(m.Name, CHR(0), ""), m.lcFile))>0
            m.lii=m.laFile(1, 2)
            IF INLIST(m.lcExt, "SCX", "VCX", "MNX", "FRX", "LBX", "DBF", "DBC")
               m.lcFile=IIF(m.lcExt="SCX", ChangeExtensionFromFile(m.lcFile, "SCT"),;
                        IIF(m.lcExt="VCX", ChangeExtensionFromFile(m.lcFile, "VCT"),;
                        IIF(m.lcExt="MNX", ChangeExtensionFromFile(m.lcFile, "MNT"),;
                        IIF(m.lcExt="FRX", ChangeExtensionFromFile(m.lcFile, "FRT"),;
                        IIF(m.lcExt="LBX", ChangeExtensionFromFile(m.lcFile, "LBR"),;
                        IIF(m.lcExt="DBF", ChangeExtensionFromFile(m.lcFile, "FPT"),;
                        IIF(m.lcExt="DBC", ChangeExtensionFromFile(m.lcFile, "DCT"), "")))))))

               =ADIR(m.laFile, m.lcFile)
               m.lii=m.lii+m.laFile(1, 2)

               IF m.lcExt="DBF" AND ADIR(m.laFile, ChangeExtensionFromFile(m.lcFile, "CDX"))>0
                  m.lii=m.lii+m.laFile(1, 2)
               ENDIF
               IF lcExt="DBC" AND ADIR(m.laFile, ChangeExtensionFromFile(m.lcFile, "DCX"))>0
                  m.lii=m.lii+m.laFile(1, 2)
               ENDIF
            ENDIF
         ELSE
            m.lii=-1
         ENDIF

         INSERT INTO (m.This.PDM_Alias) (NAME, TYPE, KEY, SIZE) VALUES (m.Name, m.Type, UPPER(ExtractShortFileFromFile(m.lcFile)), m.lii)
         m.This.ChangedPJX=.T.
      ENDIF

      SET COLLATE TO (m.This.Collate) && Nastav pvodn tdn
      SELE (m.liSele)
      RETURN .T.
   ENDPROC

   PROCEDURE AddRowToGCT(laFields) && Add row 2 global class tree
      * laFields - Array of fields for ...
      INSERT INTO (m.This.AGObj) FROM ARRAY laFields
   ENDPROC

   PROCEDURE AddFileToGCT() && Increment file counter of global class tree 
      m.This.iGObj=m.This.iGObj+1
   ENDPROC

   PROCEDURE SetListDefExt() && Set known file types
      LOCAL lii,lcList
      lcList=""
      FOR lii=1 TO ALEN(m.This.aDefExt,1)
          lcList=m.lcList+m.This.aDefExt(lii,2)
      NEXT
      This.ListDefExt=m.lcList
   ENDPROC



   PROCEDURE _Code2xhtml(lcSC,lcMeta,lcMI,lcMC) && Convert source code to xhtml (internal method)
      * lcSC   - Source code
      * lcMeta - Meta data for MHHTMLCODE
      * lcMI   - Meta data for indent
      * lcMC   - Meta data for row counter

      LOCAL loPDMs
      loPDMs=EVAL(m.This.PDMs)

      RETURN '<!-- Code Begin -->'+m.This.aSpace(21)+m.loPDMs.SC_Code+'>'+;
             IIF(m.This.SyntaxColoring=0,StrTranHTMLString(@m.lcSC),;
                 m.This.aCF(1,1).Code2xhtml(@lcSC,@lcMeta,@lcMI,@lcMC))+;
                 m.loPDMs.SC_Code_Close+m.This.aSpace(21)+" <!-- Code End -->"+m.This.aSpace(21)
   ENDPROC

   PROCEDURE _Codes2xhtml(lcSC) && Convert source code (by row) to xhtml (internal method)
      * lcSC   - Source code
      LOCAL loPDMs
      loPDMs=EVAL(m.This.PDMs)

      RETURN '<!-- Code Begin -->'+m.This.aSpace(21)+m.loPDMs.SC_Code+'>'+;
             m.lcSC+;
             m.loPDMs.SC_Code_Close+m.This.aSpace(21)+" <!-- Code End -->"+m.This.aSpace(21)
   ENDPROC

   PROCEDURE _Row2xhtml(lcSC,lcMeta,lcMI,lcMC) && Convert row source code to xhtml (internal method)
      * lcSC   - Source code
      * lcMeta - Meta data for MHHTMLCODE
      * lcMI   - Meta data for indent
      * lcMC   - Meta data for row counter

      RETURN IIF(m.This.SyntaxColoring=0,StrTranHTMLString(@m.lcSC),m.This.aCF(1,1).Code2xhtml(@lcSC,@lcMeta,@lcMI,@lcMC))
   ENDPROC


   PROCEDURE Code2xhtml(lcText) && Convert source code to xhtml
      * lcText - Source code
      LOCAL loPDMs,lcRet,lii,liCount,lcRow,lcMeta,llExit,lnMC,liIndent,llMC,llMI,lcLine,;
            lcMeta,lcMI,lcMC,llSyntaxColoring,liz,liy,llByRow,lcTextByRow
      LOCAL ARRAY laRows(1),laMI(1),laMC(1),laComments(1)
      loPDMs=EVAL(m.This.PDMs)

      =RepairSource(@m.lcText)
      liCount=ALINES(m.laRows,m.lcText)
      STORE "" TO lcMeta,lcText,m.XXMC,m.XXMI,lcTextByRow
      lnMC=LEN(LTRIM(STR(m.liCount,11)))
      llMC=m.This.SCCounter=1
      llMI=m.This.SCIndent=1
      llSyntaxColoring=m.This.SyntaxColoring>0
      laComments(1)="&"+"&"

      * I need support for row
      llByRow=m.llSyntaxColoring AND m.This.aCF(1,1).SCByRow

      FOR lii=1 TO m.liCount
          STORE laRows(m.lii) TO lcRow,lcLine
          liy=Trim_SC(@m.lcRow,@paComments,"",@liIndent) && Drop comentary and find semicolon
          lcMeta=IIF(m.llByRow,"",m.lcMeta)+STR(m.liy,1)

          lcText=IIF(m.llByRow,"",m.lcText)+;
                 IIF(m.llMC AND !llSyntaxColoring,STR(m.lii,m.lnMC)+" ","")+;
                 IIF(m.llMI AND !llSyntaxColoring,IIF(m.liIndent>0,STR(m.liIndent,2)+" ","   "),"")+;
                 IIF(LEN(m.lcLine)=0,"",m.lcLine)+CRLF

          m.XXMC=IIF(m.llByRow,"",m.XXMC)+;
                 IIF(m.llMC AND m.llSyntaxColoring,STR(m.lii,m.lnMC)+CRLF,"")

          m.XXMI=IIF(m.llByRow,"",m.XXMI)+;
                 IIF(m.llMI AND m.llSyntaxColoring,IIF(m.liIndent>0,STR(m.liIndent,2),"  ")+CRLF,"")

          IF m.llByRow
             lcTextByRow=m.lcTextByRow+m.This._Row2xhtml(@lcText,@lcMeta,@m.XXMI,@m.XXMC)+;
                         IIF(m.This.aCF(1,1).AddedEnterByRow,"",CRLF)
          ENDIF

          DO WHILE m.liy=1 AND m.lii<m.liCount
             lii=m.lii+1
             STORE laRows(m.lii) TO lcRow,lcLine
             liy=Trim_SC(@lcRow,@laComments,"",@liIndent) && Drop comentary and find semicolon
             lcMeta=IIF(m.llByRow,"",m.lcMeta)+STR(m.liy,1)

             lcText=IIF(m.llByRow,"",m.lcText)+;
                    IIF(m.llMC AND !m.llSyntaxColoring,STR(m.lii,m.lnMC)+" ","")+;
                    IIF(m.llMI AND !m.llSyntaxColoring,IIF(m.liIndent>0,STR(m.liIndent,2)+" ","   "),"")+;
                    IIF(LEN(m.lcLine)=0,"",m.lcLine)+CRLF

             m.XXMC=IIF(m.llByRow,"",m.XXMC)+;
                     IIF(m.llMC AND m.llSyntaxColoring,STR(m.lii,m.lnMC)+CRLF,"")

             m.XXMI=IIF(m.llByRow,"",m.XXMI)+;
                     IIF(m.llMI AND m.llSyntaxColoring,IIF(m.liIndent>0,STR(m.liIndent,2),"  ")+CRLF,"")

             IF m.llByRow
                lcTextByRow=m.lcTextByRow+m.This._Row2xhtml(@lcText,@lcMeta,@m.XXMI,@m.XXMC)+;
                         IIF(m.This.aCF(1,1).AddedEnterByRow,"",CRLF)
             ENDIF
          ENDDO

          IF liy=2 && If semicolon after comentary
             * read it
             llExit=.F.
             DO WHILE m.lii<m.liCount AND !m.llExit
                lii=m.lii+1
                liz=AT_NonSpace(laRows(m.lii),1,LEN(laRows(m.lii)))-1
                llExit=AT(";",laRows(m.lii))=0
                lcMeta=IIF(m.llByRow,"",m.lcMeta)+IIF(m.llExit,"0","2")

                * Jde - li o dek metody/procedury
                lcText=IIF(m.llByRow,"",m.lcText)+;
                        IIF(m.llMC AND !llSyntaxColoring,STR(m.lii,m.lnMC)+" ","")+;
                        IIF(m.llMI AND !llSyntaxColoring,IIF(m.liz>0,STR(m.liz,2)+" ","   "),"")+;
                        laRows(m.lii)+CRLF

                m.XXMC=IIF(m.llByRow,"",m.XXMC)+;
                       IIF(m.llMC AND llSyntaxColoring,STR(m.lii,m.lnMC)+CRLF,"")
  
                m.XXMI=IIF(m.llByRow,"",m.XXMI)+;
                       IIF(m.llMI AND llSyntaxColoring,IIF(m.liz>0,STR(m.liz,2),"  ")+CRLF,"")

                IF m.llByRow
                   lcTextByRow=m.lcTextByRow+m.This._Row2xhtml(@lcText,@lcMeta,@m.XXMI,@m.XXMC)+;
                         IIF(m.This.aCF(1,1).AddedEnterByRow,"",CRLF)
                ENDIF
          ENDDO
          ENDIF
      NEXT

      RETURN '<!-- Code Begin -->'+m.This.aSpace(21)+m.loPDMs.SC_Code+'>'+;
             IIF(m.This.SyntaxColoring=0,;
                StrTranHTMLString(@m.lcText),;
                IIF(m.llByRow,m.This._Code2xhtml(m.lcTextByRow),m.This.aCF(1,1).Code2xhtml(@lcText,@lcMeta,@m.XXMI,@m.XXMC)))+;
                m.loPDMs.SC_Code_Close+m.This.aSpace(21)+" <!-- Code End -->"+m.This.aSpace(21)
   ENDPROC

   PROCEDURE Expr2xhtml(lcText,liStyle,llEmpty,llEncapsulate) && Convert Expression to HTML
      * lcText  - Source code
      * liStyle - Style Expression (0 - default, 1 - div inline, 2 - span)
      * llEmpty - Empty flag (special using)
      * llEncapsulate - Encapsulation flag to <div>/<span>
      LOCAL loPDMs,lcReturn
      loPDMs=EVAL(m.This.PDMs)
      liStyle=IIF(EMPTY(m.liStyle),0,m.liStyle)

      RETURN IIF(PCOUNT()<4 OR llEncapsulate,IIF(liStyle=0,loPDMs.SC_Expr,IIF(liStyle=1,loPDMs.SC_Expr_1,loPDMs.SC_Expr_2))+'>',"")+;
             IIF(llEmpty AND EMPTY(lcText),"&nbsp;",;
             IIF(This.SyntaxColoring=0,StrTranHTMLString(@m.lcText),;
             m.This.aCF(1,1).Expr2xhtml(@lcText)))+;
             IIF(PCOUNT()<4 OR llEncapsulate,IIF(liStyle=0,loPDMs.SC_Expr_Close,IIF(liStyle=1,loPDMs.SC_Expr_1_Close,loPDMs.SC_Expr_2_Close))+m.This.aSpace(21),"")
   ENDPROC


   PROCEDURE AddToStats 
      LPARAMETERS m.loXXX, m.lcKey, m.liTYPE, m.lcDescr, m.lcNAME, m.liVAL
      * m.loXXX    - type  group
      * m.lcKey    - key path (parent)
      * m.liTYPE   - type  
      * m.lcDescr  - description (file name, class name, object path, method name, etc.) 
      * m.lcNAME   - stat name 
      * m.liVAL    - stat val
      
      LOCAL m.liXX000  
      m.liXX000=RECCOUNT(m.This.AStats)+1
      INSERT INTO (m.This.AStats)  (XX000, XX000F, KEY, XX507, XX510, XX600, XX601, XX602) VALUES;
                                   (m.liXX000, m.loXXX.Stats_FileID, ALLTRIM(m.lcKey), m.liTYPE, m.lcDescr, m.lcNAME, m.liVAL, .NULL.)
      RETURN IIF(m.liTYPE>0, ALLTRIM(m.lcKey)+PADL(m.liXX000, 10, '0'), .NULL.)
   ENDPROC


   PROCEDURE AddSToStats 
      LPARAMETERS m.loXXX, m.lcKey, m.liTYPE, m.lcDescr, m.lcNAME, m.lcVAL
      * m.loXXX    - type  group
      * m.lcKey    - key path (parent)
      * m.liTYPE   - type  
      * m.lcDescr  - description (file name, class name, object path, method name, etc.) 
      * m.lcNAME   - stat name 
      * m.lcVAL    - stat val
      
      LOCAL m.liXX000  
      m.liXX000=RECCOUNT(m.This.AStats)+1
      INSERT INTO (m.This.AStats)  (XX000, XX000F, KEY, XX507, XX510, XX600, XX601, XX602) VALUES ;
                                   (m.liXX000, m.loXXX.Stats_FileID, ALLTRIM(m.lcKey), m.liTYPE, m.lcDescr, m.lcNAME, .NULL., m.lcVAL)
      RETURN IIF(m.liTYPE>0, ALLTRIM(m.lcKey)+PADL(m.liXX000, 10, '0'), .NULL.)
   ENDPROC


   PROCEDURE AddFileToStats 
      LPARAMETERS m.loXXX, m.liTYPE, m.liSize, m.lcFile
      * m.loXXX    - type  group
      * m.liTYPE   - type  

      LOCAL m.liXX000, m.lcKEY  
      STORE RECCOUNT(m.This.AStats)+1 TO m.liXX000, m.loXXX.Stats_FileID
      STORE PADL(m.liXX000, 10, '0') TO m.lcKEY, m.loXXX.Stats_Key && base file key for statistics
      
      IF EMPTY(m.lcFile)
         m.lcFile=m.loXXX.File
      ENDIF
      
      INSERT INTO (m.This.AStats)  (XX000, XX000F, KEY, XX507, XX510, XX600, XX601) VALUES (m.liXX000, m.liXX000, m.lcKEY, m.liTYPE, m.lcFile, "", 0)
      
      =This.AddToStats(m.loXXX, m.lcKey, 0, "", "size", m.liSize)
      =This.AddSToStats(m.loXXX, m.lcKey, 0, "", "name", JUSTFNAME(m.lcFile))
      =This.AddSToStats(m.loXXX, m.lcKey, 0, "", "folder", JUSTPATH(m.lcFile))
      =This.AddSToStats(m.loXXX, m.lcKey, 0, "", "fullname", m.lcFile)

      RETURN m.lcKEY
   ENDPROC


ENDDEFINE














****************************************************************
* Definice tdy _CUSList
****************************************************************
DEFINE CLASS _CuSList AS CUSTOM
   Name="_CuSList"

   Count=0 && Poet zznam v matici aList[]
   DIME aList[1,4] && Seznam soubor
   * 1 - Upper name
   * 2 - Case sensitive name
   * 3 - Copy to repository?
   * 4 - Comment

   PROCEDURE SetDefSets() && Set default settings
      m.This.Count=0
      DIME m.This.aList[1,4] && Seznam soubor
   ENDPROC

   PROCEDURE Open(lcFile,lcSection) && Read settings
      * lcFile    - PDM File
      * lcSection - Sekce ze kter se to m nast
      LOCAL lcData,lii,liy,liz,lcPom
      LOCAL ARRAY laPom(1)
      * A te nati celou sekci jako data
      lcData=GetINISection(lcSection+"_FL",32000,@m.lcFile) && Cel sekce
      IF !EMPTY(lcData) && Pokud to nen przdn
         lcData=STRTRAN(lcData,CHR(0),CHR(13)+CHR(10))
         m.This.Count=ALINES(laPom,lcData) && Nati dky
      ENDIF
      IF m.This.Count>0
         DIME m.This.aList(m.This.Count,4)
         FOR lii=1 TO m.This.Count
             liy=AT(",",laPom(lii))
             liz=AT(",",laPom(lii),2)

             lcPom=IIF(liy>0,SUBST(laPom(lii),2,liy-2),laPom(lii))
             IF LEFT(lcPom,2)=="\\" OR SUBST(lcPom,2,2)==":\" OR ATC("://",lcPom)>0
                m.This.aList(lii,2)=lcPom
             ELSE
                m.This.aList(lii,2)=LOWER(FULLPATH(lcPom,m.lcFile))
             ENDIF
             m.This.aList(lii,1)=UPPER(m.This.aList(lii,2))
             m.This.aList(lii,3)=VAL(ALLT(SUBS(laPom(lii),liy+1,liz-liy-1)))
             m.This.aList(lii,4)=ALLT(SUBS(laPom(lii),liz+1))
         NEXT
      ENDIF
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,lcSection) && Save settings
      * lcFile    - PDM File
      * lcSection - Sekce kam se m zapisovat
      LOCAL lii,lcData
      lcData="" && Vyisti buffer
      FOR lii=1 TO m.This.Count

          lcData=lcData+"="+;
                 IIF(LEFT(m.This.aList(lii,2),2)=="\\" OR SUBST(m.This.aList(lii,2),2,2)==":\" OR ATC("://",m.This.aList(lii,2))>0,;
                 m.This.aList(lii,2),LOWER(SYS(2014,m.This.aList(lii,2),m.lcFile)))+;
                 ","+STR(m.This.aList(lii,3),1)+","+m.This.aList(lii,4)+CHR(0)
      NEXT
      =WriteINISection(lcSection+"_FL",@m.lcData,@m.lcFile) && Zapi poet
      RETURN _PDM_OK
   ENDPROC
ENDDEFINE


****************************************************************
* Definice tdy _FileList
****************************************************************
DEFINE CLASS _FileList AS CUSTOM
   Name="_FileList"

   Count=0 && Poet zznam v matici aList[]
   DIME aList[1,2] && Seznam soubor
   * 1 - Upper name
   * 2 - Case sensitive name

   PROCEDURE SetDefSets() && Set default settings
      m.This.Count=0
      DIME m.This.aList[1,2] && Seznam soubor
   ENDPROC

   PROCEDURE Open(lcFile,lcSection) && Read settings
      * lcFile    - PDM File
      * lcSection - Sekce ze kter se to m nast
      LOCAL lcData,lii
      LOCAL ARRAY laPom(1)
      * A te nati celou sekci jako data
      lcData=GetINISection(lcSection+"_FL",32000,@m.lcFile) && Cel sekce
      IF !EMPTY(lcData) && Pokud to nen przdn
         lcData=STRTRAN(lcData,CHR(0),CHR(13)+CHR(10))
         m.This.Count=ALINES(laPom,lcData) && Nati dky
      ENDIF
      IF m.This.Count>0
         DIME m.This.aList(m.This.Count,2)
         FOR lii=1 TO m.This.Count
             m.This.aList(lii,2)=FULLPATH(SUBST(laPom(lii),2),m.lcFile)
             m.This.aList(lii,1)=UPPER(m.This.aList(lii,2))
         NEXT
      ENDIF
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,lcSection) && Save settings
      * lcFile    - PDM File
      * lcSection - Sekce kam se m zapisovat
      LOCAL lii,lcData
      lcData="" && Vyisti buffer
      FOR lii=1 TO m.This.Count
          lcData=lcData+"="+LOWER(SYS(2014,m.This.aList(lii,2),m.lcFile))+CHR(0)
      NEXT
      =WriteINISection(lcSection+"_FL",@m.lcData,@m.lcFile) && Zapi poet
      RETURN _PDM_OK
   ENDPROC

ENDDEFINE











*********************************************************
** Definice tdy pro prci s large maticemi
DEFINE CLASS _SupperArray AS custom
   PROTECTED CountArray

   MaxRow=64000 && Maximln poet dk v matici
   Count=0 && Celkov poet dk
   CountArray=0 && Poet natench matic

   PROCEDURE ALines(lcSC) && Nate etzec do matice
      *@lcSC - Zdroj dk
      LOCAL lcBuff,lcBlock,lii,liy,liIndex,lcIndex,liCR,liLF,lcPom,liCount
      lcBuff=m.lcSC && Udlej si kopletn kopii
      RELE lcSC
       
      * Zjisti, zda to nemus upravit
      liCR=AT(CHR(13),m.lcBuff,1)
      liLF=AT(CHR(10),m.lcBuff,1)
       
      * Pokud tam nen pln CRLF, ale CR nebo LF
      IF m.liCR=0 OR m.liLF=0
         * Pak to nahra CRLF
         lcBuff=STRTRAN(m.lcBuff,IIF(m.liCR=0,CHR(10),CHR(13)),CRLF)
      ENDIF

      * Ne, je to vce dk
      STORE 0 TO liIndex,liCount
      lii=1
      DO WHILE m.lii>0
         lii=AT(CRLF,m.lcBuff,m.This.MaxRow) && Najdi, kde kon blok pro naten dat
         lcBlock=IIF(m.lii>0,LEFT(m.lcBuff,m.lii),m.lcBuff) && Nati buffer
         lcBuff=SUBS(m.lcBuff,m.lii+2) && Zkra buffer

         liIndex=m.liIndex+1 && Inkrementuj ta
         lcIndex=LTRIM(STR(m.liIndex,11))
         lcPom="m.This.aLines"+m.lcIndex
         IF TYPE(m.lcPom+"(1)")="U" && Pokud neexistuje
            m.This.AddProperty("aLines"+m.lcIndex+"(m.This.MaxRow)") && Pidej vlastnost
         ELSE
            * Jinak matici pedimenzuj
            DIME &lcPom.(m.This.MaxRow)
         ENDIF
         liCount=m.liCount+ALINES(&lcPom.,m.lcBlock) && Nati dky
      ENDDO
      m.This.CountArray=m.liIndex && Zapi si poet vytvoench matic
      m.This.Count=m.liCount
      RETURN m.liCount
   ENDPROC

   PROCEDURE ClearArray() && Vyist intern matice
      LOCAL lii,lcPom
      FOR lii=1 TO m.This.CountArray
          lcPom="m.This.aLines"+LTRIM(STR(m.lii,11))
          IF TYPE(m.lcPom+"(1)")#"U" && Pokud existuje
              DIME &lcPom.(1) && Pak ji pedimenzuj
              STORE "" TO (m.lcPom+"(1)") && a vyisti buku
          ENDIF
      NEXT
      STORE 0 TO m.This.Count,m.This.CountArray
   ENDPROC

   PROCEDURE GetRow(liIndex) && Vrt dek z matice
      * liIndex - Index dku v matici

      IF liIndex<1 OR m.liIndex>m.This.Count && Pokud je mimo rozsah
         RETURN "" && Pak vra przdn etzec
      ENDIF

      LOCAL lii,liy
      lii=INT(m.liIndex/m.This.MaxRow) && Index matice
      liy=m.liIndex-(m.lii*m.This.MaxRow) && Index dku v nsledujc matici
       
      RETURN IIF(m.liy=0,EVAL("m.This.aLines"+LTRIM(STR(m.lii,11))+"("+STR(m.This.MaxRow,11)+")"),;
             EVAL("m.This.aLines"+LTRIM(STR(m.lii+1,11))+"("+STR(m.liy,11)+")"))
   ENDPROC
ENDDEFINE


****************************************************************
* Definiton class _DCOPEM
****************************************************************
DEFINE CLASS _DCOPEM AS CUSTOM
   Name="_DCOPEM"
   iProperties=0
   iMethods=0

   oRam=.NULL. && Basic information about class/object/procedure

   DCOPPar=.NULL.

   * for classes/Object
   DIME aProperties[1,4] && Properties list (name, value, description,flags)
   DIME aMethods[1,4] && Methods list (name, source, description,flags)


   PROCEDURE Init()
   ENDPROC

   PROCEDURE Reset(loASC,liCM,liCP)
      LOCAL lii
      This.oRam=loASC.GetClsObj(_PDM_GetDCOPRam_Object)
      This.iProperties=liCP
      This.iMethods=liCM
      IF liCP>0
         DIME This.aProperties[liCP]
         FOR lii=1 TO liCP
             This.aProperties[lii]=loASC.GetClsObj(_PDM_GetDCOPRam_Prop)
         NEXT
      ENDIF
      IF liCM>0
         DIMENSION This.aMethods[liCM]
         FOR lii=1 TO liCM
             This.aMethods[lii]=loASC.GetClsObj(_PDM_GetDCOPRam_Method)
         NEXT
      ENDIF
   ENDPROC

ENDDEFINE



****************************************************************
* Definiton class _uList
****************************************************************
DEFINE CLASS _uList AS CUSTOM
   Name="_uList"

   Count=0 && Count rows in array aList[]
   DIME aList[1] && File list
   * 1 - Upper name

   PROCEDURE Add(lcFile)
      m.This.Count=m.This.Count+1 && Increment counter
      DIME m.This.aList(m.This.Count) && Redim Array
      m.This.aList(m.This.Count)=UPPER(m.lcFile) && Save file name
   ENDPROC

ENDDEFINE


****************************************************************
* Definiton class _PrintHTML
****************************************************************
DEFINE CLASS _PrintHTML AS CUSTOM
   Name="_PrintHTML"

   IE=.NULL. && Object reference instace Internet Explorer

   LeftM=""
   TopM=""
   RightM=""
   BottomM=""


   PROCEDURE PrintHTML(lcFile,liOrientation) && Post HTML file to printer
      * lcFile        - Directory and HTML file name
      * liOrientation - Paper Orientation
      LOCAL loIE,liOldPO,liErr
      IF !FILE(m.lcFile) && If file not exists
         RETURN && Then go out
      ENDIF
      IF m.liOrientation>-1
         liOldPO=SetPOrient(SET("PRINTER",2),m.liOrientation+1) && Set New Paper Orientation -> icrement for API
      ENDIF
      loIE=m.This.IE
      DO WHILE m.loIE.Busy
         =Sleep(250)
      ENDDO
      liErr=m.loIE.Navigate(m.lcFile)
      DO WHILE m.loIE.ReadyState<=3
         =Sleep(250)
      ENDDO
      liErr=m.loIE.ExecWB(6,2)
      DO WHILE m.loIE.ReadyState<=3
         =Sleep(250)
      ENDDO
      =Sleep(1000)
      IF m.liOrientation>-1 AND m.liOldPO>-1
         =SetPOrient(SET("PRINTER",2),m.liOldPO) && Set Old Paper Orientation
      ENDIF

   ENDPROC

   PROCEDURE PrintHTMLs(lcDir,lcFile,lcCallBack)
      * lcDir      - Output directory
      * lcFile     - Printer Log HTML file name
      * lcCallBack - Callback method or procedure
      LOCAL lcSC,lii,liCount,lcPom,loSA,liy,liOP
      IF !FILE(m.lcFile)
         RETURN _PDM_FileNE
      ENDIF
      lcSC=FILETOSTR(m.lcFile)
      IF EMPTY(m.lcSC)
         RETURN _PDM_NoPRN
      ENDIF

      loSA=CREATEOBJECT("_SupperArray") && Vytvo objekt pro prci a Super maticemi
      liCount=m.loSA.ALines(@m.lcSC) && Nati zdrojov kd do matice
      lcSC=""
      FOR lii=1 TO m.liCount
          lcPom=m.loSA.GetRow(m.lii)
          liy=AT(",",m.lcPom)
          lcFile=IIF(m.liy>0,LEFT(m.lcPom,m.liy-1),m.lcPom)
          lcPom=ALLT(SUBS(m.lcPom,m.liy+1)) && 
          liOP=IIF(m.lcPom=="" OR !INLIST(m.lcPom,"0","1"),-1,VAL(m.lcPom))
          IF !EMPTY(m.lcFile)
             =IIF(!EMPTY(m.lcCallBack),EVAL(m.lcCallBack+"(lcFile)"),.T.)
             m.This.PrintHTML(m.lcDir+m.lcFile,m.liOP)
          ENDIF
      NEXT
      =Sleep(5000)
      RETURN _PDM_OK
   ENDPROC

   PROCEDURE CreateIE(loPDM) && Create instance Internet Explorer 
      * loPDM - PDM object
      LOCAL liHKEY,lcData
      m.This.IE=CREATEOBJECT("InternetExplorer.Application") && Create instance IE
      m.This.IE.Silent=.T.
      liHKEY=0
      * Open key in Registry
      IF API_RegOpenKeyEx(HKEY_CURRENT_USER,"Software\Microsoft\Internet Explorer\PageSetup"+CHR(0),@m.liHKEY)=REGAPI_SUCCESS
         * Read Page setup settings from registry
         lcData=SPACE(20)
         IF API_RegQueryValueEx(m.liHKEY,"margin_left"+CHR(0),REG_SZ,@m.lcData,20)=REGAPI_SUCCESS
            m.This.LeftM=m.lcData
         ENDIF
         lcData=SPACE(20)
         IF API_RegQueryValueEx(m.liHKEY,"margin_top"+CHR(0),REG_SZ,@m.lcData,20)=REGAPI_SUCCESS
            m.This.TopM=m.lcData
         ENDIF
         lcData=SPACE(20)
         IF API_RegQueryValueEx(m.liHKEY,"margin_right"+CHR(0),REG_SZ,@m.lcData,20)=REGAPI_SUCCESS
            m.This.RightM=m.lcData
         ENDIF
         lcData=SPACE(20)
         IF API_RegQueryValueEx(m.liHKEY,"margin_bottom"+CHR(0),REG_SZ,@m.lcData,20)=REGAPI_SUCCESS
            m.This.BottomM=m.lcData
         ENDIF

*[HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Internet Settings] - for every file
*;   page orientation: 1=portrait, 2=landscape

         * Save new Page setup settings to registry
         =API_RegSetValueEx(m.liHKEY,"margin_left"+CHR(0),REG_SZ,STR(loPDM.Margin_Left,6,4)+CHR(0))
         =API_RegSetValueEx(m.liHKEY,"margin_top"+CHR(0),REG_SZ,STR(loPDM.Margin_Top,6,4)+CHR(0))
         =API_RegSetValueEx(m.liHKEY,"margin_right"+CHR(0),REG_SZ,STR(loPDM.Margin_Right,6,4)+CHR(0))
         =API_RegSetValueEx(m.liHKEY,"margin_bottom"+CHR(0),REG_SZ,STR(loPDM.Margin_Bottom,6,4)+CHR(0))

         * Uzavi kl
         =API_RegCloseKey(m.liHKEY)
      ENDIF
   ENDPROC

   PROCEDURE RemoveIE() && Remove instance Internet Explorer and save old page setup settings
      m.This.IE.Quit() && Quit Internet Explorer
      m.This.IE=.NULL. && Release instance

      LOCAL liHKEY
      * Save old Page setup settings to registry
      liHKEY=0
      * Open key in Registry
      IF API_RegOpenKeyEx(HKEY_CURRENT_USER,"Software\Microsoft\Internet Explorer\PageSetup"+CHR(0),@m.liHKEY)=REGAPI_SUCCESS
         =API_RegSetValueEx(m.liHKEY,"margin_left"+CHR(0),REG_SZ,m.This.LeftM)
         =API_RegSetValueEx(m.liHKEY,"margin_top"+CHR(0),REG_SZ,m.This.TopM)
         =API_RegSetValueEx(m.liHKEY,"margin_right"+CHR(0),REG_SZ,m.This.RightM)
         =API_RegSetValueEx(m.liHKEY,"margin_bottom"+CHR(0),REG_SZ,m.This.BottomM)
         =API_RegCloseKey(m.liHKEY)
      ENDIF
   ENDPROC

ENDDEFINE





*****************************************************
DEFINE CLASS _pdm_RunGUI AS custom
   Name="_pdm_RunGUI"
   Command=0
   Data=""
ENDDEFINE


*****************************************************
DEFINE CLASS _pdm_FileLevel AS Session
   Name="_pdm_FileLevel"

   nLevel=0

   I1=0 && 
   I2=0 && 
   I3=0 && 
   I4=0 && 
   I5=0 && 
   I6=0 && 
   I7=0 && 
   I8=0 && 
   I9=0 && 
   I10=0 && 

   PROCEDURE Reset(liLevel) && 
      DO CASE
         CASE PCOUNT()=0 OR liLevel=1
              STORE 0 TO This.I1,This.I2,This.I3,This.I4,This.I5,This.I6,This.I7,This.I8,This.I9,This.I10

         CASE liLevel=2
              STORE 0 TO This.I2,This.I3,This.I4,This.I5,This.I6,This.I7,This.I8,This.I9,This.I10

         CASE liLevel=3
              STORE 0 TO This.I3,This.I4,This.I5,This.I6,This.I7,This.I8,This.I9,This.I10

         CASE liLevel=4
              STORE 0 TO This.I4,This.I5,This.I6,This.I7,This.I8,This.I9,This.I10

         CASE liLevel=5
              STORE 0 TO This.I5,This.I6,This.I7,This.I8,This.I9,This.I10

         CASE liLevel=6
              STORE 0 TO This.I6,This.I7,This.I8,This.I9,This.I10

         CASE liLevel=7
              STORE 0 TO This.I7,This.I8,This.I9,This.I10

         CASE liLevel=8
              STORE 0 TO This.I8,This.I9,This.I10

         CASE liLevel=9
              STORE 0 TO This.I9,This.I10

         CASE liLevel=10
              STORE 0 TO This.I10
      ENDCASE
   ENDPROC

ENDDEFINE
